//*****************************************************************************
//*
//*
//*		WinExtension.h
//*
//*
//*****************************************************************************
//
//	Enhlt diverse Erweiterungen zur Windows API.
//	
//	Macros:		WEX_NO_MESSAGEBOX	MessageBox mir ColorListBox nicht benutzen	
//				
#ifndef 	__WINEXTENSION_H__
#define 	__WINEXTENSION_H__



#if		   _MSC_VER > 1299
#ifndef		WINVER
#define		WINVER 	0x0501
#endif
#endif

#ifndef	   	_WINDOWS_
#if	defined(_MFC_VER) || defined(AZ_LIB_ADDAFX)
	#ifndef	 __AFX_H__
	#include <Afx.h>
	#endif
#else
	#include <windows.h>
#endif
#endif

#ifndef _WCHAR_T_DEFINED
	#if _MSC_VER
	#include <wchar.h>
	#else
	typedef	 unsigned short	wchar_t;
	#define _WCHAR_T_DEFINED	1
	#endif
#endif

#ifdef	 __cplusplus
#define 	EXTAPI		extern "C"
#define 	EXTINL		inline
#ifndef		D
#define 	D(a)		a
#endif
#else
#define 	EXTAPI
#define 	EXTINL		__inline
#ifndef		D
#define 	D(a)
#endif
#endif

#ifdef	   _MSC_VER
#pragma		comment(lib, "Comctl32.lib")
#endif


// Konstanten fr DrawTextColor
#define		DT_BKCOLOR_0			0x00000000				// Kein Bit  fr Hintergrund
#define 	DT_BKCOLOR_1			0x10000000				// Ein  Bit  fr Hintergrund
#define 	DT_BKCOLOR_2			0x20000000				// Zwei Bits fr Hintergrund
#define 	DT_BKCOLOR_3			0x30000000				// Drei Bits fr Hintergrund
#define 	DT_NODEFAULT			0x80000000				// Keine Default-Text-Farbe
#define 	DT_FONTCNT_1			0x01000000				// Ist die Anzahl der benutzen Fonts
#define 	DT_FONTCNT_2			0x02000000				//			*
#define 	DT_FONTCNT_3			0x03000000				//			*
#define 	DT_FONTCNT_4			0x04000000				//			*
#define 	DT_ULINECOLOR			0x08000000				// Unterstreichen mit Farbe 15

// Konstanten fr ExtTextColor
#define 	ETO_BKCOLOR_0			0x00000000				// Kein Bit  fr Hintergrund
#define 	ETO_BKCOLOR_1			0x10000000				// Ein  Bit  fr Hintergrund
#define 	ETO_BKCOLOR_2			0x20000000				// Zwei Bits fr Hintergrund
#define 	ETO_BKCOLOR_3			0x30000000				// Drei Bits fr Hintergrund
#define 	ETO_RELATIVE			0x40000000				// Pos X/Y sind relativ zum Rechteck
#define 	ETO_NODEFAULT			0x80000000				// Keine Default-Text-Farbe
#define 	ETO_FONTCNT_1			0x01000000				// Ist die Anzahl der benutzen Fonts
#define 	ETO_FONTCNT_2			0x02000000				//			*
#define 	ETO_FONTCNT_3			0x03000000				//			*
#define 	ETO_FONTCNT_4			0x04000000				//			*
#define 	ETO_ULINECOLOR			0x08000000				// Unterstreichen mit Farbe 15

// Konstanten fr DrawButton
#define 	DB_ANSITEXT				0x00000100				// Der Text ist kein UNICODE
#define 	DB_BACKGROUND			0x00000200				// Hintergrund zeichnen
#define 	DB_USENOTHEMA			0x00000400				// Keinen Windows-Tema verwenden
#define 	DB_HASYDELTA			0x00000800				// Fr die Y-Richtung gibt es ein extra Delta
#define 	DB_TEXTLEFT(a)			(((BYTE)(a))<<16)		// Den Text links ausrichten bei Offset a

// Konstanten fr DrawMenuItem
#define 	DM_ANSITEXT				0x00000100				// Der Text ist kein UNICODE
#define 	DM_BACKGROUND			0x00000200				// Hintergrund zeichnen
#define 	DM_USENOTHEMA			0x00000400				// Keinen Windows-Tema verwenden
#define 	DM_TEXTCENTER			0x00004000				// Den Text mittig ausrichten
#define 	DM_TEXTRIGHT			0x00008000				// Den Text rechts ausrichten
#define 	DM_TEXTLEFT(a)			(((BYTE)(a))<<16)		// Den Text links ausrichten bei Offset a

// Konstanten fr DrawCheckBox
#define 	DC_ANSITEXT				0x00000100				// Der Text ist kein UNICODE
#define 	DC_BACKGROUND			0x00000200				// Hintergrund zeichnen
#define 	DC_USENOTHEMA			0x00000400				// Keinen Windows-Tema verwenden
#define 	DC_HASYDELTA			0x00000800				// Fr die Y-Richtung gibt es ein extra Delta
#define 	DC_ANSIFONT				0x00001000				// Den ANSI_VAR_FONT benutzen
#define 	DC_DEFAULTFONT			0x00002000				// Den Standart-Font benutzen
#define 	DC_TEXTLEFT(a)			(((BYTE)(a))<<16)		// Den Text links bei Offset a ausrichten

// Konstanten fr DrawRadio
#define 	DR_ANSITEXT				0x00000100				// Der Text ist kein UNICODE
#define 	DR_BACKGROUND			0x00000200				// Hintergrund zeichnen
#define 	DR_USENOTHEMA			0x00000400				// Keinen Windows-Tema verwenden
#define 	DR_HASYDELTA			0x00000800				// Fr die Y-Richtung gibt es ein extra Delta
#define 	DR_ANSIFONT				0x00001000				// Den ANSI_VAR_FONT benutzen
#define 	DR_DEFAULTFONT			0x00002000				// Den Standart-Font benutzen
#define 	DR_TEXTLEFT(a)			(((BYTE)(a))<<16)		// Den Text links bei Offset a ausrichten

// Konstanten fr DrawGlyph
#define 	DG_GLYPH		 		0x00000000				// Glyph fr Treelist
#define 	DG_MENU		     		0x00000010				// Glyph fr Menus
#define 	DG_DROPDOWN				0x00000020				// Glyph fr Dropdown
#define 	DG_BACKGROUND			0x00000200				// Hintergrund zeichnen
#define 	DG_USENOTHEMA			0x00000400				// Keinen Windows-Tema verwenden
#define 	DG_HASYDELTA			0x00000800				// Fr die Y-Richtung gibt es ein extra Delta

// Konstanten fr DrawFlatButton
#define		PFB_PRESSED				0x00000001				// Taste gedrckt zeichnen
#define		PFB_FILLED				0x00000002				// Taste gefllt zeichnen
#define 	PFB_HOT					0x00000004				// Taste etwas dunkler fllen
#define 	PFB_MONO				0x00000008				// Den Rahmen einfarbig zeichnen

// Konstanten fr CalcTextSize
#define 	DT_RETURNY				0x80000000				// Y-Gre in High-Wort zurckgeben
#define 	DT_RETURNSIZE			0x40000000				// Puffer mit SIZE-Objekt fllen
#define 	DT_RETURNRECT			0x20000000				// Puffer enthlt RECT-Objekt fr Ausrichtung

// Konstanden fr MessageBoxIndirectEx
#define 	MB_ALWAYS				0x00000008				// Taste 'Immer'   einfgen 
#define 	MB_NEVER				0x00000800				// Taste 'Niemals' einfgen
#define 	MB_SETPOS				0x00080000				// Fensterposition in dwLanguageId
#define 	MB_USEWIDE				0x00100000				// Die Texte sind Unicode
#define 	MB_USEANSI				MB_DEFAULT_DESKTOP_ONLY	// Die Texte sind Ansi
#define 	MB_NOBEEP				MB_TASKMODAL			// Keinen Signalton ausgeben
#define 	MB_TAB(a)				((a)<<22)				// Tabulatorabstand setzen		

// Konstanden fr Texte
#define 	IDS_TEXT_INFORMATION	1287					// Text "Information"
#define 	IDS_TEXT_QUESTION		1288					// Text "Frage"
#define 	IDS_TEXT_WARNING		1289					// Text "Warnung"
#define 	IDS_TEXT_CLEARLINE		1290					// Text "Zeile lschen"
#define 	IDS_TEXT_COPYFIELD		1291					// Text "Feld kopieren"
#define 	IDS_TEXT_COPY			1292					// Text "&Kopieren"
#define 	IDS_TEXT_MARK			1293					// Text "&Alles markieren"
#define 	IDS_TEXT_SELALL			1294					// Text "&Alles auswhlen"
#define 	IDS_TEXT_SELNONE		1295					// Text "&Alles abwhlen"
#define 	IDS_TEXT_CLEAR			1296					// Text "&Alles lschen"
#define 	IDS_TEXT_ALWAYS			1297					// Text "Immer"
#define 	IDS_TEXT_NEVER			1298					// Text "Niemals"

// Konstanden fr DIB Funktionen
#define 	DIB_RES_LIST			((1<<(DWORD)RT_ICON*2)|(2<<(DWORD)RT_CURSOR*2)|(3<<(DWORD)RT_GROUP_ICON*2)|(3<<(DWORD)RT_GROUP_CURSOR*2))
#define 	DIB_RES_TO_VAL(a)		((((DWORD_PTR)(a)<16)? (DIB_RES_LIST>>(U(a)*2))&3:0)<<21)
#define 	DIB_TYPE_ICON			(DIB_RES_TO_VAL(RT_CURSOR      ))
#define 	DIB_TYPE_CURSOR			(DIB_RES_TO_VAL(RT_CURSOR      ))
#define 	DIB_TYPE_GROUP			(DIB_RES_TO_VAL(RT_GROUP_CURSOR))
#define 	DIB_SET_SPECIAL(x,y,b)	(DIB_LOAD_SPECIAL|((BYTE)(x))|(((BYTE)(y))<<8)|(((b)&DIB_COLOR_BITS)<<16))
#define 	DIB_FORCE_COLORS(b)		(DIB_FORCE_COLOR|(((b)&DIB_COLOR_BITS)<<16))
#define 	DIB_LOAD_SPECIAL		0x80000000				// Ein spezielles Unterbild laden
#define 	DIB_FORCE_COLOR			0x40000000				// Die Ausgabe fr eine bestimmte Farbanzahl (Bit 16..21 = Farbe)
#define 	DIB_FILL_ALPHA			0x40000000				// Die Alpha-Maske im neuen Bitmap auf 255 setzen
#define 	DIB_CREATE_BITMAP		0x20000000				// Ein Bitmap erzeugen fr den Speicher
#define 	DIB_ALPHA_BG			0x10000000				// Das Bitmap mit der aktuellen Hintergundfarbe ausmalen
#define 	DIB_CONVERT				0x08000000				// Die drei Standartfarben konvertieren
#define 	DIB_BIT_MASK			0x03000000				// Am Ende des Bildes ist eine Bitmaske
#define 	DIB_COLOR_MASK			0x02000000				// Es ist eine Farbmaske angegeben (TextColor)
#define 	DIB_FIRST_MASK			0x01000000				// Der Pixel links oben ist die Farbmaske
#define 	DIB_MASK_BITS			0x03000000				// Bits die fr Masken-Modi
#define 	DIB_RESOURCE			0x00600000				// Der Recource Typ ist in Bit 21.23 (1=Icon 2=Cursor 3=IconGrp 4=CursorGrp)
#define 	DIB_COLOR_DEF			0x0000001F				// ID fr die aktuelle Farbtiefe des Bildschirms
#define 	DIB_COLOR_BITS			0x0000001F				// Maske fr die Farben bei Bits 16..21
#define 	DIB_COLOR_SAME			0x0000001E				// Resource mit maximale Farbanzahl laden fr gleiche Farbanzahl
#define 	DIB_COLOR_MAX			0x0000001D				// Resource mit maximale Farbanzahl laden fr 32 Bit
#define 	DIB_PIXEL_DATA			0x8060EDCB				// Die Pixeldaten werden ber den Pointer bergeben

// Konstanden fr's Subclassing vom spezial Fenstern
#define 	WM_ATTACH				0x69FD					// Meldung zum Anhngen des Fensters
#define 	WM_DETACH				0x69FC					// Meldung zum Abhngen des Fensters

#ifdef		UNICODE
#define 	MessageBoxIndirectEx	MessageBoxIndirectExW
#define 	LoadDefaultStrings		LoadDefaultStringsW
#define 	GetProcessFileName		GetProcessFileNameW
#define 	GetDibOfResource		GetDibOfResourceW
#define 	GetCurrentTheme			GetCurrentThemeW
#define 	GetTextExtentEx			GetTextExtentExW
#define 	GetTabbedSizeEx			GetTabbedSizeExW
#define 	DibSaveImageEx			DibSaveImageExW
#define 	TakeOwnership			TakeOwnershipW
#define 	GetDomainName			GetDomainNameW
#define 	GetCachedFont			GetCachedFontW
#define 	DrawTextColor			DrawTextColorW
#define 	DrawMenuItem			DrawMenuItemW
#define 	ExtTextColor			ExtTextColorW
#define 	CalcTextSize			CalcTextSizeW
#define 	DibSaveImage			DibSaveImageW
#define 	DrawGrayText			DrawGrayTextW
#define 	DrawCheckBox			DrawCheckBoxW
#define 	DrawButton				DrawButtonW
#define 	DrawRadio				DrawRadioW
#define 	GetOwner				GetOwnerW
#else
#define 	MessageBoxIndirectEx	MessageBoxIndirectExA
#define 	LoadDefaultStrings		LoadDefaultStringsA
#define 	GetProcessFileName		GetProcessFileNameA
#define 	GetDibOfResource		GetDibOfResourceA
#define 	GetCurrentTheme			GetCurrentThemeA
#define 	GetTextExtentEx			GetTextExtentExA
#define 	GetTabbedSizeEx			GetTabbedSizeExA
#define 	DibSaveImageEx			DibSaveImageExA
#define 	TakeOwnership			TakeOwnershipA
#define 	GetDomainName			GetDomainNameA
#define 	GetCachedFont			GetCachedFontA
#define 	DrawTextColor			DrawTextColorA
#define 	DrawMenuItem			DrawMenuItemA
#define 	ExtTextColor			ExtTextColorA
#define 	CalcTextSize			CalcTextSizeA
#define 	DibSaveImage			DibSaveImageA
#define 	DrawGrayText			DrawGrayTextA
#define 	DrawCheckBox			DrawCheckBoxA
#define 	DrawButton				DrawButtonA
#define 	DrawRadio				DrawRadioA
#define 	GetOwner				GetOwnerA
#endif

#ifdef		UNICODE
typedef		WCHAR					UTCHAR;
#else
typedef		UCHAR					UTCHAR;
#endif 	


#ifdef	   _WIN64

#undef		GWL_USERDATA
#define 	GWL_USERDATA			GWLP_USERDATA

#undef		GWL_WNDPROC
#define 	GWL_WNDPROC				GWLP_WNDPROC

#undef		DWL_DLGPROC
#define		DWL_DLGPROC				DWLP_DLGPROC

#undef		GCL_HICON
#define 	GCL_HICON				GCLP_HICON

#undef		GCL_HICONSM
#define 	GCL_HICONSM				GCLP_HICONSM

#undef		GCL_HMODULE
#define 	GCL_HMODULE				GCLP_HMODULE

#undef		GCL_HCURSOR
#define 	GCL_HCURSOR				GCLP_HCURSOR

#undef		GCL_WNDPROC
#define 	GCL_WNDPROC				GCLP_WNDPROC

#endif


#ifndef		GWLP_USERDATA
#define 	GWLP_USERDATA			GWL_USERDATA
#endif

#ifndef 	GWLP_WNDPROC
#define 	GWLP_WNDPROC			GWL_WNDPROC
#endif

#ifndef		DWLP_DLGPROC
#define		DWLP_DLGPROC			DWL_DLGPROC
#endif

#ifndef 	GCLP_HICON
#define 	GCLP_HICON				GCL_HICON
#endif

#ifndef 	GCLP_HICONSM
#define 	GCLP_HICONSM			GCL_HICONSM
#endif

#ifndef 	GCLP_HMODULE
#define 	GCLP_HMODULE			GCL_HMODULE
#endif

#ifndef 	GCLP_HCURSOR
#define 	GCLP_HCURSOR			GCL_HCURSOR
#endif

#ifndef 	GCLP_WNDPROC
#define 	GCLP_WNDPROC			GCL_WNDPROC
#endif

#ifndef 	GCLP_HBRBACKGROUND
#define 	GCLP_HBRBACKGROUND		GCL_HBRBACKGROUND
#endif

#ifndef		GET_X_LPARAM
#define		GET_X_LPARAM(x)			((short)LOWORD(x))
#endif

#ifndef		GET_Y_LPARAM
#define		GET_Y_LPARAM(x)			((short)HIWORD(x))
#endif

#ifndef 	IDC_HAND
#define		IDC_HAND				MAKEINTRESOURCE(32649)
#endif

#ifndef 	DFCS_HOT
#define		DFCS_HOT				0x1000
#endif

#ifndef 	DSS_HIDEPREFIX
#define		DSS_HIDEPREFIX			0x0200
#endif

#ifndef 	DSS_PREFIXONLY
#define		DSS_PREFIXONLY			0x0400
#endif

#ifndef 	DFCS_MENUARROWUP
#define		DFCS_MENUARROWUP        0x0008
#endif

#ifndef 	DFCS_MENUARROWDOWN
#define		DFCS_MENUARROWDOWN      0x0010
#endif

#ifndef 	WM_XBUTTONDOWN
#define		WM_XBUTTONDOWN			0x020B
#endif

#ifndef 	WM_XBUTTONDOWN
#define		WM_XBUTTONDOWN			0x020B
#endif

#ifndef 	WM_XBUTTONUP
#define		WM_XBUTTONUP            0x020C
#endif

#ifndef 	WM_XBUTTONDBLCLK
#define		WM_XBUTTONDBLCLK        0x020D
#endif

#ifndef 	AC_SRC_ALPHA
#define		AC_SRC_ALPHA			0x01
#endif

#ifndef 	PBS_MARQUEE
#define		PBS_MARQUEE				0x08
#endif

#ifndef 	TP_DROPDOWNBUTTONGLYPH
#define		TP_DROPDOWNBUTTONGLYPH	7
#endif

#ifndef		SM_CMONITORS
#define 	SM_CMONITORS			80
#endif

#ifndef 	MENU_POPUPCHECK
#define 	MENU_POPUPCHECK			11
#endif

#ifndef 	MC_CHECKMARKNORMAL
#define 	MC_CHECKMARKNORMAL		1
#endif

#ifndef 	MC_CHECKMARKDISABLED
#define 	MC_CHECKMARKDISABLED	2
#endif

#ifndef 	MC_BULLETNORMAL
#define 	MC_BULLETNORMAL			3
#endif

#ifndef 	MC_BULLETDISABLED
#define 	MC_BULLETDISABLED		4
#endif

#ifndef 	MENU_BARBACKGROUND
#define		MENU_BARBACKGROUND		7
#endif

#ifndef 	MENU_BARITEM
#define 	MENU_BARITEM			8
#endif

#ifndef 	MENU_POPUPBACKGROUND
#define 	MENU_POPUPBACKGROUND	9
#endif

#ifndef 	MENU_POPUPBORDERS
#define 	MENU_POPUPBORDERS		10
#endif

#ifndef 	MENU_POPUPCHECK
#define 	MENU_POPUPCHECK			11
#endif

#ifndef 	MENU_POPUPCHECKBACKGROUND
#define 	MENU_POPUPCHECKBACKGROUND 12
#endif

#ifndef 	MENU_POPUPGUTTER
#define 	MENU_POPUPGUTTER		13
#endif

#ifndef 	MENU_POPUPITEM
#define 	MENU_POPUPITEM			14
#endif

#ifndef 	MENU_POPUPSEPARATOR
#define 	MENU_POPUPSEPARATOR		15
#endif

#ifndef 	MENU_POPUPSUBMENU
#define 	MENU_POPUPSUBMENU		16
#endif

#ifndef 	MENU_POPUPSUBMENU
#define 	MENU_SYSTEMCLOSE		17
#endif

#ifndef 	MENU_SYSTEMMAXIMIZE
#define 	MENU_SYSTEMMAXIMIZE		18
#endif

#ifndef 	MENU_SYSTEMMINIMIZE
#define 	MENU_SYSTEMMINIMIZE		19
#endif

#ifndef 	MENU_SYSTEMRESTORE
#define 	MENU_SYSTEMRESTORE		20
#endif

#ifndef 	MB_ACTIVE
#define 	MB_ACTIVE				1
#endif

#ifndef 	MB_INACTIVE
#define 	MB_INACTIVE				2
#endif

#ifndef 	MS_NORMAL
#define 	MS_NORMAL				1
#endif

#ifndef 	MS_SELECTED
#define 	MS_SELECTED				2
#endif

#ifndef 	MS_DEMOTED
#define 	MS_DEMOTED				3
#endif

#ifndef 	MBI_NORMAL
#define 	MBI_NORMAL				1
#endif

#ifndef 	MBI_HOT
#define 	MBI_HOT 				2
#endif

#ifndef 	MBI_PUSHED
#define 	MBI_PUSHED 				3
#endif

#ifndef 	MBI_DISABLED
#define 	MBI_DISABLED 			4
#endif

#ifndef 	MBI_DISABLEDHOT
#define 	MBI_DISABLEDHOT			5
#endif

#ifndef 	MBI_DISABLEDPUSHED
#define 	MBI_DISABLEDPUSHED		6
#endif

#ifndef 	MC_CHECKMARKNORMAL
#define 	MC_CHECKMARKNORMAL		1
#endif

#ifndef 	MC_CHECKMARKDISABLED
#define 	MC_CHECKMARKDISABLED	2
#endif

#ifndef 	MC_BULLETNORMAL
#define 	MC_BULLETNORMAL			3
#endif

#ifndef 	MC_BULLETDISABLED
#define 	MC_BULLETDISABLED		4
#endif

#ifndef 	MCB_DISABLED
#define 	MCB_DISABLED 			1
#endif

#ifndef 	MCB_NORMAL
#define 	MCB_NORMAL 				2
#endif

#ifndef 	MCB_BITMAP
#define 	MCB_BITMAP 				3
#endif

#ifndef 	MPI_NORMAL
#define 	MPI_NORMAL 				1
#endif

#ifndef 	MPI_HOT
#define 	MPI_HOT 				2
#endif

#ifndef 	MPI_DISABLED
#define 	MPI_DISABLED 			3
#endif

#ifndef 	MPI_DISABLEDHOT
#define 	MPI_DISABLEDHOT 		4
#endif

#ifndef 	MSM_NORMAL
#define 	MSM_NORMAL 				1
#endif

#ifndef 	MSM_NORMAL
#define 	MSM_NORMAL				2
#endif

#ifndef 	DFC_POPUPMENU
#define		DFC_POPUPMENU           5
#endif

#ifndef		BPBF_COMPATIBLEBITMAP
#define 	BPBF_COMPATIBLEBITMAP	0
#endif

#ifndef		TVP_GLYPH
#define		TVP_GLYPH				2
#endif

#ifndef		BP_BUTTON
#define 	BP_BUTTON    			1
#endif

#ifndef 	BP_RADIO
#define 	BP_RADIO				2
#endif

#ifndef 	BP_CHECKBOX
#define 	BP_CHECKBOX  			3
#endif

#ifndef 	TS_NORMAL
#define 	TS_NORMAL				1
#endif

#ifndef 	TS_HOT
#define 	TS_HOT					2
#endif

#ifndef 	TS_PRESSED
#define 	TS_PRESSED				3
#endif

#ifndef 	TS_DISABLED
#define 	TS_DISABLED				4
#endif

#ifndef 	TS_CHECKED
#define 	TS_CHECKED				5
#endif

#ifndef 	TS_HOTCHECKED
#define 	TS_HOTCHECKED			6
#endif

#ifndef 	TS_NEARHOT
#define 	TS_NEARHOT				7
#endif

#ifndef 	TS_OTHERSIDEHOT
#define		TS_OTHERSIDEHOT			8
#endif

#ifndef 	HP_HEADERITEM
#define		HP_HEADERITEM			1
#endif

#ifndef		HP_HEADERITEMLEFT
#define 	HP_HEADERITEMLEFT		2
#endif

#ifndef 	HP_HEADERITEMRIGHT
#define 	HP_HEADERITEMRIGHT		3
#endif

#ifndef 	HIS_NORMAL
#define		HIS_NORMAL				1
#endif

#ifndef 	HIS_HOT
#define		HIS_HOT					2
#endif

#ifndef 	HIS_PRESSED
#define		HIS_PRESSED				3
#endif

#ifndef 	PBS_NORMAL
#define 	PBS_NORMAL			 	1
#endif

#ifndef 	PBS_HOT
#define 	PBS_HOT				 	2
#endif

#ifndef 	PBS_PRESSED
#define 	PBS_PRESSED				3
#endif

#ifndef 	PBS_DISABLED
#define 	PBS_DISABLED			4
#endif

#ifndef 	PBS_DEFAULTED
#define 	PBS_DEFAULTED			5
#endif

#ifndef		GLPS_CLOSED
#define		GLPS_CLOSED				1
#endif

#ifndef		GLPS_OPENED
#define		GLPS_OPENED				2
#endif

#ifndef		BP_CHECKBOX
#define		BP_CHECKBOX				3
#endif

#ifndef		CBS_UNCHECKEDNORMAL
#define		CBS_UNCHECKEDNORMAL		1
#endif

#ifndef		CBS_UNCHECKEDHOT
#define		CBS_UNCHECKEDHOT		2
#endif

#ifndef		CBS_UNCHECKEDPRESSED
#define		CBS_UNCHECKEDPRESSED	3
#endif

#ifndef		CBS_UNCHECKEDDISABLED
#define		CBS_UNCHECKEDDISABLED	4
#endif

#ifndef		CBS_CHECKEDNORMAL
#define		CBS_CHECKEDNORMAL		5
#endif

#ifndef		CBS_CHECKEDHOT
#define		CBS_CHECKEDHOT			6
#endif

#ifndef		CBS_CHECKEDPRESSED
#define		CBS_CHECKEDPRESSED		7
#endif

#ifndef		CBS_CHECKEDDISABLED
#define		CBS_CHECKEDDISABLED		8
#endif

#ifndef		CP_DROPDOWNBUTTON
#define		CP_DROPDOWNBUTTON		1
#endif 	

#ifndef		CP_BACKGROUND
#define		CP_BACKGROUND			2
#endif 	

#ifndef		CP_BORDER                   
#define		CP_BORDER               4
#endif 	

#ifndef		CP_READONLY                   
#define		CP_READONLY             5
#endif 	

#ifndef		CP_DROPDOWNBUTTONRIGHT 
#define		CP_DROPDOWNBUTTONRIGHT 	6
#endif 	

#ifndef		CP_DROPDOWNBUTTONLEFT        
#define		CP_DROPDOWNBUTTONLEFT   7
#endif 	

#ifndef		CP_DROPDOWNBUTTON
#define		CP_DROPDOWNBUTTON		1
#endif 	

#ifndef		CBXS_NORMAL
#define 	CBXS_NORMAL        		1
#endif 	

#ifndef		CBXS_HOT
#define 	CBXS_HOT           		2
#endif 	

#ifndef		CBXS_PRESSED
#define 	CBXS_PRESSED       		3
#endif 	

#ifndef		CBXS_DISABLED
#define 	CBXS_DISABLED      		4
#endif 	

#ifndef		EP_BACKGROUND
#define 	EP_BACKGROUND      		3
#endif 	

#ifndef		EP_BACKGROUNDWITHBORDER
#define 	EP_BACKGROUNDWITHBORDER 5
#endif 	

#ifndef		KEY_WOW64_64KEY
#define		KEY_WOW64_64KEY			0x0100
#endif

#ifndef		KEY_WOW64_32KEY
#define		KEY_WOW64_32KEY			0x0200
#endif

#ifndef 	DFCS_TRANSPARENT
#define		DFCS_TRANSPARENT		0x0800
#endif

#ifndef		WM_COPYGLOBALDATA
#define 	WM_COPYGLOBALDATA		0x0049
#endif

#ifndef		WM_MOUSEWHEEL
#define		WM_MOUSEWHEEL			0x020A
#endif

#ifndef		WHEEL_DELTA
#define		WHEEL_DELTA				120
#endif

#ifndef		DC_BRUSH
#define 	DC_BRUSH				18
#endif

#ifndef		DC_PEN
#define		DC_PEN					19
#endif

#ifndef		BI_PNG
#define 	BI_PNG					5
#endif

#ifndef 	MSGFLT_ADD
#define 	MSGFLT_ADD				1
#endif

#ifndef 	MSGFLT_REMOVE
#define 	MSGFLT_REMOVE			2
#endif

#ifndef 	COLOR_HOTLIGHT
#define		COLOR_HOTLIGHT                  26
#endif

#ifndef 	COLOR_GRADIENTACTIVECAPTION
#define		COLOR_GRADIENTACTIVECAPTION     27
#endif

#ifndef 	COLOR_GRADIENTINACTIVECAPTION
#define		COLOR_GRADIENTINACTIVECAPTION   28
#endif

#ifndef		PROCESS_QUERY_LIMITED_INFORMATION
#define		PROCESS_QUERY_LIMITED_INFORMATION	0x1000
#endif

#ifndef 	MB_CANCELTRYCONTINUE
#define 	MB_CANCELTRYCONTINUE	0x06
#endif 		

#ifndef 	MB_DEFBUTTON4
#define 	MB_DEFBUTTON4           0x00000300
#endif 		
 
#ifndef 	MB_DEFBUTTON5
#define 	MB_DEFBUTTON5           0x00000400
#endif 		

#ifndef 	MB_DEFBUTTON6
#define 	MB_DEFBUTTON6           0x00000500
#endif 		

#ifndef		IDTRYAGAIN
#define		IDTRYAGAIN          	10
#endif
 
#ifndef		IDCONTINUE
#define		IDCONTINUE				11
#endif
 
#ifndef		IDALWAYS
#define		IDALWAYS          		13
#endif
 
#ifndef		IDNEVER
#define		IDNEVER					15
#endif
 
#ifndef		IDTIMEOUT
#define		IDTIMEOUT				16
#endif

#ifndef 	COLOR_MENUICON
#define 	COLOR_MENUICON			31
#endif

#ifndef	   _WIN64
#ifndef		SetClassLongPtr
#define		SetClassLongPtr			SetClassLong
#endif
#ifndef		GetClassLongPtr
#define		GetClassLongPtr			GetClassLong
#endif
#ifndef		SetWindowLongPtr
#define		SetWindowLongPtr		SetWindowLong
#endif
#ifndef		GetWindowLongPtr
#define		GetWindowLongPtr		GetWindowLong
#endif
#ifndef		DWORD_PTR
#define		DWORD_PTR				DWORD
#endif
#ifndef		PULONG_PTR
#define		PULONG_PTR				PULONG
#endif
#ifndef		ULONG_PTR
#define		ULONG_PTR				ULONG
#endif
#ifndef		LONG_PTR
#define		LONG_PTR				LONG
#endif
#ifndef		UINT_PTR
#define		UINT_PTR				UINT
#endif
#ifndef		INT_PTR
#define		INT_PTR					INT
#endif
#endif

#ifndef		QWORD_DEFINED
#define		QWORD_DEFINED
typedef		unsigned __int64		QWORD;
#endif

#ifdef		_WINBASE_
#define 	LockResource(a)			((LPVOID)(a))
#endif

#if !defined(_WIN32_WINNT) || (_WIN32_WINNT<0x0500)
EXTAPI	DECLSPEC_IMPORT COLORREF WINAPI SetDCPenColor  (HDC hDc,COLORREF uColor);
EXTAPI	DECLSPEC_IMPORT COLORREF WINAPI SetDCBrushColor(HDC hDc,COLORREF uColor);
#endif


typedef	LPVOID	HDCEX;
typedef	LPVOID	HPENEX;

//*****************************************************************************
//*
//*		Draw-Funktionen
//*
//*****************************************************************************

EXTAPI  COLORREF	WINAPI  GetThemeColorEx  (unsigned uMode);
EXTAPI	INT			WINAPI  GetFontHeight	 (HWND hWnd,HFONT hFont);
EXTAPI  UINT		WINAPI  GetDefaultSize   (int *pWidth=NULL,int *pHeight=NULL,UINT uFont=0);
EXTAPI	HFONT		WINAPI	GetDefaultFont   (UINT uFont=0);
EXTAPI	HFONT		WINAPI	GetCachedFontA	 (LPLOGFONTA pLog);
EXTAPI	HFONT		WINAPI	GetCachedFontW	 (LPLOGFONTW pLog);
EXTAPI  HFONT		WINAPI  GetFixedFont	 (HFONT  hFont);
EXTAPI	HFONT		WINAPI	GetBoldFont		 (HFONT  hFont);
EXTAPI	BOOL		WINAPI	GetDrawSize      (INT    iMode,LPSIZE pSize);
EXTAPI	BOOL		WINAPI  GetCurrentThemeA (LPSTR  pName,int iMax);
EXTAPI	BOOL		WINAPI	GetCurrentThemeW (LPWSTR pName,int iMax);
EXTAPI	BOOL		WINAPI	GetTextExtentExA (HDC hDc,LPCSTR  pString,int iCount,int iMaxExtent,LPINT pFit,LPINT pPixelPos,LPSIZE pSize,CONST BYTE *pIndex,CONST HFONT *pFonts);
EXTAPI	BOOL		WINAPI	GetTextExtentExW (HDC hDc,LPCWSTR pString,int iCount,int iMaxExtent,LPINT pFit,LPINT pPixelPos,LPSIZE pSize,CONST BYTE *pIndex,CONST HFONT *pFonts);
EXTAPI	DWORD		WINAPI	GetTabbedSizeExA (HDC hDc,INT iPosX,LPCSTR  pText,CONST BYTE *pColors,INT iCount,INT iTabCnt,CONST INT *pTabs,INT iOrigin,HFONT *pFonts);
EXTAPI	DWORD		WINAPI	GetTabbedSizeExW (HDC hDc,INT iPosX,LPCWSTR pText,CONST BYTE *pColors,INT iCount,INT iTabCnt,CONST INT *pTabs,INT iOrigin,HFONT *pFonts);
EXTAPI	DWORD		WINAPI	CalcTextSizeA	 (HDC hDc,LPCSTR  pString,INT iCount,UINT uFlags,LPVOID pData);
EXTAPI	DWORD		WINAPI	CalcTextSizeW	 (HDC hDc,LPCWSTR pString,INT iCount,UINT uFlags,LPVOID pData);
EXTAPI	INT     	WINAPI	DrawTextColorA   (HDC hDc,LPCSTR  pString,int iCount,LPRECT pRect,UINT uFormat,CONST BYTE *pIndex,CONST COLORREF *pColors,CONST HFONT *pFonts);
EXTAPI	INT	    	WINAPI	DrawTextColorW   (HDC hDc,LPCWSTR pString,int iCount,LPRECT pRect,UINT uFormat,CONST BYTE *pIndex,CONST COLORREF *pColors,CONST HFONT *pFonts);
EXTAPI	INT			WINAPI	ExtTextColorA    (HDC hDc,int iPosX,int iPosY,UINT uOptions,CONST RECT *pRect,LPCSTR  pString,int iCount,CONST BYTE *pIndex,CONST COLORREF *pColors,CONST HFONT *pFonts);
EXTAPI	INT			WINAPI	ExtTextColorW    (HDC hDc,int iPosX,int iPosY,UINT uOptions,CONST RECT *pRect,LPCWSTR pString,int iCount,CONST BYTE *pIndex,CONST COLORREF *pColors,CONST HFONT *pFonts);
EXTAPI	COLORREF	WINAPI	SelectBkColorEx  (HDC hDc                    ,UINT uOptions,BYTE bIndex,CONST COLORREF *pColors);
EXTAPI	COLORREF	WINAPI	SelectTextColorEx(HDC hDc                    ,UINT uOptions,BYTE bIndex,CONST COLORREF *pColors);
EXTAPI	VOID		WINAPI	DrawFlatButtonEx (HDC hDc,INT iPosX,INT iPosY,INT iSizeX,int iSizeY,UINT uFlags);
EXTAPI	BOOL		WINAPI	DrawGrayTextA	 (HDC hDc,LPCSTR  pText,INT iCount,LPCRECT pRect,UINT uFlags);
EXTAPI	BOOL		WINAPI	DrawGrayTextW	 (HDC hDc,LPCWSTR pText,INT iCount,LPCRECT pRect,UINT uFlags);
EXTAPI	VOID		WINAPI	DrawCheckBoxW    (HDC hDc,LPCWSTR pText,LPCRECT pRect,int iState,int iFrame);
EXTAPI  VOID		WINAPI  DrawMenuItemW	 (HDC hDc,LPCWSTR pText,LPCRECT pRect,int iState,LPVOID hList,int iIndex);
EXTAPI	VOID		WINAPI  DrawThemeBack	 (HDC hDc,LPARAM  uType,LPCRECT pRect,int iState,int iFrame);
EXTAPI  VOID		WINAPI  DrawCbButton     (HDC hDc              ,LPCRECT pRect,int iState,int iFrame);
EXTAPI	VOID		WINAPI	DrawButtonW      (HDC hDc,LPCWSTR pText,LPCRECT pRect,int iState,int iFrame);
EXTAPI	VOID		WINAPI	DrawRadioW       (HDC hDc,LPCWSTR pText,LPCRECT pRect,int iState,int iFrame);
EXTAPI  VOID		WINAPI	DrawGlyph		 (HDC hDc,LPCRECT pRect,int iState,int iFrame);

//*****************************************************************************
//*
//*		GDI-Funktionen
//*
//*****************************************************************************

EXTAPI  BOOL		WINAPI GdiPlusInit();
EXTAPI  BOOL		WINAPI GdiPlusExit();
EXTAPI  HDCEX		WINAPI GetDcEx    (HDC    hDc);
EXTAPI  BOOL		WINAPI ReleaseDcEx(HDCEX  hDc);
EXTAPI  BOOL		WINAPI DeletePenEx(HPENEX hPen);
EXTAPI  HPENEX		WINAPI CreatePenEx(int    iWidth,COLORREF uColor);
EXTAPI  BOOL		WINAPI DrawLine   (HDCEX  hDc,LPVOID hPen,INT iPosX1,INT iPosY1,INT iPosX2,INT iPosY2);
EXTAPI  BOOL		WINAPI DrawEllipse(HDCEX  hDc,LPVOID hPen,INT iPosX,INT iPosY,INT iWidth,INT iHeight);

//*****************************************************************************
//*
//*		DIB-Funktionen
//*
//*****************************************************************************
EXTAPI  COLORREF	 WINAPI DibColorDefault	   (COLORREF     uColor);
EXTAPI	BOOL         WINAPI DibFreeHandle      (LPBITMAPINFO pInfo);
EXTAPI	HBITMAP      WINAPI DibGetBitmap       (LPBITMAPINFO pInfo);
EXTAPI  HDC			 WINAPI DibGetMemDC		   (LPBITMAPINFO pInfo);
EXTAPI  BOOL		 WINAPI DibDelMemDC		   (LPBITMAPINFO pInfo);
EXTAPI	LPVOID       WINAPI DibGetPixels       (LPBITMAPINFO pInfo);
EXTAPI	LPVOID       WINAPI DibGetPixelsEx     (LPBITMAPINFO pInfo,HDC *pDc);
EXTAPI	BOOL         WINAPI DibConvertDefault  (LPBITMAPINFO pInfo,LPVOID pPixels);
EXTAPI	BOOL         WINAPI DibConvertGrayScale(LPBITMAPINFO pInfo,LPVOID pPixels,UINT uBase,UINT uIgnore);
EXTAPI	BOOL         WINAPI DibConvertMask     (LPBITMAPINFO pInfo,LPVOID pPixels,LPBYTE pMask,COLORREF uColor);
EXTAPI	BOOL         WINAPI DibSaveImageA      (LPBITMAPINFO pInfo,LPVOID pPixels,LPCSTR  pFilename,BOOL bOverWrite);
EXTAPI	BOOL		 WINAPI DibSaveImageExA	   (                  HBITMAP hBitmap,LPCSTR  pFilename,BOOL bOverWrite);
EXTAPI	BOOL         WINAPI DibSaveImageW      (LPBITMAPINFO pInfo,LPVOID pPixels,LPCWSTR pFilename,BOOL bOverWrite);
EXTAPI	BOOL		 WINAPI DibSaveImageExW	   (                  HBITMAP hBitmap,LPCWSTR pFilename,BOOL bOverWrite);
EXTAPI	BOOL         WINAPI DibConvertColor    (LPBITMAPINFO pInfo,LPVOID pPixels,COLORREF uColorFrom,COLORREF uColorTo);
EXTAPI	BOOL		 WINAPI DibCopyImage       (LPBITMAPINFO pInfo,LPVOID pPixels,UINT uPosX,UINT uPosY,LPBITMAPINFO pTarget);
EXTAPI	BOOL		 WINAPI	DibCopyImageEx	   (LPBITMAPINFO pInfo,LPVOID pPixels,UINT uPosX,UINT uPosY,UINT uFromX,UINT uFromY,UINT uSizeX,UINT uSizeY,LPBITMAPINFO pTarget);
EXTAPI	BOOL		 WINAPI DibConvertSizeEx   (LPBITMAPINFO pInfo,LPVOID pPixels,LPBITMAPINFO pFrom,LPVOID pInput ,UINT uFromX,UINT uFromY,UINT uBaseX,UINT uBaseY,UINT uPosX,UINT uPosY,UINT uSizeX,UINT uSizeY);
EXTAPI	BOOL		 WINAPI DibConvertSmoth	   (LPBITMAPINFO pInfo,LPVOID pPixels,UINT uPosX,UINT uPosY,UINT uBoxX,UINT uBoxY);
EXTAPI	BOOL		 WINAPI DibPutAlphaEx	   (LPBITMAPINFO pInfo,LPVOID pPixels,UINT uPosX,UINT uPosY,LPBITMAPINFO pFrom,LPVOID pInput,UINT uFromX,UINT uFromY,UINT uSizeX,UINT uSizeY);
EXTAPI	BOOL		 WINAPI DibConvertLowerLeft(LPBITMAPINFO pInfo,LPVOID pPixels,COLORREF uColor,UINT uPosX,UINT uPosY);
EXTAPI	BOOL         WINAPI DibConvertAlpha    (LPBITMAPINFO pInfo,LPVOID pPixels,COLORREF uColor);
EXTAPI	COLORREF	 WINAPI DibGetUpperLeft	   (LPBITMAPINFO pInfo,LPVOID pPixels);
EXTAPI  LPBITMAPINFO WINAPI GetDibOfIcon	   (HDC hDc,HICON   hIcon  ,LPVOID pPixels,COLORREF uColor);
EXTAPI	LPBITMAPINFO WINAPI GetDibOfBitmap     (HDC hDc,HBITMAP hBitmap,LPVOID pPixels);
EXTAPI	LPBITMAPINFO WINAPI GetDibOfBitmapEx   (HDC hDc,HBITMAP hBitmap,INT iPosX,INT iPosY,INT iSizeX,INT iSizeY,UINT uBits,LPVOID pPixels);
EXTAPI	HBITMAP      WINAPI CreateDibOfMemory  (HDC hDc,CONST LPVOID pMemory,LPVOID pPixelData,DWORD uFlags);
EXTAPI	LPBITMAPINFO WINAPI CreateDibIndirect  (HDC hDc,int iSizeX,int iSizeY,UINT uBits,LPVOID pPixels);
EXTAPI	LPBITMAPINFO WINAPI GetDibOfMemory     (HDC hDc,LPVOID  pMemory,DWORD uFlags,LPVOID pPixels);
EXTAPI	LPBITMAPINFO WINAPI GetDibOfPng        (HDC hDc,LPVOID  pMemory,UINT uSize,DWORD uFlags,LPVOID pPixels);
EXTAPI	LPBITMAPINFO WINAPI GetDibOfResourceA  (HDC hDc,HMODULE hModule,LPCSTR  pName,LPCSTR  pType,DWORD uFlags,LPVOID pPixels);
EXTAPI	LPBITMAPINFO WINAPI GetDibOfResourceW  (HDC hDc,HMODULE hModule,LPCWSTR pName,LPCWSTR pType,DWORD uFlags,LPVOID pPixels);
EXTAPI  BOOL		 WINAPI GetBitmapInfoEx    (HBITMAP hBitmap,LPBITMAPINFO pData,UINT uColors);
EXTAPI  BOOL		 WINAPI GetBitmapInfo      (HBITMAP hBitmap,LPINT  pSizeX,LPINT pSizeY,LPINT pBits);
EXTAPI	BOOL		 WINAPI GetBitmapInfoSz    (HBITMAP hBitmap,LPSIZE pSize ,LPINT pBits);

//*****************************************************************************
//*
//*		Version und Zugriff
//*
//*****************************************************************************
EXTAPI DWORD		 WINAPI GetWindowsVersionEx ();
EXTAPI DWORD		 WINAPI GetWindowsVersion   ();
EXTAPI VOID			 WINAPI WinWowRedirect      (INT iMode);
EXTAPI BOOL			 WINAPI IsRunAsAdministrator();
EXTAPI BOOL			 WINAPI HasAdminPrivilege   (HANDLE hToken D(=0));
EXTAPI BOOL			 WINAPI TakeOwnershipA      (LPCVOID pObject,UINT uAccess,UINT uType D(=1));
EXTAPI BOOL			 WINAPI TakeOwnershipW      (LPCVOID pObject,UINT uAccess,UINT uType D(=1));
EXTAPI INT			 WINAPI GetOwnerA           (LPCVOID pHandle,UINT uType,LPSTR  pOwner,INT iOwnerSize D(=64),LPSTR  pDomain D(=0),INT iDomainSize D(=0));
EXTAPI INT			 WINAPI GetOwnerW           (LPCVOID pHandle,UINT uType,LPWSTR pOwner,INT iOwnerSize D(=64),LPWSTR pDomain D(=0),INT iDomainSize D(=0));
EXTAPI INT			 WINAPI IsWin64Bit          ();
EXTAPI INT			 WINAPI GetDomainNameA      (LPSTR  pBuffer,INT iSize,INT iMode D(=2));
EXTAPI INT			 WINAPI GetDomainNameW      (LPWSTR pBuffer,INT iSize,INT iMode D(=2));
EXTAPI DWORD         WINAPI GetProcessFileNameA (DWORD uId,LPSTR  pFilename,int iSize);
EXTAPI DWORD         WINAPI GetProcessFileNameW (DWORD uId,LPWSTR pFilename,int iSize);


//*****************************************************************************
//*
//*		Diverse Funktionen
//*
//*****************************************************************************
EXTAPI INT			WINAPI MessageBoxIndirectExA(CONST MSGBOXPARAMSA *pParams,CONST BYTE *pColPtr D(=0),UINT uTimeout D(=0));
EXTAPI INT			WINAPI MessageBoxIndirectExW(CONST MSGBOXPARAMSW *pParams,CONST BYTE *pColPtr D(=0),UINT uTimeout D(=0));
EXTAPI LPCSTR		WINAPI LoadDefaultStringsA(HINSTANCE hInstance,UINT uId,LPINT pSize D(=0));
EXTAPI LPCWSTR		WINAPI LoadDefaultStringsW(HINSTANCE hInstance,UINT uId,LPINT pSize D(=0));

//*****************************************************************************
//*
//*		DrawRectangle
//*
//*****************************************************************************
//	DrawRectangle zeichnet Rechtecke, die Farbe wird mit SetBkColor(...) eingestellt.
//	hDc			: Device-Context in dem gezeichnet wird
//	iPosX/Y		: Linke obere Ecke vom Beginn des Rechtecks
//	iSizeX/Y	: Breite des Rechtecks in Pixel
static EXTINL void DrawRectangle(HDC hDc,int iPosX,int iPosY,int iSizeX,int iSizeY)
	{
	RECT	sArea;
	sArea.left	 = iPosX;
	sArea.top	 = iPosY;
	sArea.right	 = iPosX+iSizeX;
	sArea.bottom = iPosY+iSizeY;
	ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);
	}


//*****************************************************************************
//*
//*		DrawRectangleEx
//*
//*****************************************************************************
//	DrawRectangleEx zeichnet Rechtecke, die Farbe wird mit SetBkColor(...) eingestellt.
//	hDc			: Device-Context in dem gezeichnet wird
//	iPosX/Y		: Start Ecke des Rechtecks
//	iSizeX/Y	: Breite des Rechtecks in Pixel (Plus/Minus sind erlaubt).
static EXTINL void DrawRectangleEx(HDC hDc,int iPosX,int iPosY,int iSizeX,int iSizeY)
	{
	RECT	sArea;

	if(iSizeX==0 || iSizeY==0)return;

	sArea.left	 = iPosX;
	sArea.top	 = iPosY;
	sArea.right	 = iPosX;
	sArea.bottom = iPosY;

	if(iSizeX>0)
			sArea.right +=iSizeX;
	else	sArea.left  +=iSizeX;

	if(iSizeY>0)
			sArea.bottom+=iSizeY;
	else	sArea.top   +=iSizeY;

	ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);
	}


//*****************************************************************************
//*
//*		DrawRectanglePtr
//*
//*****************************************************************************
//	DrawRectangleEx zeichnet Rechtecke, die Farbe wird mit SetBkColor(...) eingestellt.
//	hDc			: Ist der Gerte-Context
//	iPosX/Y		: Start Ecke des Rechtecks
//	iSizeX/Y	: Breite des Rechtecks in Pixel (Plus/Minus sind erlaubt).
static EXTINL void DrawRectanglePtr(HDC hDc,LPCRECT pRect)
	{
	ExtTextOutW(hDc,0,0,ETO_OPAQUE,pRect,NULL,0,NULL);
	}

//*****************************************************************************
//*
//*		DrawRectangleEx
//*
//*****************************************************************************
//	Zeichnet ein Glyph-Objekt mit bzw. ohne Windows-Thema.
//	hDc			: Device-Context in dem gezeichnet wird
//	iPosX/Y		: Start Ecke des Rechtecks
//	iSizeX/Y	: Breite des Rechtecks in Pixel (Plus/Minus sind erlaubt).
//	iState		: Wie soll die Taste gezeichnet werden:
//					GLPS_CLOSED				1		Glyph mit +
//					GLPS_OPENED 			2		Glyph mit -
//					MC_CHECKMARKNORMAL		1		Haken normal
//					MC_CHECKMARKDISABLED	2		Haken gesperrt
//					MC_BULLETNORMAL			3		Kugel normal
//					MC_BULLETDISABLED		4		Kugel gesperrt
//					TS_NORMAL				1		Dropdown normal
//					TS_HOT					2		Dropdown hervorgehoben
//					TS_PRESSED				3		Dropdown gedrckt
//					TS_DISABLED				4		Dropdown gesperrt
//					TS_CHECKED				5		Dropdown gedrckt
//					TS_HOTCHECKED			6		Dropdown hervorgehoben und gedrckt
//					TS_NEARHOT				7		Dropdown hervorgehoben
//					TS_OTHERSIDEHOT			8		Dropdown hervorgehoben auerhalb
//					DG_GLYPH				0x0000  Glyph fr Treelist
//					DG_MENU  				0x0010  Glyph fr Menus
//					DG_DROPDOWN  			0x0020  Glyph fr Dropdown
//					DG_BACKGROUND  			0x0200  Hintergrund zeichnen
//					DG_USENOTHEMA  			0x0400  Keinen Windows-Tema verwenden
//					DG_HASYDELTA  			0x0800  Fr die Y-Richtung gibt es ein extra Delta
static EXTINL void DrawGlyphEx(HDC hDc,int iPosX,int iPosY,int iSizeX,int iSizeY,int iState)
	{
	RECT	sArea;
	sArea.left	 = iPosX;
	sArea.top	 = iPosY;
	sArea.right	 = iPosX+iSizeX;
	sArea.bottom = iPosY+iSizeY;
	DrawGlyph(hDc,&sArea,iState,0);
	}


//*****************************************************************************
//*
//*		DrawCbButtonEx
//*
//*****************************************************************************
//	Zeichnet eine Taste fr eine ComboBox mit bzw. ohne Windows-Thema.
//	hDc			: Device-Context in dem gezeichnet wird
//	iPosX/Y		: Start Ecke des Rechtecks
//	iSizeX/Y	: Breite des Rechtecks in Pixel (Plus/Minus sind erlaubt).
//	iState		: Wie soll die Taste gezeichnet werden
//					CBXS_NORMAL      1		Taste normal zeichnen
//					CBXS_HOT         2		Maus ist ber der Taste
//					CBXS_PRESSED     3		Taste ist gedrckt
//					CBXS_DISABLED    4		Taste ist gesperrt
//					DB_USENOTHEMA	0x0400	Keinen Windows-Tema verwenden
//	iFrame		: Gre des Rahmens um die Taste in Pixeln. Das Rechteck fr
//				  die Taste wird um diese Pixelanzahl verkleinert.
static EXTINL void DrawCbButtonEx(HDC hDc,int iPosX,int iPosY,int iSizeX,int iSizeY,int iState,int iFrame)
	{
	RECT	sArea;
	sArea.left	 = iPosX;
	sArea.top	 = iPosY;
	sArea.right	 = iPosX+iSizeX;
	sArea.bottom = iPosY+iSizeY;
	DrawCbButton(hDc,&sArea,iState,iFrame);
	}


//*****************************************************************************
//*
//*		DrawFlatButton
//*
//*****************************************************************************
//	Zeichnet eine Taste mit einem ein Pixel breiten Rahmen.
//	hDc			: Gerte DC auf dem gezeichnet wird.
//	iPosX/Y		: Ist die Position der Taste.
//	iSizeX/Y	: Ist die Breite und Hhe der Taste.
//	uFlags		: Bestimmt die Ausgabeart:
//						PFB_PRESSED	0x00000001	Taste gedrckt zeichnen
//						PFB_FILLED	0x00000002	Taste gefllt zeichnen
//						PFB_HOT		0x00000004	Taste etwas dunkler fllen
//						PFB_MONO	0x00000008	Den Rahmen einfarbig zeichnen
static EXTINL void DrawFlatButton(HDC hDc,LPCRECT pRect,UINT uFlags)
	{
	DrawFlatButtonEx(hDc,pRect->left,pRect->top,pRect->right-pRect->left,pRect->bottom-pRect->top,uFlags);
	}


//*****************************************************************************
//*
//*		DrawButton
//*
//*****************************************************************************
//	Zeichnet eine Taste mit bzw. ohne WindowsThema.
//	hDc			: Device-Context in dem gezeichnet wird
//	pText		: Text fr die Taste (bei 0 wird kein Text gezeichnet)
//	pRect		: Wo soll die Taste gezeichnet werden
//	iState		: Wie soll die Taste gezeichnet werden
//					PBS_NORMAL      1		Taste normal zeichnen
//					PBS_HOT         2		Maus ist ber der Taste
//					PBS_PRESSED     3		Taste ist gedrckt
//					PBS_DISABLED    4		Taste ist gesperrt
//					PBS_DEFAULTED   5		Taste ist die Standarttaste
//					DB_ANSITEXT		0x0100	Der Text ist kein UNICODE
//					DB_BACKGROUND	0x0200	Hintergrund zeichnen
//					DB_USENOTHEMA	0x0400	Keinen Windows-Tema verwenden
//					DB_HASYDELTA	0x0800	Fr die Y-Richtung gibt es ein extra Delta
//					DB_TEXTLEFT(a)			Den Text links ausrichten bei Offset a
//	iFrame		: Gre des Rahmens um das Rechteck in Pixeln.
static EXTINL void DrawButtonA(HDC hDc,LPCSTR pText,LPCRECT pRect,int iState,int iFrame)
	{
	DrawButtonW(hDc,(LPCWSTR)pText,pRect,iState|DB_ANSITEXT,iFrame);
	}


//*****************************************************************************
//*
//*		DrawMenuItem
//*
//*****************************************************************************
//	Zeichnet einen Popup-Men-Eintrag mit bzw. ohne Windows-Thema.
//	hDc			: Device-Context in dem gezeichnet wird
//	pText		: Text fr den Eintrag (bei 0 wird kein Text gezeichnet)
//	pRect		: Wo soll der Eintrag gezeichnet werden
//	hList		: Icon-Liste fr das Icon das gezeichnet werden soll
//	iIndex		: Index der des Icons das gezeichnet werden soll
//				  Bei -1 wird kein Icon gezeichnet
//				  Bei -2 ist hList ein HBITMAP-Handle
//				  Bei -3 einen Haken zeichnen
//				  Bei -4 ein Radio-Button zeichnen
//	iState		: Wie soll die Taste gezeichnet werden
//					MPI_NORMAL      1		Eintrag normal zeichnen
//					MPI_HOT         2		Eintrag mit Maus ber dem Feld
//					MPI_DISABLED    3		Eintrag ist gesperrt
//					MPI_DISABLEDHOT 4		Eintrag ist gesperrt Eintrag
//					DM_ANSITEXT		0x0100	Der Text ist kein UNICODE
//					DM_BACKGROUND	0x0200	Hintergrund zeichnen
//					DM_USENOTHEMA	0x0400	Keinen Windows-Tema verwenden
//					DM_TEXTCENTER	0x4000	Den Text mittig ausrichten
//					DM_TEXTRIGHT	0x8000	Den Text rechts ausrichten
//					DM_TEXTLEFT(a)			Den Text links ausrichten bei Offset a
static EXTINL void WINAPI DrawMenuItemA(HDC hDc,LPCWSTR pText,LPCRECT pRect,int iState,LPVOID hList,int iIndex)
	{
	DrawMenuItemW(hDc,(LPCWSTR)pText,pRect,iState|DM_ANSITEXT,hList,iIndex);
	}

//*****************************************************************************
//*
//*		DrawCheckBox
//*
//*****************************************************************************
//	Zeichnet eine Checkbox mit Text mit bzw. ohne Windows-Thema.
//	hDc			: Device-Context in dem gezeichnet wird
//	pText		: Text fr die Taste (bei 0 wird kein Text gezeichnet)
//	pRect		: Wo soll die Taste gezeichnet werden
//	iState		: Wie soll die Taste gezeichnet werden
//					CBS_UNCHECKEDNORMAL	  1	Taste normal und zeichnen
//					CBS_UNCHECKEDHOT	  2 Taste hervorgehoben zeichnen
//					CBS_UNCHECKEDPRESSED  3 Taste gedrckt zeichnen
//					CBS_UNCHECKEDDISABLED 4	Taste gesperrt zeichnen
//					CBS_CHECKEDNORMAL     5	Taste normal und selektiert zeichnen
//					CBS_CHECKEDHOT		  6	Taste hervorgehoben und selektiert zeichnen
//					CBS_CHECKEDPRESSED	  7 Taste gedrckt und selektiert zeichnen
//					CBS_CHECKEDDISABLED   8 Taste gesperrt und selektiert zeichnen
//					DC_ANSITEXT		 0x0100	Der Text ist kein UNICODE
//					DC_BACKGROUND	 0x0200	Hintergrund zeichnen
//					DC_USENOTHEMA	 0x0400	Keinen Windows-Tema verwenden
//					DC_HASYDELTA	 0x0800	Fr die Y-Richtung gibt es ein extra Delta
//					DC_ANSIFONT		 0x1000	Den ANSI_VAR_FONT benutzen
//					DC_DEFAULTFONT	 0x2000	Den Standart-Font benutzen
//					DC_TEXTLEFT(a)			Den Text links ausrichten bei Offset a
//	iFrame		: Gre des Rahmens um die Taste in Pixeln. Das Rechteck fr
//				  die Checkbox wird um diese Pixelanzahl verkleinert.
static EXTINL void DrawCheckBoxA(HDC hDc,LPCSTR pText,LPCRECT pRect,int iState,int iFrame)
	{
	DrawCheckBoxW(hDc,(LPCWSTR)pText,pRect,iState|DC_ANSITEXT,iFrame);
	}

//*****************************************************************************
//*
//*		DrawRadio
//*
//*****************************************************************************
//	Zeichnet einen Radio-Button mit Text mit bzw. ohne Windows-Thema.
//	hDc			: Device-Context in dem gezeichnet wird
//	pText		: Text fr die Taste (bei 0 wird kein Text gezeichnet)
//	pRect		: Wo soll die Taste gezeichnet werden
//	iState		: Wie soll die Taste gezeichnet werden
//					RBS_UNCHECKEDNORMAL	  1	Taste normal und zeichnen
//					RBS_UNCHECKEDHOT	  2 Taste hervorgehoben zeichnen
//					RBS_UNCHECKEDPRESSED  3 Taste gedrckt zeichnen
//					RBS_UNCHECKEDDISABLED 4	Taste gesperrt zeichnen
//					RBS_CHECKEDNORMAL     5	Taste normal und selektiert zeichnen
//					RBS_CHECKEDHOT		  6	Taste hervorgehoben und selektiert zeichnen
//					RBS_CHECKEDPRESSED	  7 Taste gedrckt und selektiert zeichnen
//					RBS_CHECKEDDISABLED   8 Taste gesperrt und selektiert zeichnen
//					DR_ANSITEXT		 0x0100	Der Text ist kein UNICODE
//					DR_BACKGROUND	 0x0200	Hintergrund zeichnen
//					DR_USENOTHEMA	 0x0400	Keinen Windows-Tema verwenden
//					DR_HASYDELTA	 0x0800	Fr die Y-Richtung gibt es ein extra Delta
//					DR_ANSIFONT		 0x1000	Den ANSI_VAR_FONT benutzen
//					DR_DEFAULTFONT	 0x2000	Den Standart-Font benutzen
//					DR_TEXTLEFT(a)			Den Text links ausrichten bei Offset a
//	iFrame		: Gre des Rahmens um die Taste in Pixeln. Das Rechteck fr
//				  die Checkbox wird um diese Pixelanzahl verkleinert.
static EXTINL void DrawRadioA(HDC hDc,LPCSTR pText,LPCRECT pRect,int iState,int iFrame)
	{
	DrawRadioW(hDc,(LPCWSTR)pText,pRect,iState|DR_ANSITEXT,iFrame);
	}


//*****************************************************************************
//*
//*		DrawFrame
//*
//*****************************************************************************
//	DrawRectangle zeichnet einen Rahmen um ein Rechteck.
//	hDc			: Device-Context in dem gezeichnet wird
//	pFrame		: Ist das uere Rechteck
//	pRect		: Ist das innere Rechteck
static EXTINL void DrawFrame(HDC hDc,LPCRECT pFrame,LPRECT pRect)
	{
	RECT	sArea;

	if(pFrame->top<pRect->top)
		{
		sArea.top	 = pFrame->top;
		sArea.left	 = pFrame->left;
		sArea.right	 = pFrame->right;
		sArea.bottom = pRect ->top;
		DrawRectanglePtr(hDc,&sArea);
		}

	if(pFrame->bottom>pRect->bottom)
		{
		sArea.top	 = pRect ->bottom;
		sArea.left	 = pFrame->left;
		sArea.right	 = pFrame->right;
		sArea.bottom = pFrame->bottom;
		DrawRectanglePtr(hDc,&sArea);
		}

	if(pFrame->left<pRect->left)
		{
		sArea.top	 = pRect ->top;
		sArea.left	 = pFrame->left;
		sArea.right	 = pRect ->left;
		sArea.bottom = pRect ->bottom;
		DrawRectanglePtr(hDc,&sArea);
		}

	if(pFrame->right>pRect->right)
		{
		sArea.top	 = pRect ->top;
		sArea.left	 = pRect ->right;
		sArea.right	 = pFrame->right;
		sArea.bottom = pRect ->bottom;
		DrawRectanglePtr(hDc,&sArea);
		}
	}


//*****************************************************************************
//*
//*		DrawFrameEx
//*
//*****************************************************************************
//	DrawRectangle zeichnet einen Rahmen um ein Rechteck.
//	Das innere Rechteck kann dabei verndert werden.
//	hDc			: Device-Context in dem gezeichnet wird
//	pFrame		: Ist das uere Rechteck
//	pRect		: Ist das innere Rechteck
//	iDelta		: Pixel um die das innere Rechteck verkleinert wird
static EXTINL void DrawFrameEx(HDC hDc,LPCRECT pFrame,LPCRECT pRect,int iDelta)
	{
	RECT	sArea;

	sArea.bottom = pRect->top+iDelta;

	if(pFrame->top<sArea.bottom)
		{
		sArea.top	 = pFrame->top;
		sArea.left	 = pFrame->left;
		sArea.right	 = pFrame->right;
		DrawRectanglePtr(hDc,&sArea);
		}

	sArea.top = pRect ->bottom-iDelta;

	if(pFrame->bottom>sArea.top)
		{
		sArea.left	 = pFrame->left;
		sArea.right	 = pFrame->right;
		sArea.bottom = pFrame->bottom;
		DrawRectanglePtr(hDc,&sArea);
		}

	sArea.right = pRect->left+iDelta;

	if(pFrame->left<sArea.right)
		{
		sArea.top	 = pRect ->top   +iDelta;
		sArea.bottom = pRect ->bottom-iDelta;
		sArea.left	 = pFrame->left;
		DrawRectanglePtr(hDc,&sArea);
		}

	sArea.left = pRect->right-iDelta;

	if(pFrame->right>sArea.left)
		{
		sArea.top	 = pRect ->top   +iDelta;
		sArea.bottom = pRect ->bottom-iDelta;
		sArea.right	 = pFrame->right;
		DrawRectanglePtr(hDc,&sArea);
		}
	}


//*****************************************************************************
//*
//*		DrawTextDummyA
//*
//*****************************************************************************
static EXTINL INT DrawTextDummyA(HDC hDc,LPCSTR pText,INT iCount,LPRECT pRect,UINT uFlags)
	{
    DRAWTEXTPARAMS sParams;

    sParams.cbSize			= sizeof(sParams);
    sParams.iLeftMargin		= 0;
    sParams.iRightMargin	= 0;
    sParams.uiLengthDrawn	= 0;

    if(uFlags&DT_TABSTOP)
		{
        sParams.iTabLength	= (BYTE)(uFlags>>8);
        uFlags             &= 0xFFFF00FF;
		}
    else{
        sParams.iTabLength	= 0;
		}

	return DrawTextExA(hDc,(LPSTR)pText,iCount,pRect,uFlags,&sParams);
	}

static EXTINL INT DrawTextDummyW(HDC hDc,LPCWSTR pText,INT iCount,LPRECT pRect,UINT uFlags)
	{
    DRAWTEXTPARAMS sParams;

    sParams.cbSize			= sizeof(sParams);
    sParams.iLeftMargin		= 0;
    sParams.iRightMargin	= 0;
    sParams.uiLengthDrawn	= 0;

    if(uFlags&DT_TABSTOP)
		{
        sParams.iTabLength	= (BYTE)(uFlags>>8);
        uFlags             &= 0xFFFF00FF;
		}
    else{
        sParams.iTabLength	= 0;
		}

	return DrawTextExW(hDc,(LPWSTR)pText,iCount,pRect,uFlags,&sParams);
	}


//*****************************************************************************
//*
//*		SelectColorBrush
//*
//*****************************************************************************
//	Whlt den DC-Farb-Brush und setzte eine Farbe.
//	hDc			: Zeiger auf den Gerte-Context.
//	uColor		: Ist die Farbe die gewhlt werden soll.
//	pOldColor	: Hier wird die vorherige Farbe gespeichert.
//	Ergibt den vorhergewhlten Brush.
static EXTINL HGDIOBJ SelectColorBrush(HDC hDc,COLORREF uColor)
	{
	SetDCBrushColor(hDc,uColor);
	return SelectObject(hDc,GetStockObject(DC_BRUSH));
	}

static EXTINL HGDIOBJ SelectColorBrushEx(HDC hDc,COLORREF uColor,LPCOLORREF pOldColor)
	{
	*pOldColor=SetDCBrushColor(hDc,uColor);
	return SelectObject(hDc,GetStockObject(DC_BRUSH));
	}

//*****************************************************************************
//*
//*		SelectColorPen
//*
//*****************************************************************************
//	Whlt den DC-Farb-Pen und setzte eine Farbe.
//	hDc			: Zeiger auf den Gerte-Context.
//	uColor		: Ist die Farbe die gewhlt werden soll.
//	pOldColor	: Hier wird die vorherige Farbe gespeichert.
//	Ergibt den vorhergewhlten Pen.
static EXTINL HGDIOBJ SelectColorPen(HDC hDc,COLORREF uColor)
	{
	SetDCPenColor(hDc,uColor);
	return SelectObject(hDc,GetStockObject(DC_PEN));
	}

static EXTINL HGDIOBJ SelectColorPenEx(HDC hDc,COLORREF uColor,LPCOLORREF pOldColor)
	{
	*pOldColor = SetDCPenColor(hDc,uColor);
	return SelectObject(hDc,GetStockObject(DC_PEN));
	}


//*****************************************************************************
//*
//*		DibConvertSize
//*
//*****************************************************************************
//	Konvertiert ein DIB-Bitmap in ein Bitmap mit anderer Gre.
//	pInfo		: Ist das Handle der Bilddaten.
//	pPixels		: Zielpuffer fr die Bilddaten, bei NULL wird es vom Handle pInfo geholt.
//	pFrom		: Ist der Zeiger auf das originale Ausgangsbild.
//	pInput		: Bilddaten des Ausgangsbildes, bei NULL wird es vom Handle pFrom geholt.
static EXTINL BOOL DibConvertSize(LPBITMAPINFO pInfo,LPVOID pPixels,LPBITMAPINFO pFrom,LPVOID pInput)
{
return DibConvertSizeEx(pInfo,pPixels,pFrom,pInput,0,0,0x10000,0x10000,0,0,0x10000,0x10000);
}


//*****************************************************************************
//*
//*		DibPutAlpha
//*
//*****************************************************************************
//	berlagert ein DIB via Alpha-Blending ber ein anders DIB
//	pInfo		: Ist das Handle der Bilddaten.
//	pPixels		: Zielpuffer fr die Bilddaten, bei NULL wird es vom Handle pInfo geholt.
//	uPosX/Y		: Startposition im Zielpuffer
//	pFrom		: Ist der Zeiger auf das originale Ausgangsbild.
//	pInput		: Bilddaten des Ausgangsbildes, bei NULL wird es vom Handle pFrom geholt.
//	Ergibt TRUE wenn erfolgreich, bzw. FALSE bei einem Fehler
static EXTINL BOOL DibPutAlpha(LPBITMAPINFO pInfo,LPVOID pPixels,UINT uPosX,UINT uPosY,LPBITMAPINFO pFrom,LPVOID pInput)
{
return DibPutAlphaEx(pInfo,pPixels,uPosX,uPosY,pFrom,pInput,0,0,0x10000,0x10000);
}


#undef		D

#endif




