//*****************************************************************************
//*
//*
//*		WinExtension.cpp
//*
//*
//*****************************************************************************
//
//	Enhlt diverse Erweiterungen zur Windows API.
//	
//	Macros:		WEX_NO_MESSAGEBOX	MessageBox mir ColorListBox nicht benutzen	
//				
#ifdef		WINVER
#undef 		WINVER
#endif
#define 	WINVER 0x0501



#include	"WinExtension.h"
#include	<commctrl.h>
#include	<assert.h>
#include	<aclapi.h>
#include	<tchar.h>
#include	<lm.h>



#ifdef	   _MSC_VER
#pragma		warning(push )
#pragma		warning(disable:4035)
#pragma		warning(disable:4996)
#else
#ifndef		NO_ASM
#define		NO_ASM
#endif
#endif

#if defined(_MSC_VER) && !defined(NO_ASM)
#if defined(_M_X64)   ||  defined(_M_AMD64)
#define		WINEX_INSTR
#define		WINEX_X64
#include	<intrin.h>
#elif defined(_M_IX86) && (_MSC_VER>=1300)
#define		WINEX_INSTR
#include	<intrin.h>
#endif
#endif

#if			defined(_DEBUG) && defined(_MSC_VER) && !defined(NO_DEBUG_NEW)
#include	"DebugMemLeaks.h"
#endif

#define 	U(h)					((DWORD)(h))
#define 	GBR(b,g,r)				((COLORREF)(((BYTE)(r)|((WORD)((BYTE)(g))<<8))|(((DWORD)(BYTE)(b))<<16)))
#define 	ENTRIES(a)				(sizeof(a)/sizeof((a)[0]))

#define 	DIB_ROW_WIDTH(w,b)		((((((b)==15)? 16:(b))*(w)+31)/32)*4)
#define 	DIB_PTR_OFFSET(p,o,t)	((t)(((LPBYTE)(p))+((DWORD_PTR)(o))))
#define 	DIB_CHECK_DC(d,f)		{if(!d){d=GetDC(NULL);f=d;}}
#define 	DIB_PTR_DIFF(p,d)		(((LPBYTE )(p))-((LPBYTE)(d)))
#define 	DIB_SET_POINTER(p,v)	*((LPVOID*)(p))=(v)
#define 	DIB_GET_POINTER(p)		*((LPBYTE*)(p))
#define 	DIB_SET_DWORD(p,o,v)	*((LPDWORD)(p)+(o))=(v)
#define 	DIB_GET_DWORD(p,o)		*((LPDWORD)(p)+(o))
#define 	DIB_SET_BYTE(p,o,v)		*((LPBYTE )(p)+(o))=(v)
#define 	DIB_GET_BYTE(p,o)		*((LPBYTE )(p)+(o))
#define 	DIB_TAG_BITMAP			0x12345678			// Erkennungs-Tag fr allocierten Speicher

#define 	NOPOS					(0x8765)

#define 	IDS_ERROR				(2)
#define 	IDS_OK					(800)
#define 	IDS_CANCEL				(801)
#define 	IDS_ABORT				(802)
#define 	IDS_RETRY				(803)
#define 	IDS_IGNORE				(804)
#define 	IDS_YES					(805)
#define 	IDS_NO					(806)
#define 	IDS_HELP				(808)
#define 	IDS_TRYAGAIN			(809)
#define 	IDS_CONTINUE			(810)
				
#define 	MSGBOX_BUTTON_AX		(20)									
#define 	MSGBOX_BUTTON_AY		(10)
#define		MSGBOX_BUTTON_CX		(80)
#define		MSGBOX_BUTTON_CY		(32)
												   
#define 	MSGBOX_IDLIST			(1099)			   
#define		MSGBOX_IDICON			(1088)			   
#define		MSGBOX_IDTEXT			(100)
#define		MSGBOX_MAXLINES			(64)

#define 	MSGBOXEX_CAPTION		(128)
#define		MSGBOXEX_SPACING		(16)
#define 	MSGBOXEX_BTNSPACING		(16)
#define 	MSGBOXEX_MARGINX		(24)
#define 	MSGBOXEX_MARGINY		(12)
#define 	MSGBOXEX_MINHEIGH		(40)
#define 	MSGBOXEX_MINWIDTH		(100)
#define 	MSGBOXEX_MAXBTNSTR		(32)
#define 	MSGBOXEX_MAXBTNS		(6)

#define		IDI_EXCLAMATIONW		MAKEINTRESOURCEW(IDI_EXCLAMATION)
#define		IDI_QUESTIONW			MAKEINTRESOURCEW(IDI_QUESTION)
#define		IDI_ASTERISKW			MAKEINTRESOURCEW(IDI_ASTERISK)
#define		IDI_HANDW 				MAKEINTRESOURCEW(IDI_HAND)


static SIZE			sCheckSize		= {13,13};
static SIZE			sRadioSize		= {13,13};
static INT			iDefaultiWidth	= 7;				// Abmessungen fr LOGFONT 
static INT			iDefaultiHeight	= 10;				//		*
static HINSTANCE	hUser32			= NULL;				// Instanz-Hndle fr User32.dll
static HMODULE		hKernel32		= NULL;				// Instanz-Hndle fr Kernel32.dll
static BYTE			aFontsDefSizeX[4];					// X-Gre der Standartschriften
static BYTE			aFontsDefSizeY[4];					// Y-Gre der Standartschriften
static HFONT		aFontsDefault [4];					// Handle der Standartschriften (Bit0=Bold Bit1=Fixed)
static HFONT		aSysFonts     [2];
static UINT			aSysTicker    [2];
static UINT			aSysHeight    [2];
static UINT			uSysNext;	  



static const DWORD	aDibColors[16] =
	{
	0x00000000,0x00000080,0x00008000,0x00008080,
	0x00800000,0x00800080,0x00808000,0x00C0C0C0,
	0x00808080,0x000000FF,0x0000FF00,0x0000FFFF,
	0x00FF0000,0x00FF00FF,0x00FFFF00,0x00FFFFFF,
	};

static const WORD	aStringIds[] =
	{
	IDS_TEXT_INFORMATION,								// Text "Information"
	IDS_TEXT_QUESTION,									// Text "Frage"
	IDS_TEXT_WARNING,									// Text "Warnung"
	IDS_TEXT_CLEARLINE,									// Text "Zeile lschen"
	IDS_TEXT_COPYFIELD,									// Text "Feld kopieren"
	IDS_TEXT_COPY,										// Text "&Kopieren"
	IDS_TEXT_MARK,										// Text "&Alles markieren"
	IDS_TEXT_SELALL,									// Text "&Alles auswhlen"
	IDS_TEXT_SELNONE,									// Text "&Alles abwhlen"
	IDS_TEXT_CLEAR,										// Text "&Alles lschen"
	IDS_TEXT_NEVER,										// Text "Niemals"
	IDS_TEXT_ALWAYS,									// Text "Immer"
	};

static LPBYTE		pTextMemory = 0;					// Speicher fr Texte	
static BYTE			aSizeStrings[ENTRIES(aStringIds)];
static LPSTR		aAnsiStrings[ENTRIES(aStringIds)];
static LPWSTR		aWideStrings[ENTRIES(aStringIds)];
static LPCSTR		aTextStrings[ENTRIES(aStringIds)] =	// Texte wenn sie nicht existieren
	{
	"Information",
	"Frage",
	"Warnung",
	"Zeile lschen",
	"Feld kopieren",
	"&Kopieren",
	"&Alles markieren",
	"&Alles auswhlen",
	"&Alles abwhlen",
	"&Alles lschen",
	"Immer",
	"Niemals",
	};

static const WORD	aBoxStates[8] =						// Mode fr Check-Boxen und Radio-Buttons	
	{
	0,
	DFCS_HOT,
	DFCS_PUSHED,
	DFCS_INACTIVE,
	DFCS_CHECKED,
	DFCS_CHECKED|DFCS_HOT,
	DFCS_CHECKED|DFCS_PUSHED,
	DFCS_CHECKED|DFCS_INACTIVE,
	};


#pragma pack(push)
#pragma pack(1)

typedef struct
	{
    unsigned short 	wTag;								// "BM" Tag (immer 0x4D42)
    unsigned		uSize;        						// Bildgre samt Header
    unsigned short 	wReserved1;      					// Reserved ( must be 0)
	unsigned short 	wReserved2;      					// Reserved ( must be 0)
    unsigned		uOffset;        					// Offset zu den Pixeldaten
	}BMPHEADER;

typedef struct
	{
    unsigned char	bWidth;								// Width, in pixels, of the image
    unsigned char	bHeight;        					// Height, in pixels, of the image
    unsigned char	bColorCount;    					// Number of colors in image (0 if >=8bpp)
    unsigned char	bReserved;      					// Reserved ( must be 0)
    unsigned short	wPlanes;        					// Color Planes
    unsigned short	wBitCount;      					// Bits per pixel
    unsigned int	dwBytesInRes;   					// How many bytes in this resource?
    unsigned short  nID;								// Name Ordinal Points to component
	}GICONDIITEM,*LPGICONDIITEM;

typedef struct
	{
    unsigned short 	wWidth;         					// Width, in pixels, of the image
    unsigned short	wHeight;        					// Height, in pixels, of the image
    unsigned short	wPlanes;        					// Color Planes
    unsigned short	wBitCount;      					// Bits per pixel
    unsigned int	dwBytesInRes;   					// How many bytes in this resource?
    unsigned short  nID;								// Name Ordinal Points to component
	}GCURSORITEM,*LPGCURSORITEM;

typedef struct
	{
    unsigned short	wReserved;		 					// Reserved (must be 0)
    unsigned short	wType;       	 					// Resource Type (1 for icons 2 for cursors)
    unsigned short	wCount;      	 					// How many images?
	union{
    GICONDIITEM		aEntries[1]; 	 					// An entry for each image (idCount of 'em)
	GCURSORITEM		aCursors[1]; 	 					// An entry for each cursor (idCount of 'em)
	     };
	}GITEMDIR,*LPGITEMDIR;

#pragma pack(pop)

typedef struct
	{
	HANDLE			hHeap;								// Heap fr die Speicher-Allokation
	HBITMAP			hBitmap;							// Bitmap das gelscht werden soll
	LPBYTE			pLines;								// Zeiger auf die Pixeldaten
	HDC				hMemDc;								// Handle des Memory-DC's
	DWORD			uTag;								// Erkennungs-Tag (DIB_TAG_BITMAP)
	}DIBINFO,*LPDIBINFO;


typedef union
	{
	UINT			uRgb;								// Farbe als 32 Bit Wert
	struct
		{
	BYTE			ucBlue;								// Rotanteil
	BYTE			ucGreen;							// Grnanteil
	BYTE			ucRed;								// Blauanteil
	BYTE			ucAlpha;							// Alphablending
		};
	}DIBCOLOR;


typedef struct
	{
	WORD			wLength;							// Lnge der gesammten Struktur
	WORD			wValueLength;						// Lnge der Werte
	WORD			wType;								// Versionstyp (0=binr 1=Text)
	WCHAR			szKey[1];							// ID der Versions infos
	}VS_VERSIONBASE;

typedef struct
	{
	HFONT			hFont;								// Handle des Fonts
	BYTE			bItalic;							// Schrift schrg stellen
	BYTE			bUnderline;							// Schrift unterstreichen
	BYTE			bCharSet;							// Schrift Satz					
	BYTE			bPitchAndFamily;					// Schrift Familie
	WORD			wWeight;							// Schrift Gewicht
	WORD			wHeight;							// Schrift Hhe
	WORD			wWidth;								// Schrift Breite
	CHAR			cName[LF_FACESIZE];					// Schrift Name
	}FontCache;

typedef struct  
	{
	HICON			hIcon;								// Handle vom ICON
	HFONT			hFont;								// Schrift fr den Dialog
	WORD			wWitdh;								// Gesamtbreite des Textes
	BYTE			bScroll;							// Kann der Text gescrollt werden
	INT				iButtons;							// Anzahl der Tasten
	INT				iLines;								// Anzahl der Zeilen
	INT				iTabs;								// Breite der Tabulatoren
	RECT			sRect;								// Position des Textfeldes
	RECT			sScreen;							// Erlaubter Bildschirmbereich
	POINT			sPoint;								// Position vom Dialog
	LPDWORD			pSizes;								// Zeilen-Offsets und Lngen
	LPTSTR			pText;								// Ist der anzuzeigenden Text
	LPBYTE			pColors;							// Zeiger auf die Farben
	UINT			uTimeout;							// Timeout fr's schliesen
	DWORD_PTR		uHelpId;							// ID fr die Hilfe
	DWORD			uStyle;								// Style-Bist (Siehe MB_???)
	DWORD			uDefBtn;							// ID der Standart Taste
	LPWORD			pButtons;							// Zeiger auf die Tasten-ID's
	MSGBOXCALLBACK	pCallback;							// Callback fr Hilfefunktion	
	}MSGBOXINFO,*LPMSGBOXINFO;


typedef	VOID  (_stdcall *GdiplusShutdownType     )(ULONG_PTR  uToken);
typedef	DWORD (_stdcall *GdiplusStartupType      )(ULONG_PTR *pToken,LPVOID pInput,LPVOID pOutput);
typedef	DWORD (_stdcall *GdipCreateFromHDCType   )(HDC hDc, LPVOID *pGraphics);
typedef	DWORD (_stdcall *GdipDeleteGraphicsType  )(LPVOID hGraphics);
typedef	DWORD (_stdcall *GdipSetSmoothingModeType)(LPVOID hGraphics,UINT uMode);
typedef	DWORD (_stdcall *GdipDrawEllipseIType    )(LPVOID hGraphics,LPVOID hPen,INT iPosX,INT iPosY,INT iWidth,INT iHeight);
typedef	DWORD (_stdcall *GdipDrawLineIType       )(LPVOID hGraphics,LPVOID hPen,INT iPosX1,INT iPosY1,INT iPosX2,INT iPosY2);
typedef	DWORD (_stdcall *GdipCreatePen1Type      )(COLORREF uColor,FLOAT fWidth,UINT uUnit,LPVOID *pPen);
typedef	DWORD (_stdcall *GdipSetPenColorType     )(LPVOID hPen,COLORREF uColor);
typedef	DWORD (_stdcall *GdipDeletePenType       )(LPVOID hPen);
typedef BOOL  (_stdcall *LPFN_ISWOW64PROCESS     )(HANDLE hProcess,PBOOL pIsWow64Process);

static	GdipCreateFromHDCType		pGdipCreateFromHDC;
static	GdipDeleteGraphicsType		pGdipDeleteGraphics;
static	GdipSetSmoothingModeType	pGdipSetSmoothingMode;
static	GdipDrawEllipseIType		pGdipDrawEllipseI;
static	GdipDrawLineIType			pGdipDrawLineI;
static	GdipCreatePen1Type			pGdipCreatePen1;
static	GdipSetPenColorType			pGdipSetPenColor;
static	GdipDeletePenType			pGdipDeletePen;

static	ULONG_PTR					uGdiToken		= 0;
static	HMODULE						hGdiPlusDll		= 0;
static	DWORD						uWinVersion		= 0;	// Abgefragte Windows-version
static	int 						iGdiPlusInit	= 0;	// 0=nicht geladen 1=nicht gefunden 2=geladen
static	int 						iGdiPlusCount	= 0;	// Anzahl der Initialisierungen
static	int							iFontCacheCnt	= 0;	// Anzahl der gechacheten Fonts
static	int							iFontCacheMax	= 0;	// Anzahl der Bereiche im Font-Cache
static	FontCache				   *pFontCache		= 0;	// Zeiger auf gecachte FOnts

#ifndef _WIN64
static  LPFN_ISWOW64PROCESS			pIsWow64		= 0;
#endif 	


typedef struct
	{
    UINT32			GdiplusVersion;
    LPVOID			DebugEventCallback;
    BOOL			SuppressBackgroundThread;
    BOOL			SuppressExternalCodecs;
	}GdiplusStartupInput_;


//*****************************************************************************
//*
//*		ColorListBox Definitionen
//*
//*****************************************************************************
//	Dieser Abschnitt ist damit "ColorListBox.h" inkludiert werden muss.
#ifdef		AZ_LIB_COMPILE
#include	"ColorListBoxWnd.h"
#else

typedef struct
	{
    UINT	uMask;											// Bestimmt welche Werte gltig sind (siehe CLBF_???)
	int		iItem;											// Ist die Zeilennummer
    UINT	uState;											// Werte fr die Statusbits (siehe CLBS_???)
    UINT	uStateMask;										// Maske fr die Statusbits
	LPBYTE	pColor;											// Zeiger auf die Farben (Bit0..4=Farbe Bit5=Untersteichen Bit6=Fett Bit7=Fixed)
    LPTSTR	pText;											// Zeiger auf den Textpuffer
    int		iTextMax;										// Gre des Textpuffers
    LPARAM	lParam;											// Parameter fr den Eintarg
	}CLB_ITEM;


#define		CLBS_FIXEDSCROLL		0x00008000				// Kein Scrollen erlaubt
#define		CLBS_NOSCROLL			0x00003000				// Keine Scrollleisten anzeigen
#define		CLBS_NOSCROLLY			0x00002000				// Keine Y-Scrollleiste anzeigen
#define		CLBS_NOSCROLLX			0x00001000				// Keine X-Scrollleiste anzeigen
#define		CLBS_NOKEYBOARD			0x00000400				// Keine Tastatureingaben erlauben
#define 	CLBS_MULTIPLESEL 		0x00000008				// Mehrfachauswahl erlauben
															
#define 	CLB_EX_MULITFONT		0x00001000				// Mehrere Fonts zulassen
#define 	CLB_EX_MARKMULTI		0x00000002				// Mehrzeilige Markierungen
#define 	CLB_EX_SELWORDDBL		0x00800000				// Auswahl eines Wortes mit Doppelclick
															
#define 	CLBF_PARAM				0x00000001				// Der Wert lParam in CLB_ITEM ist gltig
#define 	CLBF_STATE				0x00000002				// Der Wert uState in CLB_ITEM ist gltig
#define 	CLBF_TEXT				0x00000004				// Der Wert pText  in CLB_ITEM ist gltig
#define 	CLBF_COLOR				0x00000008				// Der Wert pColor in CLB_ITEM ist gltig
#define 	CLBF_IDENT				0x00000010				// Der Wert HI(uState) in CLB_ITEM ist der Ident
#define 	CLBF_FAST				0x20000000				// Schnell Einfgemodus

#define		CLB_FIRST				(0x3800) 
#define		CLB_SETEXTENDEDSTYLE	(CLB_FIRST+27)
#define		CLB_INSERTITEM			(CLB_FIRST+ 6+CLB_UINICODE)

#ifdef		UNICODE
#define		CLB_UINICODE			1
#else						
#define		CLB_UINICODE			0
#endif

#define		ColorListBox_SetExtendedStyle(h,d)	((DWORD)::SendMessage(h,CLB_SETEXTENDEDSTYLE,0,d))
#define		ColorListBox_SetTabStops(h,n,p)		((BOOL )::SendMessage(h,LB_SETTABSTOPS,n,(LPARAM)(p)))
#define		ColorListBox_InsertItem(h,p,f)		((INT  )::SendMessage(h,CLB_INSERTITEM,f,(LPARAM)p))


#endif 	

//*****************************************************************************
//*
//*		SwapRGB
//*
//*****************************************************************************
static inline unsigned SwapRGB(unsigned uColor)
{
	#if defined(NO_ASM)

	return ((uColor&0x00FF0000)>>16)|(uColor&0xFF00FF00)|((uColor&0x000000FF)<<16);

	#elif defined(WINEX_INSTR)

	return _rotr(_byteswap_ulong(uColor),8);

	#else

	_asm{
		mov		eax,uColor
		bswap	eax;				;// Tausche Bytes in EAX
		ror		eax,8
		}

	#endif
}

//*****************************************************************************
//*
//*		SwapByte
//*
//*****************************************************************************
static inline unsigned SwapByte(unsigned uValue)
{
	#ifdef		NO_ASM

	unsigned  	uDummy;

	uDummy	=  uValue>>24;
	uDummy |=  uValue<<24;
	uDummy |= (uValue>>8)&0x0000FF00;
	uDummy |= (uValue<<8)&0x00FF0000;

	return uDummy;

	#elif defined(WINEX_INSTR)

	return _byteswap_ulong(uValue);

	#else

	_asm{
		mov		eax,uValue
		bswap	eax;				;// Tausche Bytes in EAX
		}

	#endif
}


#ifdef	   _MSC_VER
#pragma		warning(pop)
#pragma		warning(disable:4996)
#endif

typedef	HRESULT (WINAPI *GetCurrentThemeNameT)(LPWSTR,int,LPWSTR,int,LPWSTR,int);
typedef	HRESULT (WINAPI *SetWindowThemeT )(HWND,LPCWSTR,LPCWSTR);
typedef	HRESULT (WINAPI *EndBufferedPtT  )(HANDLE,BOOL);
typedef	HANDLE  (WINAPI *BeginBufferedPnT)(HDC,RECT*,DWORD,LPVOID,HDC*);
typedef	HRESULT (WINAPI *BufferedPtInitT )(VOID);
typedef	HRESULT (WINAPI *BufferedPtInitT )(VOID);

typedef	HRESULT (WINAPI *SetWindowThemeT )(HWND,LPCWSTR,LPCWSTR);
typedef	LPVOID  (WINAPI *OpenThemeDataT  )(HWND hwnd,LPCWSTR pszClassList);
typedef	HRESULT (WINAPI *CloseThemeDataT )(LPVOID);
typedef	HRESULT (WINAPI *DrawThemeBackgT )(LPVOID,HDC,int,int,const RECT*,const RECT*);
typedef	HRESULT (WINAPI *DrawThemeTextT  )(LPVOID,HDC,int,int,LPCWSTR,int,DWORD,DWORD,LPCRECT);
typedef	HRESULT (WINAPI *GetThemeBackgRcT)(LPVOID,HDC,int,int,LPCRECT,LPRECT);
typedef	HRESULT (WINAPI *GetThemePartSzT )(LPVOID,HDC,int,int,LPCRECT,int,LPSIZE);
typedef BOOL    (WINAPI *CheckTokenMembT )(HANDLE,PSID,PBOOL);



static	BOOL					bUxThemeDone		 = NULL;
static	LPVOID					hButtonTheme		 = NULL;
static	LPVOID					hComboTheme			 = NULL;
static	LPVOID					hTreeTheme			 = NULL;
static	LPVOID					hMenuTheme			 = NULL;
static	LPVOID					hToolTheme			 = NULL;
static	LPVOID					hEditTheme			 = NULL;
static	HMODULE					hAdvApiDll			 = NULL;
static	HMODULE					hUxThemeDll			 = NULL;
static	SetWindowThemeT			pSetWindowTheme		 = NULL;
static	EndBufferedPtT			pEndBufferedPt  	 = NULL;
static	BeginBufferedPnT		pBeginBufferedPt	 = NULL;
static	BufferedPtInitT			pBufferedPtInit 	 = NULL;
static	BufferedPtInitT			pBufferedPtExit		 = NULL;
static	CheckTokenMembT			pCheckTokenMembership= NULL;
static	GetCurrentThemeNameT	pGetCurrentThemeName = NULL;
static	OpenThemeDataT			pOpenThemeData		 = NULL;
static	CloseThemeDataT			pCloseThemeData		 = NULL;
static	DrawThemeBackgT			pDrawThemeBackg		 = NULL;
static	DrawThemeTextT			pDrawThemeText		 = NULL;
static	GetThemeBackgRcT		pGetThemeBackgRc	 = NULL;
static	GetThemePartSzT			pGetThemePartSz 	 = NULL;



static COLORREF	aDefaultColors[32]=
	{
	RGB(192,192,  0),		// 00		mittel gelb
	RGB(  0,  0,128),		// 01		dunkelblau
	RGB(  0,128,  0),		// 02		dunkelgrn
	RGB(  0,128,128),		// 03		dunkeltrkis
	RGB(128,  0,  0),		// 04		dunkelrot
	RGB(128,  0,128),		// 05		dunkellila
	RGB(128,128,  0),		// 06		oker
	RGB(128,128,128),		// 07		dunkelgrau
	RGB(192,192,192),		// 08		hellgrau
	RGB(  0,  0,255),		// 09		blau
	RGB(  0,255,  0),		// 10		grn
	RGB(  0,255,255),		// 11		trkis
	RGB(255,  0,  0),		// 12		rot
	RGB(255,  0,255),		// 13		lila
	RGB(255,255,  0),		// 14		gelb
	RGB(255,128,128),		// 15		hellrot (unterstreichen)
	RGB( 64, 64, 64),		// 16		sehr dunkelgrau
	RGB(  0,  0, 64),		// 17		sehr dunkelblau
	RGB(  0, 64,  0),		// 18		sehr dunkelgrn
	RGB(  0, 64, 64),		// 19		sehr dunkeltrkis
	RGB( 64,  0,  0),		// 20		sehr dunkelrot
	RGB(128,  0,255),		// 21		violet
	RGB( 64,  0,192),		// 22		dunkelviolet
	RGB(  0,  0,192),		// 23		mittel blau
	RGB(  0,  0,  0),		// 24		schwarz
	RGB(222,222,222),		// 25 HG7   bastel grau
	RGB(200,200,255),		// 26 HG6	bastel lila
	RGB(192,255,192),		// 27 HG5	bastel grn
	RGB(155,255,255),		// 28 HG4	bastel blau
	RGB(255,192,255),		// 29 HG3	bastel rosa
	RGB(255,255,255),		// 30 HG2	weis
	RGB(255,255,128),		// 31 HG1	bastel gelb
	};


//*****************************************************************************
//*
//*		LoadUxThemeDll
//*
//*****************************************************************************
//	Ld die UxTheme.dll ab XP
static void LoadUxThemeDll()
{
RECT		sRect;
UINT		uSize;

	if(bUxThemeDone)return;

	uSize			= GetSystemMetrics(SM_CXICON);
	sCheckSize.cx	= (13*uSize)/32;
	sCheckSize.cy	= sCheckSize.cy;
	sRadioSize.cx	= sCheckSize.cy;
	sRadioSize.cy	= sCheckSize.cy;


	if(!hUxThemeDll)
		{
		   hUxThemeDll = LoadLibraryA("UxTheme.dll");
		if(hUxThemeDll)
			{
			pSetWindowTheme  	 = (SetWindowThemeT     )GetProcAddress(hUxThemeDll,"SetWindowTheme"     );
			pEndBufferedPt   	 = (EndBufferedPtT      )GetProcAddress(hUxThemeDll,"EndBufferedPaint"   );
			pBeginBufferedPt 	 = (BeginBufferedPnT    )GetProcAddress(hUxThemeDll,"BeginBufferedPaint" );
			pBufferedPtInit	 	 = (BufferedPtInitT	    )GetProcAddress(hUxThemeDll,"BufferedPaintInit"  );
			pBufferedPtExit		 = (BufferedPtInitT	    )GetProcAddress(hUxThemeDll,"BufferedPaintUnInit");
			pGetCurrentThemeName = (GetCurrentThemeNameT)GetProcAddress(hUxThemeDll,"GetCurrentThemeName");
			pOpenThemeData	 	 = (OpenThemeDataT		)GetProcAddress(hUxThemeDll,"OpenThemeData"		 );
			pCloseThemeData	 	 = (CloseThemeDataT		)GetProcAddress(hUxThemeDll,"CloseThemeData"	 );
			pDrawThemeText	 	 = (DrawThemeTextT		)GetProcAddress(hUxThemeDll,"DrawThemeText"		 );
			pDrawThemeBackg	 	 = (DrawThemeBackgT 	)GetProcAddress(hUxThemeDll,"DrawThemeBackground");
			pGetThemePartSz  	 = (GetThemePartSzT		)GetProcAddress(hUxThemeDll,"GetThemePartSize"   );
			pGetThemeBackgRc 	 = (GetThemeBackgRcT	)GetProcAddress(hUxThemeDll,"GetThemeBackgroundContentRect");
			hComboTheme			 =  pOpenThemeData(GetDesktopWindow(),L"ComboBox");
			hTreeTheme	 	     =  pOpenThemeData(GetDesktopWindow(),L"TreeView");
			hToolTheme			 =  pOpenThemeData(GetDesktopWindow(),L"ToolBar");
			hButtonTheme	 	 =  pOpenThemeData(GetDesktopWindow(),L"Button");
			hMenuTheme	 	     =  pOpenThemeData(GetDesktopWindow(),L"Menu");
			hEditTheme			 =  pOpenThemeData(GetDesktopWindow(),L"Edit");

			if(hButtonTheme)
				{
				sRect.left		 = 0;
				sRect.right		 = 3;
				sRect.top		 = 0;
				sRect.bottom	 = 3;

				pGetThemePartSz(hButtonTheme,NULL,BP_CHECKBOX,CBS_UNCHECKEDNORMAL,&sRect,1,&sCheckSize);
				pGetThemePartSz(hButtonTheme,NULL,BP_RADIO   ,CBS_UNCHECKEDNORMAL,&sRect,1,&sRadioSize);
				}
			
			GetWindowsVersionEx();
			}
		}




	bUxThemeDone = TRUE;

}


//*****************************************************************************
//*
//*		GetCurrentTheme
//*
//*****************************************************************************
//	Holt den Namen des aktuellen XP-Themas.
//	pName	: Ist der Textpuffer in dem der Namen gespeichert werden soll.
//	iMax 	: Ist die Gre des Textpuffers in Zeichen.
//	Ergibt TRUE wenn ein Thema gefunden wurde.
EXTAPI BOOL WINAPI GetCurrentThemeA(LPSTR pName,int iMax)
{
wchar_t		cBuffer[256];
int			iPos;


	if(iMax<=0)return FALSE;

	if(!bUxThemeDone)LoadUxThemeDll();


	if(!pGetCurrentThemeName)
		{
		pName[0]=0;
		return FALSE;
		}

	if(pGetCurrentThemeName(cBuffer,sizeof(cBuffer)/sizeof(cBuffer[0]),0,0,0,0)!=S_OK)
		{
		pName[0]=0;
		return FALSE;
		}

	iMax--;

	if(iMax>=sizeof(cBuffer)/sizeof(cBuffer[0]))
		{
		iMax = sizeof(cBuffer)/sizeof(cBuffer[0])-1;
		}

	for(iPos=0;iPos<iMax;iPos++)
		{
		if(!cBuffer[iPos])break;
		pName[iPos] = (char)cBuffer[iPos];
		}

	pName[iPos] = 0;



return (*pName)? TRUE:FALSE;
}

EXTAPI BOOL WINAPI GetCurrentThemeW(LPWSTR pName,int iMax)
{
wchar_t		cBuffer[256];
int			iPos;


	if(iMax<=0)return FALSE;

	if(!bUxThemeDone)LoadUxThemeDll();


	if(!pGetCurrentThemeName)
		{
		pName[0]=0;
		return FALSE;
		}

	if(pGetCurrentThemeName(cBuffer,sizeof(cBuffer)/sizeof(cBuffer[0]),0,0,0,0)!=S_OK)
		{
		pName[0]=0;
		return FALSE;
		}

	iMax--;

	if(iMax>=sizeof(cBuffer)/sizeof(cBuffer[0]))
		{
		iMax = sizeof(cBuffer)/sizeof(cBuffer[0])-1;
		}

	for(iPos=0;iPos<iMax;iPos++)
		{
		if(!cBuffer[iPos])break;
		pName[iPos] = cBuffer[iPos];
		}

	pName[iPos] = 0;



return (*pName)? TRUE:FALSE;
}

//*****************************************************************************
//*
//*		CalcFontAscent
//*
//*****************************************************************************
//	Berechnet die Base-Line von Fonts
//	hDc			: Gerte DC auf dem gezeichnet wird
//	uOptions	: Format fr die Text Ausgabe mit folgenden Optionen
//						ETO_FONTCNT_?	: Ist die Anzahl der benutzen Fonts
//						DT_VCENTER		: mittig ausgerichtet (vertical)
//						DT_BOTTOM		: unten ausgerichtet
//	iCount		: Lnge des Textes (muss grer gleich 0 sein)
//	pIndex		: Liste mit den Farb Indizes, bei 0 wird DrawTextEx(...) benutzt
//	pFonts		: Ist eine Liste von bis zu 4 Schriftarten. Wenn der
//				  Zeiger NULL ist wird die Schriftart nicht verndert.
//	pAscent		: Hier werden die Y-Verschbe gespeichert (negativ fr Botton)
//				  Auf pAscent[4] wird die maximale Schrifthhe gespeichert
//	Ergibt die Position der Linie frs Unterstreichen.
static int CalcFontAscent(HDC hDc,UINT uOptions,int iCount,CONST BYTE *pIndex,CONST HFONT *pFonts,INT *pAscent)
{
INT			aHeight[4];
TEXTMETRIC	sMetrics;
int			iFont;
int			iLast;
int			iSize;
int			iStep;
int			iEnd;
int			iMax;
int			iVal;
int			iIdx;


	iEnd 	= (uOptions>>24)&0x07;
	iMax	= 0;
	iSize	= 0;

	if(iEnd)												// Ist eine Font-Anzahl definiert
		{
		if(iEnd>4)iEnd=4;

		for(iIdx=0;iIdx<iEnd;iIdx++)
			{
			SelectObject(hDc,pFonts[iIdx]);
			GetTextMetrics(hDc,&sMetrics);
			aHeight[iIdx] = sMetrics.tmHeight;
			pAscent[iIdx] = sMetrics.tmAscent;
			if(iSize<sMetrics.tmHeight)iSize= sMetrics.tmHeight;
			if(iMax <sMetrics.tmAscent)iMax = sMetrics.tmAscent;
			}
		}
	else{
		pAscent[0] = 0;
		pAscent[1] = 0;
		pAscent[2] = 0;
		pAscent[3] = 0;
		iLast	   =-1;

		for(iIdx=0;iIdx<iCount;iIdx++)						// Suche welche Fonts benutzt werden
			{
			   iFont = pIndex[iIdx]>>6;
			if(iFont==iLast)continue;

			iLast	= iFont;

			if(pAscent[iFont])continue;

			SelectObject(hDc,pFonts[iFont]);
			GetTextMetrics(hDc,&sMetrics);
			aHeight[iFont] = sMetrics.tmHeight;
			pAscent[iFont] = sMetrics.tmAscent;

			if(iSize<sMetrics.tmHeight)iSize= sMetrics.tmHeight;
			if(iMax <sMetrics.tmAscent)iMax = sMetrics.tmAscent;
			if(iEnd <=iFont)iEnd=iFont+1;
			}

		iIdx = iEnd;
		}


	for(;iIdx<4;iIdx++)
		{
		pAscent[iIdx] = iMax;
		}

	if(uOptions&DT_BOTTOM)									// Hchste Y-Vershub vom Boden
		{
		iStep = 0;

		for(iIdx=0;iIdx<iEnd;iIdx++)
			{
			if(!pAscent[iIdx])continue;
			iVal = aHeight[iIdx]-pAscent[iIdx];
			if(iStep<iVal)iStep=iVal;
			}
		}

	for(iIdx=0;iIdx<4;iIdx++)								// Y-Verschub berechnen
		{
		if(!pAscent[iIdx])
			{
			pAscent[iIdx] = iMax;
			}

		if(uOptions&DT_BOTTOM)
			{
			iVal = aHeight[iIdx]-pAscent[iIdx];
			pAscent[iIdx] = iVal-iStep;
			}
		else if(uOptions&DT_BOTTOM)
			{
			pAscent[iIdx] = (iMax-pAscent[iIdx])/2;
			}
		else{
			pAscent[iIdx] = iMax-pAscent[iIdx];
			}
		}

	pAscent[4] = iSize;


return 	iMax;
}


//*****************************************************************************
//*
//*		DrawTextColor
//*
//*****************************************************************************
//	Zeichen einen Text in verschiedenen Farben,Schriften und Stillen
//	hDc			: Gerte DC auf dem gezeichnet wird
//	pString		: Zeiger auf den Text
//	iCount		: Lnge des Textes (-1 meint Lnge mit strlen holen)
//	pRect		: Rechteck in dem der Text ausgegeben wird.
//	uFormat		: Format fr die Text Ausgabe mit folgenden Optionen
//						DT_SINGLELINE	: wird immer gesetzt (einzeilige Ausgabe)
//						DT_NOPREFIX		: wird immer gesetzt (& Zeichen nicht umwandeln)
//						DT_LEFT			: links ausgerichtet
//						DT_CENTER		: mittig ausgerichtet
//						DT_RIGHT		: rechts ausgerichtet
//						DT_TOP			: oben ausgerichtet
//						DT_VCENTER		: mittig ausgerichtet (vertical)
//						DT_BOTTOM		: unten ausgerichtet
//						DT_NOCLIP		: Clipping beim Zeichnen ausschalten
//						DT_CALCRECT		: Nur die Ausgabegre berechnen
//						DT_NODEFAULT	: Keine Default-Text-Farbe
//						DT_BKCOLOR_?	: Wieviele Bits fr Hintergrund reservieren
//						DT_FONTCNT_?	: Ist die Anzahl der benutzen Fonts
//						DT_ULINECOLOR	: Unterstreichen mit Farbe 15
//	pIndex		: Liste mit den Farb Indizes, bei 0 wird DrawTextEx(...) benutzt
//					Bit 0..4 = Farbnummer in pColors
//					Bit 5    = Unterstreichen
//					Bit 6..7 = Schriftart wenn pFonts ungleich NULL
//					Bit 2..4 = Hintergrund (siehe DT_BKCOLOR_?)
//	pColors		: Ist eine Liste mit bis zu 33 Farben, bei 0 werden
//				  Standartfarben benutzt. Bei der Hintergrundfarbe 0 wird
//				  die aktuelle Farbe benutzt, bei 1 der Index 31, bei 2 30 ...
//						00		mittel gelb oder default
//						01		dunkelblau
//						02		dunkelgrn
//						03		dunkeltrkis
//						04		dunkelrot
//						05		dunkellila
//						06		ocker
//						07		dunkelgrau
//						08		hellgrau
//						09		blau
//						10		grn
//						11		trkis
//						12		rot
//						13		lila
//						14		gelb
//						15		hellrot (DT_ULINECOLOR)
//						16		sehr dunkelgrau
//						17		sehr dunkelblau
//						18		sehr dunkelgrn
//						19		sehr dunkeltrkis
//						20		sehr dunkelrot
//						21		violett
//						22		dunkelviolett
//						23		mittel blau
//						24		schwarz
//						25 HG7 oder bastel grau
//						26 HG6 oder bastel lila
//						27 HG5 oder bastel grn
//						28 HG4 oder bastel blau
//						29 HG3 oder bastel rosa
//						30 HG2 oder weis
//						31 HG1 oder bastel gelb
//	pFonts		: Ist eine Liste von bis zu 4 Schriftarten. Wenn der
//				  Zeiger NULL ist wird die Schriftart nicht verndert.
//	Ergibt die maximale Hhe der Schrift.
EXTAPI INT WINAPI DrawTextColorA(HDC hDc,LPCSTR pString,int iCount,LPRECT pRect,UINT uFormat,CONST BYTE *pIndex,CONST COLORREF *pColors,CONST HFONT *pFonts)
{
INT			aAscent[5];
UINT		uLastMode;
COLORREF	uFirstCol;
COLORREF	uLastCbk;
COLORREF	uLastCol;
HGDIOBJ		hLastObj;
HGDIOBJ		hLastPen;
HRGN		hLastRgn;
TEXTMETRIC	sMetrics;
HRGN		hRegion;
RECT		sArea;
RECT		sRect;
SIZE		sFull;
SIZE		sSize;
BYTE		bMask;
BYTE		bLast;
BYTE		bNext;
int			iBits;
int			iDiff;
int			iLine;
int			iTop;
int 		iAnd;
int			iAdd;
int			iAll;
int			iCol;
int			iIdx;
int			iVal;



	uFormat |=  (DT_NOPREFIX |DT_SINGLELINE);
	uFormat &= ~(DT_WORDBREAK|DT_EDITCONTROL|DT_EXPANDTABS|DT_EXTERNALLEADING|DT_END_ELLIPSIS|DT_MODIFYSTRING);

	if(iCount<0)
		{
		iCount = (int)strlen(pString);
		}

	if(iCount==0 || !pIndex)								// Kein Text vorhanden oder keine Farben
		{
		return DrawTextExA(hDc,(LPSTR)pString,iCount,pRect,uFormat,NULL);
		}

	if(uFormat&(DT_CALCRECT|DT_CENTER|DT_RIGHT))			// Gre berechnen
		{
		iAll = 0;

		if(pFonts)
			{
			sFull.cx	= 0;
			sFull.cy	= 0;
			hLastObj	= GetCurrentObject(hDc,OBJ_FONT);

			while(iCount>0)									// Alle Buchstaben durchlaufen
				{
				bLast	= pIndex[0];

				for(iAdd=1;iAdd<iCount;iAdd++)				// Vor bis zum Schriftwechsel
					{
					if((bLast^pIndex[iAdd])&0xC0)break;
					}

				SelectObject(hDc,pFonts[bLast>>6]);
				GetTextExtentPoint32A(hDc,pString,iAdd,&sSize);

				   sFull.cx+= sSize.cx;
				if(sFull.cy < sSize.cy)
					{
					sFull.cy = sSize.cy;
					}

				pString	+= iAdd;
				pIndex	+= iAdd;
				iCount  -= iAdd;
				iAll	+= iAdd;
				}

			SelectObject(hDc,hLastObj);
			}
		else{												// Nur eine Schriftart
			GetTextExtentPoint32A(hDc,pString,iCount,&sFull);
			}

		if(uFormat&DT_CALCRECT)								// Nur die Gre berechnen
			{
			pRect->right	= pRect->left+sFull.cx;
			pRect->bottom	= pRect->top +sFull.cy;

			return sFull.cy;
			}

		if(iAll)
			{
			pString	-= iAll;
			pIndex	-= iAll;
			iCount   = iAll;
			}
		}


	if(!pColors)pColors=aDefaultColors;						// Standartfarben


	aAscent[0]		= 0;
	aAscent[1]		= 0;
	aAscent[2]		= 0;
	aAscent[3]		= 0;
	aAscent[4]		= 0;
	hRegion			= 0;
	hLastRgn		= 0;
	sFull.cy		= 0;
	bLast			= pIndex[0];

	if(pFonts)												// Mehrere Schriftarten
		{
		hLastPen	= GetCurrentObject(hDc,OBJ_PEN);
		hLastObj	= GetCurrentObject(hDc,OBJ_FONT);
		iLine		= CalcFontAscent(hDc,uFormat,iCount,pIndex,pFonts,aAscent)+1;
		SelectObject(hDc,GetStockObject(NULL_PEN));
		SelectObject(hDc,pFonts[bLast>>6]);
		bMask		= 0xFF;
		bNext		= bLast;

		if(uFormat&DT_BOTTOM)
			{
			iTop	= pRect->bottom-aAscent[4];
			iLine  += iTop-pRect->top;
			}
		else if(uFormat&DT_VCENTER)
			{
			iTop	= (pRect->top+pRect->bottom-aAscent[4])/2;
			iLine  += iTop-pRect->top;
			}
		else{
			iTop	= pRect->top;
			}
		}
	else{													// Nur eine Schrift
		bMask		= 0x3F;
		bLast	   &= 0x3F;
		bNext		= bLast;
		}

	iBits	= 5-((uFormat>>28)&3);							// Bits fr Textfarben
	iAnd	= (1<<iBits)-1;									// Maske fr Hintergrund


	if(uFormat&(DT_CENTER|DT_RIGHT))						// Zentriert oder rechstbndig
		{
		if(uFormat&DT_CENTER)
			{
			sRect.left	=(pRect->left+pRect->right-sFull.cx)/2;
			}
		else{
			sRect.left	= pRect->right-sFull.cx;
			}

		sRect.top		= pRect->top;
		sRect.right		= pRect->right;
		sRect.bottom	= pRect->bottom;
		uFormat		   &= ~(DT_CENTER|DT_RIGHT);
															// Rechteck beschneiden
		if(!(uFormat&DT_NOCLIP) && (sRect.left<pRect->left || sRect.right<pRect->right))
			{
			uFormat    &= ~DT_NOCLIP;
			hRegion		= CreateRectRgnIndirect(pRect);
			hLastRgn	= (HRGN)GetCurrentObject(hDc,OBJ_REGION);
			if(hLastRgn)CombineRgn(hRegion,hRegion,hLastRgn,RGN_AND);
			SelectObject(hDc,hRegion);
			}
		}
	else{
		sRect		= *pRect;
		}

	uLastMode		= GetBkMode   (hDc);
	uLastCbk		= GetBkColor  (hDc);
	uLastCol		= GetTextColor(hDc);
	uFirstCol		= (uFormat&DT_NODEFAULT)? pColors[0]:uLastCol;
	uFormat		   &= ~0xF0000000;

	if(iAnd!=0x1F && uLastMode!=OPAQUE)						// Hintergrund zeichnen
		{
		SetBkMode(hDc,(iAnd==0x1F)? TRANSPARENT:OPAQUE);
		}

	while(iCount>0)											// Alle Buchstaben durchlaufen
		{
		for(iAdd=1;iAdd<iCount;iAdd++)						// Vor bis zum Farbwechsel
			{
			   bNext = pIndex[iAdd]&bMask;
			if(bNext!=bLast)break;
			}

		iCol	= bLast&0x1F;

		if(iAnd!=0x1F)										// Auch Hintergrundfarbe verndern
			{
			iIdx   = iCol&iAnd;
			iCol >>= iBits;
			SetTextColor(hDc,(iIdx)? pColors[iIdx   ]:uFirstCol);
			SetBkColor  (hDc,(iCol)? pColors[32-iCol]:uLastCbk );
			}
		else{
			SetTextColor(hDc,(iCol)? pColors[iCol]:uFirstCol);
			}

		GetTextExtentPoint32A(hDc,pString,iAdd,&sSize);
		if(aAscent[4])sSize.cy = aAscent[4];

		   iVal = aAscent[bLast>>6];
		if(iVal)											// Base-Line ausgleichen
			{
			if(uLastMode==OPAQUE || iAnd!=0x1F)
				{
				sArea.left	  = sRect.left;
				sArea.right   = sRect.left+sSize.cx;
				sArea.top     = iTop;
				sArea.bottom  = iTop+sSize.cy;
				ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);
				}

			if(iVal>0)
				{
				sRect.top += iVal;
				DrawTextExA(hDc,(LPSTR)pString,iAdd,&sRect,uFormat,NULL);
				sRect.top -= iVal;
				}
			else{
				sRect.bottom += iVal;
				DrawTextExA(hDc,(LPSTR)pString,iAdd,&sRect,uFormat,NULL);
				sRect.bottom -= iVal;
				}
			}
		else{
			DrawTextExA(hDc,(LPSTR)pString,iAdd,&sRect,uFormat,NULL);
			}

		if(sFull.cy < sSize.cy)
			{
			sFull.cy = sSize.cy;
			}

		if((bNext^bLast)&0xC0)								// Andere Schrift
			{
			SelectObject(hDc,pFonts[bNext>>6]);
			}

		if(bLast&0x20)										// Text unterstreichen
			{
			if(!iLine)
				{
				GetTextMetrics(hDc,&sMetrics);
				iLine = (BYTE)(sMetrics.tmAscent+1);

				if(uFormat&(DT_BOTTOM|DT_VCENTER))
					{
					iDiff	= sRect.bottom-sRect.top-sSize.cy;

					if(uFormat&DT_BOTTOM)
							iLine +=iDiff;
					else	iLine +=iDiff/2;
					}
				}

			sArea.left	  = sRect.left;
			sArea.right   = sRect.left+sSize.cx;
			sArea.top     = sRect.top+iLine;
			sArea.bottom  = sArea.top+1;
			iCol		  = (uFormat&DT_ULINECOLOR)? 15:bLast&iAnd;

			SetBkColor(hDc,pColors[iCol]);
			ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);
			if(iAnd==0x1F)SetBkColor(hDc,uLastCbk);
			}

		bLast		= bNext;								// Vor auf nchsten Farbbereich
		pString	   += iAdd;
		pIndex	   += iAdd;
		iCount     -= iAdd;
		sRect.left += sSize.cx;

		if(sRect.left>=sRect.right)break;
		}



	if(pFonts)
		{
		SelectObject(hDc,hLastObj);
		SelectObject(hDc,hLastPen);
		}

	if(hRegion)
		{
		SelectClipRgn(hDc,hLastRgn);
		DeleteObject(hRegion);
		}

	SetTextColor(hDc,uLastCol );
	SetBkColor  (hDc,uLastCbk );
	SetBkMode   (hDc,uLastMode);



return sFull.cy;
}

EXTAPI INT WINAPI DrawTextColorW(HDC hDc,LPCWSTR pString,int iCount,LPRECT pRect,UINT uFormat,CONST BYTE *pIndex,CONST COLORREF *pColors,CONST HFONT *pFonts)
{
INT			aAscent[5];
UINT		uLastMode;
COLORREF	uFirstCol;
COLORREF	uLastCbk;
COLORREF	uLastCol;
HGDIOBJ		hLastObj;
HGDIOBJ		hLastPen;
HRGN		hLastRgn;
TEXTMETRIC	sMetrics;
HRGN		hRegion;
RECT		sArea;
RECT		sRect;
SIZE		sFull;
SIZE		sSize;
BYTE		bMask;
BYTE		bLast;
BYTE		bNext;
int			iBits;
int			iDiff;
int			iLine;
int 		iAnd;
int			iAdd;
int			iAll;
int			iCol;
int			iIdx;
int			iVal;
int			iTop;



	uFormat |=  (DT_NOPREFIX |DT_SINGLELINE);
	uFormat &= ~(DT_WORDBREAK|DT_EDITCONTROL|DT_EXPANDTABS|DT_EXTERNALLEADING|DT_END_ELLIPSIS|DT_MODIFYSTRING);

	if(iCount<0)
		{
		iCount = (int)wcslen(pString);
		}

	if(iCount==0 || !pIndex)								// Kein Text vorhanden oder keine Farben
		{
		return DrawTextExW(hDc,(LPWSTR)pString,iCount,pRect,uFormat,NULL);
		}

	if(uFormat&(DT_CALCRECT|DT_CENTER|DT_RIGHT))			// Gre berechnen
		{
		iAll = 0;

		if(pFonts)
			{
			sFull.cx	= 0;
			sFull.cy	= 0;
			hLastObj	= GetCurrentObject(hDc,OBJ_FONT);

			while(iCount>0)									// Alle Buchstaben durchlaufen
				{
				bLast	= pIndex[0];

				for(iAdd=1;iAdd<iCount;iAdd++)				// Vor bis zum Schriftwechsel
					{
					if((bLast^pIndex[iAdd])&0xC0)break;
					}

				SelectObject(hDc,pFonts[bLast>>6]);
				GetTextExtentPoint32W(hDc,pString,iAdd,&sSize);

				   sFull.cx+= sSize.cx;
				if(sFull.cy < sSize.cy)
					{
					sFull.cy = sSize.cy;
					}

				pString	+= iAdd;
				pIndex	+= iAdd;
				iCount  -= iAdd;
				iAll	+= iAdd;
				}

			SelectObject(hDc,hLastObj);
			}
		else{												// Nur eine Schriftart
			GetTextExtentPoint32W(hDc,pString,iCount,&sFull);
			}

		if(uFormat&DT_CALCRECT)								// Nur die Gre berechnen
			{
			pRect->right	= pRect->left+sFull.cx;
			pRect->bottom	= pRect->top +sFull.cy;

			return sFull.cy;
			}

		if(iAll)
			{
			pString	-= iAll;
			pIndex	-= iAll;
			iCount   = iAll;
			}
		}


	if(!pColors)pColors=aDefaultColors;						// Standartfarben


	aAscent[0]		= 0;
	aAscent[1]		= 0;
	aAscent[2]		= 0;
	aAscent[3]		= 0;
	aAscent[4]		= 0;
	hRegion			= 0;
	hLastRgn		= 0;
	sFull.cy		= 0;
	bLast			= pIndex[0];

	if(pFonts)												// Mehrere Schriftarten
		{
		hLastPen	= GetCurrentObject(hDc,OBJ_PEN);
		hLastObj	= GetCurrentObject(hDc,OBJ_FONT);
		iLine		= CalcFontAscent(hDc,uFormat,iCount,pIndex,pFonts,aAscent)+1;
		SelectObject(hDc,GetStockObject(NULL_PEN));
		SelectObject(hDc,pFonts[bLast>>6]);
		bMask		= 0xFF;
		bNext		= bLast;

		if(uFormat&DT_BOTTOM)
			{
			iTop	= pRect->bottom-aAscent[4];
			iLine  += iTop-pRect->top;
			}
		else if(uFormat&DT_VCENTER)
			{
			iTop	= (pRect->top+pRect->bottom-aAscent[4])/2;
			iLine  += iTop-pRect->top;
			}
		else{
			iTop	= pRect->top;
			}
		}
	else{													// Nur eine Schrift
		bMask		= 0x3F;
		bLast	   &= 0x3F;
		bNext		= bLast;
		}

	iBits	= 5-((uFormat>>28)&3);							// Bits fr Textfarben
	iAnd	= (1<<iBits)-1;									// Maske fr Hintergrund


	if(uFormat&(DT_CENTER|DT_RIGHT))						// Zentriert oder rechstbndig
		{
		if(uFormat&DT_CENTER)
			{
			sRect.left	=(pRect->left+pRect->right-sFull.cx)/2;
			}
		else{
			sRect.left	= pRect->right-sFull.cx;
			}

		sRect.top		= pRect->top;
		sRect.right		= pRect->right;
		sRect.bottom	= pRect->bottom;
		uFormat		   &= ~(DT_CENTER|DT_RIGHT);
															// Rechteck beschneiden
		if(!(uFormat&DT_NOCLIP) && (sRect.left<pRect->left || sRect.right<pRect->right))
			{
			uFormat    &= ~DT_NOCLIP;
			hRegion		= CreateRectRgnIndirect(pRect);
			hLastRgn	= (HRGN)GetCurrentObject(hDc,OBJ_REGION);
			if(hLastRgn)CombineRgn(hRegion,hRegion,hLastRgn,RGN_AND);
			SelectObject(hDc,hRegion);
			}
		}
	else{
		sRect		= *pRect;
		}

	uLastMode		= GetBkMode   (hDc);
	uLastCbk		= GetBkColor  (hDc);
	uLastCol		= GetTextColor(hDc);
	uFirstCol		= (uFormat&ETO_NODEFAULT)? pColors[0]:uLastCol;
	uFormat		   &= ~0xF0000000;

	if(iAnd!=0x1F && uLastMode!=OPAQUE)						// Hintergrund zeichnen
		{
		SetBkMode(hDc,(iAnd==0x1F)? TRANSPARENT:OPAQUE);
		}




	while(iCount>0)											// Alle Buchstaben durchlaufen
		{
		for(iAdd=1;iAdd<iCount;iAdd++)						// Vor bis zum Farbwechsel
			{
			   bNext = pIndex[iAdd]&bMask;
			if(bNext!=bLast)break;
			}

		iCol	= bLast&0x1F;

		if(iAnd!=0x1F)										// Auch Hintergrundfarbe verndern
			{
			iIdx   = iCol&iAnd;
			iCol >>= iBits;
			SetTextColor(hDc,(iIdx)? pColors[iIdx   ]:uFirstCol);
			SetBkColor  (hDc,(iCol)? pColors[32-iCol]:uLastCbk );
			}
		else{
			SetTextColor(hDc,(iCol)? pColors[iCol]:uFirstCol);
			}

		GetTextExtentPoint32W(hDc,pString,iAdd,&sSize);
		if(aAscent[4])sSize.cy = aAscent[4];

		   iVal = aAscent[bLast>>6];
		if(iVal)											// Base-Line ausgleichen
			{
			if(uLastMode==OPAQUE || iAnd!=0x1F)
				{
				sArea.left	  = sRect.left;
				sArea.right   = sRect.left+sSize.cx;
				sArea.top     = iTop;
				sArea.bottom  = iTop+sSize.cy;
				ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);
				}

			if(iVal>0)
				{
				sRect.top += iVal;
				DrawTextExW(hDc,(LPWSTR)pString,iAdd,&sRect,uFormat,NULL);
				sRect.top -= iVal;
				}
			else{
				sRect.bottom += iVal;
				DrawTextExW(hDc,(LPWSTR)pString,iAdd,&sRect,uFormat,NULL);
				sRect.bottom -= iVal;
				}
			}
		else{
			DrawTextExW(hDc,(LPWSTR)pString,iAdd,&sRect,uFormat,NULL);
			}

		if(sFull.cy < sSize.cy)
			{
			sFull.cy = sSize.cy;
			}

		if((bNext^bLast)&0xC0)								// Andere Schrift
			{
			SelectObject(hDc,pFonts[bNext>>6]);
			}

		if(bLast&0x20)										// Text unterstreichen
			{
			if(!iLine)
				{
				GetTextMetrics(hDc,&sMetrics);
				iLine = (BYTE)(sMetrics.tmAscent+1);

				if(uFormat&(DT_BOTTOM|DT_VCENTER))
					{
					iDiff	= sRect.bottom-sRect.top-sSize.cy;

					if(uFormat&DT_BOTTOM)
							iLine +=iDiff;
					else	iLine +=iDiff/2;
					}
				}

			sArea.left	  = sRect.left;
			sArea.right   = sRect.left+sSize.cx;
			sArea.top     = sRect.top+iLine;
			sArea.bottom  = sArea.top+1;
			iCol		  = (uFormat&DT_ULINECOLOR)? 15:bLast&iAnd;

			SetBkColor(hDc,pColors[iCol]);
			ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);
			if(iAnd==0x1F)SetBkColor(hDc,uLastCbk);
			}

		bLast		= bNext;								// Vor auf nchsten Farbbereich
		pString	   += iAdd;
		pIndex	   += iAdd;
		iCount     -= iAdd;
		sRect.left += sSize.cx;

		if(sRect.left>=sRect.right)break;
		}



	if(pFonts)
		{
		SelectObject(hDc,hLastObj);
		SelectObject(hDc,hLastPen);
		}

	if(hRegion)
		{
		SelectClipRgn(hDc,hLastRgn);
		DeleteObject(hRegion);
		}

	SetTextColor(hDc,uLastCol );
	SetBkColor  (hDc,uLastCbk );
	SetBkMode   (hDc,uLastMode);



return sFull.cy;
}

//*****************************************************************************
//*
//*		ExtTextColor
//*
//*****************************************************************************
//	Zeichen einen Text in verschiedenen Farben,Schriften und Stillen
//	hDc			: Gerte DC auf dem gezeichnet wird
//	uOptions		: Format fr die Text Ausgabe mit folgenden Optionen
//						ETO_CLIPPED		: Text mit dem Rechteck abschneiden
//						ETO_OPAQUE		: Rechteck mit der Hintergrundfarbe fllen
//						ETO_RELATIVE	: Pos X/Y sind relativ zum Rechteck
//						ETO_BKCOLOR_?	: Wieviele Bits fr Hintergrund reservieren
//						ETO_NODEFAULT	: Keine Default-Text-Farbe (aktuelle HG-Farbe benutzen)
//						ETO_FONTCNT_?	: Ist die Anzahl der benutzen Fonts
//						ETO_ULINECOLOR	: Unterstreichen mit Farbe 15
//	pRect		: Rechteck in dem der Text ausgegeben wird. Beim Modus ETO_OPAQUE
//				  wird das Rechteck mit der aktuellen Hintergrundfarbe ausgemalen.
//	pString		: Zeiger auf den Text
//	iCount		: Lnge des Textes (muss grer gleich 0 sein)
//	pIndex		: Liste mit den Farb Indizes, bei 0 wird DrawTextEx(...) benutzt
//					Bit 0..4 = Farbnummer in pColors
//					Bit 5    = Unterstreichen
//					Bit 6..7 = Schriftart wenn pFonts ungleich NULL
//					Bit 2..4 = Hintergrund (siehe DT_BKCOLOR_?)
//	pColors		: Ist eine Liste mit bis zu 33 Farben, bei 0 werden
//				  Standartfarben benutzt. Bei der Hintergrundfarbe 0 wird
//				  die aktuelle Farbe benutzt, bei 1 der Index 31, bei 2 30 ...
//						00		mittel gelb oder default
//						01		dunkelblau
//						02		dunkelgrn
//						03		dunkeltrkis
//						04		dunkelrot
//						05		dunkellila
//						06		oker
//						07		dunkelgrau
//						08		hellgrau
//						09		blau
//						10		grn
//						11		trkis
//						12		rot
//						13		lila
//						14		gelb
//						15		hellrot (ETO_ULINECOLOR)
//						16		sehr dunkelgrau
//						17		sehr dunkelblau
//						18		sehr dunkelgrn
//						19		sehr dunkeltrkis
//						20		sehr dunkelrot
//						21		violet
//						22		dunkelviolet
//						23		mittel blau
//						24		schwarz
//						25 HG7   bastel grau
//						26 HG6	bastel lila
//						27 HG5	bastel grn
//						28 HG4	bastel blau
//						29 HG3	bastel rosa
//						30 HG2	weis
//						31 HG1	bastel gelb
//	pFonts		: Ist eine Liste von bis zu 4 Schriftarten. Wenn der
//				  Zeiger NULL ist wird die Schriftart nicht verndert.
//	Ergibt die X-Position vom Ende des Textes
EXTAPI BOOL WINAPI ExtTextColorA(HDC hDc,int iPosX,int iPosY,UINT uOptions,CONST RECT *pRect,LPCSTR pString,int iCount,CONST BYTE *pIndex,CONST COLORREF *pColors,CONST HFONT *pFonts)
{
INT			aAscent[5];
UINT		uLastMode;
COLORREF	uFirstCol;
COLORREF	uLastCbk;
COLORREF	uLastCol;
HGDIOBJ		hLastObj;
TEXTMETRIC	sMetrics;
RECT		sArea;
SIZE		sSize;
BYTE		bMask;
BYTE		bLast;
BYTE		bNext;
int			iBits;
int			iFrom;
int			iLine;
int 		iAnd;
int			iAdd;
int			iCol;
int			iIdx;



	if(uOptions&ETO_RELATIVE)								// Pos X/Y sind relativ zum Rechteck
		{
		iPosX	   += pRect->left;
		iPosY	   += pRect->top;
		}

	if(!pIndex)												// Keine Farbtabelle
		{
		if(!pFonts || !pFonts[0])
			{
			return ExtTextOutA(hDc,iPosX,iPosY,uOptions&~0xFF000000,pRect,pString,iCount,NULL);
			}

		hLastObj = SelectObject(hDc,pFonts[0]);
		iCol	 = ExtTextOutA(hDc,iPosX,iPosY,uOptions&~0xFF000000,pRect,pString,iCount,NULL);

		SelectObject(hDc,hLastObj);

		return iCol;
		}


	if(!pColors)pColors=aDefaultColors;						// Standartfarben


	aAscent[0]		= 0;
	aAscent[1]		= 0;
	aAscent[2]		= 0;
	aAscent[3]		= 0;
	iLine			= 0;
	bLast			= pIndex[0];


	if(pFonts)												// Mehrere Schriftarten
		{
		hLastObj	= GetCurrentObject(hDc,OBJ_FONT);
		iLine		= CalcFontAscent(hDc,uOptions&0xFFFF0000,iCount,pIndex,pFonts,aAscent)+1;
		SelectObject(hDc,pFonts[bLast>>6]);
		bMask		= 0xFF;
		bNext		= bLast;
		}
	else{													// Nur eine Schrift
		bMask		= 0x3F;
		bLast	   &= 0x3F;
		bNext		= bLast;
		aAscent[0]	= 0;
		}


	iFrom			= iPosX;
	iBits			= 5-((uOptions>>28)&3);					// Bits  fr Textfarben
	iAnd			= (1<<iBits)-1;							// Maske fr Hintergrund
	uLastMode		= GetBkMode   (hDc);
	uLastCbk		= GetBkColor  (hDc);
	uLastCol		= GetTextColor(hDc);
	uFirstCol		= (uOptions&ETO_NODEFAULT)? pColors[0]:uLastCol;
	uOptions	   &= ~0xFF000000;
	iPosY		   += aAscent[bLast>>6];

	if(iAnd!=0x1F && uLastMode!=OPAQUE)						// Hintergrund zeichnen
		{
		SetBkMode(hDc,(iAnd==0x1F)? TRANSPARENT:OPAQUE);
		}


	while(iCount>0)											// Alle Buchstaben durchlaufen
		{
		for(iAdd=1;iAdd<iCount;iAdd++)						// Vor bis zum Farbwechsel
			{
			   bNext = pIndex[iAdd]&bMask;
			if(bNext==bLast)continue;

			if(pString[iAdd]!=' ' && pString[iAdd]!='\xA0')	// Wenn kein ' ' sofort stoppen
				{
				break;
				}

			if((bNext^bLast)&~iAnd)break;					// Nur nderungen bei Vordergrund
			}

		iCol	= bLast&0x1F;

		if(iAnd!=0x1F)										// Auch Hintergrundfarbe verndern
			{
			iIdx   = iCol&iAnd;
			iCol >>= iBits;
			SetTextColor(hDc,(iIdx)? pColors[iIdx]:uFirstCol);

			if(iCol && (uOptions&ETO_OPAQUE))				// Hintergrund ausmahlen
				{
				ExtTextOutW(hDc,iPosX,iPosY,uOptions,pRect,NULL,0,NULL);
				uOptions   &= ~ETO_OPAQUE;
				}

			SetBkColor(hDc,(iCol)? pColors[32-iCol]:uLastCbk);
			}
		else{
			SetTextColor(hDc,(iCol)? pColors[iCol]:uFirstCol);
			}

		GetTextExtentPoint32A(hDc,pString,iAdd,&sSize);
		ExtTextOutA(hDc,iPosX,iPosY,uOptions,pRect,pString,iAdd,NULL);

		if((bNext^bLast)&0xC0)								// Andere Schrift
			{
			iPosY -= aAscent[bLast>>6];
			iPosY += aAscent[bNext>>6];
			SelectObject(hDc,pFonts[bNext>>6]);
			}

		if(bLast&0x20)										// Text unterstreichen
			{
			if(!iLine)
				{
				GetTextMetrics(hDc,&sMetrics);
				iLine = sMetrics.tmAscent+1;
				}

			sArea.left	  = iPosX;
			sArea.right   = iPosX+sSize.cx;
			sArea.top     = iPosY+iLine;
			sArea.bottom  = sArea.top+1;
			iCol		  = (uOptions&ETO_ULINECOLOR)? 15:bLast&iAnd;

			SetBkColor(hDc,pColors[iCol]);
			ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);
			if(iAnd==0x1F)SetBkColor(hDc,uLastCbk);
			}

		bLast		= bNext;								// Vor auf nchsten Farbbereich
		iPosX	   += sSize.cx;
		pString	   += iAdd;
		pIndex	   += iAdd;
		iCount     -= iAdd;
		uOptions   &= ~ETO_OPAQUE;

		if(iPosX>=pRect->right && (uOptions&ETO_CLIPPED))
			{
			break;
			}
		}


	if((uOptions&ETO_OPAQUE) && iFrom==iPosX)				// Hintergrund zeichnen falls keine Textausgabe
		{
		DrawRectanglePtr(hDc,pRect);
		}

	if(pFonts)												// Alten Font wieder herstellen
		{
		SelectObject(hDc,hLastObj);
		}

	SetTextColor(hDc,uLastCol );
	SetBkColor  (hDc,uLastCbk );
	SetBkMode   (hDc,uLastMode);



return iPosX;
}

EXTAPI INT WINAPI ExtTextColorW(HDC hDc,int iPosX,int iPosY,UINT uOptions,CONST RECT *pRect,LPCWSTR pString,int iCount,CONST BYTE *pIndex,CONST COLORREF *pColors,CONST HFONT *pFonts)
{
INT			aAscent[5];
UINT		uLastMode;
COLORREF	uFirstCol;
COLORREF	uLastCbk;
COLORREF	uLastCol;
HGDIOBJ		hLastObj;
TEXTMETRIC	sMetrics;
RECT		sArea;
SIZE		sSize;
BYTE		bMask;
BYTE		bLast;
BYTE		bNext;
int			iLine;
int			iBits;
int			iFrom;
int 		iAnd;
int			iAdd;
int			iCol;
int			iIdx;



	if(uOptions&ETO_RELATIVE)								// Pos X/Y sind relativ zum Rechteck
		{
		iPosX	   += pRect->left;
		iPosY	   += pRect->top;
		}


	if(!pIndex)												// Keine Farbtabelle
		{
		if(!pFonts || !pFonts[0])
			{
			return ExtTextOutW(hDc,iPosX,iPosY,uOptions&~0xFF000000,pRect,pString,iCount,NULL);
			}

		hLastObj = SelectObject(hDc,pFonts[0]);
		iCol	 = ExtTextOutW(hDc,iPosX,iPosY,uOptions&~0xFF000000,pRect,pString,iCount,NULL);

		SelectObject(hDc,hLastObj);

		return iCol;
		}


	if(!pColors)pColors=aDefaultColors;						// Standartfarben


	aAscent[0]		= 0;
	aAscent[1]		= 0;
	aAscent[2]		= 0;
	aAscent[3]		= 0;
	iLine			= 0;
	bLast			= pIndex[0];


	if(pFonts)												// Mehrere Schriftarten
		{
		hLastObj	= GetCurrentObject(hDc,OBJ_FONT);
		iLine		= CalcFontAscent(hDc,uOptions&0xFFFF0000,iCount,pIndex,pFonts,aAscent)+1;
		SelectObject(hDc,pFonts[bLast>>6]);
		bMask		= 0xFF;
		bNext		= bLast;
		}
	else{													// Nur eine Schrift
		bMask		= 0x3F;
		bLast	   &= 0x3F;
		bNext		= bLast;
		}

	iFrom			= iPosX;
	iBits			= 5-((uOptions>>28)&3);					// Bits fr Textfarben
	iAnd			= (1<<iBits)-1;							// Maske fr Hintergrund
	uLastMode		= GetBkMode   (hDc);
	uLastCbk		= GetBkColor  (hDc);
	uLastCol		= GetTextColor(hDc);
	uFirstCol		= (uOptions&DT_NODEFAULT)? pColors[0]:uLastCol;
	uOptions	   &= ~0xFF000000;
	iPosY		   += aAscent[bLast>>6];

	if(iAnd!=0x1F && uLastMode!=OPAQUE)						// Hintergrund zeichnen
		{
		SetBkMode(hDc,(iAnd==0x1F)? TRANSPARENT:OPAQUE);
		}


	while(iCount>0)											// Alle Buchstaben durchlaufen
		{
		for(iAdd=1;iAdd<iCount;iAdd++)						// Vor bis zum Farbwechsel
			{
			   bNext = pIndex[iAdd]&bMask;
			if(bNext==bLast)continue;

			if(pString[iAdd]!=' ' && pString[iAdd]!='\xA0')	// Wenn kein ' ' sofort stoppen
				{
				break;
				}

			if((bNext^bLast)&~iAnd)break;					// Nur nderungen bei Vordergrund
			}

		iCol	= bLast&0x1F;

		if(iAnd!=0x1F)										// Auch Hintergrundfarbe verndern
			{
			iIdx   = iCol&iAnd;
			iCol >>= iBits;
			SetTextColor(hDc,(iIdx)? pColors[iIdx]:uFirstCol);

			if(iCol && (uOptions&ETO_OPAQUE))				// Hintergrund ausmahlen
				{
				ExtTextOutW(hDc,iPosX,iPosY,uOptions,pRect,NULL,0,NULL);
				uOptions   &= ~ETO_OPAQUE;
				}

			SetBkColor(hDc,(iCol)? pColors[32-iCol]:uLastCbk);
			}
		else{
			SetTextColor(hDc,(iCol)? pColors[iCol]:uFirstCol);
			}

		GetTextExtentPoint32W(hDc,pString,iAdd,&sSize);
		ExtTextOutW(hDc,iPosX,iPosY,uOptions,pRect,pString,iAdd,NULL);

		if((bNext^bLast)&0xC0)								// Andere Schrift
			{
			iPosY -= aAscent[bLast>>6];
			iPosY += aAscent[bNext>>6];
			SelectObject(hDc,pFonts[bNext>>6]);
			}

		if(bLast&0x20)										// Text unterstreichen
			{
			if(!iLine)
				{
				GetTextMetrics(hDc,&sMetrics);
				iLine = (BYTE)(sMetrics.tmAscent+1);
				}

			sArea.left	  = iPosX;
			sArea.right   = iPosX+sSize.cx;
			sArea.top     = iPosY+iLine;
			sArea.bottom  = sArea.top+1;
			iCol		  = (uOptions&ETO_ULINECOLOR)? 15:bLast&iAnd;

			SetBkColor(hDc,pColors[iCol]);
			ExtTextOutW(hDc,0,0,ETO_OPAQUE,&sArea,NULL,0,NULL);
			if(iAnd==0x1F)SetBkColor(hDc,uLastCbk);
			}

		bLast		= bNext;								// Vor auf nchsten Farbbereich
		iPosX	   += sSize.cx;
		pString	   += iAdd;
		pIndex	   += iAdd;
		iCount     -= iAdd;
		uOptions   &= ~ETO_OPAQUE;

		if(iPosX>=pRect->right && (uOptions&ETO_CLIPPED))
			{
			break;
			}
		}


	if((uOptions&ETO_OPAQUE) && iFrom==iPosX)				// Hintergrund zeichnen falls keine Textausgabe
		{
		DrawRectanglePtr(hDc,pRect);
		}

	if(pFonts)												// Alten Font wieder herstellen
		{
		SelectObject(hDc,hLastObj);
		}

	SetTextColor(hDc,uLastCol );
	SetBkColor  (hDc,uLastCbk );
	SetBkMode   (hDc,uLastMode);



return iPosX;
}

//*****************************************************************************
//*
//*		GetTextExtentEx
//*
//*****************************************************************************
//	Berechnet die ob ein Text in eine Breite passt.
//	hDc			: Gerte DC auf dem gezeichnet wird
//	pString		: Zeiger auf den Text
//	iCount		: Lnge des Textes
//	iMaxExtent	: Ist die maximale Breite in Pixel
//	pFit		: Hier wird gespeichert wieviele Buchstaben hinein passen.
//	pPixelPos	: Hier werden die Endpixel der Buchstaben gespeichert.
//				  Nur bis zum letzten hinein passenden.
//	pSize		: Hier wird die ganze Breite gespeichert
//	pIndex		: Liste mit den Farb Indizes, bei 0 wird DrawTextEx(...) benutzt
//					Bit 0..4 = Farbnummer in pColors
//					Bit 5    = Unterstreichen
//					Bit 6..7 = Schriftart wenn pFonts ungleich NULL
//					Bit 2..4 = Hintergrund (siehe DT_BKCOLOR_?)
//	pFonts		: Ist eine Liste von bis zu 4 Schriftarten. Wenn der
//				  Zeiger NULL ist wird die Schriftart nicht verndert.
//	Ergibt TRUE wenn die Funktion erfolgreich war.
EXTAPI BOOL WINAPI GetTextExtentExA(HDC hDc,LPCSTR pString,int iCount,int iMaxExtent,LPINT pFit,LPINT pPixelPos,LPSIZE pSize,CONST BYTE *pIndex,CONST HFONT *pFonts)
{
HGDIOBJ		hLastObj;
SIZE		sSize;
BYTE		bLast;
BYTE		bNext;
int			iAdd;
int			iPos;
int			iOff;
int			iAll;
int			iNum;


	if(!pFonts || !pIndex || iCount<=0)						// Gibt es keine Fonts
		{
		return GetTextExtentExPointA(hDc,pString,iCount,iMaxExtent,pFit,pPixelPos,pSize);
		}

	hLastObj		= GetCurrentObject(hDc,OBJ_FONT);
	bLast			= pIndex[0]>>6;
	iCount		   &= ~0x70000000;
	iOff			= 0;
	iAll			= 0;


	while(iCount>0)											// Alle Buchstaben durchlaufen
		{
		for(iAdd=1;iAdd<iCount;iAdd++)						// Vor bis zum Farbwechsel
			{
			   bNext = pIndex[iAdd]>>6;
			if(bNext!=bLast)break;
			}

		SelectObject(hDc,pFonts[bLast]);
															// Berechne die Textbreiten
		if(!GetTextExtentExPointA(hDc,pString,iAdd,iMaxExtent,&iNum,pPixelPos,&sSize))
			{
			break;
			}

		if(pPixelPos)
			{												// Buchstabenpositionen korrigieren
			if(iOff)
				{
				for(iPos=iNum;iPos>0;iPos--)
					{
					*pPixelPos += iOff;
					 pPixelPos += 1;
					 }
				}
			else{
				pPixelPos += iNum;
				}

			if(iNum<iAdd)
				{
				pPixelPos = 0;
				}
			}

		iMaxExtent -= sSize.cx;								// Ergebnis umsetzen
		iOff	   += sSize.cx;
		iAll       += iNum;
		pString	   += iAdd;									// Vor auf nchsten Farbbereich
		pIndex	   += iAdd;
		iCount     -= iAdd;
		bLast		= bNext;
		}

	if(pFit)
		{
		*pFit=iAll;
		}

	if(pSize)
		{
		pSize->cy	= sSize.cy;
		pSize->cx	= iOff;
		}

	SelectObject(hDc,hLastObj);



return TRUE;
}

EXTAPI BOOL WINAPI GetTextExtentExW(HDC hDc,LPCWSTR pString,int iCount,int iMaxExtent,LPINT pFit,LPINT pPixelPos,LPSIZE pSize,CONST BYTE *pIndex,CONST HFONT *pFonts)
{
HGDIOBJ		hLastObj;
SIZE		sSize;
BYTE		bLast;
BYTE		bNext;
int			iAdd;
int			iPos;
int			iOff;
int			iAll;
int			iNum;


	if(!pFonts || !pIndex || iCount<=0)						// Gibt es keine Fonts
		{
		return GetTextExtentExPointW(hDc,pString,iCount,iMaxExtent,pFit,pPixelPos,pSize);
		}

	hLastObj		= GetCurrentObject(hDc,OBJ_FONT);
	bLast			= pIndex[0]>>6;
	iCount		   &= ~0x70000000;
	iOff			= 0;
	iAll			= 0;


	while(iCount>0)											// Alle Buchstaben durchlaufen
		{
		for(iAdd=1;iAdd<iCount;iAdd++)						// Vor bis zum Farbwechsel
			{
			   bNext = pIndex[iAdd]>>6;
			if(bNext!=bLast)break;
			}

		SelectObject(hDc,pFonts[bLast]);
															// Berechne die Textbreiten
		if(!GetTextExtentExPointW(hDc,pString,iAdd,iMaxExtent,&iNum,pPixelPos,&sSize))
			{
			break;
			}

		if(pPixelPos)
			{												// Buchstabenpositionen korrigieren
			if(iOff)
				{
				for(iPos=iNum;iPos>0;iPos--)
					{
					*pPixelPos += iOff;
					 pPixelPos += 1;
					 }
				}
			else{
				pPixelPos += iNum;
				}

			if(iNum<iAdd)
				{
				pPixelPos = 0;
				}
			}

		iMaxExtent -= sSize.cx;								// Ergebnis umsetzen
		iOff	   += sSize.cx;
		iAll       += iNum;
		pString	   += iAdd;									// Vor auf nchsten Farbbereich
		pIndex	   += iAdd;
		iCount     -= iAdd;
		bLast		= bNext;
		}

	if(pFit)
		{
		*pFit=iAll;
		}

	if(pSize)
		{
		pSize->cy	= sSize.cy;
		pSize->cx	= iOff;
		}

	SelectObject(hDc,hLastObj);



return TRUE;
}

//*****************************************************************************
//*
//*		GetTabbedSizeEx
//*
//*****************************************************************************
//	Berechnet die Breite eines Textes unter Bercksichtigung von Tabs und Farben. 
//	hDc		: Handle des Device Contextes
//	iPosX	: Startkoordinate des Textes
//	pText	: Zeiger auf den Text
//	pColors	: Zeiger auf die Farben (Bit0..4=Farben Bit5=Unterstreichen Bit6=Fett Bit7=Fixe Breite)
//	iCount	: Ist die Lnge des Textes
//	iTabCnt	: Anzahl der Tabs (0=Zeichenbreite*8 1=Fixe Schritte 2...=Variable Schritte)
//	pTabs	: Zeiger auf die Tabpositionen
//	iOrigin	: Ist der Offset des Zeilenbeginns 
//	pFonts	: Zeiger auf die 4 Schriften  (bei NULL nur eine Schrift)
//	Ergibt die Breite des Textes in Pixel.
EXTAPI DWORD WINAPI GetTabbedSizeExA(HDC hDc,INT iPosX,LPCSTR pText,CONST BYTE *pColors,INT iCount,INT iTabCnt,CONST INT *pTabs,INT iOrigin,HFONT *pFonts)
{
TEXTMETRICA		sMetric;
HGDIOBJ			hOldObj;
SIZE			sSize;
RECT			sRect;
BYTE			bLast;
BYTE			bMask;
UINT			uFont;
int 			iWidth;
int				iStart;
int				iNext;
int				iOff;
int				iTab;
int				iNum;
int				iIdx;



	if(iCount<=0)											// Textlnge prfen
		{
		return 0;
		}

	iTab    = 0;
	uFont   = 0;
	iStart  = iPosX;
	bMask	= (pFonts)? 0xC0:0x00;
	
	if(pFonts)
		{
		hOldObj = SelectObject(hDc,pFonts[0]);
		}


    if(iTabCnt==1)											// Gleiche Tabbreite fr alle Schritte	
		{
        iTabCnt		= 0;
        iWidth		= pTabs[0];
		}
    else{
        GetTextMetricsA(hDc,&sMetric );
		iWidth		= sMetric.tmAveCharWidth*8;
		}

    while(iCount>0)
		{
		bLast		= pColors[0];
        iOff		= iPosX;
        sRect.left	= iOff;

        for(iIdx=0;iIdx<iCount;iIdx++)						// Zhle die Tabs
			{
            if(pText[iIdx]!='\t')break;
			if((bLast^pColors[iIdx])&bMask)break;
			}

		for(iNum=iIdx;iNum<iCount;iNum++)					// Zhle Buchstaben nach dem Tab
			{
            if(pText[iNum]=='\t')break;
			if((bLast^pColors[iNum])&bMask)break;
			}

		if(pFonts && ((bLast>>6)^uFont))					// Anderen Font auswhlen
			{
			uFont = bLast>>6;
			SelectObject(hDc,pFonts[uFont]);
			}

		
		GetTextExtentPoint32A(hDc,pText+iIdx,iNum-iIdx,&sSize);
 
        
		if(iIdx==0)											// Sind keine Tabs am Ende
			{
			iPosX   += sSize.cx;
			pText   += iNum;
			pColors	+= iNum;
			iCount  -= iNum;					

			continue;
			}

        
		for(;iIdx<iTabCnt;pTabs++,iTabCnt--)				// Suche nchsten Tab-Stop
			{
			   iNext = *pTabs;
			if(iNext<0)iNext=-iNext;

            if(iOrigin+iNext<=iPosX) 
				{
				continue;
				}

            if(pTabs[iIdx-1]>=0)							// Tab ist links bndig
				{
                iPosX = iOrigin+pTabs[iIdx-1]+sSize.cx;
                break;
				}
															// Tab ist rechs bndig
			if(iOrigin-pTabs[iIdx-1]-sSize.cx > iPosX)
				{
				iPosX = iOrigin-pTabs[iIdx-1];
                iOff  = iPosX  -sSize.cx;
                break;
				}
			}

        if(iIdx>=iTabCnt)									// Konstane Tab-Sprnge 
			{
			if(iWidth>0) 
				{
				iOff  = iOrigin + ((iPosX - iOrigin) / iWidth + iIdx) * iWidth;
				iPosX = iOff + sSize.cx;
				} 
			else if(iWidth<0) 
				{
				iPosX = iOrigin + ((iPosX - iOrigin + sSize.cx) / -iWidth + iIdx) * -iWidth;
				iOff  = iPosX - sSize.cx;
				}
			}

        iCount  -= iNum;									// Zeichen berspringen
        pText   += iNum;
		pColors	+= iNum;
		}


	SelectObject(hDc,hOldObj);


return iPosX-iStart;
}

EXTAPI DWORD WINAPI GetTabbedSizeExW(HDC hDc,INT iPosX,LPCWSTR pText,CONST BYTE *pColors,INT iCount,INT iTabCnt,CONST INT *pTabs,INT iOrigin,HFONT *pFonts)
{
TEXTMETRICA		sMetric;
HGDIOBJ			hOldObj;
SIZE			sSize;
RECT			sRect;
BYTE			bLast;
BYTE			bMask;
UINT			uFont;
int 			iWidth;
int				iStart;
int				iNext;
int				iOff;
int				iTab;
int				iNum;
int				iIdx;



	if(iCount<=0)											// Textlnge prfen
		{
		return 0;
		}

	iTab    = 0;
	uFont   = 0;
	iStart  = iPosX;
	bMask	= (pFonts)? 0xC0:0x00;
	
	if(pFonts)
		{
		hOldObj = SelectObject(hDc,pFonts[0]);
		}


    if(iTabCnt==1)											// Gleiche Tabbreite fr alle Schritte	
		{
        iTabCnt		= 0;
        iWidth		= pTabs[0];
		}
    else{
        GetTextMetricsA(hDc,&sMetric );
		iWidth		= sMetric.tmAveCharWidth*8;
		}

    while(iCount>0)
		{
		bLast		= pColors[0];
        iOff		= iPosX;
        sRect.left	= iOff;

        for(iIdx=0;iIdx<iCount;iIdx++)						// Zhle die Tabs
			{
            if(pText[iIdx]!='\t')break;
			if((bLast^pColors[iIdx])&bMask)break;
			}

		for(iNum=iIdx;iNum<iCount;iNum++)					// Zhle Buchstaben nach dem Tab
			{
            if(pText[iNum]=='\t')break;
			if((bLast^pColors[iNum])&bMask)break;
			}

		if(pFonts && ((bLast>>6)^uFont))					// Anderen Font auswhlen
			{
			uFont = bLast>>6;
			SelectObject(hDc,pFonts[uFont]);
			}

		
		GetTextExtentPoint32W(hDc,pText+iIdx,iNum-iIdx,&sSize);
 
        
		if(iIdx==0)											// Sind keine Tabs am Ende
			{
			iPosX   += sSize.cx;
			pText   += iNum;
			pColors	+= iNum;
			iCount  -= iNum;					

			continue;
			}

        
		for(;iIdx<iTabCnt;pTabs++,iTabCnt--)				// Suche nchsten Tab-Stop
			{
			   iNext = *pTabs;
			if(iNext<0)iNext=-iNext;

            if(iOrigin+iNext<=iPosX) 
				{
				continue;
				}

            if(pTabs[iIdx-1]>=0)							// Tab ist links bndig
				{
                iPosX = iOrigin+pTabs[iIdx-1]+sSize.cx;
                break;
				}
															// Tab ist rechs bndig
			if(iOrigin-pTabs[iIdx-1]-sSize.cx > iPosX)
				{
				iPosX = iOrigin-pTabs[iIdx-1];
                iOff  = iPosX  -sSize.cx;
                break;
				}
			}

        if(iIdx>=iTabCnt)									// Konstane Tab-Sprnge 
			{
			if(iWidth>0) 
				{
				iOff  = iOrigin + ((iPosX - iOrigin) / iWidth + iIdx) * iWidth;
				iPosX = iOff + sSize.cx;
				} 
			else if(iWidth<0) 
				{
				iPosX = iOrigin + ((iPosX - iOrigin + sSize.cx) / -iWidth + iIdx) * -iWidth;
				iOff  = iPosX - sSize.cx;
				}
			}

        iCount  -= iNum;									// Zeichen berspringen
        pText   += iNum;
		pColors	+= iNum;
		}


	SelectObject(hDc,hOldObj);


return iPosX-iStart;
}

//*****************************************************************************
//*
//*		SelectBkColorEx
//*
//*****************************************************************************
//	Whlt eine Hintergrundfarbe aus
//	hDc			: Gerte DC auf dem gezeichnet wird
//	uOptions		: Format fr die Text Ausgabe mit folgenden Optionen
//						ETO_CLIPPED		: Text mit dem Rechteck abschneiden
//						ETO_OPAQUE		: Rechteck mit der Hintergrundfarbe fllen
//						ETO_RELATIVE	: Pos X/Y sind relativ zum Rechteck
//						ETO_BKCOLOR_?	: Wieviele Bits fr Hintergrund reservieren
//						ETO_NODEFAULT	: Keine Default-Text-Farbe (aktuelle HG-Farbe benutzen)
//						ETO_FONTCNT_?	: Ist die Anzahl der benutzen Fonts
//						ETO_ULINECOLOR	: Unterstreichen mit Farbe 15
//	bIndex		: Ist der Farb Indizes, bei 0 wird die aktuelle Farbe behalten
//					Bit 0..4 = Farbnummer in pColors
//					Bit 5    = Unterstreichen
//					Bit 6..7 = Schriftart wenn pFonts ungleich NULL
//					Bit 2..4 = Hintergrund (siehe DT_BKCOLOR_?)
//	pColors		: Ist eine Liste mit bis zu 33 Farben, bei 0 werden
//				  Standartfarben benutzt. Bei der Hintergrundfarbe 0 wird
//				  die aktuelle Farbe benutzt, bei 1 der Index 31, bei 2 30 ...
//						00		mittel gelb oder default
//						01		dunkelblau
//						02		dunkelgrn
//						03		dunkeltrkis
//						04		dunkelrot
//						05		dunkellila
//						06		oker
//						07		dunkelgrau
//						08		hellgrau
//						09		blau
//						10		grn
//						11		trkis
//						12		rot
//						13		lila
//						14		gelb
//						15		hellrot (ETO_ULINECOLOR)
//						16		sehr dunkelgrau
//						17		sehr dunkelblau
//						18		sehr dunkelgrn
//						19		sehr dunkeltrkis
//						20		sehr dunkelrot
//						21		violet
//						22		dunkelviolet
//						23		mittel blau
//						24		schwarz
//						25 HG7   bastel grau
//						26 HG6	bastel lila
//						27 HG5	bastel grn
//						28 HG4	bastel blau
//						29 HG3	bastel rosa
//						30 HG2	weis
//						31 HG1	bastel gelb
//	Ergibt die alte Farbe.
EXTAPI COLORREF WINAPI SelectBkColorEx(HDC hDc,UINT uOptions,BYTE bIndex,CONST COLORREF *pColors)
{
int			iBits;
int			iAnd;


	if(!(uOptions&0x70000000))								// Keine Hintergrundfarbe benutzt
		{
		return GetBkColor(hDc);
		}

	if(!pColors)pColors=aDefaultColors;						// Standartfarben


	iBits	 =  5-((uOptions>>28)&3);
	iAnd 	 = (1<<iBits)-1;

	if(iAnd==0x1F)											// Keine Bits fr die Hintergrundfarbe
		{
		return GetBkColor(hDc);
		}

	bIndex  &= iAnd;
	bIndex >>= iBits;

	if(!bIndex)												// Aktuelle Hintergrundfarbe benzuten
		{
		return GetBkColor(hDc);
		}


return SetBkColor(hDc,pColors[32-bIndex]);
}

//*****************************************************************************
//*
//*		SelectTextColorEx
//*
//*****************************************************************************
//	Whlt eine Textfarbe aus
//	hDc			: Gerte DC auf dem gezeichnet wird
//	uOptions		: Format fr die Text Ausgabe mit folgenden Optionen
//						ETO_CLIPPED		: Text mit dem Rechteck abschneiden
//						ETO_OPAQUE		: Rechteck mit der Hintergrundfarbe fllen
//						ETO_RELATIVE	: Pos X/Y sind relativ zum Rechteck
//						ETO_BKCOLOR_?	: Wieviele Bits fr Hintergrund reservieren
//						ETO_NODEFAULT	: Keine Default-Text-Farbe (aktuelle HG-Farbe benutzen)
//						ETO_FONTCNT_?	: Ist die Anzahl der benutzen Fonts
//						ETO_ULINECOLOR	: Unterstreichen mit Farbe 15
//	bIndex		: Ist der Farb Indizes, bei 0 wird die aktuelle Farbe behalten
//					Bit 0..4 = Farbnummer in pColors
//					Bit 5    = Unterstreichen
//					Bit 6..7 = Schriftart wenn pFonts ungleich NULL
//					Bit 2..4 = Hintergrund (siehe DT_BKCOLOR_?)
//	pColors		: Ist eine Liste mit bis zu 33 Farben, bei 0 werden
//				  Standartfarben benutzt. Bei der Hintergrundfarbe 0 wird
//				  die aktuelle Farbe benutzt, bei 1 der Index 31, bei 2 30 ...
//						00		mittel gelb oder default
//						01		dunkelblau
//						02		dunkelgrn
//						03		dunkeltrkis
//						04		dunkelrot
//						05		dunkellila
//						06		oker
//						07		dunkelgrau
//						08		hellgrau
//						09		blau
//						10		grn
//						11		trkis
//						12		rot
//						13		lila
//						14		gelb
//						15		hellrot (ETO_ULINECOLOR)
//						16		sehr dunkelgrau
//						17		sehr dunkelblau
//						18		sehr dunkelgrn
//						19		sehr dunkeltrkis
//						20		sehr dunkelrot
//						21		violet
//						22		dunkelviolet
//						23		mittel blau
//						24		schwarz
//						25 HG7   bastel grau
//						26 HG6	bastel lila
//						27 HG5	bastel grn
//						28 HG4	bastel blau
//						29 HG3	bastel rosa
//						30 HG2	weis
//						31 HG1	bastel gelb
//	Ergibt die alte Farbe.
EXTAPI COLORREF WINAPI SelectTextColorEx(HDC hDc,UINT uOptions,BYTE bIndex,CONST COLORREF *pColors)
{
int			iBits;
int			iAnd;


	if(!(uOptions&0x70000000))								// Keine Hintergrundfarbe benutzt
		{
		return GetBkColor(hDc);
		}

	if(!pColors)pColors=aDefaultColors;						// Standartfarben


	iBits	 =  5-((uOptions>>28)&3);
	iAnd 	 = (1<<iBits)-1;
	bIndex  &= iAnd;

	if(!bIndex && !(uOptions&DT_NODEFAULT))					// Aktuelle Textfarbe benzuten
		{
		return GetTextColor(hDc);
		}



return SetTextColor(hDc,pColors[bIndex]);
}

//*****************************************************************************
//*
//*		DrawGrayText
//*
//*****************************************************************************
//	Zeichnet einen grauen einzeiligen Text
//	hDc			: Gerte DC auf dem gezeichnet wird
//	pText		: Zeiger auf den Text der ausgegeben werden soll.
//	iCount		: Lnge des Textes (-1=automatisch ermitteln)
//	uFlags		: Sind die Anzeige-Flags
//					DT_CENTER
//					DT_LEFT
//					DT_RIGHT
//					DT_VCENTER
//					DT_BOTTOM
//					DT_TOP
//					DT_NOPREFIX
//	Ergibt TRUE wenn erfolgreich bzw. FALSE bei einem Fehler.
EXTAPI BOOL	WINAPI DrawGrayTextA(HDC hDc,LPCSTR pText,INT iCount,LPCRECT pRect,UINT uFlags)
{
SIZE		sSize;
SIZE		sStep;
int			iDiff;
int			iChar;
int			iMode;
int			iPosX;
int			iPosY;
int			iNumX;
int			iNumY;




	iPosX	= pRect->left;
	iPosY	= pRect->top;
	iNumX	= pRect->right -iPosX;
	iNumY	= pRect->bottom-iPosY;

	if(iNumX<=0 || iNumY<=0)
		{
		return FALSE;
		}


	if(iCount< 0)iCount=(int)strlen(pText);
	if(iCount==0)return TRUE;


	if(uFlags&DT_NOPREFIX)
			iMode = DSS_DISABLED|DST_TEXT;
	else	iMode = DSS_DISABLED|DST_PREFIXTEXT;


	if(uFlags&(DT_CENTER|DT_VCENTER|DT_BOTTOM|DT_RIGHT))
		{
		GetTextExtentPoint32A(hDc,pText,iCount,&sSize);

		if(!(uFlags&DT_NOPREFIX))					// Die Breite der '&' Zeichen abziehen
			{
			for(iDiff=0,iChar=0;iDiff<iCount;iDiff++)
				{
				if(pText[iDiff]=='&')iChar++;
				}

			if(iChar)
				{
				GetTextExtentPoint32A(hDc,"&",1,&sStep);
				sSize.cx -= iChar*sStep.cx;
				}
			}

		if(uFlags&DT_CENTER)
			{
			   iDiff = iNumX-sSize.cx;
			if(iDiff>0)iPosX+=iDiff/2;
			}
		else if(uFlags&DT_RIGHT)
			{
			   iDiff = iNumX-sSize.cx;
			if(iDiff>0)iPosX+=iDiff-1;
			}

		if(uFlags&DT_VCENTER)
			{
			   iDiff = iNumY-sSize.cy;
			if(iDiff>0)iPosY+=iDiff/2;
			}
		else if(uFlags&DT_BOTTOM)
			{
			   iDiff = iNumY-sSize.cy;
			if(iDiff>0)iPosY+=iDiff-1;
			}
		}




return DrawStateA(hDc,NULL,NULL,(LPARAM)pText,iCount,iPosX,iPosY,iNumX,iNumY,iMode);
}

EXTAPI BOOL	WINAPI DrawGrayTextW(HDC hDc,LPCWSTR pText,INT iCount,LPCRECT pRect,UINT uFlags)
{
SIZE		sSize;
SIZE		sStep;
int			iDiff;
int			iChar;
int			iMode;
int			iPosX;
int			iPosY;
int			iNumX;
int			iNumY;





	iPosX	= pRect->left;
	iPosY	= pRect->top;
	iNumX	= pRect->right -iPosX;
	iNumY	= pRect->bottom-iPosY;

	if(iNumX<=0 || iNumY<=0)
		{
		return FALSE;
		}


	     if(iCount< 0)iCount=(int)wcslen(pText);
	else if(iCount==0)pText=L"";


	if(uFlags&DT_NOPREFIX)
			iMode = DSS_DISABLED|DST_TEXT;
	else	iMode = DSS_DISABLED|DST_PREFIXTEXT;


	if(uFlags&(DT_CENTER|DT_VCENTER|DT_BOTTOM|DT_RIGHT))
		{
		GetTextExtentPoint32W(hDc,pText,iCount,&sSize);

		if(!(uFlags&DT_NOPREFIX))					// Die Breite der '&' Zeichen abziehen
			{
			for(iDiff=0,iChar=0;iDiff<iCount;iDiff++)
				{
				if(pText[iDiff]=='&')iChar++;
				}

			if(iChar)
				{
				GetTextExtentPoint32A(hDc,"&",1,&sStep);
				sSize.cx -= iChar*sStep.cx;
				}
			}

		if(uFlags&DT_CENTER)
			{
			   iDiff = iNumX-sSize.cx;
			if(iDiff>0)iPosX+=iDiff/2;
			}
		else if(uFlags&DT_RIGHT)
			{
			   iDiff = iNumX-sSize.cx;
			if(iDiff>0)iPosX+=iDiff-1;
			}

		if(uFlags&DT_VCENTER)
			{
			   iDiff = iNumY-sSize.cy;
			if(iDiff>0)iPosY+=iDiff/2;
			}
		else if(uFlags&DT_BOTTOM)
			{
			   iDiff = iNumY-sSize.cy;
			if(iDiff>0)iPosY+=iDiff-1;
			}
		}




return DrawStateW(hDc,NULL,NULL,(LPARAM)pText,iCount,iPosX,iPosY,iNumX,iNumY,iMode);
}

//*****************************************************************************
//*
//*		DrawFlatButtonEx
//*
//*****************************************************************************
//	Zeichnet eine Taste mit einem ein Pixel breiten Rahmen.
//	hDc			: Gerte DC auf dem gezeichnet wird.
//	iPosX/Y		: Ist die Position der Taste.
//	iSizeX/Y	: Ist die Breite und Hhe der Taste.
//	uFlags		: Bestimmt die Ausgabeart:
//						PFB_PRESSED	0x00000001	Taste gedrckt zeichnen
//						PFB_FILLED	0x00000002	Taste gefllt zeichnen
//						PFB_HOT		0x00000004	Taste etwas dunkler fllen
//						PFB_MONO	0x00000008	Den Rahmen einfarbig zeichnen
EXTAPI VOID	WINAPI DrawFlatButtonEx(HDC hDc,INT iPosX,INT iPosY,INT iSizeX,int iSizeY,UINT uFlags)
{
COLORREF	uColorOld;
RECT		sRect;


	if(iSizeX<=0 || iSizeY<=0)return;


	if(!(uFlags&PFB_MONO))
		{
		uColorOld = SetBkColor(hDc,(uFlags&PFB_PRESSED)? GetSysColor(COLOR_3DSHADOW):RGB(255,255,255));
		}
	else{
		uColorOld = GetBkColor(hDc);
		}

	sRect.top		= iPosY;
	sRect.left		= iPosX;
	sRect.right		= iPosX+iSizeX-1;
	sRect.bottom	= iPosY+1;

	DrawRectanglePtr(hDc,&sRect);

	sRect.top		= iPosY+1;
	sRect.right		= iPosX+1;
	sRect.bottom	= iPosY+iSizeY-1;

	DrawRectanglePtr(hDc,&sRect);


	if(!(uFlags&PFB_MONO))
		{
		SetBkColor(hDc,(uFlags&PFB_PRESSED)? RGB(255,255,255):GetSysColor(COLOR_3DSHADOW));
		}

	sRect.top		= iPosY+iSizeY-1;
	sRect.right		= iPosX+iSizeX;
	sRect.bottom	= sRect.top+1;

	DrawRectanglePtr(hDc,&sRect);

	sRect.top		= iPosY;
	sRect.left		= sRect.right -1;
	sRect.bottom	= sRect.bottom-1;

	DrawRectanglePtr(hDc,&sRect);

	if(uFlags&PFB_FILLED)
		{
		SetBkColor(hDc,(uFlags&PFB_HOT)? GetSysColor(COLOR_3DLIGHT):GetSysColor(COLOR_3DFACE));

		sRect.top		= iPosY+1;
		sRect.left		= iPosX+1;
		sRect.right		= iPosX+iSizeX-1;
		sRect.bottom	= iPosY+iSizeY-1;

		DrawRectanglePtr(hDc,&sRect);
		}

	SetBkColor(hDc,uColorOld);

}


//*****************************************************************************
//*
//*		DrawButtonW
//*
//*****************************************************************************
//	Zeichnet eine Taste mit bzw. ohne Windows-Thema.
//	hDc			: Device-Context in dem gezeichnet wird
//	pText		: Text fr die Taste (bei 0 wird kein Text gezeichnet)
//	pRect		: Wo soll die Taste gezeichnet werden
//	iState		: Wie soll die Taste gezeichnet werden
//					PBS_NORMAL      1		Taste normal zeichnen
//					PBS_HOT         2		Maus ist ber der Taste
//					PBS_PRESSED     3		Taste ist gedrckt
//					PBS_DISABLED    4		Taste ist gesperrt
//					PBS_DEFAULTED   5		Taste ist die Standarttaste
//					DB_ANSITEXT		0x0100	Der Text ist kein UNICODE
//					DB_BACKGROUND	0x0200	Hintergrund zeichnen
//					DB_USENOTHEMA	0x0400	Keinen Windows-Tema verwenden
//					DB_HASYDELTA	0x0800	Fr die Y-Richtung gibt es ein extra Delta
//					DB_TEXTLEFT(a)			Den Text links ausrichten bei Offset a
//	iFrame		: Gre des Rahmens um die Taste in Pixeln. Das Rechteck fr
//				  die Taste wird um diese Pixelanzahl verkleinert.
EXTAPI void WINAPI DrawButtonW(HDC hDc,LPCWSTR pText,LPCRECT pRect,int iState,int iFrame)
{
WCHAR		cText[64];
UINT		uOldMode;
COLORREF	uOldTxt;
COLORREF	uOldBk;
INT			iDelta;
LPCSTR		pAnsi;
LPCRECT		pDraw;
RECT		sLeft;
RECT		sTemp;
RECT		sRect;
UINT		uEdge;
UINT		uMode;
UINT		uText;
size_t		iLen;



	if(!bUxThemeDone)									// Thema laden
		{
		LoadUxThemeDll();
		}


	if(iFrame)											// Rechteck um den Rahmen verkleinern
		{
		if(iState&DB_HASYDELTA)
			{
			iDelta = GET_Y_LPARAM(iFrame);
			iFrame = GET_X_LPARAM(iFrame);
			}
		else{
			iDelta = iFrame;
			}

		sTemp.left	= pRect->left  +iFrame;
		sTemp.right	= pRect->right -iFrame;
		sTemp.top	= pRect->top   +iDelta;
		sTemp.bottom= pRect->bottom-iDelta;
		pDraw		= &sTemp;
		}
	else{
		pDraw		= pRect;
		}


	if(hButtonTheme && !(iState&DB_USENOTHEMA))			// Mit Thema zeichnen
		{
		if(!pText)
			{
			iLen	= 0;
			}
		else if(iState&DB_ANSITEXT)						// In UNICODE konvertieren
			{
			pAnsi	= (LPCSTR)pText;
			pText	= cText;

			for(iLen=0;iLen<sizeof(cText)/sizeof(cText[0]);iLen++)
				{
				if(!pAnsi[iLen])break;
				cText[iLen] = (BYTE)pAnsi[iLen];
				}
			}
		else{
			iLen	= wcslen(pText);
			}


		if(iState&DB_BACKGROUND)						// Hintergrund zeichnen
			{
			uOldBk	 = GetBkColor  (hDc);
			SetBkColor (hDc,GetSysColor(COLOR_BTNFACE));
			DrawFrameEx(hDc,pRect,pDraw,2);
			SetBkColor (hDc,uOldBk  );
			}

		pDrawThemeBackg (hButtonTheme,hDc,(int)BP_BUTTON,(BYTE)iState,pDraw,0);
		pGetThemeBackgRc(hButtonTheme,hDc,(int)BP_BUTTON,(BYTE)iState,pDraw,&sRect);

		if(iState&0x00FF0000)							// Den Text links ausrichten
			{
			uMode       = DT_LEFT|DT_VCENTER|DT_SINGLELINE;
			sRect.left += (BYTE)(iState>>16);
			}
		else{
			uMode       = DT_CENTER|DT_VCENTER|DT_SINGLELINE;
			}

		if(iLen)pDrawThemeText(hButtonTheme,hDc,BP_BUTTON,(BYTE)iState,pText,(int)iLen,uMode,0,&sRect);
  		}
	else{
		iLen = (pText)? -1:0;

		uOldBk	 = GetBkColor  (hDc);
		uOldTxt	 = GetTextColor(hDc);
		uOldMode = GetBkMode   (hDc);

		SetBkColor(hDc,GetSysColor(COLOR_BTNFACE));

		if(iState&DB_BACKGROUND)						// Hintergrund zeichnen
				DrawRectanglePtr(hDc,pRect);
		else	DrawRectanglePtr(hDc,pDraw);


		if(iState&0x00FF0000)							// Den Text links ausrichten
			{
			uMode        = DT_LEFT|DT_VCENTER|DT_SINGLELINE;
			sLeft.left   = pDraw->left+(BYTE)(iState>>16);
			sLeft.top	 = pDraw->top;
			sLeft.right  = pDraw->right;
			sLeft.bottom = pDraw->bottom;
			pRect		 = &sLeft;
			}
		else{
			uMode        = DT_CENTER|DT_VCENTER|DT_SINGLELINE;
			pRect		 = pDraw;
			}

		switch((BYTE)iState)
			{
		case PBS_NORMAL:								// Taste normal zeichnen

				SetTextColor(hDc,GetSysColor(COLOR_BTNTEXT));
				uEdge	= BDR_RAISEDOUTER|BDR_RAISEDINNER;
				break;

		case PBS_HOT:									// Maus ist ber der Taste

				uText  = (GetSysColor(COLOR_BTNTEXT      )>>1)&0x007F7F7F;
				uText += (GetSysColor(COLOR_HIGHLIGHTTEXT)>>1)&0x007F7F7F;
				SetTextColor(hDc,uText);
				uEdge	= BDR_RAISEDOUTER|BDR_RAISEDINNER;
				break;

		case PBS_PRESSED:								// Taste ist gedrckt

				SetTextColor(hDc,GetSysColor(COLOR_BTNTEXT));
				uEdge	= BDR_SUNKENOUTER|BDR_SUNKENINNER;
				break;

		case PBS_DISABLED:								// Taste ist gesperrt

				if(iLen)
					{
					if(iState&DB_ANSITEXT)
							DrawGrayTextA(hDc,(LPCSTR)pText,(int)iLen,pRect,uMode);
					else	DrawGrayTextW(hDc,        pText,(int)iLen,pRect,uMode);

					iLen = 0;
					}

				uEdge	= BDR_RAISEDOUTER|BDR_RAISEDINNER;
				break;

		case PBS_DEFAULTED:								// Taste ist die Standarttaste

				SetTextColor(hDc,GetSysColor(COLOR_BTNTEXT));
				uEdge	= BDR_RAISEDOUTER|BDR_RAISEDINNER;
				break;

			}

		if(iLen)										// Text ausgeben
			{
			SetBkMode (hDc,TRANSPARENT);

			if(iState&DB_ANSITEXT)
					DrawTextA(hDc,(LPCSTR)pText,(int)iLen,(LPRECT)pRect,uMode);
			else	DrawTextW(hDc,        pText,(int)iLen,(LPRECT)pRect,uMode);
			}

		DrawEdge(hDc,(LPRECT)pDraw,uEdge,BF_RECT);

		SetBkColor  (hDc,uOldBk  );
		SetTextColor(hDc,uOldTxt );
		SetBkMode   (hDc,uOldMode);
		}

}


//*****************************************************************************
//*
//*		DrawMenuItemW
//*
//*****************************************************************************
//	Zeichnet einen Popup-Men-Eintrag mit bzw. ohne Windows-Thema.
//	hDc			: Device-Context in dem gezeichnet wird
//	pText		: Text fr den Eintrag (bei 0 wird kein Text gezeichnet)
//	pRect		: Wo soll der Eintrag gezeichnet werden
//	hList		: Icon-Liste fr das Icon das gezeichnet werden soll
//	iIndex		: Index der des Icons das gezeichnet werden soll
//				  Bei -1 wird kein Icon gezeichnet
//				  Bei -2 ist hList ein HBITMAP-Handle
//				  Bei -3 einen Haken zeichnen
//				  Bei -4 ein Radio-Button zeichnen
//	iState		: Wie soll die Taste gezeichnet werden
//					MPI_NORMAL      1		Eintrag normal zeichnen
//					MPI_HOT         2		Eintrag mit Maus ber dem Feld
//					MPI_DISABLED    3		Eintrag ist gesperrt
//					MPI_DISABLEDHOT 4		Eintrag ist gesperrt Eintrag
//					DM_ANSITEXT		0x0100	Der Text ist kein UNICODE
//					DM_BACKGROUND	0x0200	Hintergrund zeichnen
//					DM_USENOTHEMA	0x0400	Keinen Windows-Tema verwenden
//					DM_TEXTCENTER	0x4000	Den Text mittig ausrichten
//					DM_TEXTRIGHT	0x8000	Den Text rechts ausrichten
//					DM_TEXTLEFT(a)			Den Text links ausrichten bei Offset a
EXTAPI void WINAPI DrawMenuItemW(HDC hDc,LPCWSTR pText,LPCRECT pRect,int iState,LPVOID hList,int iIndex)
{
BYTE			aData[sizeof(BITMAPINFOHEADER)+sizeof(RGBQUAD)*256];
WCHAR			cText[64];
HDC				hBitmapDc;
UINT			uOldMode;
COLORREF		uOldTxt;
COLORREF		uOldBk;
LPBITMAPINFO	pData;
IMAGEINFO		sInfo;
LPCSTR			pAnsi;
RECT			sLeft;
RECT			sRect;
UINT			uMode;
UINT			uText;
int				iPosY;
int				iSize;
int				iBits;
size_t			iLen;




	if(!bUxThemeDone)									// Thema laden
		{
		LoadUxThemeDll();
		}



	if(hMenuTheme && !(iState&DM_USENOTHEMA))			// Hintergrund mit Thema
		{
		if(iState&DM_BACKGROUND)						// Hintergrund zeichnen
			{
			uOldBk		   = GetBkColor(hDc);
			SetBkColor      (hDc,GetSysColor(COLOR_MENU));
			DrawRectanglePtr(hDc,pRect);
			SetBkColor      (hDc,uOldBk);
			}
		}
	else{												// Hintergrund ohne Thema
		uOldBk	 = GetBkColor  (hDc);
		uOldTxt	 = GetTextColor(hDc);
		uOldMode = GetBkMode   (hDc);

		if(iState&DM_BACKGROUND)						// Hintergrund zeichnen
			{
			SetBkColor(hDc,GetSysColor((iState&1)? COLOR_MENU:COLOR_HIGHLIGHT));
			DrawRectanglePtr(hDc,pRect);
			}
		else if(!(iState&1))
			{
			SetBkColor(hDc,GetSysColor(COLOR_HIGHLIGHT));
			DrawRectanglePtr(hDc,pRect);
			}
		}


	if(iIndex<-1)										// Spezielles Icon
		{
		if(iIndex==-2)
			{
			hBitmapDc = CreateCompatibleDC(hDc);
			SelectObject(hBitmapDc,hList);

			pData							 = (LPBITMAPINFO)aData;
			pData->bmiHeader.biSize		 	 = sizeof(BITMAPINFOHEADER);
			pData->bmiHeader.biWidth		 = 0;
			pData->bmiHeader.biHeight	 	 = 0;
			pData->bmiHeader.biPlanes	 	 = 1;
			pData->bmiHeader.biBitCount	 	 = 0;
			pData->bmiHeader.biCompression 	 = BI_RGB;
			pData->bmiHeader.biSizeImage	 = 0;
			pData->bmiHeader.biXPelsPerMeter = 0;
			pData->bmiHeader.biYPelsPerMeter = 0;
			pData->bmiHeader.biClrUsed		 = 0;
														// Bitmap-Gre holen
			GetDIBits(hBitmapDc,(HBITMAP)hList,0,0,NULL,pData,DIB_RGB_COLORS);

			iSize	= pData->bmiHeader.biWidth;
			iPosY	= (pRect->bottom-pRect->top-pData->bmiHeader.biHeight)/2;

			BitBlt(hDc,pRect->left+2,pRect->top+iPosY,pData->bmiHeader.biWidth,pData->bmiHeader.biHeight,hBitmapDc,0,0,SRCCOPY);
			DeleteDC(hBitmapDc);
			}
		else if(iIndex==-3)								// Haken zeichnen
			{
			iBits	= iState&DM_USENOTHEMA;
			iBits  |= DG_MENU|MC_CHECKMARKNORMAL;
			iSize	= sCheckSize.cx;
			if(!(iState&1))iBits++;
			DrawGlyph(hDc,pRect,iBits,0);
			}
		else if(iIndex==-4)								// Radio-Button zeichnen
			{
			iBits	= iState&DM_USENOTHEMA;
			iBits  |= DG_MENU|MC_BULLETNORMAL;
			iSize	= sRadioSize.cx;
			if(!(iState&1))iBits++;
			DrawGlyph(hDc,pRect,iBits,0);
			}

		if(!(iState&0x00FF0000))						// Icon-Offset links korrigieren
			{
			iState |= (iSize+4)<<16;
			}
		}
	else if(hList)										// Icon aus einer Image-Liste zeichnen
		{
		ImageList_GetImageInfo((HIMAGELIST)hList,(iIndex<0)? 0:iIndex,&sInfo);

		if(iIndex>=0)
			{
			iPosY = (pRect->bottom-pRect->top-sInfo.rcImage.bottom+sInfo.rcImage.top)/2;
			ImageList_Draw((HIMAGELIST)hList,iIndex,hDc,pRect->left+2,pRect->top+iPosY,ILD_TRANSPARENT);
			}

		if(!(iState&0x00FF0000))						// Icon-Offset links korrigieren
			{
			iSize	= sInfo.rcImage.right-sInfo.rcImage.left;
			iState |= (iSize+4)<<16;
			}
		}



	if(hMenuTheme && !(iState&DM_USENOTHEMA))			// Mit Thema
		{
		if(!pText)
			{
			iLen	= 0;
			}
		else if(iState&DM_ANSITEXT)						// In UNICODE konvertieren
			{
			pAnsi	= (LPCSTR)pText;
			pText	= cText;

			for(iLen=0;iLen<sizeof(cText)/sizeof(cText[0]);iLen++)
				{
				if(!pAnsi[iLen])break;
				cText[iLen] = (BYTE)pAnsi[iLen];
				}
			}
		else{
			iLen	= wcslen(pText);
			}

		pDrawThemeBackg (hMenuTheme,hDc,MENU_POPUPITEM,(BYTE)iState,pRect,0);
		pGetThemeBackgRc(hMenuTheme,hDc,MENU_POPUPITEM,(BYTE)iState,pRect,&sRect);

		if(iState&DM_TEXTCENTER)						// Den Text mittig ausrichten
			{
			uMode       = DT_CENTER|DT_VCENTER|DT_SINGLELINE;
			}
		else if(iState&DM_TEXTRIGHT)					// Den Text rechts ausrichten
			{
			uMode       = DT_RIGHT|DT_VCENTER|DT_SINGLELINE;
			}
		else{											// Den Text links ausrichten
			uMode       = DT_LEFT|DT_VCENTER|DT_SINGLELINE;
			sRect.left += (BYTE)(iState>>16);
			}

		if(iLen)pDrawThemeText(hMenuTheme,hDc,BP_BUTTON,(BYTE)iState,pText,(int)iLen,uMode,0,&sRect);
  		}
	else{												// Ohne Thema
		iLen = (pText)? -1:0;

		if(iState&0x00FF0000)							// Den Text links ausrichten
			{
			uMode        = DT_LEFT|DT_VCENTER|DT_SINGLELINE;
			sLeft.left   = pRect->left+(BYTE)(iState>>16);
			sLeft.top	 = pRect->top;
			sLeft.right  = pRect->right;
			sLeft.bottom = pRect->bottom;
			pRect		 = &sLeft;
			}
		else{
			uMode        = DT_CENTER|DT_VCENTER|DT_SINGLELINE;
			}


		switch((BYTE)iState)
			{
		case MPI_NORMAL:								// Eintrag normal zeichnen

				SetTextColor(hDc,GetSysColor(COLOR_BTNTEXT));
				break;

		case MPI_HOT:									// Eintrag ist ber der Taste

				uText  = (GetSysColor(COLOR_BTNTEXT      )>>1)&0x007F7F7F;
				uText += (GetSysColor(COLOR_HIGHLIGHTTEXT)>>1)&0x007F7F7F;
				SetTextColor(hDc,uText);
				break;

		case MPI_DISABLED:								// Eintrag ist gesperrt
		case MPI_DISABLEDHOT:							// Eintrag ist gesperrt mit Maus

				if(iLen)
					{
					if(iState&DM_ANSITEXT)
							DrawGrayTextA(hDc,(LPCSTR)pText,(int)iLen,pRect,uMode);
					else	DrawGrayTextW(hDc,        pText,(int)iLen,pRect,uMode);

					iLen = 0;
					}

				break;
			}


		if(iLen)										// Text ausgeben
			{
			SetBkMode(hDc,TRANSPARENT);

			if(iState&DM_ANSITEXT)
					DrawTextA(hDc,(LPCSTR)pText,(int)iLen,(LPRECT)pRect,uMode);
			else	DrawTextW(hDc,        pText,(int)iLen,(LPRECT)pRect,uMode);
			}


		SetBkColor  (hDc,uOldBk  );
		SetTextColor(hDc,uOldTxt );
		SetBkMode   (hDc,uOldMode);
		}

}

//*****************************************************************************
//*
//*		DrawThemeBack
//*
//*****************************************************************************
//	Zeichnet den Hintergrund und den Rahmen mit Windows-Thema.
//	hDc			: Device-Context in dem gezeichnet wird
//	uType		: Ist die Art des Controls (oder das Handle)
//					0 = Button
//					1 = ComboBox
//					2 = Tree
//					3 = Menu
//					4 = Toolbar
//					5 = Edit
//	pRect		: Wo soll der Hintergrund gezeichnet werden
//	iState		: Ist der Status des Controls
//					MPI_NORMAL      1		Eintrag normal zeichnen
//					MPI_HOT         2		Eintrag mit Maus ber dem Feld
//					MPI_DISABLED    3		Eintrag ist gesperrt
//					MPI_DISABLEDHOT 4		Eintrag ist gesperrt Eintrag
//					DB_USENOTHEMA	0x0400	Keinen Windows-Tema verwenden
//					DB_HASYDELTA	0x0800	Fr die Y-Richtung gibt es ein extra Delta
//					Bit16..23				Ist die Nummer des Elements (z.B. EP_BACKGROUND)
//	iFrame		: Gre des Rahmens um die Taste in Pixeln. Das Rechteck fr
//				  die Taste wird um diese Pixelanzahl verkleinert.
EXTAPI void WINAPI DrawThemeBack(HDC hDc,LPARAM uType,LPCRECT pRect,int iState,int iFrame)
{
LPVOID		hThema;
COLORREF	uOldBk;
INT			iDelta;
LPCRECT		pDraw;
RECT		sTemp;



	if(!bUxThemeDone)									// Thema laden
		{
		LoadUxThemeDll();
		}


	if(iFrame)											// Rechteck um den Rahmen verkleinern
		{
		if(iState&DB_HASYDELTA)
			{
			iDelta = GET_Y_LPARAM(iFrame);
			iFrame = GET_X_LPARAM(iFrame);
			}
		else{
			iDelta = iFrame;
			}

		sTemp.left	= pRect->left  +iFrame;
		sTemp.right	= pRect->right -iFrame;
		sTemp.top	= pRect->top   +iDelta;
		sTemp.bottom= pRect->bottom-iDelta;
		pDraw		= &sTemp;
		}
	else{
		pDraw		= pRect;
		}


	switch(uType)
		{
	case 0:	hThema = hButtonTheme;	break;
	case 1:	hThema = hComboTheme;	break;
	case 2:	hThema = hTreeTheme;	break;
	case 3:	hThema = hMenuTheme;	break;
	case 4:	hThema = hToolTheme;	break;
	case 5:	hThema = hEditTheme;	break;
	default:hThema = (LPVOID)uType;	break;
		}


	if(hThema && !(iState&DB_USENOTHEMA))				// Mit Thema zeichnen
		{
		pDrawThemeBackg(hThema,hDc,iState>>16,(BYTE)iState,pDraw,0);
  		}
	else{
		if((BYTE)iState>=MPI_DISABLED)
			{
			uOldBk = SetBkColor(hDc,RGB(192,192,192));
			}
		else{
			uOldBk = SetBkColor(hDc,GetSysColor(COLOR_WINDOW));
			}

		DrawRectanglePtr(hDc,pDraw);
		DrawEdge(hDc,(LPRECT)pDraw,EDGE_SUNKEN,BF_RECT);
		SetBkColor(hDc,uOldBk);
		}

}


//*****************************************************************************
//*
//*		DrawCheckBox
//*
//*****************************************************************************
//	Zeichnet eine Checkbox mit Text mit bzw. ohne Windows-Thema.
//	hDc			: Device-Context in dem gezeichnet wird
//	pText		: Text fr die Taste (bei 0 wird kein Text gezeichnet)
//	pRect		: Wo soll die Taste gezeichnet werden
//	iState		: Wie soll die Taste gezeichnet werden
//					CBS_UNCHECKEDNORMAL	  1	Taste normal und zeichnen
//					CBS_UNCHECKEDHOT	  2 Taste hervorgehoben zeichnen
//					CBS_UNCHECKEDPRESSED  3 Taste gedrckt zeichnen
//					CBS_UNCHECKEDDISABLED 4	Taste gesperrt zeichnen
//					CBS_CHECKEDNORMAL     5	Taste normal und selektiert zeichnen
//					CBS_CHECKEDHOT		  6	Taste hervorgehoben und selektiert zeichnen
//					CBS_CHECKEDPRESSED	  7 Taste gedrckt und selektiert zeichnen
//					CBS_CHECKEDDISABLED   8 Taste gesperrt und selektiert zeichnen
//					DC_ANSITEXT		 0x0100	Der Text ist kein UNICODE
//					DC_BACKGROUND	 0x0200	Hintergrund zeichnen
//					DC_USENOTHEMA	 0x0400	Keinen Windows-Tema verwenden
//					DC_HASYDELTA	 0x0800	Fr die Y-Richtung gibt es ein extra Delta
//					DC_ANSIFONT		 0x1000	Den ANSI_VAR_FONT benutzen
//					DC_DEFAULTFONT	 0x2000	Den Standart-Font benutzen
//					DC_TEXTLEFT(a)			Den Text links ausrichten bei Offset a
//	iFrame		: Gre des Rahmens um die Taste in Pixeln. Das Rechteck fr
//				  die Checkbox wird um diese Pixelanzahl verkleinert.
EXTAPI void WINAPI DrawCheckBoxW(HDC hDc,LPCWSTR pText,LPCRECT pRect,int iState,int iFrame)
{
HGDIOBJ		hOldFont;
LPCSTR		pAnsi;
RECT		sArea;
RECT		sTemp;
UINT		uGray;
UINT		uBits;
INT			iDelta;
INT			iDiff;
INT			iLen;



	if(!bUxThemeDone)									// Thema laden
		{
		LoadUxThemeDll();
		}


	if(iState&DC_BACKGROUND)							// Hintergrund zeichnen
		{
		DrawRectanglePtr(hDc,pRect);
		}


	if(iFrame)											// Rechteck um den Rahmen verkleinern
		{
		if(iState&DC_HASYDELTA)
			{
			iDelta = GET_Y_LPARAM(iFrame);
			iFrame = GET_X_LPARAM(iFrame);
			}
		else{
			iDelta = iFrame;
			}

		sTemp.left	= pRect->left  +iFrame;
		sTemp.right	= pRect->right -iFrame;
		sTemp.top	= pRect->top   +iDelta;
		sTemp.bottom= pRect->bottom-iDelta;
		pRect		= &sTemp;
		}



	sArea.top	= pRect->top;
	sArea.left	= pRect->left;
	sArea.right	= pRect->right;
	sArea.bottom= pRect->bottom;

	if(sArea.right-sArea.left>=sCheckSize.cx)			// Rechteck fr Checkbox berechnen
		{
		sArea.right = sArea.left+sCheckSize.cx;
		}

	   iDiff = pRect->bottom-pRect->top;
	   iDiff-= sCheckSize.cy;
	if(iDiff > 0)
		{
		sArea.top	 += (iDiff+1)/2;
		sArea.bottom  = sArea.top+sCheckSize.cy;
		}


	uBits		= iState-1;
	uGray		= (uBits&3)==3;


	if(hButtonTheme && !(iState&DC_USENOTHEMA))			// Mit Thema zeichnen
		{
		pDrawThemeBackg(hButtonTheme,hDc,BP_CHECKBOX,(BYTE)iState,&sArea,0);
		}
	else{
		DrawFrameControl(hDc,&sArea,DFC_BUTTON,DFCS_BUTTONCHECK|aBoxStates[uBits&7]);
		}


	if(!pText)return;

	if(iState&DC_ANSITEXT)
		{
		pAnsi = (LPCSTR)pText;
		iLen  = (int)strlen(pAnsi);
		}
	else{
		iLen  = (int)wcslen(pText);
		}

	if(!iLen)return;


	if(iState&0x00FF0000)							// Den Text links verschieben
		{
		sArea.left = sArea.right+(BYTE)(iState>>16);
		}
	else{
		sArea.left = sArea.right+3;
		}


	sArea.right	 = pRect->right;
	if(sArea.left>=sArea.right)return;



	SetBkColor(hDc,GetSysColor(COLOR_BTNFACE));
	SetBkMode (hDc,TRANSPARENT);


	if(iState&DC_ANSIFONT)							// Den ANSI_VAR_FONT benutzen
		{
		hOldFont = SelectObject(hDc,GetStockObject(ANSI_VAR_FONT));
		}
	else if(iState&DC_DEFAULTFONT)					// Den Standart-Font benutzen
		{
		if(!aFontsDefault[0])GetDefaultFont();
		hOldFont = SelectObject(hDc,aFontsDefault[0]);
		}
	else{
		hOldFont = 0;
		}


	if(iState&DC_ANSITEXT)
			DrawStateA(hDc,NULL,NULL,(LPARAM)pText,iLen,sArea.left,sArea.top,sArea.right-sArea.left,sArea.bottom-sArea.top,(uGray)? DST_TEXT|DSS_DISABLED:DST_TEXT|DSS_NORMAL);
	else	DrawStateW(hDc,NULL,NULL,(LPARAM)pText,iLen,sArea.left,sArea.top,sArea.right-sArea.left,sArea.bottom-sArea.top,(uGray)? DST_TEXT|DSS_DISABLED:DST_TEXT|DSS_NORMAL);

	if(hOldFont)
		{
		SelectObject(hDc,hOldFont);
		}

}

//*****************************************************************************
//*
//*		DrawRadio
//*
//*****************************************************************************
//	Zeichnet einen Radio-Button mit Text mit bzw. ohne Windows-Thema.
//	hDc			: Device-Context in dem gezeichnet wird
//	pText		: Text fr die Taste (bei 0 wird kein Text gezeichnet)
//	pRect		: Wo soll die Taste gezeichnet werden
//	iState		: Wie soll die Taste gezeichnet werden
//					RBS_UNCHECKEDNORMAL	  1	Taste normal und zeichnen
//					RBS_UNCHECKEDHOT	  2 Taste hervorgehoben zeichnen
//					RBS_UNCHECKEDPRESSED  3 Taste gedrckt zeichnen
//					RBS_UNCHECKEDDISABLED 4	Taste gesperrt zeichnen
//					RBS_CHECKEDNORMAL     5	Taste normal und selektiert zeichnen
//					RBS_CHECKEDHOT		  6	Taste hervorgehoben und selektiert zeichnen
//					RBS_CHECKEDPRESSED	  7 Taste gedrckt und selektiert zeichnen
//					RBS_CHECKEDDISABLED   8 Taste gesperrt und selektiert zeichnen
//					DR_ANSITEXT		 0x0100	Der Text ist kein UNICODE
//					DR_BACKGROUND	 0x0200	Hintergrund zeichnen
//					DR_USENOTHEMA	 0x0400	Keinen Windows-Tema verwenden
//					DR_HASYDELTA	 0x0800	Fr die Y-Richtung gibt es ein extra Delta
//					DR_ANSIFONT		 0x1000	Den ANSI_VAR_FONT benutzen
//					DR_DEFAULTFONT	 0x2000	Den Standart-Font benutzen
//					DR_TEXTLEFT(a)			Den Text links ausrichten bei Offset a
//	iFrame		: Gre des Rahmens um die Taste in Pixeln. Das Rechteck fr
//				  die Checkbox wird um diese Pixelanzahl verkleinert.
EXTAPI void WINAPI DrawRadioW(HDC hDc,LPCWSTR pText,LPCRECT pRect,int iState,int iFrame)
{
HGDIOBJ		hOldFont;
LPCSTR		pAnsi;
RECT		sArea;
RECT		sTemp;
UINT		uGray;
UINT		uBits;
INT			iDelta;
INT			iDiff;
INT			iLen;



	if(!bUxThemeDone)									// Thema laden
		{
		LoadUxThemeDll();
		}


	if(iState&DR_BACKGROUND)							// Hintergrund zeichnen
		{
		DrawRectanglePtr(hDc,pRect);
		}


	if(iFrame)											// Rechteck um den Rahmen verkleinern
		{
		if(iState&DR_HASYDELTA)
			{
			iDelta = GET_Y_LPARAM(iFrame);
			iFrame = GET_X_LPARAM(iFrame);
			}
		else{
			iDelta = iFrame;
			}

		sTemp.left	= pRect->left  +iFrame;
		sTemp.right	= pRect->right -iFrame;
		sTemp.top	= pRect->top   +iDelta;
		sTemp.bottom= pRect->bottom-iDelta;
		pRect		= &sTemp;
		}



	sArea.top	= pRect->top;
	sArea.left	= pRect->left;
	sArea.right	= pRect->right;
	sArea.bottom= pRect->bottom;

	if(sArea.right-sArea.left>=sRadioSize.cx)			// Rechteck fr Checkbox berechnen
		{
		sArea.right = sArea.left+sRadioSize.cx;
		}

	   iDiff = pRect->bottom-pRect->top;
	   iDiff-= sRadioSize.cy;
	if(iDiff > 0)
		{
		sArea.top	 += (iDiff+1)/2;
		sArea.bottom  = sArea.top+sRadioSize.cy;
		}


	uBits		= iState-1;
	uGray		= (uBits&3)==3;


	if(hButtonTheme && !(iState&DR_USENOTHEMA))			// Mit Thema zeichnen
		{
		pDrawThemeBackg(hButtonTheme,hDc,BP_RADIO,(BYTE)iState,&sArea,0);
		}
	else{
		DrawFrameControl(hDc,&sArea,DFC_BUTTON,DFCS_BUTTONRADIO|aBoxStates[uBits&7]);
		}


	if(!pText)return;

	if(iState&DR_ANSITEXT)
		{
		pAnsi = (LPCSTR)pText;
		iLen  = (int)strlen(pAnsi);
		}
	else{
		iLen  = (int)wcslen(pText);
		}

	if(!iLen)return;


	if(iState&0x00FF0000)							// Den Text links verschieben
		{
		sArea.left = sArea.right+(BYTE)(iState>>16);
		}
	else{
		sArea.left = sArea.right+3;
		}


	sArea.right	 = pRect->right;
	if(sArea.left>=sArea.right)return;



	SetBkColor(hDc,GetSysColor(COLOR_BTNFACE));
	SetBkMode (hDc,TRANSPARENT);


	if(iState&DR_ANSIFONT)							// Den ANSI_VAR_FONT benutzen
		{
		hOldFont = SelectObject(hDc,GetStockObject(ANSI_VAR_FONT));
		}
	else if(iState&DR_DEFAULTFONT)					// Den Standart-Font benutzen
		{
		if(!aFontsDefault[0])GetDefaultFont();
		hOldFont = SelectObject(hDc,aFontsDefault[0]);
		}
	else{
		hOldFont = 0;
		}


	if(iState&DR_ANSITEXT)
			DrawStateA(hDc,NULL,NULL,(LPARAM)pText,iLen,sArea.left,sArea.top,sArea.right-sArea.left,sArea.bottom-sArea.top,(uGray)? DST_TEXT|DSS_DISABLED:DST_TEXT|DSS_NORMAL);
	else	DrawStateW(hDc,NULL,NULL,(LPARAM)pText,iLen,sArea.left,sArea.top,sArea.right-sArea.left,sArea.bottom-sArea.top,(uGray)? DST_TEXT|DSS_DISABLED:DST_TEXT|DSS_NORMAL);

	if(hOldFont)
		{
		SelectObject(hDc,hOldFont);
		}

}


//*****************************************************************************
//*
//*		DrawGlyph
//*
//*****************************************************************************
//	Zeichnet ein Glyph-Objekt mit bzw. ohne Windows-Thema.
//	hDc			: Device-Context in dem gezeichnet wird
//	pRect		: Wo soll das Objekt gezeichnet werden
//	iState		: Wie soll die Taste gezeichnet werden
//					GLPS_CLOSED			  1 Glyph mit +
//					GLPS_OPENED			  2	Glyph mit -
//					MC_CHECKMARKNORMAL	  1 Haken normal
//					MC_CHECKMARKDISABLED  2	Haken gesperrt
//					MC_BULLETNORMAL		  3	Kugel normal
//					MC_BULLETDISABLED	  4	Kugel gesperrt
//					TS_NORMAL			  1 Dropdown normal
//					TS_HOT				  2	Dropdown hervorgehoben
//					TS_PRESSED			  3	Dropdown gedrckt
//					TS_DISABLED			  4	Dropdown gesperrt
//					TS_CHECKED			  5	Dropdown gedrckt
//					TS_HOTCHECKED		  6	Dropdown hervorgehoben und gedrckt
//					TS_NEARHOT			  7	Dropdown hervorgehoben
//					TS_OTHERSIDEHOT		  8	Dropdown hervorgehoben auerhalb
//					DG_GLYPH		 0x0000	Glyph fr Treelist
//					DG_MENU		     0x0010	Glyph fr Menus
//					DG_DROPDOWN	     0x0020	Glyph fr Dropdown
//					DG_BACKGROUND	 0x0200	Hintergrund zeichnen
//					DG_USENOTHEMA	 0x0400	Keinen Windows-Tema verwenden
//					DG_HASYDELTA	 0x0800	Fr die Y-Richtung gibt es ein extra Delta
//	iFrame		: Gre des Rahmens um die Taste in Pixeln. Das Rechteck fr
//				  fr das Objekt wird um diese Pixelanzahl verkleinert.
EXTAPI VOID WINAPI DrawGlyph(HDC hDc,LPCRECT pRect,int iState,int iFrame)
{
LOGFONTW	sLogFont;
unsigned 	uOldMode;
COLORREF	uOldColor;
HGDIOBJ		hOldBrush;
HGDIOBJ		hOldFont;
HGDIOBJ		hOldPen;
WCHAR		cChar;
RECT		sArea;
RECT		sTemp;
UINT		uBits;
UINT		uSize;
INT			iDelta;
INT			iDiff;
INT			iMode;
INT			iType;
INT			iPos;


	if(!bUxThemeDone)									// Thema laden
		{
		LoadUxThemeDll();
		}


	if(iState&DG_BACKGROUND)							// Hintergrund zeichnen
		{
		DrawRectanglePtr(hDc,pRect);
		}


	if(iFrame)											// Rechteck um den Rahmen verkleinern
		{
		if(iState&DG_HASYDELTA)
			{
			iDelta = GET_Y_LPARAM(iFrame);
			iFrame = GET_X_LPARAM(iFrame);
			}
		else{
			iDelta = iFrame;
			}

		sTemp.left	= pRect->left  +iFrame;
		sTemp.right	= pRect->right -iFrame;
		sTemp.top	= pRect->top   +iDelta;
		sTemp.bottom= pRect->bottom-iDelta;
		pRect		= &sTemp;
		}



	sArea.top	= pRect->top;
	sArea.left	= pRect->left;
	sArea.right	= pRect->right;
	sArea.bottom= pRect->bottom;


	uBits		= iState-1;
	iMode		= (iState/16)&0x0F;
	iType		= (iState&0x0F);

														// Mit Thema zeichnen
	if(hTreeTheme && !(iState&DG_USENOTHEMA))
		{
		switch(iMode)
			{
		case 0:	if(!pDrawThemeBackg(hTreeTheme,hDc,TVP_GLYPH             ,iType,&sArea,0))return;break;
		case 1:	if(!pDrawThemeBackg(hMenuTheme,hDc,MENU_POPUPCHECK       ,iType,&sArea,0))return;break;
		case 2:	if(!pDrawThemeBackg(hToolTheme,hDc,TP_DROPDOWNBUTTONGLYPH,iType,&sArea,0))return;break;
			}
		}

	if(iMode==0)										// Treelist +/-
		{
		hOldBrush	= SelectObject(hDc,GetStockObject(WHITE_BRUSH));
		hOldPen		= SelectObject(hDc,GetStockObject(BLACK_PEN  ));
		Rectangle(hDc,sArea.left,sArea.top,sArea.right,sArea.bottom);
		SelectObject(hDc,GetStockObject(GRAY_BRUSH));
		SelectObject(hDc,GetStockObject(NULL_PEN  ));

		iPos	= (sArea.top+sArea.bottom)/2;
		Rectangle(hDc,sArea.left+2,iPos,sArea.right-1,iPos+2);

		if(iType==1)
			{
			iPos	= (sArea.left+sArea.right)/2;
			Rectangle(hDc,iPos,sArea.top+2,iPos+2,sArea.bottom-1);
			}

		SelectObject(hDc,hOldBrush);
		SelectObject(hDc,hOldPen  );
		return;
		}


	uBits	= sArea.bottom-sArea.top;
	uSize	= sArea.right -sArea.left;
	if(uBits>uSize)uBits=uSize;

	if(aSysHeight[0]==uBits)							// Passt der erste Font
		{
		iPos			= 0;
		uSysNext	   += 1;
		aSysTicker[0]	= uSysNext;
		}
	else if(aSysHeight[1]==uBits)						// Passt der zweite Font
		{
		iPos			= 1;
		uSysNext	   += 1;
		aSysTicker[1]	= uSysNext;
		}
	else{												// Neuen Font erstellen
		iDelta	= uSysNext-aSysTicker[0];
		iDiff	= uSysNext-aSysTicker[1];
		iPos	= (iDelta<iDiff)? 1:0;

		if(aSysFonts[iPos])
			{
			DeleteObject(aSysFonts[iPos]);
			aSysFonts [iPos] = NULL;
			aSysHeight[iPos] = 0;
			}

		memset(&sLogFont,0,sizeof(sLogFont));

		sLogFont.lfWidth	= 0;
		sLogFont.lfHeight	= uBits;
		sLogFont.lfWeight	= FW_NORMAL;
		sLogFont.lfCharSet	= DEFAULT_CHARSET;
		wcscpy(sLogFont.lfFaceName,L"Marlett");

			aSysFonts[iPos] = GetCachedFontW(&sLogFont);
		if(!aSysFonts[iPos])return;

		uSysNext	   += 1;
		aSysHeight[iPos]= uBits;
		aSysTicker[iPos]= uSysNext;
		}

	if(iMode==1)										// Menhaken oder Kugel
		{
		cChar     = "\0\x61\x61\x68\x68\0\0\0\0\0\0\0\0\0\0"[iType];
		uOldColor = SetTextColor(hDc,(iType&1)? GetSysColor(COLOR_MENUTEXT):GetSysColor(COLOR_GRAYTEXT));
		}
	else if(iMode==2)									// Dropdown
		{
		cChar	  = 0x75;

		if(iType==TS_HOT || iType==TS_HOTCHECKED)
			{
			uOldColor = ((GetSysColor(COLOR_HIGHLIGHT)>>1)&0x7F7F7F)+((GetSysColor(COLOR_MENUTEXT)>>1)&0x7F7F7F);
			}
		else if(iType==TS_DISABLED  )
			{
			uOldColor = GetSysColor(COLOR_GRAYTEXT);
			}
		else{
			uOldColor = GetSysColor(COLOR_MENUTEXT);
			}

		uOldColor = SetTextColor(hDc,uOldColor);

		if(iType==TS_CHECKED || iType==TS_HOTCHECKED || iType==TS_PRESSED)
			{
			OffsetRect(&sArea,1,1);
			}
		}
	else{
		uOldColor = SetTextColor(hDc,GetSysColor(COLOR_MENUTEXT));
		}

    hOldFont = SelectObject(hDc,aSysFonts[iPos]);
	uOldMode = SetBkMode(hDc,TRANSPARENT);

	DrawTextW(hDc,&cChar,1,&sArea,DT_CENTER|DT_VCENTER|DT_SINGLELINE|DT_NOPREFIX);

	SetTextColor(hDc,uOldColor);
	SelectObject(hDc,hOldFont );
	SetBkMode   (hDc,uOldMode );


}

//*****************************************************************************
//*
//*		DrawCbButton
//*
//*****************************************************************************
//	Zeichnet eine Taste fr eine ComboBox mit bzw. ohne Windows-Thema.
//	hDc			: Device-Context in dem gezeichnet wird
//	pRect		: Wo soll die Taste gezeichnet werden
//	iState		: Wie soll die Taste gezeichnet werden
//					CBXS_NORMAL      1		Taste normal zeichnen
//					CBXS_HOT         2		Maus ist ber der Taste
//					CBXS_PRESSED     3		Taste ist gedrckt
//					CBXS_DISABLED    4		Taste ist gesperrt
//					DB_BACKGROUND	0x0200	Den vorher ausmalen
//					DB_USENOTHEMA	0x0400	Keinen Windows-Tema verwenden
//					DB_HASYDELTA	0x0800	Fr die Y-Richtung gibt es ein extra Delta
//				    Bit16..19				Ist die Art der Taste CP_DROPDOWNBUTTON???
//	iFrame		: Gre des Rahmens um die Taste in Pixeln. Das Rechteck fr
//				  die Taste wird um diese Pixelanzahl verkleinert.
EXTAPI void WINAPI DrawCbButton(HDC hDc,LPCRECT pRect,int iState,int iFrame)
{
INT			iDelta;
LPCRECT		pDraw;
COLORREF	uOldC;
RECT		sTemp;
UINT		uMode;
UINT		uBits;



	if(!bUxThemeDone)									// Thema laden
		{
		LoadUxThemeDll();
		}


	if(iFrame)											// Rechteck um den Rahmen verkleinern
		{
		if(iState&DB_HASYDELTA)
			{
			iDelta = GET_Y_LPARAM(iFrame);
			iFrame = GET_X_LPARAM(iFrame);
			}
		else{
			iDelta = iFrame;
			}

		sTemp.left	= pRect->left  +iFrame;
		sTemp.right	= pRect->right -iFrame;
		sTemp.top	= pRect->top   +iDelta;
		sTemp.bottom= pRect->bottom-iDelta;
		pDraw		= &sTemp;
		}
	else{
		pDraw		= pRect;
		}


	if(hComboTheme && !(iState&DB_USENOTHEMA))			// Mit Thema zeichnen
		{
		uMode		= (iState>>16)&0x0F;

		if(uWinVersion<0x00060000)						// XP oder kleiner
			{
			if(!uMode)uMode=CP_DROPDOWNBUTTON;
			if(!iFrame)
				{
				sTemp.left	= pRect->left  +1;
				sTemp.right	= pRect->right -1;
				sTemp.top	= pRect->top   +1;
				sTemp.bottom= pRect->bottom-1;
				pDraw		= &sTemp;
				}
			}
		else{											// Vista oder hher
			if(!uMode)uMode=CP_DROPDOWNBUTTONRIGHT;
			}

		uBits   = iState&0xFF;
		iState &= 0xFF;
		uOldC	= 0xFEFEDDDD;

		if(iState&DB_BACKGROUND)						// Hintergrund auch zeichnen
			{
			uOldC = SetBkColor(hDc,(uBits==1)? GetSysColor(COLOR_WINDOW):RGB(192,192,192));
			DrawRectanglePtr(hDc,pDraw);
			}

		pDrawThemeBackg(hComboTheme,hDc,uMode,uBits,pDraw,NULL);

		if(uOldC!=0xFEFEDDDD)
			{
			SetBkColor(hDc,uOldC);
			}
  		}
	else{
		switch((BYTE)iState)
			{
		default:			uMode=PFB_FILLED;				uBits=DG_DROPDOWN|DG_USENOTHEMA;			break;
		case CBXS_HOT:		uMode=PFB_FILLED|PFB_HOT;		uBits=DG_DROPDOWN|DG_USENOTHEMA|TS_HOT;		break;
		case CBXS_PRESSED:	uMode=PFB_FILLED|PFB_PRESSED;	uBits=DG_DROPDOWN|DG_USENOTHEMA;			break;
		case CBXS_DISABLED:	uMode=PFB_FILLED;				uBits=DG_DROPDOWN|DG_USENOTHEMA|TS_DISABLED;break;
			}

		DrawFlatButton(hDc,pDraw,uMode);

		if(pDraw!=&sTemp)
			{
			sTemp = *pDraw;
			}

		InflateRect(&sTemp,-2,-2);
		DrawGlyph(hDc,&sTemp,uBits,0);
		}

}

//*****************************************************************************
//*
//*		DibAllocHandle
//*
//*****************************************************************************
//	Allokiert den Speicher fr ein DIB-Handle
//	uHeader		: Ist die Gre des Headers (BITMAPINFOHEADER+Farben|Masken)
//	Ergibt einen Zeiger auf das Handle, oder NULL bei einem Fehler
static LPDIBINFO DibAllocHandle(unsigned uHeader)
{
LPDIBINFO	pAlloc;
HANDLE		hHeap;


	hHeap = GetProcessHeap();

		pAlloc = (LPDIBINFO)HeapAlloc(hHeap,0,sizeof(DIBINFO)+uHeader);
	if(!pAlloc)return NULL;

	pAlloc->hHeap	= hHeap;
	pAlloc->hBitmap	= NULL;
	pAlloc->pLines	= NULL;
	pAlloc->hMemDc	= NULL;
	pAlloc->uTag	= DIB_TAG_BITMAP;


return pAlloc;
}

//*****************************************************************************
//*
//*		DibFreeHandle
//*
//*****************************************************************************
//	Gibt ein Handle auf Bilddaten wieder frei.
//	pInfo		: Ist das Handle
//	Ergibt TRUE wenn erfolgreich, bzw. FALSE bei einem Fehler
EXTAPI BOOL WINAPI DibFreeHandle(LPBITMAPINFO pInfo)
{
LPDIBINFO	pAlloc;


	if(!pInfo)											// Prfe das Handle
		{
		SetLastError(ERROR_INVALID_PARAMETER);
		return FALSE;
		}

	pAlloc	= DIB_PTR_OFFSET(pInfo,-(int)sizeof(DIBINFO),LPDIBINFO);
														// Ist das Handle in Ordnung
	if(IsBadReadPtr(pAlloc,sizeof(DIBINFO)) || pAlloc->uTag!=DIB_TAG_BITMAP)
		{
		SetLastError(ERROR_INVALID_PARAMETER);
		return FALSE;
		}

	if(IsBadWritePtr(pAlloc,sizeof(DIBINFO)))
		{
		SetLastError(ERROR_INVALID_PARAMETER);
		return FALSE;
		}

	if(pAlloc->hMemDc)									// Den Memory-DC lschen
		{
		DeleteDC(pAlloc->hMemDc);
		pAlloc->hMemDc = NULL;
		}

	if(pAlloc->hBitmap)									// Das Bitmap lschen
		{
		DeleteObject(pAlloc->hBitmap);
		pAlloc->hBitmap = NULL;
		}

	pAlloc->hBitmap = 0;
	pAlloc->pLines	= 0;
	pAlloc->uTag	= 0;


return HeapFree(pAlloc->hHeap,0,pAlloc);
}

//*****************************************************************************
//*
//*		DibGetBitmap
//*
//*****************************************************************************
//	Holt das erstellte Bitmap zu den Bilddaten.
//	pInfo		: Ist das Handle der Bilddaten
//	Ergibt das Bitmap-Handle, bzw. NULL bei einem Fehler.
EXTAPI HBITMAP WINAPI DibGetBitmap(LPBITMAPINFO pInfo)
{
LPDIBINFO	pAlloc;


	if(!pInfo)											// Prfe das Handle
		{
		SetLastError(ERROR_INVALID_PARAMETER);
		return NULL;
		}

	pAlloc	= DIB_PTR_OFFSET(pInfo,-(int)sizeof(DIBINFO),LPDIBINFO);

														// Ist das Handle in Ordnung
	if(IsBadWritePtr(pAlloc,sizeof(DIBINFO)) || pAlloc->uTag!=DIB_TAG_BITMAP)
		{
		SetLastError(ERROR_INVALID_PARAMETER);
		return NULL;
		}

	if(!pAlloc->hBitmap)								// Existiert ein Bitmap
		{
		SetLastError(ERROR_INVALID_DATA);
		return NULL;
		}


return pAlloc->hBitmap;
}

//*****************************************************************************
//*
//*		DibGetPixels
//*
//*****************************************************************************
//	Holt einen Zeiger auf die Pixeldaten.
//	pInfo		: Ist das Handle der Bilddaten
//	Ergibt das Bitmap-Handle, bzw. NULL bei einem Fehler.
EXTAPI LPVOID WINAPI DibGetPixels(LPBITMAPINFO pInfo)
{
LPDIBINFO	pAlloc;


	if(!pInfo)											// Prfe das Handle
		{
		SetLastError(ERROR_INVALID_PARAMETER);
		return NULL;
		}

	pAlloc	= DIB_PTR_OFFSET(pInfo,-(int)sizeof(DIBINFO),LPDIBINFO);

														// Ist das Handle in Ordnung
	if(IsBadWritePtr(pAlloc,sizeof(DIBINFO)) || pAlloc->uTag!=DIB_TAG_BITMAP)
		{
		SetLastError(ERROR_INVALID_PARAMETER);
		return NULL;
		}


return pAlloc->pLines;
}

//*****************************************************************************
//*
//*		DibGetPixelsEx
//*
//*****************************************************************************
//	Holt einen Zeiger auf die Pixeldaten und einen Memory-DC. Achtung das
//	Bitmap-Handle kann nicht benutzt werden sollange der DC aktiv ist.
//	Mit DibDelMemDC(...) kann der Memory-DC gelscht werden.
//	Der Memory-DC wird erstellet falls er nicht vorhanden ist.
//	pInfo		: Ist das Handle der Bilddaten
//	pDc			: Hier wird das Handle des Memory-DC's gespeichert
//	Ergibt das Bitmap-Handle, bzw. NULL bei einem Fehler.
EXTAPI LPVOID WINAPI DibGetPixelsEx(LPBITMAPINFO pInfo,HDC *pDc)
{
LPDIBINFO	pAlloc;
HDC			hNewDc;


	if(!pInfo || !pDc)									// Prfe das Handle
		{
		SetLastError(ERROR_INVALID_PARAMETER);
		return NULL;
		}

	pAlloc	= DIB_PTR_OFFSET(pInfo,-(int)sizeof(DIBINFO),LPDIBINFO);

														// Ist das Handle in Ordnung
	if(IsBadWritePtr(pAlloc,sizeof(DIBINFO)) || pAlloc->uTag!=DIB_TAG_BITMAP)
		{
		SetLastError(ERROR_INVALID_PARAMETER);
		return NULL;
		}

	if(!pAlloc->hBitmap)								// Existiert ein Bitmap
		{
		SetLastError(ERROR_INVALID_DATA);
		*pDc = 0;
		return NULL;
		}

	if(!pAlloc->hMemDc)									// Muss ein neuer DC erstellt werden
		{
			hNewDc = CreateCompatibleDC(NULL);
		if(!hNewDc)return NULL;

		SelectObject(hNewDc,pAlloc->hBitmap);

		pAlloc->hMemDc = hNewDc;
		}


	*pDc = pAlloc->hMemDc;


return pAlloc->pLines;
}

//*****************************************************************************
//*
//*		DibGetMemDC
//*
//*****************************************************************************
//	Holt den Memory-DC von den Bilddaten. Der Memory-DC wird erstellet falls
//	er nicht vorhanden ist. Achtung das Bitmap-Handle kann nicht benutzt werden
//	sollange der DC aktiv ist.
//	Mit DibDelMemDC(...) kann der Memory-DC gelscht werden.
//	pInfo		: Ist das Handle der Bilddaten
//	Ergibt das DC-Handle, bzw. NULL bei einem Fehler.
EXTAPI HDC WINAPI DibGetMemDC(LPBITMAPINFO pInfo)
{
LPDIBINFO	pAlloc;
HDC			hNewDc;


	if(!pInfo)											// Prfe das Handle
		{
		SetLastError(ERROR_INVALID_PARAMETER);
		return NULL;
		}

	pAlloc	= DIB_PTR_OFFSET(pInfo,-(int)sizeof(DIBINFO),LPDIBINFO);

														// Ist das Handle in Ordnung
	if(IsBadWritePtr(pAlloc,sizeof(DIBINFO)) || pAlloc->uTag!=DIB_TAG_BITMAP)
		{
		SetLastError(ERROR_INVALID_PARAMETER);
		return NULL;
		}

	if(!pAlloc->hBitmap || !pAlloc->pLines)				// Existiert ein Bitmap
		{
		SetLastError(ERROR_INVALID_DATA);
		return NULL;
		}

	if(!pAlloc->hMemDc)									// Muss ein neuer DC erstellt werden
		{
			hNewDc = CreateCompatibleDC(NULL);
		if(!hNewDc)return NULL;

		SelectObject(hNewDc,pAlloc->hBitmap);

		pAlloc->hMemDc = hNewDc;
		}



return pAlloc->hMemDc;
}

//*****************************************************************************
//*
//*		DibDelMemDC
//*
//*****************************************************************************
//	Lscht den Memory-DC von den Bilddaten.
//	pInfo		: Ist das Handle der Bilddaten
//	Ergibt TRUE wenn ok, bzw. FALSE bei einem Fehler.
EXTAPI BOOL WINAPI DibDelMemDC(LPBITMAPINFO pInfo)
{
LPDIBINFO	pAlloc;
HDC			hOldDc;


	if(!pInfo)											// Prfe das Handle
		{
		SetLastError(ERROR_INVALID_PARAMETER);
		return FALSE;
		}

	pAlloc	= DIB_PTR_OFFSET(pInfo,-(int)sizeof(DIBINFO),LPDIBINFO);

														// Ist das Handle in Ordnung
	if(IsBadWritePtr(pAlloc,sizeof(DIBINFO)) || pAlloc->uTag!=DIB_TAG_BITMAP)
		{
		SetLastError(ERROR_INVALID_PARAMETER);
		return FALSE;
		}

	if(!pAlloc->hMemDc)									// Ist kein DC vorhanden
		{
		SetLastError(ERROR_INVALID_DATA);
		return FALSE;
		}

	hOldDc			= pAlloc->hMemDc;
	pAlloc->hMemDc	= NULL;

	DeleteDC(hOldDc);									// Memory-DC lschen



return TRUE;
}

//*****************************************************************************
//*
//*		DibConvertDefault
//*
//*****************************************************************************
//	Tauscht bei einer einzelnen Farbe die Standartfarben aus:
//			RGB(128,128,128) --> COLOR_3DSHADOW
//			RGB(192,192,192) --> COLOR_3DFACE
//			RGB(223,223,223) --> COLOR_3DLIGHT
//	uColor		: Ist die Farbe die konvertiert werden soll.
//	Ergibt die neue Farbe bzw. die alte Farbe wenn es keine Standartfarbe ist.
EXTAPI COLORREF WINAPI DibColorDefault(COLORREF uColor)
{
	if(uColor==RGB(128,128,128))return GetSysColor(COLOR_3DSHADOW);
	if(uColor==RGB(192,192,192))return GetSysColor(COLOR_3DFACE);
	if(uColor==RGB(223,223,223))return GetSysColor(COLOR_3DLIGHT);

return uColor;
}

//*****************************************************************************
//*
//*		DibConvertDefault
//*
//*****************************************************************************
//	Tauscht die Standartfarben in einen DIB-Bitmap:
//			RGB(128,128,128) --> COLOR_3DSHADOW
//			RGB(192,192,192) --> COLOR_3DFACE
//			RGB(223,223,223) --> COLOR_3DLIGHT
//	pInfo		: Ist der Zeiger auf die Bildinformationen samt Farben
//	pPixels		: Zeiger auf die Pixel-Daten.
//	Ergibt TRUE wenn die Konvertierung erfolgreich war, bzw. FALSE bei einem Fehler.
EXTAPI BOOL WINAPI DibConvertDefault(LPBITMAPINFO pInfo,LPVOID pPixels)
{
LPBYTE		pTemp;
COLORREF	uCol1;
COLORREF	uCol2;
COLORREF	uCol3;
LPCOLORREF	pCol;
UINT		uVal;
UINT		uNum;
UINT		uCol;
UINT		uMax;
int			iRow;
int			iCol;



	if(!pInfo || !pPixels)									// Prfe Bilddaten
		{
		return FALSE;
		}


	if(pInfo->bmiHeader.biBitCount<=8)						// Bild mit Farbpallete
		{
		uVal = 1<<pInfo->bmiHeader.biBitCount;

			uMax  = pInfo->bmiHeader.biClrUsed;
		if(!uMax || uMax>uVal)uMax=uVal;

		pCol  = (COLORREF*)pInfo->bmiColors;
		uCol1 = SwapRGB(GetSysColor(COLOR_3DSHADOW));
		uCol2 = SwapRGB(GetSysColor(COLOR_3DFACE));
		uCol3 = SwapRGB(GetSysColor(COLOR_3DLIGHT));

		for(uNum=0;uNum<uMax;uNum++)
			{
			if(pCol[uNum]==GBR(128,128,128)){pCol[uNum]=uCol1;continue;}
			if(pCol[uNum]==GBR(192,192,192)){pCol[uNum]=uCol2;continue;}
			if(pCol[uNum]==GBR(223,223,223)){pCol[uNum]=uCol3;continue;}
			}

		return TRUE;
		}


	if(pInfo->bmiHeader.biCompression!=BI_RGB)				// Ist das Bild komprimiert
	if(pInfo->bmiHeader.biCompression!=BI_BITFIELDS)
		{
		return FALSE;
		}

	uCol1 = SwapRGB(GetSysColor(COLOR_3DSHADOW));
	uCol2 = SwapRGB(GetSysColor(COLOR_3DFACE  ));
	uCol3 = SwapRGB(GetSysColor(COLOR_3DLIGHT ));

	if(pInfo->bmiHeader.biBitCount==32)						// 32-Bit-Format
		{
		pCol	= (COLORREF*)pPixels;
		uMax	= pInfo->bmiHeader.biWidth;
		uMax   *= pInfo->bmiHeader.biHeight;

		for(uNum=0;uNum<uMax;uNum++)
			{
			uCol  = pCol[uNum]&0x00FFFFFF;
			uVal  = pCol[uNum]&0xFF000000;

			if(uCol==GBR(128,128,128)){pCol[uNum]=uCol1|uVal;continue;}
			if(uCol==GBR(192,192,192)){pCol[uNum]=uCol2|uVal;continue;}
			if(uCol==GBR(223,223,223)){pCol[uNum]=uCol3|uVal;continue;}
			}

		return TRUE;
		}

	if(pInfo->bmiHeader.biBitCount==24)						// 24-Bit-Format
		{
		pTemp	= (LPBYTE)pPixels;
		uNum	= pInfo->bmiHeader.biWidth&3;

		for(iRow=pInfo->bmiHeader.biHeight;iRow>0;iRow--,pTemp+=uNum)
		for(iCol=pInfo->bmiHeader.biWidth ;iCol>0;iCol--,pTemp+=3)
			{
			uCol  = *(UINT*)(pTemp+iCol*3);
			uCol &= 0x00FFFFFF;

			if(uCol==GBR(128,128,128)){*(UINT*)pTemp&=0xFF000000;*(UINT*)pTemp|=uCol1;continue;}
			if(uCol==GBR(192,192,192)){*(UINT*)pTemp&=0xFF000000;*(UINT*)pTemp|=uCol2;continue;}
			if(uCol==GBR(223,223,223)){*(UINT*)pTemp&=0xFF000000;*(UINT*)pTemp|=uCol3;continue;}
			}

		return TRUE;
		}


return FALSE;
}

//*****************************************************************************
//*
//*		DibConvertGrayScale
//*
//*****************************************************************************
//	ndert ein Bild in Graustuffen um.
//	pInfo		: Ist der Zeiger auf die Bildinformationen samt Farben.
//	pPixels		: Zeiger auf die Pixel-Daten.
//	uBase		: Ist die Basisfarbe um die die nderungen ausgefhrt werden.
//				  Diese Farbe sollt COLOR_3DLIGHT oder RGB(223,223,223) sein.
//	uIgnore		: Ist die Hintergrundfarbe die nicht verndert wird
//				  Wenn ein Bit 31 gesetzt ist wird die Maske
//				  bei 32-Bit-Bildern (Alpha==0) nicht verndert.
//	Ergibt TRUE wenn die Konvertierung erfolgreich war, bzw. FALSE bei einem Fehler.
EXTAPI BOOL WINAPI DibConvertGrayScale(LPBITMAPINFO pInfo,LPVOID pPixels,UINT uBase,UINT uIgnore)
{
DIBCOLOR		sColor;
unsigned		uBaseR;
unsigned		uBaseG;
unsigned		uBaseB;
unsigned		uScale;
unsigned		uSizeX;
unsigned		uPosX;
unsigned		uPosY;
LPBYTE			pData;
BYTE			bFlag;
UINT			uBits;
UINT			uNum;
UINT			uMax;



	if(!pInfo || !pPixels)									// Prfe Bilddaten
		{
		return FALSE;
		}

	uBits	= pInfo->bmiHeader.biBitCount;
	uIgnore	= SwapRGB(uIgnore);
	uBaseB	= (BYTE)(uBase>>16);
	uBaseG	= (BYTE)(uBase>>8);
	uBaseR	= (BYTE)(uBase);

	if(uBits<=8)										// Bild mit Farbpallete
		{
		uNum = 1<<pInfo->bmiHeader.biBitCount;

			uMax  = pInfo->bmiHeader.biClrUsed;
		if(!uMax || uMax>uNum)uMax=uNum;

		for(uNum=0;uNum<uMax;uNum++)
			{
			   sColor.uRgb = DIB_GET_DWORD(pInfo->bmiColors,uNum);
			if(sColor.uRgb==uIgnore)continue;

			uScale     = sColor.ucRed  * 44;
			uScale    += sColor.ucBlue *128;
			uScale    += sColor.ucGreen* 85;
			uScale   >>= 8;

			if(uScale>192)
				{
				uScale	= (uScale-192)/4;
				sColor.ucRed	= uBaseR+((256-uBaseR)*uScale)/64;
				sColor.ucBlue	= uBaseB+((256-uBaseB)*uScale)/64;
				sColor.ucGreen	= uBaseG+((256-uBaseG)*uScale)/64;
				}
			else{
				uScale			= uScale/3+192;
				sColor.ucRed	= (uBaseR*uScale)/256;
				sColor.ucBlue	= (uBaseB*uScale)/256;
				sColor.ucGreen	= (uBaseG*uScale)/256;
				}

			DIB_SET_DWORD(pInfo->bmiColors,uNum,sColor.uRgb);
			}

		return TRUE;
		}

	if(uBits==32)										// 32-Bit-Bild
		{
		pData	= (LPBYTE)pPixels;
		uPosX	= pInfo->bmiHeader.biWidth;
		uPosX  *= pInfo->bmiHeader.biHeight;
		bFlag	= (uIgnore>>31)? 0x00:0xFF;

		while(uPosX>0)
			{
			uPosX--;

			    sColor.uRgb = DIB_GET_DWORD(pData,uPosX);
			if( sColor.uRgb==uIgnore    )continue;
			if((sColor.ucAlpha|bFlag)==0)continue;

			uScale     = sColor.ucRed  * 44;
			uScale    += sColor.ucBlue *128;
			uScale    += sColor.ucGreen* 85;
			uScale   >>= 8;

			if(uScale>192)
				{
				uScale	= (uScale-192)/4;
				sColor.ucRed	= uBaseR+((256-uBaseR)*uScale)/64;
				sColor.ucBlue	= uBaseB+((256-uBaseB)*uScale)/64;
				sColor.ucGreen	= uBaseG+((256-uBaseG)*uScale)/64;
				}
			else{
				uScale			= uScale/3+192;
				sColor.ucRed	= (uBaseR*uScale)/256;
				sColor.ucBlue	= (uBaseB*uScale)/256;
				sColor.ucGreen	= (uBaseG*uScale)/256;
				}

			DIB_SET_DWORD(pData,uPosX,sColor.uRgb);
			}

		return TRUE;
		}

	if(uBits==24)										// 24-Bit-Bild
		{
		pData	= (LPBYTE)pPixels;
		uSizeX	= pInfo->bmiHeader.biWidth;
		uPosY	= pInfo->bmiHeader.biHeight;

		for(            ;uPosY>0;uPosY--,pData+=uSizeX&3)
		for(uPosX=uSizeX;uPosX>0;uPosX--,pData+=4)
			{
			    sColor.uRgb = DIB_GET_DWORD(pData,0);
			if((sColor.uRgb&0x00FFFFFF)==uIgnore)continue;

			uScale     = sColor.ucRed  * 44;
			uScale    += sColor.ucBlue *128;
			uScale    += sColor.ucGreen* 85;
			uScale   >>= 8;

			if(uScale>192)
				{
				uScale	= (uScale-192)/4;
				sColor.ucRed	= uBaseR+((256-uBaseR)*uScale)/64;
				sColor.ucBlue	= uBaseB+((256-uBaseB)*uScale)/64;
				sColor.ucGreen	= uBaseG+((256-uBaseG)*uScale)/64;
				}
			else{
				uScale			= uScale/3+192;
				sColor.ucRed	= (uBaseR*uScale)/256;
				sColor.ucBlue	= (uBaseB*uScale)/256;
				sColor.ucGreen	= (uBaseG*uScale)/256;
				}

			DIB_SET_DWORD(pData,0,sColor.uRgb);
			}

		}



return FALSE;
}

//*****************************************************************************
//*
//*		DibConvertSize
//*
//*****************************************************************************
//	Konvertiert ein DIB-Bitmap in ein Bitmap mit anderer Gre.
//	pInfo		: Ist das Handle der Bilddaten.
//	pPixels		: Zielpuffer fr die Bilddaten, bei NULL wird es vom Handle pInfo geholt.
//	pFrom		: Ist der Zeiger auf das originale Ausgangsbild.
//	pInput		: Bilddaten des Ausgangsbildes, bei NULL wird es vom Handle pFrom geholt.
//	uFromX/Y	: Startposition im Ausgangsbild
//	uBaseX/Y	: Gre des Bereiches im Ausgangsbild
//	uPosX/Y		: Startposition im Zielpuffer
//	uSizeX/Y	: Gre des Bereiches im Zielpuffer
//	Ergibt TRUE wenn erfolgreich, bzw. FALSE bei einem Fehler
EXTAPI BOOL WINAPI DibConvertSizeEx(LPBITMAPINFO pInfo,LPVOID pPixels,LPBITMAPINFO pFrom,LPVOID pInput,UINT uFromX,UINT uFromY,UINT uBaseX,UINT uBaseY,UINT uPosX,UINT uPosY,UINT uSizeX,UINT uSizeY)
{
LPDIBINFO		pAlloc;
LPBITMAPINFO	pFree;
UINT			uStepX;
UINT			uStepY;
UINT			uBits;
BYTE			bMask;
BYTE			bVal;
LPDWORD			pPtr;
LPDWORD			pLine;
LPDWORD			pDelta;
LPBYTE			pMemOld;
LPBYTE			pMemNew;
UINT			r,g,b,a,d;
UINT			uFactX;
UINT			uFactY;
UINT			uDiffX;
UINT			uDiffY;
UINT			uOldX4;
UINT			uStart;
UINT			uDelta;
UINT			uOrigX;
UINT			uOrigY;
UINT			uEnd;
UINT			uCol;
UINT			uMul;
ULONGLONG		uVal;



	if(pFrom == NULL || pInfo == NULL )return FALSE;
	if(pInfo->bmiHeader.biBitCount!=32)return FALSE;

	uOrigX	= pFrom->bmiHeader.biWidth;
	uStepX	= pInfo->bmiHeader.biWidth;
	uOrigY	= pFrom->bmiHeader.biHeight;
	uStepY  = pInfo->bmiHeader.biHeight;
	uBits	= (uOrigX-1)|(uOrigY-1)|(uStepX-1)|(uStepY-1);

	if(uBits>=0x10000)return FALSE;						// Prfe die Gre
	if(uPosX >=uStepX || uPosY >=uStepY)return FALSE;
	if(uFromX>=uOrigX || uFromY>=uOrigY)return FALSE;
	if(uSizeX<=0      || uSizeY<=0     )return FALSE;
	if(uBaseX<=0      || uBaseY<=0     )return FALSE;

	if(uPosX +uSizeX>uStepX)uSizeX=uStepX-uPosX;
	if(uPosY +uSizeY>uStepY)uSizeY=uStepY-uPosY;
	if(uFromX+uBaseX>uOrigX)uBaseX=uOrigX-uFromX;
	if(uFromY+uBaseY>uOrigY)uBaseY=uOrigY-uFromY;


	if(!pPixels)
		{
		    pAlloc = DIB_PTR_OFFSET(pInfo,-(int)sizeof(DIBINFO),LPDIBINFO);
		if( pAlloc->uTag!=DIB_TAG_BITMAP)return FALSE;
			pPixels = pAlloc->pLines;
		if(!pPixels)return FALSE;
		}

	if(!pInput)
		{
		    pAlloc = DIB_PTR_OFFSET(pFrom,-(int)sizeof(DIBINFO),LPDIBINFO);
		if( pAlloc->uTag!=DIB_TAG_BITMAP)return FALSE;
			pInput = pAlloc->pLines;
		if(!pInput)return FALSE;
		}


	pFree = NULL;

	if(pFrom->bmiHeader.biBitCount!=32)					// Ist die Quelle kein 32 Bit-Bild
		{
			pFree = GetDibOfMemory(NULL,pFrom,DIB_FORCE_COLORS(32)|DIB_PIXEL_DATA,&pInput);
		if(!pFree)return FALSE;

		pFrom = pFree;
		}



	if(uSizeX==uBaseX && uSizeY==uBaseY)				// Gleiche Gre (kopieren)
		{
		if(uSizeX==uStepX && uSizeX==uOrigX)
			{
			pMemOld	 = DIB_PTR_OFFSET(pInput ,0,LPBYTE);
			pMemNew	 = DIB_PTR_OFFSET(pPixels,0,LPBYTE);
			pMemOld += (uOrigY-uFromY-uSizeY)*uSizeX*4;
			pMemNew += (uStepY-uPosY -uSizeY)*uSizeX*4;

			memcpy(pMemNew,pMemOld,uSizeX*uSizeY*4);
			}
		else{
			pMemOld	 = DIB_PTR_OFFSET(pInput ,uFromX*4,LPBYTE);
			pMemNew	 = DIB_PTR_OFFSET(pPixels,uPosX *4,LPBYTE);
			pMemOld += (uOrigY-uFromY-uSizeY)*uOrigX*4;
			pMemNew += (uStepY-uPosY -uSizeY)*uStepX*4;

			for(;uSizeY;uSizeY--)						// Spalten durchlaufen
				{
				memcpy(pMemNew,pMemOld,uSizeX*4);
				pMemOld += uOrigX*4;
				pMemNew += uStepX*4;
				}
			}

		if(pFree)DibFreeHandle(pFree);
		return TRUE;
		}


//*****************************************************************************


	pMemOld = DIB_PTR_OFFSET(pInput,-1,LPBYTE);
	bMask	= 0x00;

	for(uEnd=uOrigX*uOrigY*4;;uEnd-=4)					// Hat das Bild eine Maske
		{
		if(uEnd==0){bMask=0xFF;break;}
		if(pMemOld[uEnd])break;
		}


	if(uBaseX<uSizeX)									// Quelle ist kleiner
		{
		uFactX	= uBaseX-1;
		uDiffX	= uSizeX-1;
		}
	else{
		uFactX	= uBaseX;								// Quelle ist grer
		uDiffX	= uSizeX;
		}

	while(!((uFactX|uDiffX)&1))							// Faktoren krzen
		{
		uDiffX	>>= 1;
		uFactX	>>= 1;
		}

	uVal	= uSizeX;
	uVal   *= uFactX;
	uVal   *= 256;
	uVal  >>= 31;
	uMul    = (unsigned)uVal;

	while(uMul)											// Sind Faktoren zu gro
		{
		uMul	>>= 1;
		uDiffX	>>= 1;
		uFactX	>>= 1;
		}

	uFactX *= 256;

	if(!uDiffX)uDiffX=1;

	if(uBaseY<uSizeY)									// Quelle ist kleiner
		{
		uFactY	= uBaseY-1;
		uDiffY	= uSizeY-1;
		}
	else{
		uFactY	= uBaseY;								// Quelle ist grer
		uDiffY	= uSizeY;
		}

	while(!((uFactY|uDiffY)&1))							// Faktoren krzen
		{
		uDiffY	>>= 1;
		uFactY	>>= 1;
		}

	uVal	= uSizeY;
	uVal   *= uFactY;
	uVal   *= 256;
	uVal  >>= 31;
	uMul    = (unsigned)uVal;

	while(uMul)											// Sind Faktoren zu gro
		{
		uMul	>>= 1;
		uDiffY	>>= 1;
		uFactY	>>= 1;
		}

	uFactY *= 256;

	if(!uDiffY)uDiffY=1;


	uOldX4	= uBaseX*4;
	pLine	= new DWORD[uOldX4+uBaseX];					// Temporren Speicher allokieren
	pDelta	= pLine+uOldX4;

	pInput	= DIB_PTR_OFFSET(pInput ,uFromX*4+(uOrigY-uFromY-uBaseY)*uOrigX*4,LPVOID);
	pPixels	= DIB_PTR_OFFSET(pPixels,uPosX *4+(uStepY-uPosY -uSizeY)*uStepX*4,LPVOID);


	for(uPosY=0;uPosY<uSizeY;uPosY++)					// Spalten durchlaufen
		{
		uStart = ((uPosY  )*uFactY)/uDiffY;
		uEnd   = ((uPosY+1)*uFactY)/uDiffY;

		if(uStart+256>uEnd  )uEnd=uStart+256;			// Stufe zu klein ?
		if(uEnd  /256>uBaseY)uEnd=uBaseY*256;

		   uDelta=uEnd-uStart;
		if(uDelta<=0)uDelta=1;

		uMul = 256-(uStart&0xFF);						// Start-Ziele holen

		pMemOld = DIB_PTR_OFFSET(pInput,(uOrigX*4)*(uStart/256),LPBYTE);

		for(uPosX=0;uPosX<uOldX4;uPosX+=4)
			{
				bVal = pMemOld[uPosX+3]|bMask;
			if(!bVal)
				{
				pLine[uPosX  ] = 0;
				pLine[uPosX+1] = 0;
				pLine[uPosX+2] = 0;
				pLine[uPosX+3] = 0;
				DIB_GET_DWORD(pDelta,uPosX/4) = 0;
				continue;
				}

			pLine[uPosX  ] = ((DWORD)pMemOld[uPosX  ]*uMul)>>8;
			pLine[uPosX+1] = ((DWORD)pMemOld[uPosX+1]*uMul)>>8;
			pLine[uPosX+2] = ((DWORD)pMemOld[uPosX+2]*uMul)>>8;
			pLine[uPosX+3] = ((DWORD)bVal            *uMul)>>8;

			DIB_GET_DWORD(pDelta,uPosX/4) = uMul;
			}

		   uStart /= 256;								// Mittlere Zeilen addieren
		if(uStart<((uEnd-1)/256))
			{
			for(uStart++;uStart<uEnd/256;uStart++)
				{
				pMemOld = DIB_PTR_OFFSET(pInput,uOrigX*uStart*4,LPBYTE);

				for(uPosX=0;uPosX<uOldX4;uPosX+=4)
					{
						bVal = pMemOld[uPosX+3]|bMask;
					if(!bVal)continue;

					pLine [uPosX  ] += (DWORD)pMemOld[uPosX  ];
					pLine [uPosX+1] += (DWORD)pMemOld[uPosX+1];
					pLine [uPosX+2] += (DWORD)pMemOld[uPosX+2];
					pLine [uPosX+3] += (DWORD)bVal;
					DIB_GET_DWORD(pDelta,uPosX/4) += 256;
					}
				}

			uMul = uEnd&0xFF;							// Letzte Zeile addieren

			if(uMul)
				{
				pMemOld = DIB_PTR_OFFSET(pInput,(uOrigX*4)*(uEnd/256),LPBYTE);

				for(uPosX=0;uPosX<uOldX4;uPosX+=4)
					{
						bVal = pMemOld[uPosX+3]|bMask;
					if(!bVal)continue;

					pLine[uPosX  ] += ((DWORD)pMemOld[uPosX  ]*uMul)>>8;
					pLine[uPosX+1] += ((DWORD)pMemOld[uPosX+1]*uMul)>>8;
					pLine[uPosX+2] += ((DWORD)pMemOld[uPosX+2]*uMul)>>8;
					pLine[uPosX+3] += ((DWORD)bVal            *uMul)>>8;
					DIB_GET_DWORD(pDelta,uPosX/4) += uMul;
					}
				}
			}

		for(uPosX=0;uPosX<uOldX4;uPosX+=4)				// Farben normieren
			{
			   uMul = DIB_GET_DWORD(pDelta,uPosX/4);
			if(uMul!=0 && uMul!=256)
				{
				pLine[uPosX  ] = (pLine[uPosX  ]<<8)/uMul;
				pLine[uPosX+1] = (pLine[uPosX+1]<<8)/uMul;
				pLine[uPosX+2] = (pLine[uPosX+2]<<8)/uMul;
				}
			}

		if(uDelta!=256)									// Alpha-Maske normieren
			{
			for(uPosX=3;uPosX<uOldX4;uPosX+=4)
				{
				pLine[uPosX] = (pLine[uPosX]<<8)/uDelta;
				}
			}

		pMemNew = DIB_PTR_OFFSET(pPixels,uStepX*uPosY*4,LPBYTE);

		//**************** X-Richtung *********************************************

		for(uPosX=0;uPosX<uSizeX;uPosX++)
			{
			uStart = ((uPosX  )*uFactX)/uDiffX;
			uEnd   = ((uPosX+1)*uFactX)/uDiffX;

			if(uStart+256>uEnd  )uEnd=uStart+256;		// Stufe zu klein ?
			if(uEnd  /256>uBaseX)uEnd=uBaseX*256;

			   uDelta=uEnd-uStart;
			if(uDelta<=0)uDelta=1;

			uMul	= 256-(uStart&0xFF);				// Start Pixel
			uStart /= 256;
			pPtr	= pLine+uStart*4;

			if(!pPtr[3])
				{
				d = 0;
				b = 0;
				g = 0;
				r = 0;
				a = 0;
				}
			else{
				d = uMul;
				b = (pPtr[0]*uMul)>>8;
				g = (pPtr[1]*uMul)>>8;
				r = (pPtr[2]*uMul)>>8;
				a = (pPtr[3]*uMul)>>8;
				}

			pPtr += 4;

			if(uStart<((uEnd-1)/256))					// Weitere Pixel vorhanden
				{
				uMul  = uEnd&0xFF;
				uEnd /= 256;

				for(uStart++;uStart<uEnd;uStart++)		// Mittlere Pixel
					{
					if(pPtr[3])
						{
						d += 256;
						b += pPtr[0];
						g += pPtr[1];
						r += pPtr[2];
						a += pPtr[3];
						}

					pPtr+=4;
					}

				if(uMul)								// Letzter Pixel
					{
					if(pPtr[3])
						{
						d += uMul;
						b += (pPtr[0]*uMul)>>8;
						g += (pPtr[1]*uMul)>>8;
						r += (pPtr[2]*uMul)>>8;
						a += (pPtr[3]*uMul)>>8;
						}

					}
				}

			if(d!=0 && d!=256)							// Farbe normieren
				{
				b = (b<<8)/d;
				g = (g<<8)/d;
				r = (r<<8)/d;
				}

			if(uDelta!=256)								// Alpha-Wert normieren
				{
				a = (a<<8)/uDelta;
				}

			uCol = uPosX*4;

			pMemNew[uCol  ]=(BYTE)b;					// Pixel speichern
			pMemNew[uCol+1]=(BYTE)g;
			pMemNew[uCol+2]=(BYTE)r;
			pMemNew[uCol+3]=(BYTE)a;
			}
		}


	if(pFree)DibFreeHandle(pFree);
	delete pLine;


return TRUE;
}

//*****************************************************************************
//*
//*		DibPutAlphaEx
//*
//*****************************************************************************
//	berlagert ein DIB via Alpha-Blending ber ein anders DIB
//	pInfo		: Ist das Handle der Bilddaten.
//	pPixels		: Zielpuffer fr die Bilddaten, bei NULL wird es vom Handle pInfo geholt.
//	uPosX/Y		: Startposition im Zielpuffer
//	pFrom		: Ist der Zeiger auf das originale Ausgangsbild.
//	pInput		: Bilddaten des Ausgangsbildes, bei NULL wird es vom Handle pFrom geholt.
//	uFromX/Y	: Startposition im Ausgangsbild
//	uSizeX/Y	: Gre des Bereiches im Zielpuffer
//	Ergibt TRUE wenn erfolgreich, bzw. FALSE bei einem Fehler
EXTAPI BOOL WINAPI DibPutAlphaEx(LPBITMAPINFO pInfo,LPVOID pPixels,UINT uPosX,UINT uPosY,LPBITMAPINFO pFrom,LPVOID pInput,UINT uFromX,UINT uFromY,UINT uSizeX,UINT uSizeY)
{
LPBITMAPINFO	pFree;
LPDIBINFO		pAlloc;
LPBYTE			pMemOld;
LPBYTE			pMemNew;
UINT			uAlpha1;
UINT			uAlpha2;
UINT			uValue;
UINT			uStepX;
UINT			uStepY;
UINT			uOrigX;
UINT			uOrigY;
UINT			uBits;



	if(pFrom == NULL || pInfo == NULL )return FALSE;
	if(pInfo->bmiHeader.biBitCount!=32)return FALSE;

	uOrigX	= pFrom->bmiHeader.biWidth;
	uStepX	= pInfo->bmiHeader.biWidth;
	uOrigY	= pFrom->bmiHeader.biHeight;
	uStepY  = pInfo->bmiHeader.biHeight;
	uBits	= (uOrigX-1)|(uOrigY-1)|(uStepX-1)|(uStepY-1);

	if(uBits>=0x10000)return FALSE;						// Prfe die Gre
	if(uPosX >=uStepX || uPosY >=uStepY)return FALSE;
	if(uFromX>=uOrigX || uFromY>=uOrigY)return FALSE;

	if(uPosX +uSizeX>uStepX)uSizeX=uStepX-uPosX;
	if(uPosY +uSizeY>uStepY)uSizeY=uStepY-uPosY;
	if(uFromX+uSizeX>uOrigX)uSizeX=uOrigX-uFromX;
	if(uFromY+uSizeY>uOrigY)uSizeY=uOrigY-uFromY;

	if(!pPixels)
		{
		    pAlloc = DIB_PTR_OFFSET(pInfo,-(int)sizeof(DIBINFO),LPDIBINFO);
		if( pAlloc->uTag!=DIB_TAG_BITMAP)return FALSE;
			pPixels = pAlloc->pLines;
		if(!pPixels)return FALSE;
		}

	if(!pInput)
		{
		    pAlloc = DIB_PTR_OFFSET(pFrom,-(int)sizeof(DIBINFO),LPDIBINFO);
		if( pAlloc->uTag!=DIB_TAG_BITMAP)return FALSE;
			pInput = pAlloc->pLines;
		if(!pInput)return FALSE;
		}

	pFree = NULL;

	if(pFrom->bmiHeader.biBitCount!=32)					// Ist die Quelle kein 32 Bit-Bild
		{
			pFree = GetDibOfMemory(NULL,pFrom,DIB_FORCE_COLORS(32)|DIB_PIXEL_DATA,&pInput);
		if(!pFree)return FALSE;

		pFrom = pFree;
		}


//*****************************************************************************

	uSizeX  *= 4;
	uOrigX  *= 4;
	uStepX  *= 4;
	pMemOld	 = DIB_PTR_OFFSET(pInput ,uFromX*4,LPBYTE);
	pMemNew	 = DIB_PTR_OFFSET(pPixels,uPosX *4,LPBYTE);
	pMemOld += (uOrigY-uFromY-uSizeY)*uOrigX;
	pMemNew += (uStepY-uPosY -uSizeY)*uStepX;


	for(uPosY=0;uPosY<uSizeY;uPosY++)					// Spalten durchlaufen
		{
		for(uPosX=0;uPosX<uSizeX;uPosX+=4)
			{
			   uValue=pMemOld[uPosX+3];
			if(uValue==0)continue;
			if(uValue==255)
				{
				pMemNew[uPosX  ] = pMemOld[uPosX  ];
				pMemNew[uPosX+1] = pMemOld[uPosX+1];
				pMemNew[uPosX+2] = pMemOld[uPosX+2];
				continue;
				}

			uAlpha1	= uValue+1;
			uAlpha2	= 257-uAlpha1;

			pMemNew[uPosX  ] = (pMemOld[uPosX  ]*uAlpha1 + pMemNew[uPosX  ]*uAlpha2)>>8;
			pMemNew[uPosX+1] = (pMemOld[uPosX+1]*uAlpha1 + pMemNew[uPosX+1]*uAlpha2)>>8;
			pMemNew[uPosX+2] = (pMemOld[uPosX+2]*uAlpha1 + pMemNew[uPosX+2]*uAlpha2)>>8;
			}

		pMemOld += uOrigX;
		pMemNew += uStepX;
		}


	if(pFree)DibFreeHandle(pFree);


return TRUE;
}

//*****************************************************************************
//*
//*		DibConvertColor
//*
//*****************************************************************************
//	Tauscht eine Farbe gegen eine andere aus.
//	pInfo		: Ist der Zeiger auf die Bildinformationen samt Farben.
//	pPixels		: Zeiger auf die Pixel-Daten.
//	uColorFrom	: Ist die Farbe die getauscht werden soll bzw. der Farbindex.
//				  Wenn die Bits 24..31 auf 0x80 sind ist es ein Farbindex.
//				  Wenn ein Bit 31 gesetzt ist wird die Maske
//				  bei 32-Bit-Bildern (Alpha==0) nicht verndert.
//				  Wenn ein Bit 30 gesetzt ist wird der Alpha-Wert bei nicht
//				  getauschten Pixeln auf 255 gesetzt.
//	uColorTo	: Ist die neue Farbe, ihr Alpha-Wert wird mit dem originalen verodert
//	Ergibt TRUE wenn die Konvertierung erfolgreich war, bzw. FALSE bei einem Fehler.
EXTAPI BOOL WINAPI DibConvertColor(LPBITMAPINFO pInfo,LPVOID pPixels,COLORREF uColorFrom,COLORREF uColorTo)
{
BYTE		bFlag;
BYTE		bMask;
LPBYTE		pTemp;
COLORREF	uFrom;
COLORREF	uSet;
LPCOLORREF	pCol;
UINT		uVal;
UINT		uNum;
UINT		uMax;
UINT		uCol;
int			iRow;
int			iCol;


	if(!pInfo || !pPixels)									// Prfe Bilddaten
		{
		return FALSE;
		}


	if(uColorFrom==uColorTo)return TRUE;


	if(pInfo->bmiHeader.biBitCount<=8)						// Bild mit Farbpallete
		{
		uNum = 1<<pInfo->bmiHeader.biBitCount;

			uMax  = pInfo->bmiHeader.biClrUsed;
		if(!uMax || uMax>uNum)uMax=uNum;

		pCol	= (LPCOLORREF)pInfo->bmiColors;
		uSet	= SwapRGB(uColorTo  );
		uFrom	= SwapRGB(uColorFrom);

		if(uColorFrom>>24==0x80)							// Via Index setzen
			{
			uColorFrom &= 0xFF;
			if(uColorFrom<uMax)pCol[uColorFrom]=uSet;
			return TRUE;
			}

		for(uNum=0;uNum<uMax;uNum++)
			{
			if(pCol[uNum]==uFrom)pCol[uNum]=uSet;
			}

		return TRUE;
		}


	if(pInfo->bmiHeader.biCompression!=BI_RGB)				// Ist das Bild komprimiert
	if(pInfo->bmiHeader.biCompression!=BI_BITFIELDS)
		{
		return FALSE;
		}


	uSet  = SwapRGB(uColorTo  );
	uFrom = SwapRGB(uColorFrom);

	if(pInfo->bmiHeader.biBitCount==32)						// 32-Bit-Format
		{
		pTemp	= (LPBYTE)pPixels;
		uMax	= pInfo->bmiHeader.biWidth;
		uMax   *= pInfo->bmiHeader.biHeight;
		bMask	= (BYTE)(uFrom>>30)&1;
		bFlag	= (BYTE)(uFrom>>31);
		uFrom  &= 0x00FFFFFF;

		for(uNum=0;uNum<uMax;uNum++)
			{
			uCol  = DIB_GET_DWORD(pTemp,uNum);
			uCol &= 0x00FFFFFF;

			if((uCol&0x00FFFFFF)!=uFrom)					// Farbe nicht ndern
				{
				if(!bMask)continue;
				DIB_SET_BYTE(pTemp,uNum*4+3,0xFF);
				continue;
				}

				uVal=uCol&0xFF000000;
			if(!uVal && bFlag)continue;

			DIB_SET_DWORD(pTemp,uNum,uSet|uVal);
			}

		return TRUE;
		}

	if(pInfo->bmiHeader.biBitCount==24)						// 24-Bit-Format
		{
		uSet   &= 0x00FFFFFF;
		uFrom  &= 0x00FFFFFF;
		pTemp	= (LPBYTE)pPixels;
		uNum	= pInfo->bmiHeader.biWidth&3;

		for(iRow=pInfo->bmiHeader.biHeight;iRow>0;iRow--,pTemp+=uNum)
		for(iCol=pInfo->bmiHeader.biWidth ;iCol>0;iCol--,pTemp+=3)
			{
			uCol  = *(UINT*)(pTemp+iCol*3);
			uCol &= 0x00FFFFFF;

			if(uCol==uFrom)
				{
				((LPWORD)pTemp)[0] =(WORD)(uSet);
				((LPBYTE)pTemp)[2] =(BYTE)(uSet>>16);
				}
			}

		return TRUE;
		}


return FALSE;
}

//*****************************************************************************
//*
//*		DibConvertAlpha
//*
//*****************************************************************************
//	Zeichnet eine Farbe ber das ganze Bild unter Bercksichtigung der Alpha-Werte.
//	pInfo		: Ist der Zeiger auf die Bildinformationen samt Farben
//	pPixels		: Zeiger auf die Pixel-Daten.
//	uColor		: Ist die Hintergrundfarbe die gesetzt wird.
//	Ergibt TRUE wenn die Konvertierung erfolgreich war, bzw. FALSE bei einem Fehler.
EXTAPI BOOL WINAPI DibConvertAlpha(LPBITMAPINFO pInfo,LPVOID pPixels,COLORREF uColor)
{
unsigned		uColorR;
unsigned		uColorG;
unsigned		uColorB;
unsigned		uAlpha;
unsigned		uBeta;
LPBYTE			pData;
COLORREF		uSet;
UINT			uNum;
UINT			uMax;


	if(!pInfo || !pPixels)									// Prfe Bilddaten
		{
		return FALSE;
		}

	if(pInfo->bmiHeader.biBitCount!=32)						// Prfe die Farbanzahl
		{
		return FALSE;
		}


	if(pInfo->bmiHeader.biCompression!=BI_RGB)				// Ist das Bild komprimiert
	if(pInfo->bmiHeader.biCompression!=BI_BITFIELDS)
		{
		return FALSE;
		}


	pData	= (LPBYTE)pPixels;
	uMax	= pInfo->bmiHeader.biWidth;
	uMax   *= pInfo->bmiHeader.biHeight;
	uSet	= SwapRGB(uColor)&0x00FFFFFF;
	uColorB	= (uSet    )&0xFF;
	uColorG	= (uSet>> 8)&0xFF;
	uColorR	= (uSet>>16);

	for(uNum=0;uNum<uMax;uNum++)							// Allex Pixel durchlaufen
		{
		   uAlpha = pData[uNum*4+3];
		if(uAlpha==255)										// Pixel nicht ndern
			{
			continue;
			}

		if(uAlpha==0)										// Pixel vollstndig ndern
			{
			DIB_SET_DWORD(pData,uNum,uSet);
			continue;
			}

		uBeta		= 255-uAlpha;
		pData[0]	= ((pData[0]*uAlpha+uColorB*uBeta)*257)>>16;
		pData[1]	= ((pData[1]*uAlpha+uColorG*uBeta)*257)>>16;
		pData[2]	= ((pData[2]*uAlpha+uColorR*uBeta)*257)>>16;
		}


return TRUE;
}

//*****************************************************************************
//*
//*		DibConvertMask
//*
//*****************************************************************************
//	Tauscht die diverse Pixels die mit einer Maske bestimmt sind gegen eine Farbe aus.
//	pInfo		: Ist der Zeiger auf die Bildinformationen samt Farben
//	pPixels		: Zeiger auf die Pixel-Daten.
//	pMask		: Zeiger auf die Bitmaske
//	uColor		: Ist die neue Farbe die getauscht werden soll bzw. der Farbindex
//				  wenn die Bits 24..31 auf 0x80 sind ist es ein Farbindex
//				  Bei Toolbars sollte die Farbe COLOR_3DFACE benutzt werden.
//				  Wenn ein Bit 30 gesetzt ist wird der Alpha-Wert bei nicht
//				  getauschten Pixeln auf 255 gesetzt.
//	Ergibt TRUE wenn die Konvertierung erfolgreich war, bzw. FALSE bei einem Fehler.
EXTAPI BOOL WINAPI DibConvertMask(LPBITMAPINFO pInfo,LPVOID pPixels,LPBYTE pMask,COLORREF uColor)
{
LPCOLORREF	pCol;
LPDWORD		pData;
LPBYTE		pTemp;
BYTE		bMask;
BYTE		bHigh;
WORD		wHigh;
UINT		aVal[8];
UINT		aBit[8];
UINT		uSizeX;
UINT		uSizeY;
UINT		uAddT;
UINT		uAddM;
UINT		uBits;
UINT		uMask;
UINT		uLast;
UINT		uRest;
UINT		uVal;
UINT		uNot;
UINT		uMax;
INT			iRow;
INT			iCol;



	if(!pInfo || !pPixels)								// Prfe Bilddaten
		{
		return FALSE;
		}


	uBits	= pInfo->bmiHeader.biBitCount;
	uSizeY	= pInfo->bmiHeader.biHeight;
	uSizeX	= pInfo->bmiHeader.biWidth;
	pTemp	= (LPBYTE)pPixels;
	uMax	= DIB_ROW_WIDTH(uSizeX,1)*uSizeY;

	if(IsBadReadPtr(pMask,uMax))						// Maske prfen
		{
		return FALSE;
		}


	if(uBits<=8)										// Bild mit Farbpallette
		{
		if(!(0x0113&(1<<uBits)))return FALSE;

		uVal = 1<<uBits;

			uMax  = pInfo->bmiHeader.biClrUsed;
		if(!uMax || uMax>uVal)uMax=uVal;

		uVal	= pTemp[0];
		uVal  >>= 8-uBits;
		uVal   |= 0x80000000;


		pCol	= (COLORREF*)pInfo->bmiColors;

		if(uColor>>24!=0x80)							// Suche RGB-Farbe
			{
			uVal = SwapRGB(uColor);

			for(uColor=0;pCol[uColor]!=uVal;uColor++)
				{
				if(uColor>=uMax)
					{
					return FALSE;
					}
				}
			}

		if(uBits==8)									// 8-Bit-Bild
			{
			uLast	= (0xFF00>>(uSizeX&7))&0xFF;
			uSizeX	= (uSizeX+3)&~3;
			uAddT	= (uSizeX&4);
			uAddM	= (0-((uSizeX+4)/8))&3;

			for(iRow=uSizeY;iRow>0;iRow-=1)
				{
				for(iCol=uSizeX;;iCol-=8,pTemp+=8,pMask+=1)
					{
					if(iCol>=8)
						{
						uVal = *pMask;
						}
					else if(iCol>0)
						{
						uVal = *pMask&uLast;
						}
					else{
						break;
						}

					if(uVal==0)continue;

					if(uVal&0x80)pTemp[0]=(BYTE)uColor;
					if(uVal&0x40)pTemp[1]=(BYTE)uColor;
					if(uVal&0x20)pTemp[2]=(BYTE)uColor;
					if(uVal&0x10)pTemp[3]=(BYTE)uColor;
					if(uVal&0x08)pTemp[4]=(BYTE)uColor;
					if(uVal&0x04)pTemp[5]=(BYTE)uColor;
					if(uVal&0x02)pTemp[6]=(BYTE)uColor;
					if(uVal&0x01)pTemp[7]=(BYTE)uColor;
					}

				pMask += uAddM;
				pTemp -= uAddT;
				}

			return TRUE;
			}

														// 1-2-4-Bit-Bild
		uSizeX	 = (uSizeX+7)&~7;
		uAddT	 = (0-((uSizeX*uBits)/8))&3;
		uAddM	 = (0-((uSizeX      )/8))&3;
		uRest	 =	32-uBits;
		uMask	 = (1<<uBits)-1;
		uVal	 =  uColor&uMask;
		uMask  <<=  uRest;
		uVal   <<=  uRest;

		for(iRow=0;iRow<8;iRow++)
			{
			aBit[iRow] = ~SwapByte(uMask);
			aVal[iRow] =  SwapByte(uVal );

			uMask >>= uBits;
			uVal  >>= uBits;
			}

		for(iRow=uSizeY;iRow>0;iRow-=1)
			{
			for(iCol=uSizeX;iCol>0;iCol-=8,pTemp+=uBits,pMask+=1)
				{
				uVal = *pMask;

				if(uVal==0)continue;

				pData = (LPDWORD)pTemp;

				if(uVal&0x80){*pData&=aBit[0];*pData|=aVal[0];}
				if(uVal&0x40){*pData&=aBit[1];*pData|=aVal[1];}
				if(uVal&0x20){*pData&=aBit[2];*pData|=aVal[2];}
				if(uVal&0x10){*pData&=aBit[3];*pData|=aVal[3];}
				if(uVal&0x08){*pData&=aBit[4];*pData|=aVal[4];}
				if(uVal&0x04){*pData&=aBit[5];*pData|=aVal[5];}
				if(uVal&0x02){*pData&=aBit[6];*pData|=aVal[6];}
				if(uVal&0x01){*pData&=aBit[7];*pData|=aVal[7];}
				}

			pMask += uAddM;
			pTemp += uAddT;
			}

		return TRUE;
		}


	if(uBits==32)										// 32-Bit-Bild
		{
		pData	= (LPDWORD)pPixels;
		uLast	= (0xFF00>>(uSizeX&7))&0xFF;
		uAddM	= (0-((uSizeX+7)/8))&3;
		uAddT	= (0-uSizeX)&7;
		uColor	= SwapRGB(uColor);
		bMask	= (BYTE)(uColor>>30)&1;

		if(bMask)
			{
			uColor &= 0x00FFFFFF;

			for(iRow=uSizeY;iRow>0;iRow-=1)
				{
				for(iCol=uSizeX;;iCol-=8,pData+=8,pMask+=1)
					{
					if(iCol>=8)
						{
						uVal = (BYTE) *pMask;
						uNot = (BYTE)~*pMask;
						}
					else if(iCol>0)
						{
						uVal = (BYTE) *pMask&uLast;
						uNot = (BYTE)~*pMask&uLast;
						}
					else{
						break;
						}

					if(uVal)
						{
						if(uVal&0x80)pData[0]=uColor;
						if(uVal&0x40)pData[1]=uColor;
						if(uVal&0x20)pData[2]=uColor;
						if(uVal&0x10)pData[3]=uColor;
						if(uVal&0x08)pData[4]=uColor;
						if(uVal&0x04)pData[5]=uColor;
						if(uVal&0x02)pData[6]=uColor;
						if(uVal&0x01)pData[7]=uColor;
						}

					if(uNot)
						{
						if(uNot&0x80)DIB_SET_BYTE(pData  ,3,0xFF);
						if(uNot&0x40)DIB_SET_BYTE(pData+1,3,0xFF);
						if(uNot&0x20)DIB_SET_BYTE(pData+2,3,0xFF);
						if(uNot&0x10)DIB_SET_BYTE(pData+3,3,0xFF);
						if(uNot&0x08)DIB_SET_BYTE(pData+4,3,0xFF);
						if(uNot&0x04)DIB_SET_BYTE(pData+5,3,0xFF);
						if(uNot&0x02)DIB_SET_BYTE(pData+6,3,0xFF);
						if(uNot&0x01)DIB_SET_BYTE(pData+7,3,0xFF);
						}
					}

				pMask += uAddM;
				pData -= uAddT;
				}
			}
		else{
			for(iRow=uSizeY;iRow>0;iRow-=1)
				{
				for(iCol=uSizeX;;iCol-=8,pData+=8,pMask+=1)
					{
					if(iCol>=8)
						{
						uVal = *pMask;
						}
					else if(iCol>0)
						{
						uVal = *pMask&uLast;
						}
					else{
						break;
						}

					if(uVal==0)continue;

					if(uVal&0x80)pData[0]=uColor;
					if(uVal&0x40)pData[1]=uColor;
					if(uVal&0x20)pData[2]=uColor;
					if(uVal&0x10)pData[3]=uColor;
					if(uVal&0x08)pData[4]=uColor;
					if(uVal&0x04)pData[5]=uColor;
					if(uVal&0x02)pData[6]=uColor;
					if(uVal&0x01)pData[7]=uColor;
					}

				pMask += uAddM;
				pData -= uAddT;
				}
			}

		return TRUE;
		}

	if(uBits==24)										// 24-Bit-Bild
		{
		uLast	= (0xFF00>>(uSizeX&7))&0xFF;
		uAddM	= (0-((uSizeX+7)/8))&3;
		uColor	= SwapRGB(uColor);
		bHigh	= (BYTE)(uColor>>16);
		wHigh	= (WORD)(uColor>>8);
		uAddT	= "\0\x14\x10\x0C\x0C\x8\x4"[uSizeX&7];

		for(iRow=uSizeY;iRow>0;iRow-=1)
			{
			for(iCol=uSizeX;;iCol-=8,pTemp+=8*3,pMask+=1)
				{
				if(iCol>=8)
					{
					uVal = *pMask;
					}
				else if(iCol>0)
					{
					uVal = *pMask&uLast;
					}
				else{
					break;
					}

				if(uVal==0)continue;

				if(uVal&0x80){((LPWORD)pTemp)[ 0]=(WORD)uColor;((LPBYTE)pTemp)[ 2]=(BYTE)bHigh;}
				if(uVal&0x40){((LPBYTE)pTemp)[ 3]=(BYTE)uColor;((LPWORD)pTemp)[ 2]=(WORD)wHigh;}
				if(uVal&0x20){((LPWORD)pTemp)[ 3]=(WORD)uColor;((LPBYTE)pTemp)[ 8]=(BYTE)bHigh;}
				if(uVal&0x10){((LPBYTE)pTemp)[ 9]=(BYTE)uColor;((LPWORD)pTemp)[ 5]=(WORD)wHigh;}
				if(uVal&0x08){((LPWORD)pTemp)[ 6]=(WORD)uColor;((LPBYTE)pTemp)[14]=(BYTE)bHigh;}
				if(uVal&0x04){((LPBYTE)pTemp)[15]=(BYTE)uColor;((LPWORD)pTemp)[ 8]=(WORD)wHigh;}
				if(uVal&0x02){((LPWORD)pTemp)[ 9]=(WORD)uColor;((LPBYTE)pTemp)[20]=(BYTE)bHigh;}
				if(uVal&0x01){((LPBYTE)pTemp)[21]=(BYTE)uColor;((LPWORD)pTemp)[11]=(WORD)wHigh;}
				}

			pMask += uAddM;
			pTemp -= uAddT;
			}

		return TRUE;
		}



return FALSE;
}

//*****************************************************************************
//*
//*		DibCopyImage
//*
//*****************************************************************************
//	Kopiert ein DIB in ein anders DIB.
//	pInfo		: Ist der Zeiger auf die Bildinformationen samt Farben.
//	pPixels		: Zeiger auf die Pixel-Daten.
//	uPosX/Y		: Ist die Position in pTarget wohin das DIB kopiert wird.
//	Ergibt TRUE wenn die Konvertierung erfolgreich war, bzw. FALSE bei einem Fehler.
EXTAPI BOOL WINAPI DibCopyImage(LPBITMAPINFO pInfo,LPVOID pPixels,UINT uPosX,UINT uPosY,LPBITMAPINFO pTarget)
{
HDC		hDc;


	if(!pInfo || !pPixels)									// Prfe Bilddaten
		{
		return FALSE;
		}

		hDc	= DibGetMemDC(pTarget);
	if(!hDc)return FALSE;

	SetDIBitsToDevice(hDc,uPosX,uPosY,pInfo->bmiHeader.biWidth,pInfo->bmiHeader.biHeight,0,0,0,pInfo->bmiHeader.biHeight,pPixels,pInfo,DIB_RGB_COLORS);


return TRUE;
}

//*****************************************************************************
//*
//*		DibCopyImageEx
//*
//*****************************************************************************
//	Kopiert einen Teile eines DIB's in ein anders DIB.
//	pInfo		: Ist der Zeiger auf die Bildinformationen samt Farben
//	pPixels		: Zeiger auf die Pixel-Daten.
//	uPosX/Y		: Ist die Position in pTarget wohin das DIB kopiert wird.
//	uFormX/Y	: Ist die Position in pInfo ab woher das Bild kopiert wird.
//	uSizeX/Y	: Ist die Gre vom pInfo die kopiert werden soll.
//	Ergibt TRUE wenn die Konvertierung erfolgreich war, bzw. FALSE bei einem Fehler.
EXTAPI BOOL WINAPI DibCopyImageEx(LPBITMAPINFO pInfo,LPVOID pPixels,UINT uPosX,UINT uPosY,UINT uFromX,UINT uFromY,UINT uSizeX,UINT uSizeY,LPBITMAPINFO pTarget)
{
HDC		hDc;


	if(!pInfo || !pPixels)									// Prfe Bilddaten
		{
		return FALSE;
		}

	if(uSizeX>0xFFFF || uSizeX>0xFFFF)						// Prfe die Gre
		{
		return FALSE;
		}

		hDc	= DibGetMemDC(pTarget);
	if(!hDc)return FALSE;

	if(uFromX>=U(pInfo->bmiHeader.biWidth))					// Position auerhalb der Quelle
		{
		return FALSE;
		}

	if(uFromY>=U(pInfo->bmiHeader.biHeight))
		{
		return FALSE;
		}

	if(uSizeX>U(pInfo->bmiHeader.biWidth)-uFromX)			// Passt die Gre zur Quelle
		{
		uSizeX = pInfo->bmiHeader.biWidth-uFromX;
		}

	if(uSizeY>U(pInfo->bmiHeader.biHeight)-uFromY)
		{
		uSizeX = pInfo->bmiHeader.biHeight-uFromY;
		}

	SetDIBitsToDevice(hDc,uPosX,uPosY,uSizeX,uSizeY,uFromX,pInfo->bmiHeader.biHeight-uFromY-uSizeY,0,pInfo->bmiHeader.biHeight,pPixels,pInfo,DIB_RGB_COLORS);


return TRUE;
}

//*****************************************************************************
//*
//*		GetDibOfBitmap
//*
//*****************************************************************************
//	Holt die Bilddaten aus einem Bitmap-Handle. Bitmaps sind in der
//	Regel immer mit der aktuellen Farbmaske des Bildschirms erstellt.
//	hDc			: Handle zu einem Device-Context, bei NULL wird er automatisch erstellt.
//	hBitmap		: Ist das Bitmap-Handle.
//	pPixels		: Hier wird ein Zeiger auf die Pixeldaten gespeichert.
//				  Wenn dieser Zeiger NULL ist, wird nur der Bild-Header
//				  ohne Farben und Masken geholt.
//	Ergibt einen Zeiger auf den Bild-Header, bzw. NULL bei einem Fehler.
//	Dieser Zeiger muss mit DibFreeHandle(...) freigegeben werden.
EXTAPI LPBITMAPINFO WINAPI GetDibOfBitmap(HDC hDc,HBITMAP hBitmap,LPVOID pPixels)
{
BYTE			aData[sizeof(BITMAPINFOHEADER)+256*sizeof(RGBQUAD)];
HBITMAP			hNewBmp;
LPBYTE			pOutput;
HDC				hFree;
LPBITMAPINFO	pInfo;
LPDIBINFO		pAlloc;
unsigned		uBytes;
unsigned		uRowByte;
int				iColors;
int				iLines;
int				iBits;


	if(pPixels)
		{
		DIB_SET_POINTER(pPixels,NULL);
		}

	if(!hBitmap)										// Prfe das Bitmap-Handle
		{
		SetLastError(ERROR_INVALID_PARAMETER);
		return 0;
		}

	hFree = NULL;

	DIB_CHECK_DC(hDc,hFree);

	memset(aData,0,sizeof(BITMAPINFOHEADER));

	pInfo							= (BITMAPINFO*)aData;
	pInfo->bmiHeader.biSize		  	= sizeof(BITMAPINFOHEADER);
	pInfo->bmiHeader.biPlanes	  	= 1;
	pInfo->bmiHeader.biCompression 	= BI_RGB;

	iLines = GetDIBits(hDc,hBitmap,0,0,NULL,pInfo,DIB_RGB_COLORS);

														// Prfe die Bilddaten
	if(iLines<=0 || pInfo->bmiHeader.biWidth<=0 || pInfo->bmiHeader.biHeight<=0)
		{
		SetLastError(ERROR_INVALID_DATA);
		pInfo = NULL;
		goto Exit;
		}


	iBits							= pInfo->bmiHeader.biBitCount;
	iColors							= (iBits>8)? 0:1<<iBits;
	pInfo->bmiHeader.biClrUsed		= iColors;
	pInfo->bmiHeader.biClrImportant	= iColors;
														// Gibt es Farbmasken
	if(pInfo->bmiHeader.biCompression==BI_BITFIELDS)
		{
		if(iBits>=24 || iBits<15)
				pInfo->bmiHeader.biCompression=BI_RGB;
		else	iColors = 3;
		}


	uBytes	= sizeof(BITMAPINFOHEADER);
	uBytes += sizeof(RGBQUAD)*iColors;

	if(!pPixels)										// Nur Header holen
		{
			pAlloc = DibAllocHandle(uBytes);
		if(!pAlloc)
			{
			pInfo = NULL;
			goto Exit;
			}

		memcpy(pAlloc+1,pInfo,uBytes);

		pInfo = (LPBITMAPINFO)(pAlloc+1);

		goto Exit;
		}
														// Gre der Pixeldaten
	uRowByte	= DIB_ROW_WIDTH(pInfo->bmiHeader.biWidth,iBits);
	iLines		= pInfo->bmiHeader.biHeight;

		pAlloc = DibAllocHandle(uBytes);
	if(!pAlloc)
		{
		pInfo = NULL;
		goto Exit;
		}

	memcpy(pAlloc+1,pInfo,uBytes);

	pInfo	= DIB_PTR_OFFSET(pAlloc,sizeof(DIBINFO),LPBITMAPINFO);

															// Ein neues Bitmap erstellen
		hNewBmp = CreateDIBSection(hDc,pInfo,DIB_RGB_COLORS,(LPVOID*)&pOutput,NULL,0);
	if(!hNewBmp)
		{
		SetLastError(ERROR_INVALID_DATA);
		HeapFree(pAlloc->hHeap,0,pAlloc);
		pInfo = NULL;
		goto Exit;
		}

	pAlloc->pLines	= pOutput;
	pAlloc->hBitmap	= hNewBmp;


	   iLines = GetDIBits(hDc,hBitmap,0,iLines,pOutput,pInfo,DIB_RGB_COLORS);
	if(iLines<=0)										// Fehler beim Holen der Pixeldaten
		{
		SetLastError(ERROR_INVALID_DATA);
		HeapFree(pAlloc->hHeap,0,pAlloc);
		pInfo = NULL;
		}
	else{
		DIB_SET_POINTER(pPixels,pOutput);
		}

Exit:

	if(hFree)ReleaseDC(NULL,hFree);


return pInfo;
}

//*****************************************************************************
//*
//*		GetDibOfBitmapEx
//*
//*****************************************************************************
//	Holt die Bilddaten aus einem Bitmap-Handle. Bitmaps sind in der
//	Regel immer mit der aktuellen Farbmaske des Bildschirms erstellt.
//	hDc			: Handle zu einem Device-Context, bei NULL wird er automatisch erstellt.
//	hBitmap		: Ist das Bitmap-Handle.
//	iPosX/Y		: Position im Quell-Bitmap von wo das neue Bild geholt wird.
//	iSizeX/Y	: Die Gre die das neue Bild haben soll
//	uBits		: Anzahl der Bits pro Pixel (0x1F=vom Schirm 0=32Bit,0xFFFFFFFF=wie BM)
//	pPixels		: Hier wird ein Zeiger auf die Pixeldaten gespeichert.
//				  Wenn dieser Zeiger NULL ist, wird nur der Bild-Header
//				  ohne Farben und Masken geholt.
//	Ergibt einen Zeiger auf den Bild-Header, bzw. NULL bei einem Fehler.
//	Dieser Zeiger muss mit DibFreeHandle(...) freigegeben werden.
EXTAPI LPBITMAPINFO WINAPI GetDibOfBitmapEx(HDC hDc,HBITMAP hBitmap,INT iPosX,INT iPosY,INT iSizeX,INT iSizeY,UINT uBits,LPVOID pPixels)
{
LPBITMAPINFO 	pFrom;
LPBITMAPINFO 	pInfo;
LPBYTE			pData;
HDC				hFree;


	if(pPixels)DIB_SET_POINTER(pPixels,NULL);

	if(!hBitmap)return NULL;

	hFree = NULL;
	DIB_CHECK_DC(hDc,hFree);

		pFrom = GetDibOfBitmap(hDc,hBitmap,&pData);			// Bild vom Handle holen
	if(!pFrom)
		{
		if(hFree)ReleaseDC(NULL,hFree);
		return NULL;
		}

	if(uBits==0xFFFFFFFF)									// Farben wie das Bitmap
		{
		uBits = pFrom->bmiHeader.biBitCount;
		}


		pInfo = CreateDibIndirect(hDc,iSizeX,iSizeY,uBits,pPixels);
	if(!pInfo)
		{
		if(hFree)ReleaseDC(NULL,hFree);
		DibFreeHandle(pFrom);
		return NULL;
		}
															// Kopiere das Bild aus der Quelle
	DibCopyImageEx(pFrom,pData,0,0,iPosX,iPosY,iSizeX,iSizeY,pInfo);

	if(hFree)ReleaseDC(NULL,hFree);
	DibFreeHandle(pFrom);


return pInfo;
}


//*****************************************************************************
//*
//*		GetDibOfIcon
//*
//*****************************************************************************
//	Holt die Bilddaten aus einem Icon-Handle. Icons sind in der

//	Regel immer mit der aktuellen Farbmaske des Bildschirms erstellt.
//	hDc			: Handle zu einem Device-Context, bei NULL wird er automatisch erstellt.
//	hIcon		: Ist das Icon-Handle.
//	pPixels		: Hier wird ein Zeiger auf die Pixeldaten gespeichert.
//				  Wenn dieser Zeiger NULL ist, wird nur der Bild-Header
//				  ohne Farben und Masken geholt.
//	uColor		: Ist die neue Farbe die getauscht werden soll bzw. der Farbindex.
//				  Wenn ein Bit 30 gesetzt ist wird der Alpha-Wert bei nicht
//				  getauschten Pixels auf 255 gesetzt.
//				  Wenn die Bits 24..31 auf 0x80 sind ist es ein Farbindex.
 //	Ergibt einen Zeiger auf den Bild-Header, bzw. NULL bei einem Fehler.
//	Dieser Zeiger muss mit DibFreeHandle(...) freigegeben werden.
EXTAPI LPBITMAPINFO WINAPI GetDibOfIcon(HDC hDc,HICON hIcon,LPVOID pPixels,COLORREF uColor)
{
BYTE			aTemp[sizeof(BITMAPINFO)+sizeof(RGBQUAD)*3];
ICONINFO		sInfo;
LPBITMAPINFO	pInfo;
LPBITMAPINFO	pMask;
LPBYTE			pData;
HDC				hFree;
UINT			uLine;
UINT			uSize;


	if(pPixels)DIB_SET_POINTER(pPixels,NULL);

	if(!GetIconInfo(hIcon,&sInfo))							// Icon-Infos holen
		{
		return NULL;
		}

	DIB_CHECK_DC(hDc,hFree);

		pInfo = GetDibOfBitmap(hDc,sInfo.hbmColor,pPixels);
	if(!pInfo || !pPixels)
		{
		DeleteObject(sInfo.hbmColor);
		DeleteObject(sInfo.hbmMask );
		goto Exit;
		}

	uLine	= DIB_ROW_WIDTH(pInfo->bmiHeader.biWidth,1);
	uSize   = uLine*pInfo->bmiHeader.biHeight;
	pData	= new BYTE[uSize];
	pMask	= (LPBITMAPINFO)aTemp;

	memcpy(pMask,pInfo,sizeof(BITMAPINFOHEADER));
	pMask->bmiHeader.biPlanes		= 1;
	pMask->bmiHeader.biBitCount		= 1;
	pMask->bmiHeader.biCompression 	= BI_RGB;
															// Msakenbits holen
	GetDIBits(hDc,sInfo.hbmMask,0,pMask->bmiHeader.biHeight,pData,pMask,DIB_RGB_COLORS);

															// Farbe fr Masken setzen
	DibConvertMask(pInfo,DIB_GET_POINTER(pPixels),pData,uColor);
	DeleteObject(sInfo.hbmMask);

	delete pData;

Exit:

	if(hFree)ReleaseDC(NULL,hFree);


return pInfo;
}


//*****************************************************************************
//*
//*		CreateDibOfMemory
//*
//*****************************************************************************
//	Wandelt ein DIB-Speicher-Image in ein Bitmap um
//	hDc			: Handle zu einem Device-Context, bei NULL wird er automatisch erstellt.
//	pMemory		: Zeiger auf das DIB-Speicher-Image
//	pPixels		: Zeiger auf die Pixel-Daten, bei NULL sind die Pixel-Daten
//				  hinter dem Bild-Header.
//	uFlags		: Bestimmt die Art der Erstellung und die Arts der Quelle:
//					DIB_FORCE_COLOR			= Die Ausgabe fr eine bestimmte Farbanzahl (Bit 16..21 = Farbe,0=32Bits)
//					DIB_FORCE_COLORS(b)		= Die Ausgabe fr eine bestimmte Farbanzahl mit Auswahl (3Fh/0 fr default)
//					DIB_ALPHA_BG			= Das Bitmap mit der aktuellen Hintergrundfarbe ausmalen
//					DIB_CONVERT				= Die drei Standartfarben konvertieren
//					DIB_BIT_MASK			= Am Ende des Bildes ist eine Bitmaske
//					DIB_COLOR_MASK			= Es ist eine Farbmaske angegeben (TextColor)
//					DIB_FIRST_MASK			= Der Pixel links oben ist die Farbmaske
//	Ergibt ein HBITMAP Handle oder NULL bei einem Fehler
EXTAPI HBITMAP WINAPI CreateDibOfMemory(HDC hDc,CONST LPVOID pMemory,LPVOID pPixels,DWORD uFlags)
{
DIBINFO		   *pAlloc;
BITMAPINFO	   *pInfo;
BYTE		   *pTemp;
VOID		   *pData;
UINT			uBits;
HDC				hFree;
HBITMAP			hBmp;
UINT			uNew;
UINT			uNum;
UINT			uOff;
UINT			uUse;
UINT			uMax;
int				iLen;



	pInfo = (LPBITMAPINFO)pMemory;
															// Zugriff prfen
	if(!pInfo || IsBadReadPtr(pInfo,sizeof(BITMAPINFO)))
		{
		SetLastError(ERROR_INVALID_PARAMETER);
		return FALSE;
		}


	if(pInfo->bmiHeader.biSize!=sizeof(BITMAPINFOHEADER) ||	// Prfe die Bilddaten
	  (UINT)(pInfo->bmiHeader.biWidth -1)>=0xFFFFU ||
	  (UINT)(pInfo->bmiHeader.biHeight-1)>=0xFFFFU ||
	  (UINT)(pInfo->bmiHeader.biBitCount)> 32)
		{
		SetLastError(ERROR_BAD_FORMAT);
		return NULL;
		}

	iLen	= pInfo->bmiHeader.biSizeImage;
	uBits	= pInfo->bmiHeader.biBitCount;

	if(iLen<=0)												// Gre der Pixeldaten ermitteln
		{
		if(iLen || (pInfo->bmiHeader.biCompression!=BI_RGB && pInfo->bmiHeader.biCompression!=BI_BITFIELDS))
			{
			SetLastError(ERROR_BAD_FORMAT);
			return NULL;
			}

		iLen	= DIB_ROW_WIDTH(pInfo->bmiHeader.biWidth,uBits);
		iLen   *= pInfo->bmiHeader.biHeight;
		}

	uOff  = sizeof(BITMAPINFOHEADER);
	pTemp = NULL;


	if(pPixels)												// Eigener Zeiger fr Pixeldaten
		{
		pData = (LPVOID)pPixels;
		}
	else if(uBits>0 && uBits<=8)							// Bild mit Farbtabelle
		{
		uNum = 1<<uBits;

			uMax  = pInfo->bmiHeader.biClrUsed;
		if(!uMax || uMax>uNum)uMax=uNum;

		uOff += uMax*4;
		pData = ((LPBYTE)pMemory)+uOff;
		}
	else{													// RGB Bild
		if(pInfo->bmiHeader.biCompression==BI_BITFIELDS)
				uOff = 3;
		else	uOff = 0;

		pData = pInfo->bmiColors+uOff;						// Pixeldaten nach Header
		}

	hFree	= NULL;
	uNew	= uFlags&(DIB_CONVERT|DIB_MASK_BITS|DIB_ALPHA_BG);

	DIB_CHECK_DC(hDc,hFree);								// Gerte-Context automatisch anlegen

	if(uFlags&DIB_FORCE_COLOR)
		{
		   uUse = (uFlags>>16)&DIB_COLOR_BITS;
		if(uUse==DIB_COLOR_DEF)
			{
			uUse = GetDeviceCaps(hDc,BITSPIXEL);
			}
		else if(uUse)
			{
			uUse = 32;
			}

		if(uUse!=uBits)										// Bimap mit spezieller Farbeanzahl erstellen
			{
			uFlags &= ~(DIB_COLOR_BITS<<16);
			uFlags |=  (DIB_COLOR_BITS&uUse)<<16;
			uNew	=   1;
			}
		}

	if(uNew)												// Gibt es Konvertierungen
		{
		uFlags &= ~0x80E0FFFF;
		uFlags |=  DIB_CREATE_BITMAP;
		uFlags |=  DIB_PIXEL_DATA;

		pInfo	= GetDibOfMemory(hDc,pInfo,uFlags,&pData);

		if(hFree)ReleaseDC(NULL,hFree);
		if(pTemp)delete pTemp;
		if(pInfo==NULL)return NULL;

		pAlloc	= DIB_PTR_OFFSET(pInfo,-(int)sizeof(DIBINFO),LPDIBINFO);
		hBmp	= pAlloc->hBitmap;

		HeapFree(pAlloc->hHeap,0,pAlloc);

		return hBmp;
		}

	hBmp = CreateDIBitmap(hDc,&pInfo->bmiHeader,CBM_INIT,pData,pInfo,DIB_RGB_COLORS);

	if(hFree)ReleaseDC(NULL,hFree);
	if(pTemp)delete pTemp;


return hBmp;
}

//*****************************************************************************
//*
//*		CreateDibIndirect
//*
//*****************************************************************************
//	Erzeugt ein uninitialisiertes Bitmap samt Speicher
//	hDc			: Handle zu einem Device-Context, bei NULL wird er automatisch erstellt.
//	iSizeX/Y	: Ist die Gre des Bildes
//				  hinter dem Bild-Header.
//	uBits		: Anzahl der Bits pro Pixel (0x1F=vom Schirm 0=32Bit)
//	pPixels		: Hier wird ein Zeiger auf die Pixeldaten gespeichert.
//				  Bei Null wird nichts gespeichert.
//	Ergibt einen Zeiger auf die Bildinfos oder NULL bei einem Fehler
//	Dieser Zeiger muss mit DibFreeHandle(...) freigegeben werden.
EXTAPI LPBITMAPINFO WINAPI CreateDibIndirect(HDC hDc,int iSizeX,int iSizeY,UINT uBits,LPVOID pPixels)
{
LPBYTE			pOutput;
HBITMAP			hBitmap;
LPDIBINFO		pAlloc;
LPBITMAPINFO	pInfo;
HDC				hFree;
UINT			uFill;
UINT			uByte;
UINT			uOff;
UINT			uVal;


	if(pPixels)DIB_SET_POINTER(pPixels,NULL);

	uVal	= iSizeX-1;
	uVal   |= iSizeY-1;

	if(uVal>=0x10000)										// Prfe die Gre
		{
		SetLastError(ERROR_INVALID_PARAMETER);
		return FALSE;
		}

	hFree = NULL;

	DIB_CHECK_DC(hDc,hFree);

	if(uBits&DIB_FILL_ALPHA)								// Alpha-Maske fllen
		{
		uBits &= ~DIB_FILL_ALPHA;
		uFill  = 1;
		}
	else{
		uFill  = 0;
		}

	if(uBits==0)											// Bitanzahl korrigieren
		{
		uBits = 32;
		}
	else if(uBits==DIB_COLOR_DEF || (uBits&DIB_MASK_BITS)==DIB_MASK_BITS)
		{
		uBits = GetDeviceCaps(hDc,BITSPIXEL);
		}

	uByte	= sizeof(BITMAPINFOHEADER);
	uByte  += (uBits>8)? 0:(int)(1<<uBits)*sizeof(RGBQUAD);

		pAlloc = DibAllocHandle(uByte);
	if(!pAlloc)												// Header mit Handle allokieren
		{
		if(hFree)DeleteDC(hFree);
		return NULL;
		}



	pInfo = DIB_PTR_OFFSET(pAlloc,sizeof(DIBINFO),LPBITMAPINFO);
	memset(pInfo,0,sizeof(BITMAPINFOHEADER));

	pInfo->bmiHeader.biPlanes		= 1;
	pInfo->bmiHeader.biBitCount		= uBits;
	pInfo->bmiHeader.biWidth		= iSizeX;
	pInfo->bmiHeader.biHeight		= iSizeY;
	pInfo->bmiHeader.biCompression	= BI_RGB;
	pInfo->bmiHeader.biSize			= sizeof(BITMAPINFOHEADER);

	if(uBits<=8)											// Farbpallete erstellen
		{
		uOff = 1<<uBits;

		GetSystemPaletteEntries(hDc,0,uOff,(LPPALETTEENTRY)pInfo->bmiColors);

		while(uOff>0)
			{
			uOff   -= 1;
			uVal	= DIB_GET_DWORD(pInfo->bmiColors,uOff);
			uVal	= SwapRGB(uVal)&0x00FFFFFF;
			DIB_SET_DWORD(pInfo->bmiColors,uOff,uVal);
			}

		if(uBits>=4)
			{
			memcpy(pInfo->bmiColors,aDibColors,sizeof(RGBQUAD)*16);
			}
		else{
			DIB_SET_DWORD(pInfo->bmiColors,(1<<uBits)-1,0x00FFFFFF);
			}
		}

															// Ein neues Bitmap erstellen
		hBitmap = CreateDIBSection(hDc,pInfo,DIB_RGB_COLORS,(LPVOID*)&pOutput,NULL,0);
	if(!hBitmap)
		{
		SetLastError(ERROR_INVALID_DATA);
		HeapFree(pAlloc->hHeap,0,pAlloc);
		pInfo = 0;
		goto Exit;
		}

	pAlloc->hBitmap	= hBitmap;
	pAlloc->pLines	= pOutput;
	if(pPixels)DIB_SET_POINTER(pPixels,pOutput);

	if(uFill && uBits==32)									// Alpha-Maske fllen
		{
		uOff = iSizeX*iSizeY*4+3;

		while(uOff>4)
			{
			uOff         -= 4;
			pOutput[uOff] = 0xFF;
			}
		}

Exit:

	if(hFree)DeleteDC(hFree);


return pInfo;
}

//*****************************************************************************
//*
//*		GetDibOfPng
//*
//*****************************************************************************
//	Ld ein PNG-Bild aus eine Speicherbereich fr ein PNG-Bild.
//	Achtung, diese Funktion wird erst ab Windows-Vista untersttzt.
//	hDc			: Handle zu einem Device-Context, bei NULL wird
//				  er automatisch erstellt.
//	pMemory		: Ist der Zeiger auf die Daten des PNG-Bildes
//	uSize		: Ist die Gre des PNG-Bildes in Byte
//	uFlags		: Bestimmt die Art der Erstellung und die Arts der Quelle:
//					DIB_FORCE_COLOR			= Die Ausgabe fr eine bestimmte Farbanzahl (Bit 16..21 = Farbe,0=32Bits)
//					DIB_FORCE_COLORS(b)		= Die Ausgabe fr eine bestimmte Farbanzahl mit Auswahl (1Fh fr default)
//					DIB_CREATE_BITMAP		= Ein Bitmap erzeugen fr den Speicher
//					DIB_CONVERT				= Die drei Standartfarben konvertieren
//					DIB_ALPHA_BG			= Das Bitmap mit der aktuellen Hintergrundfarbe ausmalen
//					DIB_BIT_MASK			= Am Ende des Bildes ist eine Bitmaske
//					DIB_COLOR_MASK			= Es ist eine Farbmaske angegeben (TextColor)
//					DIB_FIRST_MASK			= Der Pixel links oben ist die Farbmaske
//	pPixels		: Hier wird ein Zeiger auf die Pixeldaten gespeichert.
//				  Wenn dieser Zeiger NULL ist, wird nur der Bild-Header
//				  ohne Farben und Masken geholt.
//	Ergibt einen Zeiger auf den Bild-Header, bzw. NULL bei einem Fehler.
//	Dieser Zeiger muss mit DibFreeHandle(...) freigegeben werden.
EXTAPI LPBITMAPINFO WINAPI GetDibOfPng(HDC hDc,LPVOID pMemory,UINT uSize,DWORD uFlags,LPVOID pPixels)
{
LPDWORD			pData=(LPDWORD)pMemory;
BITMAPINFO		sInfoData;
LPBITMAPINFO	pInfoNew;
LPBITMAPINFO	pInfoBmp;
LPBITMAPINFO	pInfoBit;
LPBYTE			pMemBmp;
LPBYTE			pMemBit;
LPDIBINFO		pAlloc;
ICONINFO		sIcon;
HICON			hIcon;
UINT			uPicX;
UINT			uPicY;
UINT			uMask;


														// Header prfen
	if(uSize<16 || pData[0]!=0x474E5089 || pData[1]!=0x0A1A0A0D || pData[2]!=0x0D000000 || pData[3]!=0x52444849)
		{
		SetLastError(ERROR_BAD_FORMAT);
		return NULL;
		}

	uPicX = SwapByte(pData[4]);
	uPicY = SwapByte(pData[5]);


	if(!pPixels)										// Nur Gre und Farbanzahl
		{
			pAlloc = DibAllocHandle(sizeof(BITMAPINFOHEADER));
		if(!pAlloc)return NULL;

		pInfoNew = DIB_PTR_OFFSET(pAlloc,sizeof(DIBINFO),LPBITMAPINFO);
		memset(pInfoNew,0,sizeof(BITMAPINFOHEADER));

		pInfoNew->bmiHeader.biPlanes		= 1;
		pInfoNew->bmiHeader.biBitCount		= 32;
		pInfoNew->bmiHeader.biWidth			= uPicX;
		pInfoNew->bmiHeader.biHeight		= uPicY;
		pInfoNew->bmiHeader.biCompression	= BI_PNG;
		pInfoNew->bmiHeader.biSizeImage		= uSize;
		pInfoNew->bmiHeader.biSize			= sizeof(BITMAPINFOHEADER);

		return pInfoNew;
		}

		hIcon = CreateIconFromResourceEx((LPBYTE)pMemory,uSize,TRUE,0x00030000,uPicX,uPicY,0);
	if(!hIcon)
		{
		SetLastError(ERROR_INVALID_DATA);
		return NULL;
		}

	if(!GetIconInfo(hIcon,&sIcon))						// Icon aus Resource laden
		{
		DeleteObject(hIcon);
		SetLastError(ERROR_INVALID_DATA);
		return NULL;
		}

	DeleteObject(sIcon.hbmMask);

														// Daten vom Icon-Bimap holen
		pInfoBmp = GetDibOfBitmap(NULL,sIcon.hbmColor,&pMemBmp);
	if(!pInfoBmp)
		{
		DeleteObject(sIcon.hbmColor);
		DeleteObject(hIcon);
		SetLastError(ERROR_INVALID_DATA);
		return NULL;
		}


	if((uFlags&DIB_MASK_BITS)==DIB_BIT_MASK)			// Pixeldaten werden via Pointer bergeben
		{
		uFlags &= ~DIB_MASK_BITS;
		uMask	=  1;
		}
	else{
		uMask	=  0;
		}

	uFlags &= ~0x80E0FFFF;
	uFlags |=  DIB_PIXEL_DATA;
	DIB_SET_POINTER(pPixels,pMemBmp);


	memset(&sInfoData,0,sizeof(BITMAPINFOHEADER));

	sInfoData.bmiHeader.biPlanes		= 1;
	sInfoData.bmiHeader.biBitCount		= 32;
	sInfoData.bmiHeader.biWidth			= uPicX;
	sInfoData.bmiHeader.biHeight		= uPicY;
	sInfoData.bmiHeader.biCompression	= BI_RGB;
	sInfoData.bmiHeader.biSize			= sizeof(BITMAPINFOHEADER);

	pInfoNew = GetDibOfMemory(hDc,&sInfoData,uFlags,pPixels);

	if(uMask)											// Auch die Maske setzen
		{
		   pInfoBit = GetDibOfBitmap(NULL,sIcon.hbmMask,&pMemBit);
		if(pInfoBit)
			{
			DibConvertMask(pInfoNew,DIB_GET_POINTER(pPixels),pMemBit,GetBkColor(hDc));
			DibFreeHandle(pInfoBit);
			}
		}


	DibFreeHandle(pInfoBmp);
	DeleteObject(hIcon);


return pInfoNew;
}

//*****************************************************************************
//*
//*		GetDibOfResource
//*
//*****************************************************************************
//	Holt die Bilddaten aus einer Recource.
//	hDc			: Handle zu einem Device-Context, bei NULL wird
//				  er automatisch erstellt.
//	hModule		: Ist das Instanz-Handle einer DLL oder EXE-Datei.
//				  Bei NULL wird der aktuelle Prozess benutzt.
//	pName		: Ist der Name der Resource, oder eine Resource-ID (kleiner 0x10000)
//	pType		: Ist der Typ der Resource, oder eine Type-ID
//					RT_BITMAP	= Bitmap
//					RT_ICON		= Einzelnes Icon
//	uFlags		: Bestimmt die Art der Erstellung und die Arts der Quelle:
//					DIB_LOAD_SPECIAL		= Den bestimmten Eintrag laden (BYTE[0]=X BYTE[1]=Y BYTE[2]=Bit,3F0000h fr max,FFFFh=grtes)
//					DIB_SET_SPECIAL(x,y,b)	= Den bestimmten Eintrag laden samt Auswahl
//					DIB_FORCE_COLOR			= Die Ausgabe fr eine bestimmte Farbanzahl (Bit 16..21 = Farbe,0=32Bits)
//					DIB_FORCE_COLORS(b)		= Die Ausgabe fr eine bestimmte Farbanzahl mit Auswahl (3Fh/0 fr default)
//					DIB_CREATE_BITMAP		= Ein Bitmap erzeugen fr den Speicher
//					DIB_CONVERT				= Die drei Standartfarben konvertieren
//					DIB_ALPHA_BG			= Das Bitmap mit der aktuellen Hintergrundfarbe ausmalen
//					DIB_BIT_MASK			= Am Ende des Bildes ist eine Bitmaske
//					DIB_COLOR_MASK			= Es ist eine Farbmaske angegeben (TextColor)
//					DIB_FIRST_MASK			= Der Pixel links oben ist die Farbmaske
//					DIB_PIXEL_DATA			= Die Pixeldaten werden ber den Pointer bergeben
//	pPixels		: Hier wird ein Zeiger auf die Pixeldaten gespeichert.
//				  Wenn dieser Zeiger NULL ist, wird nur der Bild-Header
//				  ohne Farben und Masken geholt.
//	Ergibt einen Zeiger auf den Bild-Header, bzw. NULL bei einem Fehler.
//	Dieser Zeiger muss mit DibFreeHandle(...) freigegeben werden.
EXTAPI LPBITMAPINFO WINAPI GetDibOfResourceA(HDC hDc,HMODULE hModule,LPCSTR pName,LPCSTR pType,DWORD uFlags,LPVOID pPixels)
{
HRSRC			hResource;
LPBYTE			pMemory;


		hResource = FindResourceA(hModule,pName,pType);	// Existiert die Resource
	if(!hResource)
		{
		DIB_SET_POINTER(pPixels,NULL);
		return NULL;
		}
														// Resource laden
		pMemory = (LPBYTE)LoadResource(hModule,hResource);
	if(!pMemory)
		{
		DIB_SET_POINTER(pPixels,NULL);
		return NULL;
		}


	DeleteObject(pMemory);								// Der Zeiger auf die Resource ist immer vorhanden

	if((DWORD_PTR)pType<0x10)							// Resource Type setzen
		{
		if(!pPixels)pPixels = &hModule;
		DIB_SET_POINTER(pPixels,hModule);

		uFlags &= ~DIB_RESOURCE;
		uFlags |=  DIB_RES_TO_VAL(pType);
		}


	if(((LPDWORD)pMemory)[0]==0x474E5089)				// Ist es ein PNG-Bild
		{
		return GetDibOfPng(hDc,pMemory,SizeofResource(hModule,hResource),uFlags,pPixels);
		}


return GetDibOfMemory(hDc,pMemory,uFlags,pPixels);
}

EXTAPI LPBITMAPINFO WINAPI GetDibOfResourceW(HDC hDc,HMODULE hModule,LPCWSTR pName,LPCWSTR pType,DWORD uFlags,LPVOID pPixels)
{
HRSRC			hResource;
LPBYTE			pMemory;



		hResource = FindResourceW(hModule,pName,pType);	// Existiert die Resource
	if(!hResource)
		{
		DIB_SET_POINTER(pPixels,NULL);
		return NULL;
		}
														// Resource laden
		pMemory = (LPBYTE)LoadResource(hModule,hResource);
	if(!pMemory)
		{
		DIB_SET_POINTER(pPixels,NULL);
		return NULL;
		}

	DeleteObject(pMemory);								// Der Zeiger auf die Resource ist immer vorhanden

	if((DWORD_PTR)pType<0x10)							// Resource Type setzen
		{
		if(!pPixels)pPixels = &hModule;
		DIB_SET_POINTER(pPixels,hModule);

		uFlags &= ~DIB_RESOURCE;
		uFlags |=  DIB_RES_TO_VAL(pType);
		}

	if(((LPDWORD)pMemory)[0]==0x474E5089)				// Ist es ein PNG-Bild
		{
		return GetDibOfPng(hDc,pMemory,SizeofResource(hModule,hResource),uFlags,pPixels);
		}


return GetDibOfMemory(hDc,pMemory,uFlags,pPixels);
}

//*****************************************************************************
//*
//*		GetDibOfMemory
//*
//*****************************************************************************
//	Holt die Bilddaten aus einem Speicherbereich.
//	hDc			: Handle zu einem Device-Context, bei NULL wird
//				  er automatisch erstellt.
//	pMemory		: Ist der Zeiger auf die BITMAPINFO Daten. Am Ende sind die
//				  Pixeldaten angehngt wenn DIB_PIXEL_DATA nicht gesetzt ist.
//	uFlags		: Bestimmt die Art der Erstellung und die Arts der Quelle:
//					DIB_RESOURCE			= Bits fr den Resourcen-Typ (Bit 21..23=Typ)
//					DIB_TYPE_ICON       	= Der Speicher ist eine Cursor-Resource
//					DIB_TYPE_CURSOR       	= Der Speicher ist eine Cursor-Resource
//					DIB_TYPE_GROUP 			= Der Speicher ist eine Cursor/Icon-Gruppen-Resource
//					DIB_LOAD_SPECIAL		= Den bestimmten Eintrag laden (BYTE[0]=X BYTE[1]=Y BYTE[2]=Bit,3F0000h fr max,FFFFh=grtes)
//					DIB_SET_SPECIAL(x,y,b)	= Den bestimmten Eintrag laden samt Auswahl
//					DIB_FORCE_COLOR			= Die Ausgabe fr eine bestimmte Farbanzahl (Bit 16..21 = Farbe,0=32Bits)
//					DIB_FORCE_COLORS(b)		= Die Ausgabe fr eine bestimmte Farbanzahl mit Auswahl (3Fh/0 fr default)
//					DIB_CREATE_BITMAP		= Ein Bitmap erzeugen fr den Speicher
//					DIB_ALPHA_BG			= Das Bitmap mit der aktuellen Hintergrundfarbe ausmalen
//					DIB_CONVERT				= Die drei Standartfarben konvertieren
//					DIB_BIT_MASK			= Am Ende des Bildes ist eine Bitmaske
//					DIB_COLOR_MASK			= Es ist eine Farbmaske angegeben (TextColor)
//					DIB_FIRST_MASK			= Der Pixel links oben ist die Farbmaske
//					DIB_PIXEL_DATA			= Die Pixeldaten werden ber den Pointer bergeben
//	pPixels		: Hier wird ein Zeiger auf die Pixeldaten gespeichert.
//				  Wenn dieser Zeiger NULL ist, wird nur der Bild-Header
//				  ohne Farben und Masken geholt. Mit dem Flags DIB_PIXEL_DATA
//				  wird hier der Pointer zu den Pixeldaten bergeben.
//	Ergibt einen Zeiger auf den Bild-Header, bzw. NULL bei einem Fehler.
//	Dieser Zeiger muss mit DibFreeHandle(...) freigegeben werden.
EXTAPI LPBITMAPINFO WINAPI GetDibOfMemory(HDC hDc,LPVOID pMemory,DWORD uFlags,LPVOID pPixels)
{
HDC				hMem;
HDC				hFree;
LPBITMAPINFO	pOrig;
LPBITMAPINFO	pInfo;
LPBYTE			pMask;
LPBYTE			pBase;
LPBYTE			pLines;
LPDIBINFO		pAlloc;
LPGICONDIITEM	pEntry;
LPGCURSORITEM	pCursor;
LPGITEMDIR		pFolder;
LPBYTE			pOutput;
HMODULE			hModule;
HBITMAP			hBitmap;
UINT			uColor;
UINT			uBytes;
UINT			uSizeX;
UINT			uSizeY;
UINT			uSize;
UINT			uMaxS;
UINT			uMaxB;
UINT			uMaxI;
UINT			uUseB;
UINT			uUseS;
UINT			uBits;
UINT			uHalf;
UINT			uMask;
UINT			uRow;
UINT			uNum;
UINT			uBmp;
UINT			uVal;
UINT			uOff;


	pInfo = (LPBITMAPINFO)pMemory;

	if(!pInfo || IsBadReadPtr(pInfo,sizeof(BITMAPINFO)))	// Zugriff prfen
		{
		SetLastError(ERROR_INVALID_PARAMETER);
		DIB_SET_POINTER(pPixels,NULL);
		return FALSE;
		}

ReTry:

	if(pInfo->bmiHeader.biSize>=sizeof(BITMAPINFOHEADER) &&	// Ist ein Bild-Header vorhanden
	   pInfo->bmiHeader.biSize<=sizeof(BITMAPV5HEADER  ) &&
	  (UINT)(pInfo->bmiHeader.biWidth -1)<0xFFFFU &&
	  (UINT)(pInfo->bmiHeader.biHeight-1)<0xFFFFU &&
	  (UINT)(pInfo->bmiHeader.biBitCount)<=32)
		{
		uBits	= pInfo->bmiHeader.biBitCount;
		uBytes	= pInfo->bmiHeader.biSize;

		if(uBits==0)
			{
			uBits	= 32;
			uColor	= 0;
			}
		else if(uBits<=8)
			{
			uNum = 1<<uBits;

				uOff= pInfo->bmiHeader.biClrUsed;
			if(!uOff || uOff>uNum)uOff=uNum;

			uColor 	= sizeof(RGBQUAD)*uOff;
			}
		else if(pInfo->bmiHeader.biCompression==BI_BITFIELDS)
			{
			uColor  = sizeof(RGBQUAD)*3;
			}
		else{
			uColor 	= 0;
			}

		pLines	= DIB_PTR_OFFSET(pInfo,uBytes+uColor,LPBYTE);
		pOrig	= pInfo;
		pAlloc	= NULL;
		pMask	= NULL;
		hFree	= NULL;
		uHalf	= 0;
		uBmp    = 0;

		if((uFlags&0x8060FFFF)==DIB_PIXEL_DATA)				// Pixeldaten aus Pointer
			{
			pLines = DIB_GET_POINTER(pPixels);
			}

		pBase	= pLines;

		if(uFlags&DIB_RESOURCE)								// Ist die Bildhhe bei Icoons/verdoppelt
		if(pInfo->bmiHeader.biCompression==BI_RGB)
		if(pInfo->bmiHeader.biHeight%2==0)
			{
			uSize	= DIB_ROW_WIDTH(pInfo->bmiHeader.biWidth,uBits);
			uMask	= DIB_ROW_WIDTH(pInfo->bmiHeader.biWidth,1);
			uSize  *= pInfo->bmiHeader.biHeight;
			uMask  *= pInfo->bmiHeader.biHeight;

			if(uSize+uMask==pInfo->bmiHeader.biSizeImage*2)
				{
				uSize /= 2;
				uHalf  = 1;
				}

			pMask	= pLines+uSize;
			}


		if(pPixels)											// Auch Pixeldaten holen
			{
			uBmp = uFlags&(DIB_CREATE_BITMAP|DIB_MASK_BITS|DIB_CONVERT|DIB_ALPHA_BG);

			if(uFlags&DIB_FORCE_COLOR)						// Wird eine bestimmte Farbanzahl gewnscht
				{
				   uBits = (uFlags>>16)&DIB_COLOR_BITS;
				if(uBits==DIB_COLOR_DEF)
					{
					DIB_CHECK_DC(hDc,hFree);
					uBits = GetDeviceCaps(hDc,BITSPIXEL);
					}
				else if(uBits==0)
					{
					uBits = 32;
					}

				if(uBits!=pInfo->bmiHeader.biBitCount)
					{
					uColor	= (uBits>8)? 0:(int)(1<<uBits)*sizeof(RGBQUAD);
					uFlags |= DIB_CREATE_BITMAP;
					uBmp	= 1;
					}
				}
			else if(uBmp)									// Farbanzahl vom Bildschirm benutzen
				{
				DIB_CHECK_DC(hDc,hFree);
				uBits	= GetDeviceCaps(hDc,BITSPIXEL);
				uColor	= (uBits>8)? 0:(int)(1<<uBits)*sizeof(RGBQUAD);
				}
			}

		if(uHalf || uBmp)									// Einen extra Speicher allokieren
			{
				pAlloc = DibAllocHandle(sizeof(BITMAPINFOHEADER)+uColor);
			if(!pAlloc){pInfo=NULL;goto Exit;}

			pInfo = DIB_PTR_OFFSET(pAlloc,sizeof(DIBINFO),LPBITMAPINFO);
			memcpy(pInfo,pOrig       ,sizeof(BITMAPINFOHEADER));
			pInfo->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);

			if(uColor)										// Farben kopieren
				{
				memcpy(	DIB_PTR_OFFSET(pInfo,sizeof(BITMAPINFOHEADER),LPVOID),
						DIB_PTR_OFFSET(pOrig,uBytes                  ,LPVOID),
						uColor);
				}

			if(uHalf)pInfo->bmiHeader.biHeight /= 2;
			}

		if(uBmp==0)											// Keine Bitmap erstellen
			{
			if(pPixels==NULL)goto Exit;
			if(pAlloc)pAlloc->pLines=pLines;
			DIB_SET_POINTER(pPixels,pLines);
			goto Exit;
			}

		DIB_CHECK_DC(hDc,hFree);

		pInfo->bmiHeader.biBitCount		= uBits;
		pInfo->bmiHeader.biCompression	= BI_RGB;


		uVal = pOrig->bmiHeader.biBitCount;
		if(uBits<=8 && (uBits>uVal || uVal>8))				// Hat Original keine Farben aber das neue Bild
			{
			uOff = 1<<uBits;

			GetSystemPaletteEntries(hDc,0,uOff,(LPPALETTEENTRY)pInfo->bmiColors);

			while(uOff>0)
				{
				uOff   -= 1;
				uVal	= DIB_GET_DWORD(pInfo->bmiColors,uOff);
				uVal	= SwapRGB(uVal)&0x00FFFFFF;
				DIB_SET_DWORD(pInfo->bmiColors,uOff,uVal);
				}

			if(uBits>=4)
				{
				memcpy(pInfo->bmiColors,aDibColors,sizeof(RGBQUAD)*16);
				}
			else{
				DIB_SET_DWORD(pInfo->bmiColors,(1<<uBits)-1,0x00FFFFFF);
				}
			}

															// Ein neuese Bitmap erstellen
			hBitmap = CreateDIBSection(hDc,pInfo,DIB_RGB_COLORS,(LPVOID*)&pOutput,NULL,0);
		if(!hBitmap)
			{
			SetLastError(ERROR_INVALID_DATA);
			HeapFree(pAlloc->hHeap,0,pAlloc);
			pInfo = 0;
			goto Exit;
			}


		uRow = DIB_ROW_WIDTH(pInfo->bmiHeader.biWidth,uBits);
		uVal = pOrig->bmiHeader.biBitCount;

		if(pLines)											// Pixeldaten direkt kopieren
			{
			if(uBits==uVal && (pOrig->bmiHeader.biCompression==BI_RGB || pOrig->bmiHeader.biCompression==BI_BITFIELDS))
				{
				uSize = uRow*pInfo->bmiHeader.biHeight;
				memcpy(pOutput,pLines,uSize);
				}
			else{											// Pixeldaten via DC bertragen
					hMem = CreateCompatibleDC(hDc);
				if(!hMem)
					{
					HeapFree(pAlloc->hHeap,0,pAlloc);
					DeleteObject(hBitmap);
					pInfo = 0;
					goto Exit;
					}

				SelectObject(hMem,hBitmap);
				SetDIBitsToDevice(hMem,0,0,pInfo->bmiHeader.biWidth,pInfo->bmiHeader.biHeight,0,0,0,pInfo->bmiHeader.biHeight,pLines,pOrig,DIB_RGB_COLORS);
				DeleteDC(hMem);
				}
			}

		pAlloc->hBitmap = hBitmap;
		pAlloc->pLines	= pOutput;
		pLines			= pOutput;

		if(uFlags&DIB_CONVERT)								// Standartfarben ndern
			{
			DibConvertDefault(pInfo,pLines);
			}

		switch(uFlags&DIB_MASK_BITS)
			{
		case DIB_FIRST_MASK:								// Der Pixel links oben ist die Farbmaske

			uOff = uRow*(pInfo->bmiHeader.biHeight-1);

			if(uBits<=8)
				{
				uVal  = pLines[uOff];
				uVal>>=	8-uBits;
				uVal |= 0x80000000;
				DibConvertColor(pInfo,pLines,uVal,GetBkColor(hDc));
				}
			else{
				uVal  = *(LPDWORD)(pLines+uOff);
				uVal &= 0x00FFFFFF;
				if(uBits==32 && pOrig->bmiHeader.biBitCount<=8)uVal|=0x40000000;
				DibConvertColor(pInfo,pLines,uVal,GetBkColor(hDc));
				}

			break;

		case DIB_COLOR_MASK:								// Es ist eine Farbmaske angegeben (TextColor)

			uVal  = GetTextColor(hDc);
			if(uBits==32 && pOrig->bmiHeader.biBitCount<=8)uVal|=0x40000000;
			DibConvertColor(pInfo,pLines,uVal,GetBkColor(hDc));
			break;

		case DIB_BIT_MASK:									// Am Ende des Bildes ist eine Bitmaske

			if(!pMask)
				{
				uVal	= pOrig->bmiHeader.biBitCount;
				uRow	= DIB_ROW_WIDTH (pOrig->bmiHeader.biWidth,uVal);
				pMask	= DIB_PTR_OFFSET(pBase,uRow*pOrig->bmiHeader.biHeight,LPBYTE);
				}

			uVal = GetBkColor(hDc);
			if(uBits==32 && pOrig->bmiHeader.biBitCount<=8)uVal|=0x40000000;
			DibConvertMask(pInfo,pLines,pMask,uVal);
			break;
			}

		if((uFlags&DIB_ALPHA_BG) && uBits==32)				// Mit Hintergrundfarbe ausmahlen
			{
			DibConvertAlpha(pInfo,pLines,GetBkColor(hDc));
			}

		DIB_SET_POINTER(pPixels,pLines);

	Exit:

		if(hFree)ReleaseDC(NULL,hFree);

		return pInfo;
		}


//******************** Cursor-Resource ****************************************


	if((uFlags&DIB_RESOURCE)==DIB_TYPE_CURSOR)				// Ist es ein Cursor
		{
		pInfo	= (LPBITMAPINFO)((LPBYTE)pMemory+sizeof(DWORD));
		uFlags	= NULL;
		goto ReTry;
		}


//******************** Gruppen-Resource ***************************************


	if((uFlags&DIB_RESOURCE)==DIB_TYPE_GROUP)				// Ist es eine Cursor/Icon-Gruppe
		{
		pFolder	= (LPGITEMDIR)pMemory;
		pCursor	= pFolder->aCursors;
		pEntry	= pFolder->aEntries;

		if(pFolder->wReserved!=0 || pFolder->wType<1 || pFolder->wType>2 || pFolder->wCount>32)
			{
			if(pPixels)*(LPVOID*)pPixels = NULL;
			SetLastError(ERROR_BAD_FORMAT);
			return NULL;
			}

		if(uFlags&DIB_LOAD_SPECIAL)							// Ein Spezielles Unterbild laden
			{
			uUseB	= (uFlags>>16)&DIB_COLOR_BITS;
			uMaxI	= 0xFFFFFFFF;

			if(uUseB>=DIB_COLOR_MAX)						// Hchste Farbanzahl suchen
				{
				if(uUseB==DIB_COLOR_MAX )uFlags&=~(DIB_COLOR_BITS<<16);
				if(uUseB==DIB_COLOR_SAME)uFlags&=~(DIB_FORCE_COLOR);
				uUseB = 0x0000;
				uMaxB = 0x0000;
				}
			else{
				if(!uUseB)uUseB=32;
				uMaxB = uUseB;
				}

			if((WORD)uFlags==0xFFFF)						// Grtes Bild laden
				{
				uUseS = 0xFFFFFFFF;
				uMaxS = 0x00000000;
				}
			else{											// Passentes Bild laden
				uUseS = (WORD)uFlags;
				}

															// Durchsuche Subbilder
			for(uOff=0;uOff<pFolder->wCount;uOff++,pCursor++,pEntry++)
				{
					uBits=pCursor->wBitCount;
				if(!uBits)uBits=1;

				if(uUseB && uUseB!=uBits)					// Bitanzahl prfen
					{
					continue;
					}

				if(pFolder->wType==2)						// Cursor
					{
					uSizeX	= pCursor->wWidth;
					uSizeY	= pCursor->wHeight;
					}
				else{										// Icon
					uSizeX	= pEntry->bWidth;
					uSizeY	= pEntry->bHeight;
					}

				if(!uSizeX)uSizeX=256;
				if(!uSizeY)uSizeY=256;

				if(uUseS!=0xFFFFFFFF)						// Passentes Bild suchen
					{
					uVal	=  (BYTE)uSizeX;
					uVal   |= ((BYTE)uSizeY)<<8;

					if(uUseS!=uVal)continue;
					if(uMaxB>uBits)continue;

					uMaxI = pCursor->nID;
					uMaxB = uBits;
					continue;
					}

				uSize = uSizeX*uSizeY;
															// Greres Bild gefunden
				if(uSize>uMaxS || (uSize==uMaxS && uBits>uMaxB))
					{
					uMaxI = pCursor->nID;
					uMaxS = uSize;
					uMaxB = uBits;
					}
				}
			}
		else{												// Via Index laden
			   uOff	= (WORD)uFlags;
			if(uOff<pFolder->wCount)
					uMaxI = pCursor[uOff].nID;
			else	uMaxI = 0xFFFFFFFF;
			}

		if(uMaxI>0xFFFF)									// Kein Bild gefunden
			{
			if(pPixels)*(LPVOID*)pPixels = NULL;
			SetLastError(ERROR_OBJECT_NOT_FOUND);
			return NULL;
			}
															// Modul aus Pointerspeicher
		hModule	= (pPixels)? (HMODULE)*(LPVOID*)pPixels:NULL;

		return GetDibOfResource(hDc,hModule,MAKEINTRESOURCE(uMaxI),(pFolder->wType==2)? RT_CURSOR:RT_ICON,uFlags,pPixels);
		}


	SetLastError(ERROR_BAD_FORMAT);


return NULL;
}

//*****************************************************************************
//*
//*		DibConvertLowerLeft
//*
//*****************************************************************************
//	Tauscht die Farbe des linken unteren Pixels gegen eine Farbe aus.
//	Der Punkt darber wird ebenfalls getauscht wenn er gleich ist.
//	pInfo		: Ist der Zeiger auf die Bildinformationen samt Farben
//	pPixels		: Zeiger auf die Pixel-Daten.
//	uColor		: Ist die neue Farbe die getauscht werden soll bzw. der Farbindex
//				  wenn die Bits 24..31 auf 0x80 sind ist es ein Farbindex
//				  Bei Toolbars sollte die Farbe COLOR_3DFACE benutzt werden.
//	uPosX/Y		: Ist die Position des des linken unteren Pixels.
//	Ergibt TRUE wenn die Konvertierung erfolgreich war, bzw. FALSE bei einem Fehler.
EXTAPI BOOL WINAPI DibConvertLowerLeft(LPBITMAPINFO pInfo,LPVOID pPixels,COLORREF uColor,UINT uPosX,UINT uPosY)
{
LPCOLORREF	pCol;
LPBYTE		pTemp;
UINT		uLast;
UINT		uMove;
UINT		uMask;
UINT		uBits;
UINT		uRow;
UINT		uVal;
UINT		uMax;



	if(!pInfo || !pPixels)								// Prfe die Bilddaten
		{
		return FALSE;
		}

	uBits	= pInfo->bmiHeader.biBitCount;
	uRow	= DIB_ROW_WIDTH(pInfo->bmiHeader.biWidth,uBits);
	pTemp	= (LPBYTE)pPixels;
	pTemp  += uRow*(pInfo->bmiHeader.biHeight-uPosY-1);

	if(uBits==32)										// 32-Bit-Bild
		{
		pTemp  += uPosX*4;
		uLast	= *(LPDWORD)(pTemp);
		*(LPDWORD)(pTemp) = uColor;

		if(*(LPDWORD)(pTemp+uRow)==uLast)
			{
			*(LPDWORD)(pTemp+uRow)	= uColor;
			}

		return TRUE;
		}

	if(uBits==24)										// 24-Bit-Bild
		{
		pTemp			   += uPosX*3;
		uColor			   &= 0x00FFFFFF;
		uLast				= *(LPDWORD)(pTemp);
		uLast			   &= 0xFF000000;
		*(LPDWORD)(pTemp)  &= 0xFF000000;
		*(LPDWORD)(pTemp)  |= uColor;

		if((*(LPDWORD)(pTemp+uRow)&0x00FFFFFF)==uLast)
			{
			*(LPDWORD)(pTemp+uRow)  &= 0xFF000000;
			*(LPDWORD)(pTemp+uRow)  |= uColor;
			}

		return TRUE;
		}

	if(uBits<=8 && uBits>0)								// Bild mit Farbpallette
		{
		uVal = 1<<pInfo->bmiHeader.biBitCount;

			uMax  = pInfo->bmiHeader.biClrUsed;
		if(!uMax || uMax>uVal)uMax=uVal;

		if(uColor>>24!=0x80)							// Suche RGB-Farbe
			{
			pCol = (COLORREF*)pInfo->bmiColors;
			uVal = SwapRGB(uColor);

			for(uColor=0;pCol[uColor]!=uVal;uColor++)
				{
				if(uColor>=uMax)
					{
					return FALSE;
					}
				}
			}

		pTemp   += (uPosX*8)/uBits;
		uMove	 = ~uPosX&((8/uBits)-1);
		uMove   *=  uBits;
		uMask	 = (1<<uBits)-1;
		uColor	&=  uMask;
		uColor <<=  uMove;
		uMask  <<=  uMove;

		uVal	 =  pTemp[0];							// Linken unteren Pixel ndern
		uLast	 =  uVal&uMask;
		uVal	&= ~uMask;
		uVal	|=  uColor;
		pTemp[0] = (BYTE)uVal;

		uVal	 =  pTemp[uRow];

		if((uVal&uMask)==uLast)
			{
			uVal &= ~uMask;
			uVal |=  uColor;
			pTemp[uRow] = (BYTE)uVal;
			}

		return TRUE;
		}


return FALSE;
}



//*****************************************************************************
//*
//*		DibConvertSmoth
//*
//*****************************************************************************
//	Macht einen Weichzeichner ber einen rechteckigen Bildteil.
//	pInfo		: Ist der Zeiger auf die Bildinformationen samt Farben
//	pPixels		: Zeiger auf die Pixel-Daten.
//	uPosX/Y		: Startposition des Rechtecks
//	uBoxX/Y		: Gre des Rechtecks
//	Ergibt TRUE wenn die Konvertierung erfolgreich war, bzw. FALSE bei einem Fehler.
EXTAPI BOOL WINAPI DibConvertSmoth(LPBITMAPINFO pInfo,LPVOID pPixels,UINT uPosX,UINT uPosY,UINT uBoxX,UINT uBoxY)
{
LPDWORD			pTemp;
LPDWORD			pBase;
LPDWORD			pData;
DIBCOLOR		aCol[9];
unsigned		uAlpha;
unsigned		uGreen;
unsigned		uBlue;
unsigned		uRed;
unsigned		uAdd;
unsigned		uMaxX;
unsigned		uMaxY;
int		 		iLine;

														// Prfe die Bilddaten
	if(!pInfo || !pPixels || pInfo->bmiHeader.biBitCount!=32)
		{
		return FALSE;
		}

	uMaxX	= pInfo->bmiHeader.biWidth;
	uMaxY	= pInfo->bmiHeader.biHeight;

	if(uPosX>=uMaxX || uPosY>=uMaxY)					// Prfe die Position
		{
		return FALSE;
		}

	if(uPosX+uBoxX>uMaxX)uBoxX = uMaxX-uPosX;
	if(uPosY+uBoxY>uMaxY)uBoxY = uMaxY-uPosY;

		pTemp = new DWORD[(uBoxX+2)*(uBoxY+2)];
	if(!pTemp)											// Speicher allokieren
		{
		return FALSE;
		}

	pData	= (LPDWORD)pPixels;
	pData  += uPosX;
	pData  += uMaxX*(uMaxY-uBoxY-uPosY);
	iLine	= uBoxX+2;
	pBase	= pTemp+iLine+1;
	uAdd	= uMaxX-uBoxX;



	#define r(i)	(aCol[i].ucRed  )
	#define b(i)	(aCol[i].ucBlue )
	#define g(i)	(aCol[i].ucGreen)
	#define a(i)	(aCol[i].ucAlpha)



	for(uPosY=0;uPosY<uBoxY;uPosY++)					// Temporres Bild erzeugen
		{
		memcpy(pBase+uPosY*iLine,pData+uPosY*uMaxX,uBoxX*4);

		pBase[uPosY*iLine    -1] = pBase[uPosY*iLine        ];
		pBase[uPosY*iLine+uBoxX] = pBase[uPosY*iLine+uBoxX-1];
		}

	memcpy(pBase-iLine      -1,pBase                -1,iLine*4);
	memcpy(pBase+iLine*uBoxY-1,pBase+(uBoxY-1)*iLine-1,iLine*4);



	for(uPosY=uBoxY;uPosY;uPosY--,pBase+=2,pData+=uAdd)
	for(uPosX=uBoxX;uPosX;uPosX--,pBase+=1,pData+=1)
		{
		aCol[0].uRgb = pBase[ 0      ];
		aCol[1].uRgb = pBase[-1-iLine];
		aCol[2].uRgb = pBase[  -iLine];
		aCol[3].uRgb = pBase[ 1-iLine];
		aCol[5].uRgb = pBase[-1+iLine];
		aCol[6].uRgb = pBase[   iLine];
		aCol[7].uRgb = pBase[ 1+iLine];
		aCol[8].uRgb = pBase[-1      ];
		aCol[4].uRgb = pBase[ 1      ];

		uRed     = r(0)*52+r(1)+r(3)+r(5)+r(7)+r(2)*2+r(4)*2+r(6)*2+r(8)*2;
		uBlue    = b(0)*52+b(1)+b(3)+b(5)+b(7)+b(2)*2+b(4)*2+b(6)*2+b(8)*2;
		uGreen   = g(0)*52+g(1)+g(3)+g(5)+g(7)+g(2)*2+g(4)*2+g(6)*2+g(8)*2;
		uAlpha   = a(0)*52+a(1)+a(3)+a(5)+a(7)+a(2)*2+a(4)*2+a(6)*2+a(8)*2;

		uRed   >>= 6;
		uBlue  >>= 6;
		uGreen >>= 6;
		uAlpha >>= 6;

		*pData = uBlue|(uGreen<<8)|(uRed<<16)|(uAlpha<<24);
		}


	delete	pTemp;

	#undef	r
	#undef	g
	#undef	b
	#undef	a


return TRUE;
}


//*****************************************************************************
//*
//*		DibSaveImage
//*
//*****************************************************************************
//	Speichert ein DIB-Bild in einer Datei
//	pInfo		: Zeiger auf den DIB-Header
//	pPixels		: Zeiger auf die Pixeldaten, bei 0 sind sie am Ende
//	pFilename	: Ist der Dateiname
//	bOverWrite	: Existierente Dateien berschreiben
//	Ergibt TRUE wenn erfolgreich
EXTAPI BOOL WINAPI DibSaveImageA(LPBITMAPINFO pInfo,LPVOID pPixels,LPCSTR pFilename,BOOL bOverWrite)
{
LPDIBINFO		pAlloc;
HANDLE			hHandle;
BMPHEADER		sHeader;
DWORD			uColors;
DWORD			uBytes;
DWORD			uSize;
DWORD			uRow;
DWORD			uNum;



															// Prfe die Bilddaten
	if(!pInfo || pInfo->bmiHeader.biWidth==0 || pInfo->bmiHeader.biHeight==0)
		{
		return FALSE;
		}

	if(pInfo->bmiHeader.biWidth>0xFFFF || pInfo->bmiHeader.biHeight>0xFFFF)
		{
		return FALSE;
		}


															// RGB-Bild
	if(pInfo->bmiHeader.biCompression==BI_BITFIELDS || pInfo->bmiHeader.biCompression==BI_RGB)
		{
		uRow	= DIB_ROW_WIDTH(pInfo->bmiHeader.biWidth,pInfo->bmiHeader.biBitCount);
		uSize	= uRow*pInfo->bmiHeader.biHeight;
		}
	else{
		uSize	= pInfo->bmiHeader.biSize;
		}

	if(!uSize)
		{
		return FALSE;
		}

	if(pInfo->bmiHeader.biBitCount<=8)						// Mit Pallete
		{
		uNum = 1<<pInfo->bmiHeader.biBitCount;

			uColors	= pInfo->bmiHeader.biClrUsed;
		if(!uColors || uColors>uNum)uColors=uNum;
		}
	else if(pInfo->bmiHeader.biCompression==BI_BITFIELDS)	// RGB-Bild
		{
		uColors = 3;
		}
	else{
		uColors = 0;
		}

	uBytes	= sizeof(BITMAPINFOHEADER)+sizeof(RGBQUAD)*uColors;

	if(!pPixels)
		{
		pAlloc	= DIB_PTR_OFFSET(pInfo,-(int)sizeof(DIBINFO),LPDIBINFO);
															// Ist das Handle in Ordnung
		if(IsBadWritePtr(pAlloc,sizeof(DIBINFO)) || pAlloc->uTag!=DIB_TAG_BITMAP)
			{
			pPixels = DIB_PTR_OFFSET(pInfo,uBytes,LPVOID);
			}
		else{
			pPixels = pAlloc->pLines;
			}
		}

															// Datei speichern
	   hHandle	= CreateFileA(pFilename,GENERIC_WRITE,0,NULL,(bOverWrite)? CREATE_ALWAYS:CREATE_NEW,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,NULL);
	if(hHandle==INVALID_HANDLE_VALUE)return FALSE;

    sHeader.wTag		= 0x4D42;
    sHeader.uSize		= sizeof(sHeader)+uBytes+uSize;
    sHeader.wReserved1	= 0x0000;
    sHeader.wReserved2	= 0x0000;
    sHeader.uOffset		= sizeof(sHeader)+uBytes;

	WriteFile(hHandle,&sHeader,sizeof(sHeader),&uNum,NULL);
	WriteFile(hHandle,pInfo   ,uBytes         ,&uNum,NULL);
	WriteFile(hHandle,pPixels ,uSize          ,&uNum,NULL);

	CloseHandle(hHandle);


return TRUE;
}

EXTAPI BOOL WINAPI DibSaveImageW(LPBITMAPINFO pInfo,LPVOID pPixels,LPCWSTR pFilename,BOOL bOverWrite)
{
LPDIBINFO		pAlloc;
HANDLE			hHandle;
BMPHEADER		sHeader;
DWORD			uColors;
DWORD			uBytes;
DWORD			uSize;
DWORD			uRow;
DWORD			uNum;



															// Prfe die Bilddaten
	if(!pInfo || pInfo->bmiHeader.biWidth==0 || pInfo->bmiHeader.biHeight==0)
		{
		return FALSE;
		}

	if(pInfo->bmiHeader.biWidth>0xFFFF || pInfo->bmiHeader.biHeight>0xFFFF)
		{
		return FALSE;
		}


															// RGB-Bild
	if(pInfo->bmiHeader.biCompression==BI_BITFIELDS || pInfo->bmiHeader.biCompression==BI_RGB)
		{
		uRow	= DIB_ROW_WIDTH(pInfo->bmiHeader.biWidth,pInfo->bmiHeader.biBitCount);
		uSize	= uRow*pInfo->bmiHeader.biHeight;
		}
	else{
		uSize	= pInfo->bmiHeader.biSize;
		}

	if(!uSize)
		{
		return FALSE;
		}

	if(pInfo->bmiHeader.biBitCount<=8)						// Mit Pallete
		{
		uNum = 1<<pInfo->bmiHeader.biBitCount;

			uColors	= pInfo->bmiHeader.biClrUsed;
		if(!uColors || uColors>uNum)uColors=uNum;
		}
	else if(pInfo->bmiHeader.biCompression==BI_BITFIELDS)	// RGB-Bild
		{
		uColors = 3;
		}
	else{
		uColors = 0;
		}

	uBytes	= sizeof(BITMAPINFOHEADER)+sizeof(RGBQUAD)*uColors;

	if(!pPixels)
		{
		pAlloc	= DIB_PTR_OFFSET(pInfo,-(int)sizeof(DIBINFO),LPDIBINFO);
															// Ist das Handle in Ordnung
		if(IsBadWritePtr(pAlloc,sizeof(DIBINFO)) || pAlloc->uTag!=DIB_TAG_BITMAP)
			{
			pPixels = DIB_PTR_OFFSET(pInfo,uBytes,LPVOID);
			}
		else{
			pPixels = pAlloc->pLines;
			}
		}

															// Datei speichern
	   hHandle	= CreateFileW(pFilename,GENERIC_WRITE,0,NULL,(bOverWrite)? CREATE_ALWAYS:CREATE_NEW,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,NULL);
	if(hHandle==INVALID_HANDLE_VALUE)return FALSE;

    sHeader.wTag		= 0x4D42;
    sHeader.uSize		= sizeof(sHeader)+uBytes+uSize;
    sHeader.wReserved1	= 0x0000;
    sHeader.wReserved2	= 0x0000;
    sHeader.uOffset		= sizeof(sHeader)+uBytes;

	WriteFile(hHandle,&sHeader,sizeof(sHeader),&uNum,NULL);
	WriteFile(hHandle,pInfo   ,uBytes         ,&uNum,NULL);
	WriteFile(hHandle,pPixels ,uSize          ,&uNum,NULL);

	CloseHandle(hHandle);


return TRUE;
}

//*****************************************************************************
//*
//*		DibSaveImageEx
//*
//*****************************************************************************
//	Speichert ein DIB-Bild in einer Datei
//	hBitmap		: Handle auf das Bitmap
//	pFilename	: Ist der Dateiname
//	bOverWrite	: Existierente Dateien berschreiben
//	Ergibt TRUE wenn erfolgreich
EXTAPI BOOL WINAPI DibSaveImageExA(HBITMAP hBitmap,LPCSTR pFilename,BOOL bOverWrite)
{
LPVOID			pPixels;
LPBITMAPINFO	pInfo;
BOOL			bRet;

		pInfo = GetDibOfBitmap(NULL,hBitmap,&pPixels);
	if(!pInfo)return FALSE;

	bRet = DibSaveImageA(pInfo,pPixels,pFilename,bOverWrite);

	DibFreeHandle(pInfo);


return bRet;
}

EXTAPI BOOL WINAPI DibSaveImageExW(HBITMAP hBitmap,LPCWSTR pFilename,BOOL bOverWrite)
{
LPVOID			pPixels;
LPBITMAPINFO	pInfo;
BOOL			bRet;

		pInfo = GetDibOfBitmap(NULL,hBitmap,&pPixels);
	if(!pInfo)return FALSE;

	bRet = DibSaveImageW(pInfo,pPixels,pFilename,bOverWrite);

	DibFreeHandle(pInfo);


return bRet;
}

//*****************************************************************************
//*
//*		DibConvertUpperLeft
//*
//*****************************************************************************
//	Holt die Farbe des linken oberen Pixels.
//	pInfo		: Ist der Zeiger auf die Bildinformationen samt Farben
//	pPixels		: Zeiger auf die Pixel-Daten.
//	Ergibt die Farbe oder 0x80000000 bei einem Fehler.
EXTAPI COLORREF WINAPI DibGetUpperLeft(LPBITMAPINFO pInfo,LPVOID pPixels)
{
LPBYTE		pTemp;
UINT		uData;
UINT		uBits;
UINT		uRow;



	if(!pInfo || !pPixels)								// Prfe die Bilddaten
		{
		return FALSE;
		}

	uBits	= pInfo->bmiHeader.biBitCount;
	uRow	= DIB_ROW_WIDTH(pInfo->bmiHeader.biWidth,uBits);
	pTemp	= (LPBYTE)pPixels;
	pTemp  += uRow*(pInfo->bmiHeader.biHeight-1);

	if(uBits==32)										// 32-Bit-Bild
		{
		uData	= *(LPDWORD)(pTemp);
		return SwapRGB(uData);
		}

	if(uBits==24)										// 24-Bit-Bild
		{
		uData	= *(LPDWORD)(pTemp)&0x00FFFFFF;
		return SwapRGB(uData);
		}

	if(uBits<=8 && uBits>0)								// Bild mit Farbpallette
		{
		uData   = *pTemp>>(8-uBits);
		uData	=  DIB_GET_DWORD(pInfo->bmiColors,uData);
		return SwapRGB(uData);
		}


return 0x80000000;
}

//*****************************************************************************
//*
//*		GetDrawSize
//*
//*****************************************************************************
EXTAPI BOOL	WINAPI GetDrawSize(INT iMode,LPSIZE pSize)
{

	if(!bUxThemeDone)LoadUxThemeDll();

	switch(iMode)
		{
	case 0:	*pSize = sCheckSize;	return TRUE;
	case 1: *pSize = sRadioSize;	return TRUE;
		}

return FALSE;
}

//*****************************************************************************
//*
//*		CalcTextSize
//*
//*****************************************************************************
//	Berechnet die Abmessungen eines Textes entsprechend dem aktuellen Font.
//	hDc			: Gertekontext fr die Berechnug, bei NULL wird er automatisch
//				  angelegt, und pData als Font interpretiert.
//	pText		: Zeiger auf den Text
//	iCount		: Ist die Lnge des Textes, bei -1 wird sie mit strlen(...) berechnet.
//	uFlags		: Diverse Flags fr die Berechnung:
//					DT_SINGLELINE	0x00000020	Der Text ist einzeilig
//					DT_NOPREFIX		0x00000800	'&' Zeichen sind keine Prfixe
//					DT_EXPANDTABS	0x00000040	Tabulatoren bercksichtigen
//					DT_TABSTOP		0x00000080	Tabulatorbreite in den Bits 8..15 angeben
//					DT_RETURNY		0x80000000	Y-Gre in High-Wort zurckgeben
//					DT_RETURNSIZE	0x40000000	SIZE-Objekt in pData fllen
//					DT_RETURNRECT	0x20000000	RECT-Objekt in pData neu ausrichten
//	pData		: Hier wird das Ergebnis gespeichert, falls der Zeiger nicht
//				  NULL ist.	Je nach DT_RETURN?? in den Flags ndert sich der Typ:
//					DT_RETURNSIZE	-->		LPSIZE  Typ fr Abmessungen
//					DT_RETURNRECT	-->		LPRECT  Typ mit Zielrechteckt
//					<keine Angabe>	-->		LPDWORD	Typ fr Y-Gre
//	Ergibt die Breite des Textes in Pixel, bzw. die Hhe des Textes wenn
//	das Flag DT_RETURNY gesetzt ist.
EXTAPI DWORD WINAPI CalcTextSizeA(HDC hDc,LPCSTR pText,INT iCount,UINT uFlags,LPVOID pData)
{
LPDWORD	pValue;
LPRECT	pRect;
LPSIZE	pSize;
RECT	sRect;
HDC		hFree;
INT		iDiff;


	if(!hDc)												// Standart DC anlegen
		{
		hFree	= GetDC(NULL);
		hDc		= hFree;

		if(pData)
			{
			SelectObject(hDc,pData);
			pData = NULL;
			}
		}
	else{
		hFree	= NULL;
		}


	sRect.top	= 0;
	sRect.left	= 0;
	sRect.right	= 0;
	sRect.bottom= 0;										// Textabmessungen berechnen

	DrawTextA(hDc,pText,iCount,&sRect,(uFlags&(DT_SINGLELINE|DT_NOPREFIX|DT_EXPANDTABS|DT_EXTERNALLEADING|DT_TABSTOP|0xFF00))|DT_CALCRECT);

	if(hFree)ReleaseDC(NULL,hFree);


	if(pData)												// Rckgabe via Pointer
		{
		if(uFlags&DT_RETURNSIZE)
			{
			pSize		= (LPSIZE)pData;
			pSize->cx	= sRect.right;
			pSize->cy	= sRect.bottom;
			}
		else if(uFlags&DT_RETURNRECT)						// In Rechteck mit Ausrichtung
			{
			pRect		= (LPRECT)pData;
			iDiff		= pRect->right-pRect->left;
			iDiff	   -= sRect .right;

			if(uFlags&DT_CENTER)
				{
				if(iDiff>0)
					{
					pRect->left  += (iDiff  )/2;
					pRect->right -= (iDiff+1)/2;
					}
				}
			else if(uFlags&DT_RIGHT)
				{
				if(iDiff>0)
					{
					pRect->left  += iDiff;
					}
				}
			else{
				if(iDiff>0)
					{
					pRect->right -= iDiff;
					}
				}

			iDiff		= pRect->bottom-pRect->top;
			iDiff	   -= sRect .bottom;

			if(uFlags&DT_VCENTER)
				{
				if(iDiff>0)
					{
					pRect->top    += (iDiff  )/2;
					pRect->bottom -= (iDiff+1)/2;
					}
				}
			else if(uFlags&DT_BOTTOM)
				{
				if(iDiff>0)
					{
					pRect->top    += iDiff;
					}
				}
			else{
				if(iDiff>0)
					{
					pRect->bottom -= iDiff;
					}
				}
			}
		else{												// Nur Y-Wert
			pValue		= (LPDWORD)pData;
			pValue[0]	= sRect.bottom;
			}
		}

	if(uFlags&DT_RETURNY)									// Hhe in HIGH-Wort
		{
		sRect.right |= sRect.bottom<<16;
		}



return sRect.right;
}

EXTAPI DWORD WINAPI CalcTextSizeW(HDC hDc,LPCWSTR pText,INT iCount,UINT uFlags,LPVOID pData)
{
LPDWORD	pValue;
LPRECT	pRect;
LPSIZE	pSize;
RECT	sRect;
HDC		hFree;
INT		iDiff;


	if(!hDc)												// Standart DC anlegen
		{
		hFree	= GetDC(NULL);
		hDc		= hFree;

		if(pData)
			{
			SelectObject(hDc,pData);
			pData = NULL;
			}
		}
	else{
		hFree	= NULL;
		}


	sRect.top	= 0;
	sRect.left	= 0;
	sRect.right	= 0;
	sRect.bottom= 0;										// Textabmessungen berechnen

	DrawTextW(hDc,pText,iCount,&sRect,(uFlags&(DT_SINGLELINE|DT_NOPREFIX|DT_EXPANDTABS|DT_EXTERNALLEADING|DT_TABSTOP|0xFF00))|DT_CALCRECT);

	if(hFree)ReleaseDC(NULL,hFree);


	if(pData)												// Rckgabe via Pointer
		{
		if(uFlags&DT_RETURNSIZE)
			{
			pSize		= (LPSIZE)pData;
			pSize->cx	= sRect.right;
			pSize->cy	= sRect.bottom;
			}
		else if(uFlags&DT_RETURNRECT)						// In Rechteck mit Ausrichtung
			{
			pRect		= (LPRECT)pData;
			iDiff		= pRect->right-pRect->left;
			iDiff	   -= sRect .right;

			if(uFlags&DT_CENTER)
				{
				if(iDiff>0)
					{
					pRect->left  += (iDiff  )/2;
					pRect->right -= (iDiff+1)/2;
					}
				}
			else if(uFlags&DT_RIGHT)
				{
				if(iDiff>0)
					{
					pRect->left  += iDiff;
					}
				}
			else{
				if(iDiff>0)
					{
					pRect->right -= iDiff;
					}
				}

			iDiff		= pRect->bottom-pRect->top;
			iDiff	   -= sRect .bottom;

			if(uFlags&DT_VCENTER)
				{
				if(iDiff>0)
					{
					pRect->top    += (iDiff  )/2;
					pRect->bottom -= (iDiff+1)/2;
					}
				}
			else if(uFlags&DT_BOTTOM)
				{
				if(iDiff>0)
					{
					pRect->top    += iDiff;
					}
				}
			else{
				if(iDiff>0)
					{
					pRect->bottom -= iDiff;
					}
				}
			}
		else{												// Nur Y-Wert
			pValue		= (LPDWORD)pData;
			pValue[0]	= sRect.bottom;
			}
		}

	if(uFlags&DT_RETURNY)									// Hhe in HIGH-Wort
		{
		sRect.right |= sRect.bottom<<16;
		}



return sRect.right;
}


//*****************************************************************************
//*
//*		ClearFontCache
//*
//*****************************************************************************
//	Lcht den Font-Cache am Programmende
static void __cdecl ClearFontCache(void)
{
HFONT	hFont;


	while(iFontCacheCnt>0)
		{
		iFontCacheCnt--;
		hFont = pFontCache[iFontCacheCnt].hFont;
		pFontCache[iFontCacheCnt].hFont = NULL;
		DeleteObject(hFont);
		}

	iFontCacheMax = 0;
	delete pFontCache;
	pFontCache = NULL;

}


//*****************************************************************************
//*
//*		GetCachedFont
//*
//*****************************************************************************
//	Erzeugt einen Font aus LOGFONT Daten, und legt ihn im Cache ab.
//	Dieser Font darf nicht freigegeben werden.
//	pLog		: Zeiger auf die LOGFONT Daten
//	Ergibt das Font-Handle oder NULL bei einem Fehler.
EXTAPI HFONT WINAPI GetCachedFontA(LPLOGFONTA pLog)
{
FontCache  *pCache;
HFONT		hFont;
int			iPos;
int			iMax;


	pCache = pFontCache;

	for(iPos=0;iPos<iFontCacheCnt;iPos++,pCache++)			// Ist der Font bereits im Chache
		{
		if(strcmp(pLog->lfFaceName,pCache->cName         ))continue;
		if(pLog->lfHeight        !=pCache->wHeight        )continue;
		if(pLog->lfWidth         !=pCache->wWidth         )continue;
		if(pLog->lfWeight        !=pCache->wWeight        )continue;
		if(pLog->lfItalic        !=pCache->bItalic        )continue;
		if(pLog->lfUnderline     !=pCache->bUnderline     )continue;
		if(pLog->lfCharSet       !=pCache->bCharSet       )continue;
		if(pLog->lfPitchAndFamily!=pCache->bPitchAndFamily)continue;

		return pCache->hFont;
		}

		hFont = CreateFontIndirectA(pLog);					// Neuen Font erstellen
	if(!hFont)return NULL;

	if(iPos>=iFontCacheMax)									// Muss der Cache vergert werden
		{
		if(!pFontCache)atexit(ClearFontCache);

		iMax	= iFontCacheMax+iFontCacheMax/2+8;
		pCache	= new FontCache[iMax];

		memcpy(pCache,pFontCache,iPos*sizeof(FontCache));
		memset(pCache+iPos,0,(iMax-iPos)*sizeof(FontCache));

		delete pFontCache;
		pFontCache		= pCache;
		pCache		   += iPos;
		iFontCacheMax	= iMax;
		}


	pCache->hFont		   = hFont;
	pCache->wHeight        = (WORD)pLog->lfHeight;
	pCache->wWidth         = (WORD)pLog->lfWidth;
	pCache->wWeight        = (WORD)pLog->lfWeight;
	pCache->bItalic        = pLog->lfItalic;
	pCache->bUnderline     = pLog->lfUnderline;
	pCache->bCharSet       = pLog->lfCharSet;
	pCache->bPitchAndFamily= pLog->lfPitchAndFamily;

	strncpy(pCache->cName,pLog->lfFaceName,sizeof(pCache->cName)-1);

	iFontCacheCnt++;



return hFont;
}

EXTAPI HFONT WINAPI GetCachedFontW(LPLOGFONTW pLog)
{
WCHAR		cName[LF_FACESIZE];
LOGFONTA   *pLogFont;
HFONT		hFont;
int			iPos;


	wcsncpy(cName,pLog->lfFaceName,LF_FACESIZE);

	pLogFont = (LPLOGFONTA)pLog;

	for(iPos=1;iPos<LF_FACESIZE;iPos++)
		{
			pLogFont->lfFaceName[iPos] = pLogFont->lfFaceName[iPos*2];
		if(!pLogFont->lfFaceName[iPos])break;
		}

	hFont = GetCachedFontA(pLogFont);

	wcsncpy(pLog->lfFaceName,cName,LF_FACESIZE);


return	hFont;
}

//*****************************************************************************
//*
//*		GetBoldFont
//*
//*****************************************************************************
//	Holt den zu einem Font einen fetten Font.
//	Dieser Font darf nicht gelscht werden.
//	hFont		: Handle vom normalen Font.
//	Ergibt das Font-Handle oder NULL bei einem Fehler.
EXTAPI HFONT WINAPI GetBoldFont(HFONT hFont)
{
TEXTMETRICA	sMetrics;
LOGFONTA	sLog;
HDC			hDc;


	if(!hFont)return 0;

	hDc = GetDC(NULL);
	SelectObject(hDc,hFont);
	GetTextMetricsA(hDc,&sMetrics);
	GetTextFaceA(hDc,LF_FACESIZE,sLog.lfFaceName);
	ReleaseDC(NULL,hDc);


	sLog.lfHeight			=-sMetrics.tmHeight;
	sLog.lfWidth 			= sMetrics.tmAveCharWidth;
	sLog.lfEscapement 		= GM_COMPATIBLE;
	sLog.lfOrientation 		= 0;
	sLog.lfItalic 			= sMetrics.tmItalic;
	sLog.lfUnderline 		= sMetrics.tmUnderlined;
	sLog.lfStrikeOut 		= sMetrics.tmStruckOut;
	sLog.lfCharSet 			= sMetrics.tmCharSet;
	sLog.lfOutPrecision 	= OUT_DEVICE_PRECIS;
	sLog.lfClipPrecision 	= CLIP_DEFAULT_PRECIS;
	sLog.lfQuality 			= DEFAULT_QUALITY;
	sLog.lfPitchAndFamily 	= sMetrics.tmPitchAndFamily;
	sLog.lfWeight			= FW_BOLD;

	hFont = GetCachedFontA(&sLog);


return hFont;
}

//*****************************************************************************
//*
//*		GetFixedFont
//*
//*****************************************************************************
//	Holt den zu einem Font einen Font mit fixer Breite.
//	Dieser Font darf nicht gelscht werden.
//	hFont		: Handle vom normalen Font.
//	Ergibt das Font-Handle oder NULL bei einem Fehler.
EXTAPI HFONT WINAPI GetFixedFont(HFONT hFont)
{
TEXTMETRICA	sMetrics;
HFONT		hTemp;
BOOL		bFlag;
LOGFONTA	sLog;
HDC			hDc;


	if(!hFont)return 0;

	hTemp = (HFONT)GetStockObject(ANSI_FIXED_FONT);
	hDc   = GetDC(NULL);
	SelectObject(hDc,hFont);
	GetTextMetricsA(hDc,&sMetrics);
	SelectObject(hDc,hTemp);
	GetTextFaceA(hDc,LF_FACESIZE,sLog.lfFaceName);
	ReleaseDC(NULL,hDc);

														// Schriftnamen austauschen
	if(sLog.lfFaceName[0]=='C' && !strcmp(sLog.lfFaceName,"Courier"))
		{
		strcpy(sLog.lfFaceName,"Courier New");
		bFlag = TRUE;
		}
	else{
		bFlag = FALSE;
		}

	sLog.lfHeight			=-sMetrics.tmHeight;
	sLog.lfWidth 			= 0;
	sLog.lfEscapement 		= 0;
	sLog.lfOrientation 		= 0;
	sLog.lfItalic 			= 0;
	sLog.lfUnderline 		= 0;
	sLog.lfStrikeOut 		= 0;
	sLog.lfCharSet 			= sMetrics.tmCharSet;
	sLog.lfOutPrecision 	= OUT_DEFAULT_PRECIS;
	sLog.lfClipPrecision 	= CLIP_DEFAULT_PRECIS;
	sLog.lfQuality 			= DEFAULT_QUALITY;
	sLog.lfPitchAndFamily 	= DEFAULT_PITCH;
	sLog.lfWeight			= FW_NORMAL;

	hFont = GetCachedFontA(&sLog);
	
	if(!hFont && bFlag)									// Zweiter Versuch
		{
		strcpy(sLog.lfFaceName,"Courier New");
		hFont = GetCachedFontA(&sLog);
		}


return hFont;
}

//*****************************************************************************
//*
//*		GetDefaultFont
//*
//*****************************************************************************
//	Holt den aktuellen Font
//	uFont	: Whlt den Font aus
//				Bit0 = Fr fette Schrift
//				Bit1 = Fr fixe  Schrift
//	Ergibt das Font-Handle oder NULL bei einem Fehler.
EXTAPI	HFONT WINAPI GetDefaultFont(UINT uFont)
{
TEXTMETRIC	sData;
LOGFONTA	sFont;
HFONT	   *pFont;
HFONT		hTemp;
HFONT		hNext;
BOOL		bFlag;
HDC			hDc;


														// Font ID prfen	
	if(uFont>=sizeof(aFontsDefault)/sizeof(aFontsDefault[0]))
		{
		return NULL;
		}

	pFont = aFontsDefault+uFont;


	if(!pFont[0])										// Existiert der Font noch nicht
		{
		hTemp = NULL;
		hDc   = GetDC(NULL);

		if(GetWindowsVersion()>=0x00060000)				// Ist es kein XP
			{
			SystemParametersInfoA(SPI_GETICONTITLELOGFONT,sizeof(sFont),&sFont,0);
			sFont.lfWeight	= (uFont&1)? FW_BOLD:FW_NORMAL;
			bFlag			= FALSE;

			if(uFont&2)									// Fixke Schrift
				{
				if(!iDefaultiHeight)
					{
					GetDefaultFont(0);
					}

				sFont.lfHeight = (iDefaultiHeight)? -iDefaultiHeight:-15;

				SelectObject(hDc,GetStockObject(ANSI_FIXED_FONT));
				GetTextFaceA(hDc,LF_FACESIZE,sFont.lfFaceName);

				if(sFont.lfFaceName[0]=='C' && !strcmp(sFont.lfFaceName,"Courier"))
					{
					bFlag = TRUE;
					}
				}

			hTemp = GetCachedFontA(&sFont);

			if(bFlag)									// Ist es eine "Courier" Schrift
				{
				SelectObject(hDc,hTemp);
				GetTextMetrics(hDc,&sData);

				if(sData.tmHeight!=aFontsDefSizeY[0])
					{
					strcpy(sFont.lfFaceName,"Courier New");
					hNext = GetCachedFontA(&sFont);

					if(hNext)							
						{								// Statt "Courier" wird "Courier New" benutzt
						DeleteObject(hTemp);
						hTemp = hNext;
						}
					}
				}
			}


		if(!hTemp)										// Ist es XP
			{
			hTemp = (HFONT)GetStockObject((uFont&2)? ANSI_FIXED_FONT:ANSI_VAR_FONT);

			if(uFont&1)									// Ist es eine fette Schrift
				{
				hTemp = GetBoldFont(hTemp);
				}
			
			if(!GetObject(hTemp,sizeof(sFont),&sFont))
				{
				sFont.lfWidth  = 10;
				sFont.lfHeight = 13;
				}
			}


		SelectObject(hDc,hTemp);
		GetTextMetrics(hDc,&sData);

		aFontsDefSizeX[uFont] = (BYTE)sData.tmAveCharWidth;
		aFontsDefSizeY[uFont] = (BYTE)sData.tmHeight;


		if(uFont==0)									// Schriftabmessungen fr LOGFONT berechnen
			{
			iDefaultiWidth	= sFont.lfWidth;
			iDefaultiHeight	= sFont.lfHeight;

			if(iDefaultiWidth  <0)iDefaultiWidth =-iDefaultiWidth;
			if(iDefaultiHeight <0)iDefaultiHeight=-iDefaultiHeight;
			if(iDefaultiWidth ==0)iDefaultiWidth =(iDefaultiHeight*2)/3;
			if(iDefaultiWidth ==0)iDefaultiWidth = 7;
			if(iDefaultiHeight==0)iDefaultiWidth =(iDefaultiWidth*3)/2;
			}
		

		ReleaseDC(NULL,hDc);

		*pFont = hTemp;
		}


return *pFont;
}

//*****************************************************************************
//*
//*		GetDefaultSize
//*
//*****************************************************************************
//	Holt den die Gre vom aktuellen Font
//	pWidth		: Hier wird die Breite gespeichert
//	pHeight		: Hier wird die Hhe gespeichert
//	uFont		: Ist die Nummer des Fonts
//					Bit0 = Fr fette Schrift
//					Bit1 = Fr fixe  Schrift
//	Ergibt die Bereite des Fonts.
EXTAPI UINT WINAPI GetDefaultSize(int *pWidth,int *pHeight,UINT uFont)
{


	if(uFont>=sizeof(aFontsDefault)/sizeof(aFontsDefault[0]))
		{
		if(pWidth )*pWidth =0;
		if(pHeight)*pHeight=0;
		return 0;
		}


	if(!aFontsDefault[uFont])							// Existiert der Font noch nicht	
		{
		GetDefaultFont(uFont);
		}
	

	if(pWidth )*pWidth =aFontsDefSizeX[uFont];
	if(pHeight)*pHeight=aFontsDefSizeY[uFont];


return aFontsDefSizeY[uFont];
}

//*****************************************************************************
//*
//*		GetFontHeight
//*
//*****************************************************************************
//	Holt die Hhe eines Fonts.
//	hWnd		: Handle vom Fenster, bei NULL wird der Desktop benutzt.
//	hFont		: Ist das Font-Handle
//	Ergibt die Hhe des Fonts in Pixel.
EXTAPI INT WINAPI GetFontHeight(HWND hWnd,HFONT hFont)
{
TEXTMETRIC		sData;
BOOL			bRet;
HDC				hDc;


	hDc		= GetWindowDC(hWnd);
	bRet	= GetTextMetrics(hDc,&sData);
	ReleaseDC(hWnd,hDc);

	if(bRet)return sData.tmHeight;


return 0;
}

//*****************************************************************************
//*
//*		GetThemeColorEx
//*
//*****************************************************************************
//	Holt eine Farbe zu einem bestimmten Thema. Wenn das kein Thema aktiviert
//	ist wird die Standart-System-Farbe verwentet
//	uMode		: Ist die Nummer der Farbe
//					 COLOR_SCROLLBAR         		0
//					 COLOR_BACKGROUND        		1
//					 COLOR_ACTIVECAPTION     		2
//					 COLOR_INACTIVECAPTION   		3
//					 COLOR_MENU              		4
//					 COLOR_WINDOW            		5
//					 COLOR_WINDOWFRAME       		6
//					 COLOR_MENUTEXT          		7
//					 COLOR_WINDOWTEXT        		8
//					 COLOR_CAPTIONTEXT       		9
//					 COLOR_ACTIVEBORDER      		10
//					 COLOR_INACTIVEBORDER    		11
//					 COLOR_APPWORKSPACE      		12
//					 COLOR_HIGHLIGHT         		13
//					 COLOR_HIGHLIGHTTEXT     		14
//					 COLOR_BTNFACE           		15
//					 COLOR_BTNSHADOW         		16
//					 COLOR_GRAYTEXT          		17
//					 COLOR_BTNTEXT           		18
//					 COLOR_INACTIVECAPTIONTEXT		19
//					 COLOR_BTNHIGHLIGHT      		20
//					 COLOR_3DDKSHADOW        		21
//					 COLOR_3DLIGHT           		22
//					 COLOR_INFOTEXT          		23
//					 COLOR_INFOBK            		24
//					 COLOR_HOTLIGHT             	26
//					 COLOR_GRADIENTACTIVECAPTION	27
//					 COLOR_GRADIENTINACTIVECAPTION	28
//					 COLOR_MENUICON					31 (AZ Erweiterung)
//	Ergibt die RGB-Werte der Farbe
EXTAPI COLORREF WINAPI GetThemeColorEx(unsigned uMode)
{
static COLORREF	aColor[32];
static CHAR		aDone[32];
LPBITMAPINFO	pInfo;
COLORREF		uColor;									
RECT			sRect;
UINT			uSel;
UINT			uSub;
HBITMAP			hBmp;
HDC				hDc;



	if(aDone[uMode])return aColor[uMode];

	if(!bUxThemeDone)									// Thema laden
		{
		LoadUxThemeDll();
		}


	switch(uMode)
		{
	case COLOR_MENUICON:								// Hintergrund vom Men-Icon

			if(hMenuTheme)
				{
				uSel = MENU_POPUPGUTTER;
				uSub = MS_NORMAL;
				break;
				}


	case COLOR_MENU:									// Hintergrund vom Men-Icon

			if(hMenuTheme)
				{
				uSel = MENU_POPUPBACKGROUND;
				uSub = MS_NORMAL;
				break;
				}

			aColor[COLOR_MENU    ] = GetSysColor(COLOR_MENU);
			aColor[COLOR_MENUICON] = aColor[COLOR_MENU];
			aDone [COLOR_MENU    ] = 1;
			aDone [COLOR_MENUICON] = 1;

			return aColor[COLOR_MENU];

	default:											// Systemfarbe benutzen

			aColor[uMode] = GetSysColor(COLOR_MENU);
			aDone [uMode] = 1;

			return aColor[uMode];
		}



	hDc		= CreateCompatibleDC(NULL);
	pInfo	= CreateDibIndirect(NULL,32,32,DIB_COLOR_DEF,NULL);
	hBmp	= DibGetBitmap(pInfo);

	SelectObject(hDc,hBmp);

	sRect.top	 = 0;
	sRect.left	 = 0;
	sRect.right	 = 32;
	sRect.bottom = 32;

	SetBkColor(hDc,GetSysColor(uMode));
	DrawRectangle(hDc,0,0,16,16);

	pDrawThemeBackg(hMenuTheme,hDc,uSel,uSub,&sRect,NULL);
	uColor = GetPixel(hDc,16,16);

	DibFreeHandle(pInfo);
	DeleteDC(hDc);


	aColor[uMode] = uColor;
	aDone [uMode] = 1;


return uColor;
}


//*****************************************************************************
//*
//*		GetWindowsVersionEx
//*
//*****************************************************************************
//	Holt die wahre Windows-Versionsnummer (auch wenn der Combatibility-Mode aktiv ist)
//	Ergibt die Windows-Versionsnummer (Bit 16..31=Major 0..15=Minor) oder 0 bei einem Fehler.
//		Windows 10.0		   10.0		0x000A0000
//		Windows 8.1				6.3		0x00060003
//		Windows Server 2012 R2	6.3		0x00060003
//		Windows 8				6.2		0x00060002
//		Windows Server 2012		6.2		0x00060002
//		Windows 7				6.1		0x00060001
//		Windows Server 2008 R2	6.1		0x00060001
//		Windows Server 2008		6.0		0x00060000
//		Windows Vista			6.0		0x00060000
//		Windows Server 2003 R2	5.2		0x00050002
//		Windows Server 2003		5.2		0x00050002
//		Windows XP				5.1		0x00050001
//		Windows 2000			5.0		0x00050000
EXTAPI DWORD WINAPI GetWindowsVersionEx()
{
HRSRC				hResource;
HGLOBAL				hGlobal;
LPVOID				pMemory;
VS_FIXEDFILEINFO   *pVersion;
VS_VERSIONBASE	   *pInfo;
LPCWSTR				pName;
UINT				uPos;


	if(uWinVersion)return uWinVersion;

	if(!hKernel32)hKernel32=GetModuleHandleW(L"KERNEL32");

		hResource = FindResource(hKernel32,MAKEINTRESOURCE(1),RT_VERSION);
	if(!hResource)return 0;

		hGlobal	  = LoadResource(hKernel32,hResource);
	if(!hGlobal)return 0;

		pMemory	  = LockResource(hGlobal);
	if(!pMemory)
		{
		FreeResource(hGlobal);
		return 0;
		}

	pInfo	= (VS_VERSIONBASE*)pMemory;
	pName	= L"VS_VERSION_INFO";

	for(uPos=0;;uPos++)
		{
		if(pInfo->szKey[uPos]!=pName[uPos])break;
		if(uPos<15)continue;

		while(uPos<18)
			{
			uPos++;

			   pVersion	= (VS_FIXEDFILEINFO*)(pInfo->szKey+uPos);
			if(pVersion->dwSignature!=0xFEEF04BD)continue;

			uWinVersion = pVersion->dwProductVersionMS;
			break;
			}

		break;
		}


	FreeResource(hGlobal);


return uWinVersion;
}

//*****************************************************************************
//*
//*		GetWindowsVersion
//*
//*****************************************************************************
//	Holt die aktuelle Windows-Versionsnummer
//	Ergibt die Windows-Versionsnummer (Bit 16..31=Major 0..15=Minor) oder 0 bei einem Fehler.
//		Windows 10.0		   10.0		0x000A0000
//		Windows 8.1				6.3		0x00060003
//		Windows Server 2012 R2	6.3		0x00060003
//		Windows 8				6.2		0x00060002
//		Windows Server 2012		6.2		0x00060002
//		Windows 7				6.1		0x00060001
//		Windows Server 2008 R2	6.1		0x00060001
//		Windows Server 2008		6.0		0x00060000
//		Windows Vista			6.0		0x00060000
//		Windows Server 2003 R2	5.2		0x00050002
//		Windows Server 2003		5.2		0x00050002
//		Windows XP				5.1		0x00050001
//		Windows 2000			5.0		0x00050000
EXTAPI DWORD WINAPI GetWindowsVersion()
{
static OSVERSIONINFO	sInfo;


	if(!sInfo.dwMajorVersion)
		{
		sInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
		GetVersionEx(&sInfo);
		}

return (sInfo.dwMajorVersion<<16)|(sInfo.dwMinorVersion);
}


//*****************************************************************************
//*
//*		WinWowRedirect
//*
//*****************************************************************************
//	Die Umleitung des "C:\Windows\system32" Pfades ndern
//	iMode	:  0 = umleiten von vorher herstellen
//			   1 = Umleitung aufheben
//			  -1 = Umleitung einschalten
EXTAPI VOID WINAPI WinWowRedirect(INT iMode)
{

	#ifndef _WIN64

	typedef BOOL (WINAPI *LPFN_WOW64DISABLE)(PVOID*);
	static	LPFN_WOW64DISABLE   Wow64Ena =0;
	static	LPFN_WOW64DISABLE   Wow64Dis =0;
	static	LPFN_WOW64DISABLE   Wow64Res =0;
	static	int					iOld64Ini=0;
	static	int					iOld64Cnt=0;
	static	PVOID				pOld64Dis=0;

	if(!iOld64Ini)										// Funktionen laden
		{
		iOld64Ini = 1;
		
		if(!hKernel32)hKernel32=GetModuleHandleW(L"KERNEL32");
		
		Wow64Dis  = (LPFN_WOW64DISABLE)GetProcAddress(hKernel32,"Wow64DisableWow64FsRedirection");
		Wow64Ena  = (LPFN_WOW64DISABLE)GetProcAddress(hKernel32,"Wow64EnableWow64FsRedirection");
		Wow64Res  = (LPFN_WOW64DISABLE)GetProcAddress(hKernel32,"Wow64RevertWow64FsRedirection");
		}

	if(iMode>0)											// Umleitung aufheben
		{
		iOld64Cnt++;

		if(iOld64Cnt>1)return;

		if(Wow64Dis)
			{
			Wow64Dis(&pOld64Dis);
			}
		}
	else if(iMode<0)									// Umleitung einschalten
		{
		iOld64Cnt++;

		if(iOld64Cnt>1)return;

		if(Wow64Ena)
			{
			Wow64Ena(&pOld64Dis);
			}
		}
	else{												// Umleitung von vorher wieder herstellen
		if(iOld64Cnt<=0)return;
		   iOld64Cnt--;
		if(iOld64Cnt<=0)return;

		if(Wow64Res)
			{
			Wow64Res(&pOld64Dis);
			}
		}

	#endif

}

//*****************************************************************************
//*
//*		IsWin64Bit
//*
//*****************************************************************************
//	Prft ob ein 64-Bit-Betriebsystem vorhanden ist
//	Ergibt 0 wenn kein 64-Bit-Betriebsystem vorhanden ist ansonsten
//				0 = 32-Bit-Betriebsystem
//				1 = 64-Bit-Betriebsystem und 32-Bit-Prozess
//				2 = 64-Bit-Betriebsystem
EXTAPI INT WINAPI IsWin64Bit()
{

	#ifdef _WIN64

	return 2;

	#else

	static  int 				 iIs64Bit= 0;
	static  BOOL				 bInit   = 0;

	if(!bInit)
		{
		if(!hKernel32)hKernel32=GetModuleHandleW(L"KERNEL32");
		
		pIsWow64 = (LPFN_ISWOW64PROCESS)GetProcAddress(hKernel32,"IsWow64Process");
		bInit	 = TRUE;

		if(pIsWow64)
			{
			pIsWow64(GetCurrentProcess(),&iIs64Bit);
			if(iIs64Bit)iIs64Bit=1;
			}
		}


	return iIs64Bit;

	#endif

}

//*****************************************************************************
//*
//*		HasAdminPrivilege
//*
//*****************************************************************************
//	Prfen ob der aktuelle User oder Handle Admin-Rechte hat
//	hToken		: Ist das Handle bzw. 0 fr den User.
//	Ergibt 1 wenn ja
EXTAPI BOOL WINAPI HasAdminPrivilege(HANDLE hToken)
{
SID_IDENTIFIER_AUTHORITY	sNtAuthority = SECURITY_NT_AUTHORITY;
UCHAR						aInfoBuffer[4096];
HANDLE						hAccessToken;
PSID						pSidAdmin;
BOOL						bSuccess;
PTOKEN_GROUPS				pGroups;
DWORD						dwSize;
UINT						uPos;


	pGroups = (PTOKEN_GROUPS)aInfoBuffer;

    if(hToken)
		{
        hAccessToken = hToken;
		}
    else{
        if(!OpenProcessToken(GetCurrentProcess(),TOKEN_READ,&hAccessToken))
            {
			return FALSE;
            }
		}

	bSuccess = GetTokenInformation(hAccessToken,TokenGroups,aInfoBuffer,sizeof(aInfoBuffer),&dwSize);
    CloseHandle(hAccessToken);


    if(!bSuccess)
		{
        return FALSE;
		}

    if(!AllocateAndInitializeSid(&sNtAuthority,2,SECURITY_BUILTIN_DOMAIN_RID,DOMAIN_ALIAS_RID_ADMINS,0,0,0,0,0,0,&pSidAdmin))
        {
		return FALSE;
		}

    bSuccess = FALSE;									// assume that we don't find the admin SID.

    for(uPos=0;uPos<pGroups->GroupCount;uPos++)
		{
        if(EqualSid(pSidAdmin,pGroups->Groups[uPos].Sid))
			{
            bSuccess = TRUE;
            break;
			}
		}

	FreeSid(pSidAdmin);



return bSuccess;
}

//*****************************************************************************
//*
//*		IsRunAsAdministrator
//*
//*****************************************************************************
//	Prft ob das Programm mit "Run as Administator" gestartet wurde.
//	Ergibt TRUE wenn ja, bzw. FALSE wenn nicht.
EXTAPI BOOL WINAPI IsRunAsAdministrator()
{
SID_IDENTIFIER_AUTHORITY sNtAuthority=SECURITY_NT_AUTHORITY;
PSID			pAdministratorsGroup;
BOOL			bIsRunAsAdmin;


    pAdministratorsGroup	= NULL;
    bIsRunAsAdmin			= FALSE;

	if(!AllocateAndInitializeSid(&sNtAuthority,2,SECURITY_BUILTIN_DOMAIN_RID,DOMAIN_ALIAS_RID_ADMINS,0,0,0,0,0,0,&pAdministratorsGroup))
		{
        goto Cleanup;
		}

	if(!hAdvApiDll)
		{
		    hAdvApiDll = LoadLibraryA("Advapi32.dll");
		if(!hAdvApiDll)
			{
			bIsRunAsAdmin = FALSE;
			goto Cleanup;
			}

		pCheckTokenMembership = (CheckTokenMembT)GetProcAddress(hAdvApiDll,"CheckTokenMembership");
		}

	if(!pCheckTokenMembership)
		{
		bIsRunAsAdmin = FALSE;
		goto Cleanup;
		}


    if(!pCheckTokenMembership(NULL, pAdministratorsGroup,&bIsRunAsAdmin))
		{
		bIsRunAsAdmin	= FALSE;
		}

Cleanup:

    if(pAdministratorsGroup)
		{
        FreeSid(pAdministratorsGroup);
        pAdministratorsGroup = NULL;
		}


return bIsRunAsAdmin;
}



//*****************************************************************************
//*
//*		AdjustRegName
//*
//*****************************************************************************
//	Passt den Registry-Namen fr einen Security-Zugriff an.
//		HKEY_LOCAL_MACHINE\...  --> MACHINE\...
//		HKEY_CURRENT_CONFIG\..	--> CONFIG\...
//		HKEY_CURRENT_USER\...   --> CURRENT_USER\...
//		usw.
static LPSTR AdjustRegNameA(LPSTR pName)
{
int		iPos;

	if(!pName)return NULL;

	if(pName[0]=='H' || pName[0]=='h')
		{
		for(iPos=0;;iPos++)
			{
			if((pName[iPos]^"HKEY_"[iPos])&~0x20)break;
			if(iPos<4)continue;

			pName+=5;

			if(pName[0]=='L' || pName[0]=='l')
				{
				for(iPos=0;;iPos++)
					{
					if((pName[iPos]^"LOCAL_"[iPos])&~0x20)break;
					if(iPos<5)continue;

					pName += 6;
					break;
					}
				}

			if(pName[0]=='C' || pName[0]=='C')
				{
				for(iPos=0;;iPos++)
					{
					if((pName[iPos]^"CURRENT_C"[iPos])&~0x20)break;
					if(iPos<8)continue;

					pName += 8;
					break;
					}
				}

			break;
			}
		}

return pName;
}

static LPWSTR AdjustRegNameW(LPWSTR pName)
{
int		iPos;

	if(!pName)return NULL;

	if(pName[0]=='H' || pName[0]=='h')
		{
		for(iPos=0;;iPos++)
			{
			if((pName[iPos]^L"HKEY_"[iPos])&~0x20)break;
			if(iPos<4)continue;

			pName+=5;

			if(pName[0]=='L' || pName[0]=='l')
				{
				for(iPos=0;;iPos++)
					{
					if((pName[iPos]^L"LOCAL_"[iPos])&~0x20)break;
					if(iPos<5)continue;

					pName += 6;
					break;
					}
				}

			if(pName[0]=='C' || pName[0]=='C')
				{
				for(iPos=0;;iPos++)
					{
					if((pName[iPos]^L"CURRENT_C"[iPos])&~0x20)break;
					if(iPos<8)continue;

					pName += 8;
					break;
					}
				}

			break;
			}
		}

return pName;
}



//*****************************************************************************
//*
//*		GetOwner
//*
//*****************************************************************************
//	Holt den Besitzernamen einer Datei bzw. eines Registry-Pfades
//	uType		: Ist der Typ des Handels
//					1..n	= SE_OBJECT_TYPE
//					1		= Datei-Handle
//					4		= Registry-Handle
//					0x81	= Dateiname
//					0x84	= Registry-Name
//	pOwner		: Ist der Puffer fr den Besitzernamen.
//	iOwnerSize	: Ist die Puffergre fr den Besitzernamen.
//	pDomain		: Ist der Puffer fr den Domain-Namen (NULL=nicht speichern).
//	iDomainSize	: Ist die Puffergre fr den Besitzernamen.
//	Ergibt 0 wenn ok oder eine Fehlernummer
//					 0		= Alles ok
//					-1		= Die SID konnte nicht geholt werden
//					-2		= Die Namensgre konnten nicht geholt werden
//					-3		= Ein Puffer ist zu klein
//					-4		= Zu wenig Speicher
EXTAPI INT WINAPI GetOwnerA(LPCVOID pHandle,UINT uType,LPSTR pOwner,INT iOwnerSize,LPSTR pDomain,INT iDomainSize)
{
PSID					pSidOwner;
DWORD 					dwAcctName;
DWORD 					dwDomainName;
LPSTR 					pDomainName;
LPSTR 					pAcctName;
LPSTR 					pName;
DWORD					dwRet;
DWORD					dwPos;
SID_NAME_USE 			eUse;
INT						iRet;
BOOL 					bOk;
PSECURITY_DESCRIPTOR	pSD;



	pSidOwner	= NULL;
	pAcctName	= NULL;
	pDomainName	= NULL;
	eUse		= SidTypeUnknown;
	pSD			= NULL;


	if(uType&0x80)											// Hole die owner SID von einem Handle
		{
		uType	&= 0x7F;

		   dwRet = GetSecurityInfo((HANDLE)pHandle,(SE_OBJECT_TYPE)uType,OWNER_SECURITY_INFORMATION,&pSidOwner,NULL,NULL,NULL,&pSD);
		if(dwRet!=ERROR_SUCCESS)
			{
			return -1;
			}
		}
	else{													// Hole die owner SID vom Namen
		pName = (LPSTR)pHandle;

		if(uType==SE_REGISTRY_KEY)
			{
			pName = AdjustRegNameA(pName);
			}

		   dwRet = GetNamedSecurityInfoA(pName,(SE_OBJECT_TYPE)uType,OWNER_SECURITY_INFORMATION,&pSidOwner,NULL,NULL,NULL,&pSD);
		if(dwRet!=ERROR_SUCCESS)
			{
			return -1;
			}
		}

		bOk = LookupAccountSidA(NULL,pSidOwner,NULL,(LPDWORD)&dwAcctName,NULL,(LPDWORD)&dwDomainName,&eUse);
	if(!bOk && GetLastError()!=ERROR_INSUFFICIENT_BUFFER)
		{
        return -2;
		}

	if(pOwner && (int)dwAcctName>=iOwnerSize)				// Prfe die Puffer gren
		{
        return -3;
		}

	if(pDomain && (int)dwDomainName>=iDomainSize)
		{
        return -3;
		}

	pAcctName	= NULL;
	pDomainName	= NULL;

		pAcctName = (LPSTR)GlobalAlloc(GMEM_FIXED,dwAcctName);
	if(!pAcctName)
		{
        iRet = -4;
		goto Exit;
		}

		pDomainName = (LPSTR)GlobalAlloc(GMEM_FIXED,dwDomainName);
	if(!pDomainName)
		{
        iRet = -4;
		goto Exit;
		}

															// Die Namen holen
		bOk = LookupAccountSidA(NULL,pSidOwner,pAcctName,&dwAcctName,pDomainName,&dwDomainName,&eUse);
    if(!bOk)
		{
        iRet = -5;
		goto Exit;
	    }


	if(pOwner)												// Namen vom Owner kopieren
		{
		for(dwPos=0;;dwPos++)
			{
			pOwner[dwPos] = (CHAR)pAcctName[dwPos];
			if(!pAcctName[dwPos])break;
			}
		}


	if(pDomain)												// Domainnamen kopieren
		{
		for(dwPos=0;;dwPos++)
			{
			pDomain[dwPos] = (CHAR)pDomainName[dwPos];
			if(!pDomainName[dwPos])break;
			}
		}

	iRet = 0;

Exit:

	if(pDomainName)GlobalFree(pDomainName);
	if(pAcctName  )GlobalFree(pAcctName  );



return iRet;
}

EXTAPI INT WINAPI GetOwnerW(LPCVOID pHandle,UINT uType,LPWSTR pOwner,INT iOwnerSize,LPWSTR pDomain,INT iDomainSize)
{
PSID					pSidOwner;
DWORD 					dwAcctName;
DWORD 					dwDomainName;
LPWSTR 					pDomainName;
LPWSTR 					pAcctName;
LPWSTR 					pName;
DWORD					dwRet;
DWORD					dwPos;
SID_NAME_USE 			eUse;
INT						iRet;
BOOL 					bOk;
PSECURITY_DESCRIPTOR	pSD;



	pSidOwner	= NULL;
	pAcctName	= NULL;
	pDomainName	= NULL;
	eUse		= SidTypeUnknown;
	pSD			= NULL;


	if(uType&0x80)											// Hole die owner SID von einem Handle
		{
		uType	&= 0x7F;

		   dwRet = GetSecurityInfo((HANDLE)pHandle,(SE_OBJECT_TYPE)uType,OWNER_SECURITY_INFORMATION,&pSidOwner,NULL,NULL,NULL,&pSD);
		if(dwRet!=ERROR_SUCCESS)
			{
			return -1;
			}
		}
	else{													// Hole die owner SID vom Namen
		pName = (LPWSTR)pHandle;

		if(uType==SE_REGISTRY_KEY)
			{
			pName = AdjustRegNameW(pName);
			}

		   dwRet = GetNamedSecurityInfoW(pName,(SE_OBJECT_TYPE)uType,OWNER_SECURITY_INFORMATION,&pSidOwner,NULL,NULL,NULL,&pSD);
		if(dwRet!=ERROR_SUCCESS)
			{
			return -1;
			}
		}

		bOk = LookupAccountSid(NULL,pSidOwner,NULL,(LPDWORD)&dwAcctName,NULL,(LPDWORD)&dwDomainName,&eUse);
	if(!bOk && GetLastError()!=ERROR_INSUFFICIENT_BUFFER)
		{
        return -2;
		}

	if(pOwner && (int)dwAcctName>=iOwnerSize)				// Prfe die Puffer gren
		{
        return -3;
		}

	if(pDomain && (int)dwDomainName>=iDomainSize)
		{
        return -3;
		}

	pAcctName	= NULL;
	pDomainName	= NULL;

		pAcctName = (LPWSTR)GlobalAlloc(GMEM_FIXED,dwAcctName);
	if(!pAcctName)
		{
        iRet = -4;
		goto Exit;
		}

		pDomainName = (LPWSTR)GlobalAlloc(GMEM_FIXED,dwDomainName);
	if(!pDomainName)
		{
        iRet = -4;
		goto Exit;
		}

															// Die Namen holen
		bOk = LookupAccountSidW(NULL,pSidOwner,pAcctName,&dwAcctName,pDomainName,&dwDomainName,&eUse);
    if(!bOk)
		{
        iRet = -5;
		goto Exit;
	    }


	if(pOwner)												// Namen vom Owner kopieren
		{
		for(dwPos=0;;dwPos++)
			{
			pOwner[dwPos] = (WCHAR)pAcctName[dwPos];
			if(!pAcctName[dwPos])break;
			}
		}


	if(pDomain)												// Domainnamen kopieren
		{
		for(dwPos=0;;dwPos++)
			{
			pDomain[dwPos] = (WCHAR)pDomainName[dwPos];
			if(!pDomainName[dwPos])break;
			}
		}

	iRet = 0;

Exit:

	if(pDomainName)GlobalFree(pDomainName);
	if(pAcctName  )GlobalFree(pAcctName  );



return iRet;
}




//*****************************************************************************
//*
//*		SetPrivilege
//*
//*****************************************************************************
static BOOL SetPrivilege(HANDLE hToken,LPCTSTR pPrivilege,BOOL bEnablePrivilege)
{
TOKEN_PRIVILEGES	sToken;
LUID				sLuid;


	if(!LookupPrivilegeValue(NULL,pPrivilege,&sLuid))		// lookup privilege on local system
		{
		return FALSE;
		}

	sToken.PrivilegeCount		= 1;
	sToken.Privileges[0].Luid	= sLuid;

	if(bEnablePrivilege)
		{
		sToken.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
		}
	else{
		sToken.Privileges[0].Attributes = 0;
		}

															// Enable the privilege or disable all privileges.

	if(!AdjustTokenPrivileges(hToken,FALSE,&sToken,sizeof(TOKEN_PRIVILEGES),(PTOKEN_PRIVILEGES)NULL,(PDWORD)NULL))
		{
		return FALSE;
		}

	if(GetLastError()==ERROR_NOT_ALL_ASSIGNED)
		{
		return FALSE;
		}


return TRUE;
}




//*****************************************************************************
//*
//*		TakeOwnership
//*
//*****************************************************************************
//	bernimmt den Besitz eines Objektes und setzt die Rechche fr die
//	User "Administrator" und "Jeder". Administratoren erhallten alle Rechte.
//	pObject		: Ist der Objektname (Datei oder Registry-Key oder ein Handle)
//	uAccess		: Sind die Rechte fr den User "Jeder"
//					GENERIC_READ GENERIC_WRITE GENERIC_EXECUTE GENERIC_ALL
//	uType		: Ist der Typ des Objektes (siehe SE_OBJECT_TYPE)
//					1..n	= SE_OBJECT_TYPE
//					1		= Datei-Handle
//					4		= Registry-Handle
//					0x81	= Dateiname
//					0x84	= Registry-Name
//	Ergibt TRUE wenn erfolgreich.
EXTAPI BOOL WINAPI TakeOwnershipA(LPCVOID pObject,UINT uAccess,UINT uType)
{
const int					NUM_ACES	  = 2;
SID_IDENTIFIER_AUTHORITY	sSidAuthWorld =	SECURITY_WORLD_SID_AUTHORITY;
SID_IDENTIFIER_AUTHORITY	sSidAuthNt    = SECURITY_NT_AUTHORITY;
EXPLICIT_ACCESSA			aAccess[NUM_ACES];
PSID						pSidEveryone;
PSID						pSidAdmin;
BOOL						bRetval;
HANDLE						hToken;
LPSTR						pName;
PACL						pAcl;
BOOL						bMode;
DWORD						dwRes;


	pSidEveryone = NULL;
	pSidAdmin	 = NULL;
	bRetval		 = FALSE;
	hToken		 = NULL;
	pAcl		 = NULL;

															// Specify the DACL to use.
															// Create a SID for the Everyone group.
	if(!AllocateAndInitializeSid(&sSidAuthWorld,1,SECURITY_WORLD_RID,0,0,0,0,0,0,0,&pSidEveryone))
		{
		goto Cleanup;
		}

															// Create a SID for the BUILTIN\Administrators group.
	if(!AllocateAndInitializeSid(&sSidAuthNt,2,SECURITY_BUILTIN_DOMAIN_RID,DOMAIN_ALIAS_RID_ADMINS,0,0,0,0,0,0,&pSidAdmin))
		{
		goto Cleanup;
		}

	ZeroMemory(&aAccess,NUM_ACES*sizeof(EXPLICIT_ACCESS));


	aAccess[0].grfAccessPermissions	=  uAccess;				// Set read access for Everyone.
	aAccess[0].grfAccessMode 		=  SET_ACCESS;
	aAccess[0].grfInheritance		=  NO_INHERITANCE;
	aAccess[0].Trustee.TrusteeForm	=  TRUSTEE_IS_SID;
	aAccess[0].Trustee.TrusteeType	=  TRUSTEE_IS_WELL_KNOWN_GROUP;
	aAccess[0].Trustee.ptstrName 	= (LPSTR)pSidEveryone;


	aAccess[1].grfAccessPermissions	=  GENERIC_ALL;			// Set full control for Administrators.
	aAccess[1].grfAccessMode 		=  SET_ACCESS;
	aAccess[1].grfInheritance		=  NO_INHERITANCE;
	aAccess[1].Trustee.TrusteeForm	=  TRUSTEE_IS_SID;
	aAccess[1].Trustee.TrusteeType	=  TRUSTEE_IS_GROUP;
	aAccess[1].Trustee.ptstrName 	= (LPSTR)pSidAdmin;

	if(SetEntriesInAclA(NUM_ACES,aAccess,NULL,&pAcl)!=ERROR_SUCCESS)
		{
		goto Cleanup;										// Failed SetEntriesInAcl
		}

	if(uType&0x80)											// Via Handle
		{
		bMode  = TRUE;
		uType &= 0x7F;
		dwRes  = SetSecurityInfo(   (HANDLE)pObject,		// name of the object
								    (SE_OBJECT_TYPE)uType,	// type of object
									 DACL_SECURITY_INFORMATION, // change only the object's DACL
									 NULL, NULL,			// do not change owner or group
									 pAcl,					// DACL specified
									 NULL); 				// do not change SACL

		}
	else{													// Try to modify the object's DACL via Name.
		bMode  = FALSE;
		pName  = (LPSTR)pObject;

		if(uType==SE_REGISTRY_KEY)
			{
			pName = AdjustRegNameA(pName);
			}

		dwRes = SetNamedSecurityInfoA(pName,				// name of the object
								    (SE_OBJECT_TYPE)uType,	// type of object
									 DACL_SECURITY_INFORMATION, // change only the object's DACL
									 NULL, NULL,			// do not change owner or group
									 pAcl,					// DACL specified
									 NULL); 				// do not change SACL
		}


	if(dwRes==ERROR_SUCCESS)
		{
		bRetval = TRUE;										// No more processing needed.
		goto Cleanup;
		}

	if(dwRes!=ERROR_ACCESS_DENIED)
		{
		goto Cleanup;										// First SetNamedSecurityInfo call failed
		}


															// Open a handle to the access token for the calling process.
	if(!OpenProcessToken(GetCurrentProcess(),TOKEN_ADJUST_PRIVILEGES,&hToken))
		{
		goto Cleanup;										// OpenProcessToken failed
		}


	if(!SetPrivilege(hToken,SE_TAKE_OWNERSHIP_NAME,TRUE))	// Enable the SE_TAKE_OWNERSHIP_NAME privilege.
		{
		goto Cleanup;										// You must be logged on as Administrator
		}

	if(bMode)
		{
		dwRes = SetSecurityInfo(    (HANDLE)pObject,		// name of the object
									(SE_OBJECT_TYPE)uType,	// type of object
									 OWNER_SECURITY_INFORMATION,// change only the object's owner
									 pSidAdmin, 			// SID of Administrator group
									 NULL,
									 NULL,
									 NULL);
		}
	else{													// Set the owner in the object's security descriptor.
		dwRes = SetNamedSecurityInfoA(pName,				// name of the object
									(SE_OBJECT_TYPE)uType,	// type of object
									 OWNER_SECURITY_INFORMATION,// change only the object's owner
									 pSidAdmin, 			// SID of Administrator group
									 NULL,
									 NULL,
									 NULL);
		}


	if(dwRes!=ERROR_SUCCESS)
		{
		goto Cleanup;										// Could not set owner
		}


	if(!SetPrivilege(hToken,SE_TAKE_OWNERSHIP_NAME,FALSE))	// Disable the SE_TAKE_OWNERSHIP_NAME privilege.
		{
		goto Cleanup;
		}

															// Try again to modify the object's DACL,now that we are the owner.
	if(bMode)
		{
		dwRes = SetSecurityInfo(    (HANDLE)pObject,		// name of the object
									(SE_OBJECT_TYPE)uType,	// type of object
									 DACL_SECURITY_INFORMATION, // change only the object's DACL
									 NULL,NULL,				// do not change owner or group
									 pAcl,					// DACL specified
									 NULL); 				// do not change SACL
		}
	else{
		dwRes = SetNamedSecurityInfoA(pName,				// name of the object
									(SE_OBJECT_TYPE)uType,	// type of object
									 DACL_SECURITY_INFORMATION, // change only the object's DACL
									 NULL,NULL,				// do not change owner or group
									 pAcl,					// DACL specified
									 NULL); 				// do not change SACL
		}

	if(dwRes==ERROR_SUCCESS)
		{
		bRetval = TRUE;										// Successfully changed DACL
		}

Cleanup:

	if(pSidAdmin)
		{
		FreeSid(pSidAdmin);
		}

	if(pSidEveryone)
		{
		FreeSid(pSidEveryone);
		}

	if(pAcl)
		{
		LocalFree(pAcl);
		}

	if(hToken)
		{
		CloseHandle(hToken);
		}


return bRetval;
}

EXTAPI BOOL WINAPI TakeOwnershipW(LPCVOID pObject,UINT uAccess,UINT uType)
{
const int					NUM_ACES	  = 2;
SID_IDENTIFIER_AUTHORITY	sSidAuthWorld =	SECURITY_WORLD_SID_AUTHORITY;
SID_IDENTIFIER_AUTHORITY	sSidAuthNt    = SECURITY_NT_AUTHORITY;
EXPLICIT_ACCESSW			aAccess[NUM_ACES];
PSID						pSidEveryone;
PSID						pSidAdmin;
BOOL						bRetval;
HANDLE						hToken;
LPWSTR						pName;
PACL						pAcl;
BOOL						bMode;
DWORD						dwRes;


	pSidEveryone = NULL;
	pSidAdmin	 = NULL;
	bRetval		 = FALSE;
	hToken		 = NULL;
	pAcl		 = NULL;

															// Specify the DACL to use.
															// Create a SID for the Everyone group.
	if(!AllocateAndInitializeSid(&sSidAuthWorld,1,SECURITY_WORLD_RID,0,0,0,0,0,0,0,&pSidEveryone))
		{
		goto Cleanup;
		}

															// Create a SID for the BUILTIN\Administrators group.
	if(!AllocateAndInitializeSid(&sSidAuthNt,2,SECURITY_BUILTIN_DOMAIN_RID,DOMAIN_ALIAS_RID_ADMINS,0,0,0,0,0,0,&pSidAdmin))
		{
		goto Cleanup;
		}

	ZeroMemory(&aAccess,NUM_ACES*sizeof(EXPLICIT_ACCESS));


	aAccess[0].grfAccessPermissions	=  uAccess;				// Set read access for Everyone.
	aAccess[0].grfAccessMode 		=  SET_ACCESS;
	aAccess[0].grfInheritance		=  NO_INHERITANCE;
	aAccess[0].Trustee.TrusteeForm	=  TRUSTEE_IS_SID;
	aAccess[0].Trustee.TrusteeType	=  TRUSTEE_IS_WELL_KNOWN_GROUP;
	aAccess[0].Trustee.ptstrName 	= (LPWSTR)pSidEveryone;


	aAccess[1].grfAccessPermissions	=  GENERIC_ALL;			// Set full control for Administrators.
	aAccess[1].grfAccessMode 		=  SET_ACCESS;
	aAccess[1].grfInheritance		=  NO_INHERITANCE;
	aAccess[1].Trustee.TrusteeForm	=  TRUSTEE_IS_SID;
	aAccess[1].Trustee.TrusteeType	=  TRUSTEE_IS_GROUP;
	aAccess[1].Trustee.ptstrName 	= (LPWSTR)pSidAdmin;

	if(SetEntriesInAclW(NUM_ACES,aAccess,NULL,&pAcl)!=ERROR_SUCCESS)
		{
		goto Cleanup;										// Failed SetEntriesInAcl
		}

	if(uType&0x80)											// Via Handle
		{
		bMode  = TRUE;
		uType &= 0x7F;
		dwRes  = SetSecurityInfo(   (HANDLE)pObject,		// name of the object
								    (SE_OBJECT_TYPE)uType,	// type of object
									 DACL_SECURITY_INFORMATION, // change only the object's DACL
									 NULL, NULL,			// do not change owner or group
									 pAcl,					// DACL specified
									 NULL); 				// do not change SACL

		}
	else{													// Try to modify the object's DACL via Name.
		bMode  = FALSE;
		pName  = (LPWSTR)pObject;

		if(uType==SE_REGISTRY_KEY)
			{
			pName = AdjustRegNameW(pName);
			}

		dwRes = SetNamedSecurityInfoW(pName,					// name of the object
								    (SE_OBJECT_TYPE)uType,	// type of object
									 DACL_SECURITY_INFORMATION, // change only the object's DACL
									 NULL, NULL,			// do not change owner or group
									 pAcl,					// DACL specified
									 NULL); 				// do not change SACL
		}


	if(dwRes==ERROR_SUCCESS)
		{
		bRetval = TRUE;										// No more processing needed.
		goto Cleanup;
		}

	if(dwRes!=ERROR_ACCESS_DENIED)
		{
		goto Cleanup;										// First SetNamedSecurityInfo call failed
		}


															// Open a handle to the access token for the calling process.
	if(!OpenProcessToken(GetCurrentProcess(),TOKEN_ADJUST_PRIVILEGES,&hToken))
		{
		goto Cleanup;										// OpenProcessToken failed
		}


	if(!SetPrivilege(hToken,SE_TAKE_OWNERSHIP_NAME,TRUE))	// Enable the SE_TAKE_OWNERSHIP_NAME privilege.
		{
		goto Cleanup;										// You must be logged on as Administrator
		}

	if(bMode)
		{
		dwRes = SetSecurityInfo(    (HANDLE)pObject,		// name of the object
									(SE_OBJECT_TYPE)uType,	// type of object
									 OWNER_SECURITY_INFORMATION,// change only the object's owner
									 pSidAdmin, 			// SID of Administrator group
									 NULL,
									 NULL,
									 NULL);
		}
	else{													// Set the owner in the object's security descriptor.
		dwRes = SetNamedSecurityInfoW(pName,				// name of the object
									(SE_OBJECT_TYPE)uType,	// type of object
									 OWNER_SECURITY_INFORMATION,// change only the object's owner
									 pSidAdmin, 			// SID of Administrator group
									 NULL,
									 NULL,
									 NULL);
		}


	if(dwRes!=ERROR_SUCCESS)
		{
		goto Cleanup;										// Could not set owner
		}


	if(!SetPrivilege(hToken,SE_TAKE_OWNERSHIP_NAME,FALSE))	// Disable the SE_TAKE_OWNERSHIP_NAME privilege.
		{
		goto Cleanup;
		}

															// Try again to modify the object's DACL,now that we are the owner.
	if(bMode)
		{
		dwRes = SetSecurityInfo(    (HANDLE)pObject,		// name of the object
									(SE_OBJECT_TYPE)uType,	// type of object
									 DACL_SECURITY_INFORMATION, // change only the object's DACL
									 NULL,NULL,				// do not change owner or group
									 pAcl,					// DACL specified
									 NULL); 				// do not change SACL
		}
	else{
		dwRes = SetNamedSecurityInfoW(pName,				// name of the object
									(SE_OBJECT_TYPE)uType,	// type of object
									 DACL_SECURITY_INFORMATION, // change only the object's DACL
									 NULL,NULL,				// do not change owner or group
									 pAcl,					// DACL specified
									 NULL); 				// do not change SACL
		}

	if(dwRes==ERROR_SUCCESS)
		{
		bRetval = TRUE;										// Successfully changed DACL
		}

Cleanup:

	if(pSidAdmin)
		{
		FreeSid(pSidAdmin);
		}

	if(pSidEveryone)
		{
		FreeSid(pSidEveryone);
		}

	if(pAcl)
		{
		LocalFree(pAcl);
		}

	if(hToken)
		{
		CloseHandle(hToken);
		}


return bRetval;
}

//*****************************************************************************
//*
//*		GetDomainName
//*
//*****************************************************************************
//	Den Domnen-Namen des Rechners abfragen.
//	pBuffer		: Textpuffer wo der Domnen-Namen gespeichert wird
//	iSize		: Ist die Gre des Textpuffers in Zeichen
//	iMode		: Bestimmt die Art der Abfrage
//				   -1 = LanGroup					(z.B.:	"GAW2000")
//					0 = NetBIOS						(z.B.:	"AX-PC-36")
//					1 = DnsHostname					(z.B.:	"AX-PC-36")
//					2 = DnsDomain					(z.B.:	"gaw.gawgroup.com")
//					3 = DnsFullyQualified			(z.B.:	"AX-PC-36.gaw.gawgroup.com")
//					4 = PhysicalNetBIOS				(z.B.:	"AX-PC-36")
//					5 = PhysicalDnsHostname			(z.B.:	"AX-PC-36")
//					6 = PhysicalDnsDomain			(z.B.:	"gaw.gawgroup.com")
//					7 = PhysicalDnsFullyQualified	(z.B.:	"AX-PC-36.gaw.gawgroup.com")
//	Ergibt die Lnge des gespeicherten Namens, bzw. 0 bei einem Fehler.
EXTAPI INT WINAPI GetDomainNameA(LPSTR pBuffer,INT iSize,INT iMode)
{
typedef	DWORD (__stdcall *NetWkstaGetInfoType   )(LPTSTR,DWORD,LPBYTE*);
typedef	BOOL  (__stdcall *GetComputerNameExAType)(int,LPSTR,LPDWORD);
static	GetComputerNameExAType	pGetComputerNameExA=0;
static	NetWkstaGetInfoType		pNetWkstaGetInfo=0;
static	char 					iInitDone;
static	char 					iInitNet;
_WKSTA_INFO_100				   *pInfo;
LPWSTR							pText;
LPBYTE							pData;
WCHAR							uSign;
DWORD							uSize;
HMODULE							hDll;
INT								iRet;
INT								iPos;


	if(iSize<=0)										// Prfe die Puffergre
		{
		SetLastError(ERROR_INVALID_PARAMETER);
		return 0;
		}

	if(iMode==-1)										// LanGroup abfragen
		{
		if(!iInitNet)
			{
				iInitNet		= TRUE;
				hDll			= GetModuleHandleA("NETAPI32");
			if(!hDll)hDll		= LoadLibraryA    ("NETAPI32");
			pNetWkstaGetInfo	= (NetWkstaGetInfoType)GetProcAddress(hDll,"NetWkstaGetInfo");
			}

		if(!pNetWkstaGetInfo)
			{
			SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
			goto Error;
			}

		   iRet = pNetWkstaGetInfo(NULL,100,&pData);
		if(iRet!=NERR_Success)
			{
			goto Error;
			}

		    pInfo = (_WKSTA_INFO_100*)pData;
		if(!pInfo->wki100_langroup)
			{
			goto Error;
			}

		pText = (LPWSTR)pInfo->wki100_langroup;

		for(iPos=0;;iPos++)								// Text von UTF16 auf Byte umkopieren
			{
			if(iPos>=iSize-1)
				{
				SetLastError(ERROR_BUFFER_OVERFLOW);
				goto Error;
				}

			uSign			= pText[iPos];
			pBuffer[iPos]	= (char)uSign;

			if(!uSign)break;
			}

		return iPos;
		}


	if(!iInitDone)										// Funktionszeiger holen
		{
		iInitDone			= TRUE;
		
		if(!hKernel32)hKernel32=GetModuleHandleW(L"KERNEL32");
		pGetComputerNameExA = (GetComputerNameExAType)GetProcAddress(hKernel32,"GetComputerNameExA");
		}

	if(!pGetComputerNameExA)
		{
		SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
		goto Error;
		}


	uSize = iSize;

	if(!pGetComputerNameExA(iMode,pBuffer,&uSize))		// Name abfragen
		{
		goto Error;
		}


	return uSize;

Error:

	pBuffer[0] = 0;

return 0;
}

EXTAPI INT WINAPI GetDomainNameW(LPWSTR pBuffer,INT iSize,INT iMode)
{
LPSTR	pText;
BYTE	bSign;
INT		iRet;
INT		iPos;


	if(iSize<=0)										// Prfe die Puffergre
		{
		SetLastError(ERROR_INVALID_PARAMETER);
		return 0;
		}


	pText = (LPSTR)pBuffer;
	iRet  = GetDomainNameA(pText,iSize,iMode);


	for(iPos=iRet;iPos>=0;iPos--)						// Von Byte auf UTF16 konvertieren
		{
		bSign		  = pText[iPos];
		pBuffer[iPos] = bSign;
		}


return iRet;
}

//*****************************************************************************
//*
//*		GetBitmapInfoEx
//*
//*****************************************************************************
//	Holt Informationen zu einem Bitmap
//	hBitmap		: Handle des Bitmaps
//	pData		: Hier werden die Informationen gespeichert
//	uColors		: Anzahl der Farbe die kopiert werden sollen
//	Ergibt TRUE wenn erfolgreich
EXTAPI BOOL WINAPI GetBitmapInfoEx(HBITMAP hBitmap,LPBITMAPINFO pData,UINT uColors)
{
BYTE			aData[sizeof(BITMAPINFOHEADER)+sizeof(RGBQUAD)*256];
LPBITMAPINFO	pInfo;
UINT			uCnt;
INT				iRet;
HDC				hDc;


	if(!hBitmap)											// Prfe das Handle
		{
		memset(pData,0,sizeof(BITMAPINFOHEADER));
		return FALSE;
		}

	hDc		= GetDC(NULL);
	pInfo	=(LPBITMAPINFO)aData;

	pInfo->bmiHeader.biSize		  		= sizeof(BITMAPINFOHEADER);
	pInfo->bmiHeader.biWidth		  	= 0;
	pInfo->bmiHeader.biHeight	  		= 0;
	pInfo->bmiHeader.biPlanes	  		= 1;
	pInfo->bmiHeader.biBitCount	  		= 0;
	pInfo->bmiHeader.biCompression 		= BI_RGB;
	pInfo->bmiHeader.biSizeImage		= 0;
	pInfo->bmiHeader.biXPelsPerMeter	= 0;
	pInfo->bmiHeader.biYPelsPerMeter	= 0;
	pInfo->bmiHeader.biClrUsed			= 0;

	iRet = GetDIBits(hDc,hBitmap,0,0,NULL,pInfo,DIB_RGB_COLORS);
	ReleaseDC(NULL,hDc);

	if(iRet<=0)												// Konnte der Header geholt werden
		{
		memset(pData,0,sizeof(BITMAPINFOHEADER));
		return FALSE;
		}

	if(!pInfo->bmiHeader.biClrUsed && pInfo->bmiHeader.biBitCount<=8)
		{
		uCnt = 1<<pInfo->bmiHeader.biBitCount;
		}
	else{
		uCnt = pInfo->bmiHeader.biClrUsed;
		}

	if(uCnt>uColors)uCnt=uColors;							// Farben kopieren

	memcpy(pData,pInfo,sizeof(BITMAPINFOHEADER)+sizeof(RGBQUAD)*uCnt);


return TRUE;
}


//*****************************************************************************
//*
//*		GetBitmapInfo
//*
//*****************************************************************************
//	Holt Informationen zu einem Bitmap
//	hBitmap		: Handle des Bitmaps
//	pSizeX/Y	: Hier wird die Bildgre gespeichert (bei NULL nichts)
//	pBits		: Anzahl die Bitanzahl gespeichert	  (bei NULL nichts)
//	Ergibt TRUE wenn erfolgreich
EXTAPI BOOL WINAPI GetBitmapInfo(HBITMAP hBitmap,LPINT pSizeX,LPINT pSizeY,LPINT pBits)
{
BITMAPINFO	sInfo;


	if(!GetBitmapInfoEx(hBitmap,&sInfo,0))					// Infos holen
		{
		if(pBits )*pBits =0;
		if(pSizeX)*pSizeX=0;
		if(pSizeY)*pSizeY=0;
		return FALSE;
		}

	if(pBits )*pBits =sInfo.bmiHeader.biBitCount;
	if(pSizeX)*pSizeX=sInfo.bmiHeader.biWidth;
	if(pSizeY)*pSizeY=sInfo.bmiHeader.biHeight;


return TRUE;
}

//*****************************************************************************
//*
//*		GetBitmapInfoSz
//*
//*****************************************************************************
//	Holt Informationen zu einem Bitmap
//	hBitmap		: Handle des Bitmaps
//	pSizeX/Y	: Hier wird die Bildgre gespeichert (bei NULL nichts)
//	pBits		: Anzahl die Bitanzahl gespeichert	  (bei NULL nichts)
//	Ergibt TRUE wenn erfolgreich
EXTAPI BOOL WINAPI GetBitmapInfoSz(HBITMAP hBitmap,LPSIZE pSize,LPINT pBits)
{
BITMAPINFO	sInfo;


	if(!GetBitmapInfoEx(hBitmap,&sInfo,0))					// Infos holen
		{
		if(pBits)
			{
			*pBits = 0;
			}

		if(pSize)
			{
			pSize->cx = 0;
			pSize->cy = 0;
			}

		return FALSE;
		}

	if(pBits)
		{
		*pBits = sInfo.bmiHeader.biBitCount;
		}

	if(pSize)
		{
		pSize->cx = sInfo.bmiHeader.biWidth;
		pSize->cy = sInfo.bmiHeader.biHeight;
		}


return TRUE;
}


//*****************************************************************************
//*
//*		GdiPlusInit
//*
//*****************************************************************************
//	GDI+ initialisieren
EXTAPI BOOL WINAPI GdiPlusInit()
{
GdiplusStartupType		pGdiplusStartup;
GdiplusStartupInput_	sStartup;


	if(iGdiPlusInit)
		{
		iGdiPlusCount++;
		return iGdiPlusInit-1;
		}

		hGdiPlusDll = LoadLibraryW(L"gdiplus.dll");
	if(!hGdiPlusDll)
		{
		iGdiPlusInit = 1;
		return FALSE;
		}

	pGdiplusStartup			= (GdiplusStartupType    	)GetProcAddress(hGdiPlusDll,"GdiplusStartup"    	);
	pGdipCreateFromHDC		= (GdipCreateFromHDCType 	)GetProcAddress(hGdiPlusDll,"GdipCreateFromHDC" 	);
	pGdipDeleteGraphics		= (GdipDeleteGraphicsType	)GetProcAddress(hGdiPlusDll,"GdipDeleteGraphics"	);
	pGdipSetSmoothingMode	= (GdipSetSmoothingModeType	)GetProcAddress(hGdiPlusDll,"GdipSetSmoothingMode"	);
	pGdipDrawEllipseI		= (GdipDrawEllipseIType  	)GetProcAddress(hGdiPlusDll,"GdipDrawEllipseI"  	);
	pGdipDrawLineI			= (GdipDrawLineIType     	)GetProcAddress(hGdiPlusDll,"GdipDrawLineI"     	);
	pGdipCreatePen1			= (GdipCreatePen1Type    	)GetProcAddress(hGdiPlusDll,"GdipCreatePen1"    	);
	pGdipSetPenColor		= (GdipSetPenColorType   	)GetProcAddress(hGdiPlusDll,"GdipSetPenColor"   	);
	pGdipDeletePen			= (GdipDeletePenType     	)GetProcAddress(hGdiPlusDll,"GdipDeletePen"     	);
	iGdiPlusInit			= 2;

	memset(&sStartup,0,sizeof(sStartup));
	sStartup.GdiplusVersion	= 1;
	pGdiplusStartup(&uGdiToken,&sStartup,NULL);


return TRUE;
}

//*****************************************************************************
//*
//*		GdiPlusExit
//*
//*****************************************************************************
//	GDI+ deinitialisieren
EXTAPI BOOL WINAPI GdiPlusExit()
{
GdiplusShutdownType	pGdiplusShutdown;
BOOL				bRet;


	if(iGdiPlusCount>0)
		{
		iGdiPlusCount--;
		return TRUE;
		}

	if(iGdiPlusInit<=1)
		{
		bRet = iGdiPlusInit;
		iGdiPlusInit = 0;
		return bRet;
		}

	pGdiplusShutdown = (GdiplusShutdownType)GetProcAddress(hGdiPlusDll,"GdiplusShutdown");
	pGdiplusShutdown(uGdiToken);

	bRet		 = FreeLibrary(hGdiPlusDll);
	hGdiPlusDll  = NULL;
	iGdiPlusInit = 0;


return bRet;
}

//*****************************************************************************
//*
//*		GetDcEx
//*
//*****************************************************************************
//	Einen erweiterten Device-Context erstellen
//	hDc		: Ist der aktuelle Device-Context
//	Ergibt das Handle des erweiterten Device-Context oder NULL bei einem Fehler.
EXTAPI HDCEX WINAPI GetDcEx(HDC hDc)
{
HDCEX	hDcEx;


	if(iGdiPlusInit<=1)
		{
		return (HDCEX)hDc;
		}

	if(pGdipCreateFromHDC(hDc,&hDcEx))
		{
		return NULL;
		}

	pGdipSetSmoothingMode(hDcEx,4);


return hDcEx;
}

//*****************************************************************************
//*
//*		ReleaseDcEx
//*
//*****************************************************************************
//	Einen erweiterten Device-Context freigeben
//	hDc		: Ist der aktuelle erweiterte Device-Context
//	Ergibt TRUE wenn erfolgreich
EXTAPI BOOL WINAPI ReleaseDcEx(HDCEX hDc)
{


	if(iGdiPlusInit<=1)
		{
		return iGdiPlusInit;
		}

	if(pGdipDeleteGraphics(hDc))
		{
		return FALSE;
		}


return TRUE;
}

//*****************************************************************************
//*
//*		CreatePenEx
//*
//*****************************************************************************
//	Erzeugt einen neuen PEN
//	iWidth		: Breite des Pens
//	uColor		: Farbe des Pens
//	Ergibt das Handle auf den Pen oder NULL bei einem Fehler
EXTAPI HPENEX WINAPI CreatePenEx(int iWidth,COLORREF uColor)
{
COLORREF	uBgr;
HPENEX		hPen;


	if(iGdiPlusInit<=1)
		{
		return (HPENEX)CreatePen(PS_SOLID,iWidth,uColor);
		}

	uBgr  = uColor&0x0000FF00;
	uBgr |= uColor>>16;
	uBgr |=	uColor<<16;
	uBgr |= 0xFF000000;

	if(pGdipCreatePen1(uBgr,(FLOAT)iWidth,2,&hPen))
		{
		return NULL;
		}


return hPen;
}

//*****************************************************************************
//*
//*		DeletePenEx
//*
//*****************************************************************************
//	Lcht einen GDI+ Strift.
//	hPen		: Handle des Stiftes.
//	Ergibt TRUE wenn erfolgreich bzw. FALSE bei einem Fehler.
EXTAPI BOOL WINAPI DeletePenEx(HPENEX hPen)
{


	if(iGdiPlusInit<=1)
		{
		return DeleteObject((HPEN)hPen);
		}

	if(pGdipDeletePen(hPen))
		{
		return FALSE;
		}


return TRUE;
}

//*****************************************************************************
//*
//*		DrawLine
//*
//*****************************************************************************
//	Zeichnet eine Linie vorzglich mit GDI+
//	hDc			: GDI+ oder GDI Device-Context
//	hPen		: Stift mit dem die Linie gezeichnet werden soll
//	iPosX1/Y1	: Startpunkt der Linie
//	iPosX2/Y2	: Endpunkt der Linie
//	Ergibt TRUE wenn die Linie gezeichnet wurde
EXTAPI BOOL WINAPI DrawLine(HDCEX hDc,LPVOID hPen,INT iPosX1,INT iPosY1,INT iPosX2,INT iPosY2)
{
HGDIOBJ		hOld;
BOOL		bOk;

	if(iGdiPlusInit<=1)
		{
		hOld = SelectObject((HDC)hDc,hPen);
		       MoveToEx((HDC)hDc,iPosX1,iPosY1,NULL);
		bOk  = LineTo  ((HDC)hDc,iPosX2,iPosY2);

		SelectObject((HDC)hDc,hOld);

		return bOk;
		}

	if(pGdipDrawLineI(hDc,hPen,iPosX1,iPosY1,iPosX2,iPosY2))
		{
		return FALSE;
		}

return TRUE;
}

//*****************************************************************************
//*
//*		DrawEllipse
//*
//*****************************************************************************
//	Zeichnet eine Ellipse vorzglich mit GDI+
//	hDc			: GDI+ oder GDI Device-Context
//	hPen		: Stift mit dem die Linie gezeichnet werden soll
//	iPosX/Y		: Linke obere Ecke der Ellipse
//	iWidth		: Breite der Ellipse
//	iHeight		: Hhe der Ellipse
//	Ergibt TRUE wenn die Linie gezeichnet wurde
EXTAPI BOOL WINAPI DrawEllipse(HDCEX hDc,LPVOID hPen,INT iPosX,INT iPosY,INT iWidth,INT iHeight)
{
HGDIOBJ		hOld;
BOOL		bOk;

	if(iGdiPlusInit<=1)
		{
		hOld	= SelectObject((HDC)hDc,hPen);
		bOk		= Ellipse((HDC)hDc,iPosX,iPosY,iPosX+iWidth,iPosY+iHeight);

		SelectObject((HDC)hDc,hOld);

		return bOk;
		}

	if(pGdipDrawEllipseI(hDc,hPen,iPosX,iPosY,iWidth,iHeight))
		{
		return FALSE;
		}

return TRUE;
}

//*****************************************************************************
//*
//*		GetProcessFileName
//*
//*****************************************************************************
//	Den Pfad der EXE-Datei eines Prozesses abfragen.
//	uId			: Ist die Prozess ID
//	pFilename	: Zeiger auf Puffer fr den Pfad
//	iSize		: Ist die Gre des Puffers in Zeichen
//	Ergibt die Lnge des gespeicherten Pfades, oder 0 bei einem Fehler.
//	Im Pfad bei pFilename[Lnge+1] wir gespeichert ob es ein 64-Bit-Prozess ist.
EXTAPI DWORD WINAPI GetProcessFileNameA(DWORD uId,LPSTR pFilename,int iSize)
{
typedef BOOL  (_stdcall *QueryFullProcessImageNameType)(HANDLE,DWORD,LPSTR,LPDWORD);
typedef DWORD (_stdcall *GetModuleFileNameExType      )(HANDLE,HMODULE,LPSTR,DWORD);
static QueryFullProcessImageNameType	pProc=0;
static GetModuleFileNameExType			pGetN=0;
static BOOL								bDone=0;
BOOL									b64Bit;
DWORD									dwByte;
HANDLE									hExe;
HMODULE									hDll;
INT										iRet;


	if(iSize<=2)										// Puffergre prfen
		{
		SetLastError(ERROR_INVALID_PARAMETER);
		if(iSize>0)*pFilename=0;
		return 0;
		}

	if(!pProc && !bDone)								// Beim erstenmal die Funktionszeiger laden
		{
		bDone = 1;

		if(!hKernel32)hKernel32=GetModuleHandleW(L"KERNEL32");

														// Exist only on Vista and higher
		pProc = (QueryFullProcessImageNameType)GetProcAddress(hKernel32,"QueryFullProcessImageNameA");

		#ifndef _WIN64

		if(!pIsWow64)
			{
			pIsWow64 = (LPFN_ISWOW64PROCESS)GetProcAddress(hKernel32,"IsWow64Process");
			}

		#endif				

		    hDll = GetModuleHandleW(L"Psapi.dll");
		if(!hDll)
			{
			hDll = LoadLibraryW(L"Psapi.dll");
			}

		if(hDll)
			{											// Exist only on XP and higher
			pGetN = (GetModuleFileNameExType)GetProcAddress(hDll,"GetModuleFileNameExA");
			}
		}


		hExe = OpenProcess(PROCESS_QUERY_LIMITED_INFORMATION,FALSE,uId);
	if(!hExe)
		{
			hExe = OpenProcess(PROCESS_QUERY_INFORMATION,FALSE,uId);
		if(!hExe)
			{
			return 0;
			}
		}

	
	iSize -= 2;
	dwByte = iSize;

	if(pProc && pProc(hExe,0,pFilename,&dwByte))		// Pfad mit "QueryFullProcessImageName" abfragen
		{
		iRet =  dwByte;
		}
	else if(pGetN)										// Pfad mit "GetModuleFileNameEx" abfragen
		{
		iRet =  pGetN(hExe,0,pFilename,dwByte);
		if(iRet<=0)pFilename[0]=0;
		}
	else{
		SetLastError(ERROR_NOT_SUPPORTED);
		pFilename[0] = 0;
		iRet        = 0;
		}

	#ifndef _WIN64
	
	if(!pIsWow64 || !pIsWow64(hExe,&b64Bit))			// Ist es ein 64 Bit-Prozess
		{
		b64Bit = 0;
		}
	
	#else

	b64Bit = 1;

	#endif

	pFilename[iRet+1] = (CHAR)b64Bit;



	CloseHandle(hExe);


return iRet;
}

EXTAPI DWORD WINAPI GetProcessFileNameW(DWORD uId,LPWSTR pFilename,int iSize)
{
typedef BOOL  (_stdcall *QueryFullProcessImageNameType)(HANDLE,DWORD,LPWSTR,LPDWORD);
typedef DWORD (_stdcall *GetModuleFileNameExType      )(HANDLE,HMODULE,LPWSTR,DWORD);
static QueryFullProcessImageNameType	pProc=0;
static GetModuleFileNameExType			pGetN=0;
static BOOL								bDone=0;
BOOL									b64Bit;
DWORD									dwByte;
HANDLE									hExe;
HMODULE									hDll;
INT										iRet;



	if(iSize<=2)										// Puffergre prfen
		{
		SetLastError(ERROR_INVALID_PARAMETER);
		if(iSize>0)*pFilename=0;
		return 0;
		}

	if(!pProc && !bDone)								// Beim erstenmal die Funktionszeiger laden
		{
		bDone = 1;

		if(!hKernel32)hKernel32=GetModuleHandleW(L"KERNEL32");

														// Exist only on Vista and higher
		pProc = (QueryFullProcessImageNameType)GetProcAddress(hKernel32,"QueryFullProcessImageNameW");

		if(!hKernel32)hKernel32=GetModuleHandleW(L"KERNEL32");

		#ifndef _WIN64
		
		if(!pIsWow64)
			{
			pIsWow64 = (LPFN_ISWOW64PROCESS)GetProcAddress(hKernel32,"IsWow64Process");
			}

		#endif 	

		    hDll = GetModuleHandleW(L"Psapi.dll");
		if(!hDll)
			{
			hDll = LoadLibraryW(L"Psapi.dll");
			}

		if(hDll)
			{											// Exist only on XP and higher
			pGetN = (GetModuleFileNameExType)GetProcAddress(hDll,"GetModuleFileNameExW");
			}
		}


		hExe = OpenProcess(PROCESS_QUERY_LIMITED_INFORMATION,FALSE,uId);
	if(!hExe)
		{
			hExe = OpenProcess(PROCESS_QUERY_INFORMATION,FALSE,uId);
		if(!hExe)
			{
			return 0;
			}
		}


	iSize -= 2;
	dwByte = iSize;

	if(pProc && pProc(hExe,0,pFilename,&dwByte))		// Pfad mit "QueryFullProcessImageName" abfragen
		{
		iRet =  dwByte;
		}
	else if(pGetN)										// Pfad mit "GetModuleFileNameEx" abfragen
		{
		iRet =  pGetN(hExe,0,pFilename,dwByte);
		if(iRet<=0)pFilename[0]=0;
		}
	else{
		SetLastError(ERROR_NOT_SUPPORTED);
		pFilename[0] = 0;
		iRet        = 0;
		}


	#ifndef _WIN64
	
	if(!pIsWow64 || !pIsWow64(hExe,&b64Bit))			// Ist es ein 64 Bit-Prozess
		{
		b64Bit = 0;
		}
	
	#else

	b64Bit = 1;

	#endif

	pFilename[iRet+1] = (WCHAR)b64Bit;



	CloseHandle(hExe);


return iRet;
}


//*****************************************************************************
//*
//*		MessageBoxProc
//*
//*****************************************************************************
//	Dialog-Funktion fr MessageBoxIndirectEx
#ifndef		WEX_NO_MESSAGEBOX
static INT_PTR CALLBACK MessageBoxProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
COLORREF		uColor;
DWORD			uFlags;
HWND			hOwner;
HWND			hList;
RECT			sRect;
HELPINFO		sInfo;
CLB_ITEM		sItem;
LPMSGBOXINFO	pBox;
INT				iOff;	
INT				iPos;
INT				iVal;
HDC				hDc;



	switch(uMsg) 
		{
	case WM_INITDIALOG:

		pBox = (LPMSGBOXINFO)lParam;

		if(!GetPropW(hWnd,L"ROS_MSGBOX"))
			{
			SetPropW(hWnd,L"ROS_MSGBOX",(HANDLE)lParam);

			if(pBox->hIcon)
				{
				SendDlgItemMessage(hWnd,MSGBOX_IDICON,STM_SETICON,(WPARAM)pBox->hIcon,0);
				}

			SetWindowContextHelpId(hWnd,(DWORD)pBox->uHelpId);

															// Schrift einstellen
			SendDlgItemMessage(hWnd,MSGBOX_IDTEXT,WM_SETFONT,(WPARAM)pBox->hFont, 0);
			
			for(iPos=0;iPos<pBox->iButtons;iPos++)
				{
				SendDlgItemMessage(hWnd,pBox->pButtons[iPos],WM_SETFONT,(WPARAM)pBox->hFont, 0);
				}


			// ColorListBoxRegister(GetModuleHandle(NULL));	// Muss extern aufgerufen werden

			uFlags = WS_CHILD|WS_VISIBLE|CLBS_NOSCROLLX;
			if(!pBox->bScroll)uFlags|=CLBS_NOSCROLLY|CLBS_FIXEDSCROLL;

			hList = CreateWindowExW(0,L"ColorListBox",L"",uFlags,
							pBox->sRect.left,
							pBox->sRect.top,
							pBox->sRect.right  - pBox->sRect.left,
							pBox->sRect.bottom - pBox->sRect.top,
							hWnd,(HMENU)MSGBOX_IDLIST,NULL,NULL);

			ColorListBox_SetExtendedStyle(hList,CLB_EX_MULITFONT|CLB_EX_MARKMULTI|CLB_EX_SELWORDDBL);
			sItem.uStateMask	= 0xFFFF0000;

			if(pBox->iTabs)									// Tabulatorabstant einstellen
				{
				ColorListBox_SetTabStops(hList,1,&pBox->iTabs);
				}


			for(iPos=0;iPos<pBox->iLines;iPos++)
				{
				iOff				= pBox->pSizes[iPos*2];
				sItem.uMask			= CLBF_TEXT|CLBF_COLOR;
				sItem.iTextMax		= pBox->pSizes[iPos*2+1];
				sItem.pColor		= pBox->pColors+iOff;
				sItem.pText			= pBox->pText  +iOff;
				sItem.iItem			= iPos;

				if(HIWORD(sItem.iTextMax))					// Spezielle Ausrichtung
					{
					iVal			= pBox->wWitdh-HIWORD(sItem.iTextMax);	
					sItem.iTextMax  = LOWORD(sItem.iTextMax);

					if(sItem.pColor[sItem.iTextMax]==0x9F)
						{
						iVal		= iVal/2;
						}
					
					sItem.uMask	   |= CLBF_IDENT;
					sItem.uState	= iVal<<16;
					}
				
				ColorListBox_InsertItem(hList,&sItem,CLBF_FAST);
				}
															// Den Dialog verschieben
			if(pBox->sPoint.x!=NOPOS && pBox->sPoint.y!=NOPOS)
				{
				GetWindowRect(hWnd,&sRect);
				
				iVal				  = sRect.right-sRect.left;
				sRect.left			  = pBox->sPoint.x-iVal/2;
				pBox->sScreen.right  -= 8+iVal;
				pBox->sScreen.left   += 8;

				iVal				  = sRect.bottom-sRect.top;
				sRect.top			  = pBox->sPoint.y-iVal/2;
				pBox->sScreen.bottom -= 8+iVal;
				pBox->sScreen.top    += 8;

				if(sRect.left<pBox->sScreen.left  )sRect.left=pBox->sScreen.left;
				if(sRect.left>pBox->sScreen.right )sRect.left=pBox->sScreen.right;
				if(sRect.top >pBox->sScreen.bottom)sRect.top =pBox->sScreen.bottom;
				if(sRect.top <pBox->sScreen.top   )sRect.top =pBox->sScreen.top;
				
				SetWindowPos(hWnd,NULL,sRect.left,sRect.top,0,0,SWP_NOSIZE|SWP_NOZORDER);
				}

			pBox->sPoint.x	= NOPOS;
			pBox->sPoint.y	= NOPOS;


			switch(pBox->uStyle&MB_TYPEMASK)				// Keine 'Abbruch' Taste
				{
			case MB_ABORTRETRYIGNORE:
			case MB_YESNO:

				RemoveMenu(GetSystemMenu(hWnd,FALSE),SC_CLOSE,MF_BYCOMMAND);
				break;
				}

			SetFocus(GetDlgItem(hWnd,pBox->uDefBtn));		
															
			if(pBox->uTimeout && pBox->uTimeout!=INFINITE)	// Den Dialog nach einer gewissen Zeit schlieen
				{
				SetTimer(hWnd,0,pBox->uTimeout,NULL);
				}
			}

		return 0;

	case WM_COMMAND:										// Wurde eine Taste gedrckt

		switch(LOWORD(wParam))
			{
		case IDTRYAGAIN:
		case IDCONTINUE:
		case IDALWAYS:
		case IDCANCEL:
		case IDIGNORE:
		case IDABORT:
		case IDRETRY:
		case IDNEVER:
		case IDYES:
		case IDNO:
		case IDOK:

			   pBox = (LPMSGBOXINFO)GetPropW(hWnd,L"ROS_MSGBOX");
			if(pBox)
				{
				GetWindowRect(hWnd,&sRect);		
				pBox->sPoint.x	= (sRect.left+sRect.right )/2;
				pBox->sPoint.y	= (sRect.top +sRect.bottom)/2;
				}

			EndDialog(hWnd,wParam);
			
			return 0;

		case IDHELP:										// Ein Hilfe-Fenster anzeigen
			
			sInfo.cbSize		=  sizeof(HELPINFO);
			sInfo.iContextType	=  HELPINFO_WINDOW;
			sInfo.iCtrlId		=  LOWORD(wParam);
			sInfo.hItemHandle	= (HANDLE)lParam;
			sInfo.dwContextId	=  0;
			
			GetCursorPos(&sInfo.MousePos);
			SendMessage(hWnd,WM_HELP,0,(LPARAM)&sInfo);
			
			return 0;
			}

		return 0;

	case WM_HELP:											// Eine Hilfe anzeigen

			pBox = (LPMSGBOXINFO)GetPropW(hWnd,L"ROS_MSGBOX");
		if(!pBox)
			{
			return 0;
			}

		memcpy(&sInfo,(LPVOID)lParam,sizeof(sInfo));
		sInfo.dwContextId = GetWindowContextHelpId(hWnd);

		if(pBox->pCallback)
			{
			pBox->pCallback(&sInfo);
			}
		else{
			   hOwner = GetWindow(hWnd,GW_OWNER);
			if(hOwner)
				{
				SendMessage(GetWindow(hWnd,GW_OWNER),WM_HELP,0,(LPARAM)&sInfo);
				}
			}

		return 0;

	case WM_CLOSE:											// Der Dialog wird geschlossen

			pBox = (LPMSGBOXINFO)GetPropW(hWnd,L"ROS_MSGBOX");
		if(!pBox)
			{
			return 0;
			}

		GetWindowRect(hWnd,&sRect);		
		pBox->sPoint.x	= (sRect.left+sRect.right )/2;
		pBox->sPoint.y	= (sRect.top +sRect.bottom)/2;

		switch(pBox->uStyle&MB_TYPEMASK)
			{
		case MB_ABORTRETRYIGNORE:
		case MB_YESNO:

			return 1;
			}


		EndDialog(hWnd,IDCANCEL);
		
		return 1;

	case WM_TIMER:											// Dialog nach einer gewissen Zeit schliesen

		if(wParam==0)
			{
			EndDialog(hWnd,IDTIMEOUT);
			}

		return 0;

	case WM_CTLCOLORSTATIC:									// Hindergrund Farbe fr Icon und Textfeld

		hDc		= (HDC)wParam;
		uColor	= GetSysColor(COLOR_WINDOW);
		
		SetBkColor(hDc,uColor);
		
		return (LRESULT)GetSysColorBrush(COLOR_WINDOW);
		}


return 0;
}

#else

static INT_PTR CALLBACK MessageBoxProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
return 0;
}

#endif 	

//*****************************************************************************
//*
//*
//*		MessageBoxIndirectEx
//*
//*
//*****************************************************************************
//	ffnet eine spezille MessageBox mit Farben und verschiedenen Schriften
//	Ohne Farbangabe knnen die Farben mit speziellen Texten angegeben werden:
//					\b	 = Fette Schrift
//					\b\n = Zeile rechst ausrichten
//					\f	 = Schrift mit fixer Breite
//					\f\n = Zeile mittig ausrichten
//					\v	 = Unterstreichen
//					\a	 = Zurck auf normale Schrift
//					\n	 = Neue Zeile und normale Schrift
//					\r	 = Neue Zeile und normale Schrift
//					\1	 = Farbe auf 4  (schwarz)		(folgt \a ist es die Begrenzung)
//					\2	 = Farbe auf 5  (dunkel blau)
//					\3	 = Farbe auf 6  (grn)
//					\4	 = Farbe auf 7  (trkis)
//					\5	 = Farbe auf 8  (rot)
//					\6	 = Farbe auf 9  (lila)
//					\16	 = Farbe auf 10 (dunkel gelb)
//					\17	 = Farbe auf 11 (grau)
//					\20	 = Farbe auf 12 (hell grau)
//					\21	 = Farbe auf 12 (blau)
//					....
//					\35	 = Farbe auf 25
//	pParams		: Zeiger auf die Parameter fr die Messagebox
//	pColPtr		: Zeiger auf die Farben, bei NULL werden sie aus dem Text geholt.
//	uTimeout	: Zeit in Millisekunden nach dem die MessageBox geschlossen wird.
//				  Bei 0 und INFINITE wird die MessageBox nicht automatisch geschlossen.
//	Ergibt die ID der gedrckten Taste, oder IDTIMEOUT bei einem automatischen Abbruch.
EXTAPI INT WINAPI MessageBoxIndirectExA(CONST MSGBOXPARAMSA *pParams,CONST BYTE *pColPtr,UINT uTimeout)
{


	if(!(pParams->dwStyle&(MB_USEWIDE|MB_USEANSI)))
		{
		if(uTimeout==INFINITE)
			{
			uTimeout = 0x65000000;
			}
		else if(uTimeout>=0x65000000)
			{
			uTimeout = 0x65FFFFFF;
			}
		else{
			uTimeout |= 0x65000000;
			}
		}


return MessageBoxIndirectExW((LPMSGBOXPARAMSW)pParams,pColPtr,uTimeout);
}

EXTAPI INT WINAPI MessageBoxIndirectExW(CONST MSGBOXPARAMSW *pParams,CONST BYTE *pColPtr,UINT uTimeout)
{
static POINT		sLastPt={NOPOS,NOPOS};
WCHAR				aBtnText[MSGBOXEX_MAXBTNS][MSGBOXEX_MAXBTNSTR];
LPDLGITEMTEMPLATE	aBtnPt  [MSGBOXEX_MAXBTNS];
WORD				aBtnIds [MSGBOXEX_MAXBTNS];
WCHAR				cCapBuf [MSGBOXEX_CAPTION];
HFONT				aFonts  [4];
LPDLGTEMPLATE		pTemplate;
LPWSTR				pBtnText;
LPCWSTR				pTxtTemp;
LPCWSTR				pCaption;
MONITORINFO			sMonInfo;
NONCLIENTMETRICSW	sMetrics;
LPDLGITEMTEMPLATE	pIcoPt;
LPDLGITEMTEMPLATE	pTxtPt;
LPDWORD				pSizes;
LPDWORD				pTemp;
LPTSTR				pText;
LPBYTE				pDest;
LPBYTE				pBuffer;
LPBYTE				pColors;
RECT				sRect;
SIZE				sSize;
BYTE				bLast;
UINT				uId;
HDC					hDC;
HFONT				hFont;
HICON				hIcon;
UTCHAR				uSign;
MSGBOXINFO			sInfo;
HWND				hOwner;
DWORD				uUnitsX;
DWORD				uUnitsY;
DWORD				dwStyle;
HMONITOR			hMonitor;
INT					iDefault;
INT					iMaxLines;
INT					iButtons;
INT					iBtnLeft;
INT					iBtnTop;
INT					iBtnLen;
INT					iTxtLen;
INT					iCapLen;
INT					iLines;
INT					iDelta;
INT					iHeigh;
INT					iWidth;
INT					iSize;
INT					iStep;
INT					iBeep;
INT					iLen;
INT					iPos;
INT					iAdd;
INT					iIdx;
INT					iOff;
INT					iRet;


	
	iButtons	   = 0;
	uUnitsX		   = GetDialogBaseUnits();
	uUnitsY		   = HIWORD(uUnitsX);
	uUnitsX		   = LOWORD(uUnitsX);
	dwStyle		   = pParams->dwStyle&~(MB_ALWAYS|MB_NEVER|MB_NOBEEP);
	iDefault	   = (dwStyle&MB_DEFMASK)>>8;	
	sInfo.iTabs	   = (dwStyle>>22);
	sInfo.bScroll  = FALSE;


	if(dwStyle&MB_SETPOS)									// Fensterposition in dwLanguageId
		{
		sInfo.sPoint.x = GET_X_LPARAM(pParams->dwLanguageId);
		sInfo.sPoint.y = GET_Y_LPARAM(pParams->dwLanguageId);
		}
	else{
		sInfo.sPoint.x = sLastPt.x;
		sInfo.sPoint.y = sLastPt.y;
		}

	
	if(!hUser32)
		{
		hUser32 = (HINSTANCE)GetModuleHandleW(L"USER32");
		}

	if((uTimeout&0xFF000000)==0x65000000)					// Aufruf von Ansi-Funktion
		{
		dwStyle  |= MB_USEANSI;
		uTimeout &= 0x00FFFFFF;
		}

	pCaption = pParams->lpszCaption;
															
	if((DWORD_PTR)pCaption<=0xFFFF)							// Die berschrift laden
		{
			uId = LOWORD(pCaption);
		if(!uId)
			{
			iCapLen = LoadStringW(hUser32,IDS_ERROR,cCapBuf,MSGBOXEX_CAPTION)+1;
			}
		else{
			iCapLen = LoadStringW(pParams->hInstance,uId,cCapBuf,MSGBOXEX_CAPTION)+1;
			}

		pCaption = cCapBuf;
		}
	else if(dwStyle&MB_USEANSI)								// Ist es ein Bytestring
		{
		iCapLen  = MultiByteToWideChar(CP_ACP,0,(LPCSTR)pCaption,-1,cCapBuf,MSGBOXEX_CAPTION)+1;
		pCaption = cCapBuf;
		}
	else{													// Unicode-String
		iCapLen	 = (int)wcslen(pCaption)+1;
		}


	pText = (LPTSTR)pParams->lpszText;

	if((DWORD_PTR)pText<=0xFFFF)							// Den Text laden
		{
			uId = LOWORD(pText);
		if(!uId)
			{
			iTxtLen = 0;
			}
		else{
			iTxtLen = LoadStringW(pParams->hInstance,uId,aBtnText[0],0);
			}
		}
	else if(dwStyle&MB_USEANSI)								// Ist es ein Bytestring
		{
		iTxtLen = (int)strlen((LPCSTR)pText);
		}
	else{													// Unicode-String
		iTxtLen = (int)wcslen((LPWSTR)pText);
		}

	
	

	switch(dwStyle&MB_TYPEMASK)								// Tasten erstellen
		{
	case MB_OKCANCEL:

		aBtnIds[0]	= IDOK;
		aBtnIds[1]	= IDCANCEL;
		iButtons	= 2;
		break;

	case MB_CANCELTRYCONTINUE:

		aBtnIds[0]	= IDCANCEL;
		aBtnIds[1]	= IDTRYAGAIN;
		aBtnIds[2]	= IDCONTINUE;
		iButtons	= 3;
		break;

	case MB_ABORTRETRYIGNORE:

		aBtnIds[0]	= IDABORT;
		aBtnIds[1]	= IDRETRY;
		aBtnIds[2]	= IDIGNORE;
		iButtons	= 3;
		break;

	case MB_YESNO:

		aBtnIds[0]	= IDYES;
		aBtnIds[1]	= IDNO;
		iButtons	= 2;
		break;

	case MB_YESNOCANCEL:

		aBtnIds[0]	= IDYES;
		aBtnIds[1]	= IDNO;
		aBtnIds[2]	= IDCANCEL;
		iButtons	= 3;
		break;

	case MB_RETRYCANCEL:

		aBtnIds[0]	= IDRETRY;
		aBtnIds[1]	= IDCANCEL;
		iButtons	= 2;
		break;

	case MB_OK:
	default:

		aBtnIds[0]	= IDOK;
		iButtons	= 1;
		break;
		}
	
	if(pParams->dwStyle&MB_ALWAYS)							// Taste "Immer" hinzufgen
		{
		if(aBtnIds[iButtons-1]==IDCANCEL)
			{
			aBtnIds[iButtons-1] = IDALWAYS;
			aBtnIds[iButtons  ] = IDCANCEL;
			}
		else{
			aBtnIds[iButtons  ] = IDALWAYS;
			}

		iButtons++;
		}

	if(pParams->dwStyle&MB_NEVER)							// Taste "Niemals" hinzufgen
		{
		if(aBtnIds[iButtons-1]==IDCANCEL)
			{
			aBtnIds[iButtons-1] = IDNEVER;
			aBtnIds[iButtons  ] = IDCANCEL;
			}
		else{
			aBtnIds[iButtons  ] = IDNEVER;
			}

		iButtons++;
		}

	if(dwStyle&MB_HELP)										// Hilfe-Taste einfgen 
		{
		aBtnIds[iButtons] = IDHELP;
		iButtons++;
		}

	switch(dwStyle&MB_ICONMASK)
		{
	case MB_ICONEXCLAMATION:	hIcon=LoadIconW(0,IDI_EXCLAMATIONW);	iBeep=MB_ICONEXCLAMATION;	break;
	case MB_ICONQUESTION:		hIcon=LoadIconW(0,IDI_QUESTIONW   );	iBeep=MB_ICONQUESTION   ;	break;
	case MB_ICONASTERISK:		hIcon=LoadIconW(0,IDI_ASTERISKW   );	iBeep=MB_ICONASTERISK   ;	break;
	case MB_ICONHAND:			hIcon=LoadIconW(0,IDI_HANDW       );	iBeep=MB_ICONHAND       ;	break;
	case MB_USERICON:			
	
		hIcon = LoadIconW(pParams->hInstance,pParams->lpszIcon);	
		iBeep = MB_OK;
		break;

	default:												// Kein Icon

		hIcon = NULL;
		iBeep = -1;
		break;
		}
		   
	if(iBeep>0 && !(pParams->dwStyle&MB_NOBEEP))			// Einen Ton ausgeben
		{
		MessageBeep(iBeep);
		}


//******************** Gre vom Template berechnen ***************************

															
	iSize	= sizeof(DLGTEMPLATE);							// Speichergre fr Dialog
	iSize  += (2+iCapLen)*sizeof(WORD);					

	if(hIcon)												// Speichergre fr Icon
		{
		iSize  += (-iSize)&3;
		iSize  += sizeof(DLGITEMTEMPLATE);
		iSize  += 5*sizeof(WORD);
		}

	iSize  += (-iSize)&3;									// Speichergre fr Text
	iSize  += sizeof(DLGITEMTEMPLATE);
	iSize  += (4)*sizeof(WORD);


	for(iPos=0;iPos<iButtons;iPos++)						// Texte fr die Tasten laden
		{
		pBtnText = aBtnText[iPos];

		switch(aBtnIds[iPos])
			{
		case IDOK:			iLen=LoadStringW(hUser32,IDS_OK      ,pBtnText,MSGBOXEX_MAXBTNSTR);	break;
		case IDNO:			iLen=LoadStringW(hUser32,IDS_NO      ,pBtnText,MSGBOXEX_MAXBTNSTR);	break;
		case IDYES:			iLen=LoadStringW(hUser32,IDS_YES     ,pBtnText,MSGBOXEX_MAXBTNSTR);	break;
		case IDCANCEL:		iLen=LoadStringW(hUser32,IDS_CANCEL  ,pBtnText,MSGBOXEX_MAXBTNSTR);	break;
		case IDIGNORE:		iLen=LoadStringW(hUser32,IDS_IGNORE  ,pBtnText,MSGBOXEX_MAXBTNSTR);	break;
		case IDTRYAGAIN:	iLen=LoadStringW(hUser32,IDS_TRYAGAIN,pBtnText,MSGBOXEX_MAXBTNSTR);	break;
		case IDCONTINUE:	iLen=LoadStringW(hUser32,IDS_CONTINUE,pBtnText,MSGBOXEX_MAXBTNSTR);	break;
		case IDABORT:		iLen=LoadStringW(hUser32,IDS_ABORT   ,pBtnText,MSGBOXEX_MAXBTNSTR);	break;
		case IDRETRY:		iLen=LoadStringW(hUser32,IDS_RETRY   ,pBtnText,MSGBOXEX_MAXBTNSTR);	break;
		case IDHELP:		iLen=LoadStringW(hUser32,IDS_HELP    ,pBtnText,MSGBOXEX_MAXBTNSTR);	break;

		case IDALWAYS:		pTxtTemp = LoadDefaultStringsW(pParams->hInstance,IDS_TEXT_ALWAYS);
							wcscpy(pBtnText,pTxtTemp);
							iLen = (int)wcslen(pBtnText);
							break;

		case IDNEVER:		pTxtTemp = LoadDefaultStringsW(pParams->hInstance,IDS_TEXT_NEVER);
							wcscpy(pBtnText,pTxtTemp);
							iLen = (int)wcslen(pBtnText);
							break;

		default:			pBtnText[0] = 0;				// Unbekannte Taste
							iLen        = 0;
							break;
			}

		iSize  += (-iSize)&3;								// Speichergre fr Tasten
		iSize  += sizeof(DLGITEMTEMPLATE);
		iSize  += (3+iLen+1)*sizeof(WORD);
		}

	
	iLen	= (iTxtLen+1)*sizeof(TCHAR);
	
	
	if(pColPtr)												// Wurden Farben bergeben
		{
		pColors	= (LPBYTE)pColPtr;
		}
	else{
		pColors = NULL;
		iLen   += iTxtLen+1;
		}
		
	

		pBuffer = (LPBYTE)HeapAlloc(GetProcessHeap(),0,iSize+iLen+MSGBOX_MAXLINES*2*sizeof(DWORD));
	if(!pBuffer)
		{
		return 0;
		}

	
	pSizes		= (LPDWORD)(pBuffer+iSize);					// Zeiger auf Textdaten holen
	iMaxLines	= MSGBOX_MAXLINES;
	iSize	   += MSGBOX_MAXLINES*2*sizeof(DWORD);	
	iLines		= 0;

	
	if((DWORD_PTR)pText<=0xFFFF)							// Den Text laden
		{
		uId		= LOWORD(pText);
		pText	= (LPTSTR)(pBuffer+iSize);

		if(!uId)
			{
			pText[0] = 0;
			}
		else{
			iTxtLen = LoadString(pParams->hInstance,uId,pText,iTxtLen+1);
			}
		}
	else if(dwStyle&MB_USEANSI)								// Ist es ein Bytestring
		{
		if(sizeof(TCHAR)==1)
			{
			memcpy(pBuffer+iSize,pText,iTxtLen+1);
			}
		else{
			iTxtLen  = WideCharToMultiByte(CP_ACP,0,(LPWSTR)pText,iTxtLen+1,(LPSTR)(pBuffer+iSize),iTxtLen+1,NULL,NULL);
			}

		pText = (LPTSTR)(pBuffer+iSize);
		}
	else{													// Unicode-String
		if(sizeof(TCHAR)==1)
			{
			iTxtLen = MultiByteToWideChar(CP_ACP,0,(LPCSTR)pText,iTxtLen+1,(LPWSTR)(pBuffer+iSize),iTxtLen+1);
			}
		else{
			memcpy(pBuffer+iSize,pText,(iTxtLen+1)*sizeof(TCHAR));
			}
		
		pText = (LPTSTR)(pBuffer+iSize);
		}


//******************** Farben zum Text holen **********************************
	

	if(!pColors)											// Die Farben aus dem Text holen
		{
		pColors	= pBuffer+iSize+(iTxtLen+1)*sizeof(TCHAR);
		bLast	= 0;
		
		for(iPos=0,iLen=0;iPos<iTxtLen;iPos++)
			{
			uSign = pText[iPos];

			if(uSign>=' ')									// Kein spezial Zeichen
				{
				pColors[iLen] = bLast;
				pText  [iLen] = uSign;
				iLen++;
				continue;
				}

			switch(uSign)
				{
			case '\a':										// Zurck zur normal Farbe
			
				bLast  = 0x00;
				continue;

			case '\b':										// Fette Schrift

				if(pText[iPos+1]=='\n')
					{
					pColors[iLen] = 0x5F;					// Rechts ausrichten
					pText  [iLen] = '\n';
					bLast		  = 0x00;
					iLen++;
					continue;
					}
				
				bLast |= 0x40;
				
				continue;

			case '\f':										// Fixe Breite

				if(pText[iPos+1]=='\n')
					{
					pColors[iLen] = 0x9F;					// Mittig ausrichten
					pText  [iLen] = '\n';
					bLast		  = 0x00;
					iLen++;
					continue;
					}
				
				bLast |= 0x40;
				
				continue;

			case '\v':										// Unterstreichen

				bLast |= 0x40;
				continue;
			
			case '\t':										// Tabulator

				pColors[iLen] = bLast;
				pText  [iLen] = uSign;
				iLen++;
				continue;
			
			case '\r':										// Carriage-Return

				if(pText[iPos+1]=='\n')iPos++;

			case '\n':										// Neue Zeile

				pColors[iLen] = bLast;
				pText  [iLen] = '\n';
				bLast		  = 0x00;
				iLen++;
				continue;
				}

			if(pText[iPos+1]=='\a')iPos++; 

			bLast &= 0xE0;
			
			if(uSign<7)										// Andere Farbe einstellen
					bLast |= uSign+4-1;
			else	bLast |= uSign+4-8;
			}

		iTxtLen		  = iLen;	
		pColors[iLen] = bLast;
		pText  [iLen] = 0;
		}


//******************** Zeilenbreiten berechnen ********************************


	hOwner			= (pParams->hwndOwner)? pParams->hwndOwner:GetActiveWindow();
	hDC				= CreateCompatibleDC(0);
	hMonitor		= MonitorFromWindow(hOwner,MONITOR_DEFAULTTONEAREST);
	sMonInfo.cbSize	= sizeof(sMonInfo);

	if(!hMonitor || !GetMonitorInfo(hMonitor,&sMonInfo))
		{
		sInfo.sScreen.top		= 0;
		sInfo.sScreen.left		= 0;
		sInfo.sScreen.right		= GetSystemMetrics(SM_CXSCREEN);
		sInfo.sScreen.bottom	= GetSystemMetrics(SM_CYSCREEN)-32;
		}
	else{
		sInfo.sScreen			= sMonInfo.rcWork;
		}


	for(iPos=0;iPos<4;iPos++)								// Array mit Standartschriften erstellen
		{
		aFonts[iPos] = GetDefaultFont(iPos);
		}
	
	iHeigh	= sInfo.sScreen.bottom;
	iHeigh -= sInfo.sScreen.top;
	iDelta	= sInfo.sScreen.right;
	iDelta -= sInfo.sScreen.left;
	iDelta	= (iDelta*3)/5; if(iDelta>iHeigh)iDelta=iHeigh;
	iWidth	= 0;
	
	for(iPos=0;iPos<iTxtLen;)								// Zeilen abschreiten
		{
		uSign = pText[iPos];
		iLen  =	iPos+iDelta/4+40;

		if(iLen>iTxtLen)iLen=iTxtLen;

		for(iOff=iPos;iOff<iLen;iOff++)						// Suche Zeilenende
			{
			if(pText[iOff]>=' ' )continue;
			if(pText[iOff]=='\n')break;
			if(pText[iOff]=='\r')break;
			}
		
		iLen	= iOff-iPos;
		iSize	= GetTabbedSizeEx(hDC,0,pText+iPos,pColors+iPos,iLen,(sInfo.iTabs)? 1:0,&sInfo.iTabs,0,aFonts);
		iIdx	= iOff;
		iAdd	= 0;	
		
		while(iSize>iDelta)									// Ist der Text zu breit
			{
			for(iOff--;iOff>iPos;iOff--)
				{
				if(pText[iOff]==' '   )break;
				if(pText[iOff]=='\t'  )break;
				if(pText[iOff]=='\xA0')break;
				}

			for(iAdd=1;iOff>iPos;iOff--,iAdd++)				// Gre vom Leerraum bestimmen
				{
				if(pText[iOff-1]!=' '   )
				if(pText[iOff-1]!='\t'  )
				if(pText[iOff-1]!='\xA0')break;
				}

			if(iOff>iPos)									// Wurde ein Leerraum gefunden
				{
				iLen	= iOff-iPos;
				iSize	= GetTabbedSizeEx(hDC,0,pText+iPos,pColors+iPos,iLen,(sInfo.iTabs)? 1:0,&sInfo.iTabs,0,aFonts);
				continue;
				}

			
			while(iLen>32)									// Wir sind auf einem langen Wort
				{
				iLen   -= 10;
				iSize	= GetTabbedSizeEx(hDC,0,pText+iPos,pColors+iPos,iLen,(sInfo.iTabs)? 1:0,&sInfo.iTabs,0,aFonts);

				if(iSize<iDelta)break;
				}

			sInfo.bScroll = TRUE;
			
			iOff = iPos+iLen;
			iAdd = 0;
			break;
			}

		
		if(iWidth<iSize)									// Neue maximale Breite
			{
			iWidth = iSize;
			}


		bLast = pColors[iOff];
		
		if(bLast==0x9F || bLast==0x5F)						// Spezille Ausrichtung
			{
			iLen |= iSize<<16;	
			}	
		
		if(iLines>=iMaxLines)								// Den Zeilenspeicher vergrern	
			{
			iSize = iMaxLines+MSGBOX_MAXLINES;

				pTemp = (LPDWORD)HeapAlloc(GetProcessHeap(),0,iSize*2*sizeof(DWORD));
			if(!pTemp){iRet=0;goto Exit;}

			memcpy(pTemp,pSizes,iLines*2*sizeof(DWORD));

			iMaxLines = iSize;
			pSizes    = pTemp;
			}

		
		pSizes[iLines*2  ]	= iPos;							// Zeilendaten speichern
		pSizes[iLines*2+1]	= iLen;
		iPos			    = iOff;
		iPos			   += iAdd;
		iLines			   += 1; 

		if(pText[iPos]=='\r')iPos++;
		if(pText[iPos]=='\n')iPos++;
		}


	if(iWidth>iDelta)iWidth=iDelta;

	sInfo.wWitdh		= iWidth;
	iSize				= (iHeigh*4)/5-MSGBOX_BUTTON_CY-MSGBOXEX_MARGINY*4;

	GetDefaultSize(NULL,&iHeigh);							// Hhe der Zeile holen

	iHeigh			    = iHeigh*iLines+8;
	iDelta				= sInfo.sScreen.bottom;
	iDelta			   -= sInfo.sScreen.top;
	iAdd				= GetSystemMetrics(SM_CXHSCROLL);
	iOff				= (MSGBOXEX_MARGINY*8)/uUnitsY;

	if(iHeigh>iSize)										// Ist der Text zu hoch
		{
		sInfo.bScroll	= TRUE;
		iHeigh			= iSize;
		}

	sInfo.sRect.top		= 0;
	sInfo.sRect.left	= 0;
	sInfo.sRect.right	= iWidth+8;
	sInfo.sRect.right  += iAdd;
	sInfo.sRect.bottom	= iHeigh;

	if(iWidth<MSGBOXEX_MINWIDTH)							// Text nicht breit genug
		{
		sInfo.sRect.left	= (MSGBOXEX_MINWIDTH-iWidth)/2;
		sInfo.sRect.right	=  MSGBOXEX_MINWIDTH;
		}

	if(iHeigh<MSGBOXEX_MINHEIGH)							// Text nicht hoch genug
		{
		sInfo.sRect.top		= (MSGBOXEX_MINHEIGH-iHeigh)/2;
		sInfo.sRect.bottom	=  MSGBOXEX_MINHEIGH;
		}


//******************** Template erstellen *************************************


	pIcoPt   = NULL;
	pTxtPt   = NULL;

	sMetrics.cbSize				= sizeof(sMetrics);			// Schrift erstellen
	SystemParametersInfoW(SPI_GETNONCLIENTMETRICS,sizeof(sMetrics),&sMetrics,0);
	hFont						= CreateFontIndirectW(&sMetrics.lfMessageFont);

	pTemplate					= (DLGTEMPLATE*)pBuffer;
	pTemplate->style			= WS_CAPTION|WS_POPUP|WS_VISIBLE|WS_CLIPSIBLINGS|WS_SYSMENU|DS_CENTER|DS_MODALFRAME|DS_NOIDLEMSG;
	pTemplate->dwExtendedStyle	= WS_EX_DLGMODALFRAME|WS_EX_WINDOWEDGE|WS_EX_CONTROLPARENT;
	
	if(dwStyle&MB_TOPMOST)
		{
		pTemplate->dwExtendedStyle |= WS_EX_TOPMOST;
		}

	if(dwStyle&MB_RIGHT)
		{
		pTemplate->dwExtendedStyle |= WS_EX_RIGHT;
		}

	pTemplate->x				= 100;						// Dialog erstellen
	pTemplate->y				= 100;
	pTemplate->cdit				= iButtons+((hIcon)? 2:1);
	pDest						= (BYTE *)(pTemplate + 1);
	*(LPDWORD)pDest				= 0x0000;					// Kein Men + Standart-Fenster-Klasse
	pDest					   += 2*sizeof(WORD);
	
	memcpy(pDest,pCaption,iCapLen*sizeof(WCHAR));
	pDest   			       += iCapLen*sizeof(WCHAR);
	pDest   			       += (-(INT)pDest)&3;

	pTxtPt  					= (LPDLGITEMTEMPLATE)pDest;
	pTxtPt->style				=  WS_CHILD|WS_VISIBLE|WS_CLIPSIBLINGS|SS_NOPREFIX;
	

	pTxtPt->dwExtendedStyle		= 0;
	pTxtPt->id					= MSGBOX_IDTEXT;
	pDest					   += sizeof(DLGITEMTEMPLATE);
	*(LPWORD)pDest				= 0xFFFF;
	pDest					   += sizeof(WORD);
	*(LPWORD)pDest				= 0x0082;					// Static-Control 
	pDest					   += sizeof(WORD);
	*(LPWORD)pDest				= 0x0000;					// Keinen Text einfgen		
	pDest					   += sizeof(WORD);				
	*(LPWORD)pDest				= 0x0000;
	pDest					   += sizeof(WORD);
	pDest					   += (-(INT)pDest)&3;

	if(hIcon)												// Icon erzeugen
		{
		pIcoPt					= (LPDLGITEMTEMPLATE)pDest;
		pIcoPt->style 			= WS_CHILD|WS_VISIBLE|SS_ICON;
		pIcoPt->id				= MSGBOX_IDICON;
		pIcoPt->dwExtendedStyle = 0;
		
		pDest				   +=  sizeof(DLGITEMTEMPLATE);
		*(LPWORD)pDest			= 0xFFFF;
		pDest				   += sizeof(WORD);
		*(LPWORD)pDest			= 0x0082;					// Static-Control 
		pDest				   += sizeof(WORD);
		*(LPWORD)pDest			= 0xFFFF;
		pDest				   += sizeof(WORD);
		*(LPWORD)pDest			= 0x0000;
		pDest				   += sizeof(WCHAR);
		*(LPWORD)pDest			= 0x0000;
		pDest				   += sizeof(WORD);
		}


//******************** Positionen der Controls berechnen **********************


	sSize.cx					= MSGBOX_BUTTON_CX;
	sSize.cy					= MSGBOX_BUTTON_CY;
	sRect.left					= 0;
	sRect.top					= 0;

	SelectObject(hDC,hFont);
	
	
	for(iPos=0;iPos<iButtons;iPos++)						// Tasten erzeugen
		{
		aBtnPt[iPos] 			= (LPDLGITEMTEMPLATE)pDest;
		aBtnPt[iPos]->style		=  WS_CHILD|WS_VISIBLE|WS_TABSTOP;
		
		if(iPos==iDefault)
			{
			aBtnPt[iPos]->style|= BS_DEFPUSHBUTTON;
			sInfo.uDefBtn		= aBtnIds[iPos];
			}
		else{
			aBtnPt[iPos]->style|= BS_PUSHBUTTON;
			}

		aBtnPt[iPos]->dwExtendedStyle = 0;
		aBtnPt[iPos]->id 		= (WORD)aBtnIds[iPos];
		pDest				   +=  sizeof(DLGITEMTEMPLATE);
		*(LPWORD)pDest			= 0xFFFF;
		pDest				   += sizeof(WORD);
		*(LPWORD)pDest			= 0x0080;					// Button-Control 
		pDest				   += sizeof(WORD);
		iBtnLen					= (int)wcslen(aBtnText[iPos])+1;
		
		memcpy(pDest,aBtnText[iPos],iBtnLen*sizeof(WCHAR));
		pDest				   +=   iBtnLen*sizeof(WCHAR);
		*(LPWORD)pDest			= 0x0000;
		pDest				   += sizeof(WORD);
		pDest			       += (-(INT)pDest)&3;

		DrawTextW(hDC,aBtnText[iPos],iBtnLen-1,&sRect,DT_LEFT|DT_SINGLELINE|DT_CALCRECT);

		sRect.right  		   += MSGBOX_BUTTON_AX;
		sRect.bottom		   += MSGBOX_BUTTON_AY;
		sSize.cx				= max(sSize.cx,sRect.right );
		sSize.cy				= max(sSize.cy,sRect.bottom);
		}

	
	if(pIcoPt)
		{													// Ist ein Icon vorhanden
		sRect.left	  = iAdd;	
		sRect.top     = MSGBOXEX_MARGINY*2;
		sRect.right	  = GetSystemMetrics(SM_CXICON);
		sRect.bottom  = GetSystemMetrics(SM_CYICON);
		sRect.right	 += sRect.left;
		sRect.bottom += sRect.top;

		pIcoPt->x 	  = (short)((sRect.left  *4)/uUnitsX);
		pIcoPt->y 	  = (short)((sRect.top   *8)/uUnitsY);
		pIcoPt->cx	  = (short)((sRect.right *4)/uUnitsX);
		pIcoPt->cy	  = (short)((sRect.bottom*8)/uUnitsY);
		
		sRect.right	 += MSGBOXEX_SPACING;
		sRect.bottom += MSGBOXEX_SPACING;
		sRect.bottom += MSGBOXEX_MARGINY;

		sInfo.sRect.top	   += MSGBOXEX_SPACING;					
		sInfo.sRect.bottom += MSGBOXEX_SPACING;
		sInfo.sRect.bottom += MSGBOXEX_MARGINY;
		sInfo.sRect.left   += sRect.right;	
		sInfo.sRect.right  += sRect.right;
		iStep				= sRect.bottom;
		iStep			   -= sInfo.sRect.bottom;

		if(iStep>0)											// Ist das Icon hher als der Text
			{
			sInfo.sRect.top	   += iStep/2;					
			sInfo.sRect.bottom += iStep/2;
			}
		}
	else{													// Kein Icon vorhanden
		sInfo.sRect.top	   += iOff;					
		sInfo.sRect.bottom += iOff;
		sInfo.sRect.left   += iAdd;	
		sInfo.sRect.right  += iAdd;
		}
					  
															
	iSize		  = iButtons*(sSize.cx+MSGBOXEX_BTNSPACING);
	iSize        -= MSGBOXEX_BTNSPACING;
	iSize        += MSGBOXEX_MARGINX*2;
	iBtnLeft	  = MSGBOXEX_MARGINX;
	iBtnTop		  = sInfo.sRect.bottom;						
	iStep		  =(sInfo.sRect.right-iSize)/2;	
	
	if(iStep>0)												// Sind die Tasten schmaler als der Text 
		{
		iBtnLeft += iStep;
		}
	else{
		sInfo.sRect.left  -= iStep;
		sInfo.sRect.right -= iStep;
		}

	iBtnTop	   +=  MSGBOXEX_SPACING;						// Tastenpositionen berechnen
	iBtnTop		= (iBtnTop            *8)/uUnitsY;
	iBtnLeft	= (iBtnLeft           *4)/uUnitsX;
	sSize.cx	= (sSize.cx           *4)/uUnitsX;
	sSize.cy	= (sSize.cy           *8)/uUnitsY;
	iSize		= (MSGBOXEX_BTNSPACING*8)/uUnitsY;
	iStep		=  iBtnLeft;

	for(iPos=0;iPos<iButtons;iPos++)						 
		{
		aBtnPt[iPos]->x  = (short)iBtnLeft;
		aBtnPt[iPos]->y  = (short)iBtnTop;
		aBtnPt[iPos]->cx = (short)sSize.cx;
		aBtnPt[iPos]->cy = (short)sSize.cy;
		iBtnLeft		+= sSize.cx;
		iBtnLeft        += iSize;
		}
											 
															
	iBtnLeft       += iStep-iSize;							// Berechne die Position vom Fenster
	iBtnTop	       += sSize.cy;
	iBtnTop	       += (MSGBOXEX_MARGINY*8)/uUnitsY;

	pTemplate->cx	= iBtnLeft;
	pTemplate->cy	= iBtnTop;
															
	iDelta			= iBtnTop-sSize.cy-aBtnPt[0]->y;		// Berechne die Position vom weien Feld
	pTxtPt->x 		= 0;
	pTxtPt->y 		= 0;
	pTxtPt->cx		= pTemplate->cx;
	pTxtPt->cy		= aBtnPt[0]->y-iDelta;

												
	sInfo.hIcon		= hIcon;								// Die MessageBox anzeigen
	sInfo.hFont		= hFont;
	sInfo.uHelpId	= pParams->dwContextHelpId;
	sInfo.pCallback	= pParams->lpfnMsgBoxCallback;
	sInfo.uStyle	= dwStyle;
	sInfo.iButtons	= iButtons;
	sInfo.pButtons	= aBtnIds;
	sInfo.uTimeout 	= uTimeout;
	sInfo.pColors	= pColors;
	sInfo.pText		= pText;
	sInfo.iLines	= iLines;
	sInfo.pSizes	= pSizes;
	

	if(hDC)
		{
		DeleteDC(hDC);
		}

	if(sInfo.sPoint.x==NOPOS || sInfo.sPoint.y==NOPOS)		// Den Dialog zentrieren
		{
		sInfo.sPoint.x	= (sInfo.sScreen.left+sInfo.sScreen.right )/2;
		sInfo.sPoint.y	= (sInfo.sScreen.top +sInfo.sScreen.bottom)/2;
		}

	iRet =  (int)DialogBoxIndirectParamW(pParams->hInstance,pTemplate,hOwner,MessageBoxProc,(LPARAM)&sInfo);

	if(sInfo.sPoint.x!=NOPOS && sInfo.sPoint.y!=NOPOS)
		{
		sLastPt = sInfo.sPoint;								// Letzte Fensterposition speichern

		if(dwStyle&MB_SETPOS)	
			{
			*(LPDWORD)&pParams->dwLanguageId = MAKELONG(sInfo.sPoint.x,sInfo.sPoint.y);
			}
		}

	if(hFont)
		{
		DeleteObject(hFont);
		}

Exit:

	HeapFree(GetProcessHeap(),0,pBuffer);					// Speicher wieder freigeben

	if(iMaxLines>MSGBOX_MAXLINES)
		{
		HeapFree(GetProcessHeap(),0,pSizes);
		}


return iRet;
}

//*****************************************************************************
//*
//*		ClearStringList
//*
//*****************************************************************************
//	Lcht die Texte am Programmende
static void __cdecl ClearStringList(void)
{
	
	if(pTextMemory)
		{
		HeapFree(GetProcessHeap(),0,pTextMemory);
		pTextMemory = 0;
		}

}


//*****************************************************************************
//*
//*		LoadDefaultList
//*
//*****************************************************************************
static void LoadDefaultList(HINSTANCE hInstance)
{
CHAR	aMark[ENTRIES(aStringIds)];
WCHAR	cText[2];
LPWSTR	pWide;
LPSTR	pAnsi;
int		iAll;
int		iPos;
int		iLen;
int		iNum;



	for(iPos=0,iAll=0;iPos<ENTRIES(aStringIds);iPos++)		// Textlngen berechnen
		{
		   iLen = LoadStringW(hInstance,aStringIds[iPos],cText,0);
		if(iLen)
			{
			aMark[iPos] = 1;
			}
		else{
			iLen		= (int)strlen(aTextStrings[iPos]);
			aMark[iPos] = 0;
			}

		aSizeStrings[iPos] = iLen;
		iAll += (iLen+2)&~1;	
		}

															// Speicher fr Texte allokieren
		pTextMemory = (LPBYTE)HeapAlloc(GetProcessHeap(),0,iAll*3);
	if(!pTextMemory)
		{
		return;
		}
	
	atexit(ClearStringList);	


	for(iPos=0,iAll=0;iPos<ENTRIES(aStringIds);iPos++)		// Textlngen berechnen
		{
		iLen	= aSizeStrings[iPos];
		pWide	= (LPWSTR)(pTextMemory+iAll);
		pAnsi	= (LPSTR )(pTextMemory+iAll+iLen*2+2);

		if(aMark[iPos])
			{
			iNum = LoadStringW(hInstance,aStringIds[iPos],pWide,iLen+1);
			}
			
		if(!aMark[iPos] || !iNum)							// Standarttext benutzen
			{
			memcpy(pAnsi,aTextStrings[iPos],iLen+1);
			MultiByteToWideChar(CP_ACP,0,pAnsi,iLen+1,pWide,iLen+1);			
			}
		else{												// Resource benutzen
			WideCharToMultiByte(CP_ACP,0,pWide,iLen+1,pAnsi,iNum+1,NULL,NULL);
			}

		aAnsiStrings[iPos] = pAnsi;
		aWideStrings[iPos] = pWide;
		
		iNum  = (iLen+2)&~1;	
		iAll +=  iNum*3;
		}

}


//*****************************************************************************
//*
//*		LoadDefaultStrings
//*
//*****************************************************************************
//	Ld alle Standarttexte
//	hInstance		: Ist die Instanz wo die Text konfiguriert sind
//	uId				: Ist die ID des Textes (siehe IDS_TEXT_???)
//	pSize			: Hier wird die Textlnge gespeichert (bei NULL nicht)
//	Ergibt eine Zeiger auf den Text oder NULL bei einem Fehler
EXTAPI LPCSTR WINAPI LoadDefaultStringsA(HINSTANCE hInstance,UINT uId,LPINT pSize)
{
LPCSTR	pAnsi;
int		iPos;


	for(iPos=0;;iPos++)										// Suche die ID
		{
		if(iPos>=ENTRIES(aStringIds))return NULL;
		if(aStringIds[iPos]==uId)break;
		}

	if(pSize)												// Textlnge speichern
		{
		*pSize = aSizeStrings[iPos];
		}

	if(!pTextMemory)										// Wurden die Texte noch nicht geladen
		{
		LoadDefaultList(hInstance);

		if(!pTextMemory)
			{
			pAnsi = aTextStrings[iPos];
			
			return pAnsi;
			}
		}

	
return aAnsiStrings[iPos];
}

EXTAPI LPCWSTR WINAPI LoadDefaultStringsW(HINSTANCE hInstance,UINT uId,LPINT pSize)
{
int		iPos;


	for(iPos=0;;iPos++)										// Suche die ID
		{
		if(iPos>=ENTRIES(aStringIds))return NULL;
		if(aStringIds[iPos]==uId)break;
		}

	if(pSize)												// Textlnge speichern
		{
		*pSize = aSizeStrings[iPos];
		}

	if(!pTextMemory)										// Wurden die Texte noch nicht geladen
		{
		LoadDefaultList(hInstance);

		if(!pTextMemory)
			{
			return NULL;
			}
		}

	
return aWideStrings[iPos];
}


